/*
   Copyright 10/07/02 Sun Microsystems, Inc.  All Rights Reserved.
*/
 
#ifndef __SUNINTERVALIMPL_H
#define __SUNINTERVALIMPL_H

#pragma ident "@(#)sunintervalimpl.h 1.3 02/10/07 Sun Microsystems, Inc."

/* DO NOT DIRECTLY USE THESE IMPLEMENTATION-PRIVATE DECLARATIONS. */

struct __r_interval { float l, u; };
struct __d_interval { double l, u; };
struct __q_interval { long double l, u; };

extern "C" {

/*
 * __r_interval interval elementary functions
 */

extern __r_interval	__ri_acos	(__r_interval);
extern __r_interval	__ri_asin	(__r_interval);
extern __r_interval	__ri_atan	(__r_interval);
extern __r_interval	__ri_atan2	(__r_interval, __r_interval);
extern __r_interval 	__ri_cbrt	(__r_interval);
extern __r_interval	__ri_cos	(__r_interval);
extern __r_interval	__ri_cosh	(__r_interval);
extern __r_interval	__ri_exp	(__r_interval);
extern __r_interval	__ri_fmod	(__r_interval, __r_interval);
extern __r_interval	__ri_log	(__r_interval);
extern __r_interval	__ri_log10	(__r_interval);
extern __r_interval	__ri_sign	(__r_interval, __r_interval);
extern __r_interval	__ri_sin	(__r_interval);
extern __r_interval	__ri_sinh	(__r_interval);
extern __r_interval 	__ri_sqr	(__r_interval);
extern __r_interval	__ri_sqrt	(__r_interval);
extern __r_interval	__ri_tan	(__r_interval);
extern __r_interval	__ri_tanh	(__r_interval);

/*
 * __d_interval interval elementary functions
 */

extern __d_interval	__di_acos	(__d_interval);
extern __d_interval 	__di_asin	(__d_interval);
extern __d_interval 	__di_atan	(__d_interval);
extern __d_interval 	__di_atan2	(__d_interval, __d_interval);
extern __d_interval 	__di_cbrt	(__d_interval);
extern __d_interval 	__di_cos	(__d_interval);
extern __d_interval 	__di_cosh	(__d_interval);
extern __d_interval 	__di_exp	(__d_interval);
extern __d_interval 	__di_fmod	(__d_interval, __d_interval);
extern __d_interval 	__di_log	(__d_interval);
extern __d_interval 	__di_log10	(__d_interval);
extern __d_interval	__di_sign	(__d_interval, __d_interval);
extern __d_interval 	__di_sin	(__d_interval);
extern __d_interval 	__di_sinh	(__d_interval);
extern __d_interval 	__di_sqr	(__d_interval);
extern __d_interval 	__di_sqrt	(__d_interval);
extern __d_interval 	__di_tan	(__d_interval);
extern __d_interval 	__di_tanh	(__d_interval);

/*
 * __q_interval interval elementary functions
 */

extern __q_interval	__qi_exp	(__q_interval);
extern __q_interval	__qi_log	(__q_interval);
extern __q_interval	__qi_sin	(__q_interval);
extern __q_interval	__qi_cos	(__q_interval);
extern __q_interval	__qi_asin	(__q_interval);
extern __q_interval	__qi_acos	(__q_interval);
extern __q_interval	__qi_fmod	(__q_interval, __q_interval);
extern __q_interval	__qi_sqrt	(__q_interval);
extern __q_interval	__qi_sign	(__q_interval, __q_interval);
extern __q_interval	__qi_sqr	(__q_interval);

/* Interval abs */
extern __r_interval	__ri_fabs	(__r_interval);
extern __d_interval	__di_fabs	(__d_interval);
extern __q_interval	__qi_fabs	(__q_interval);

/*
 * Implementation of interval operations & interval specific functions
 */

/* Interval constructor */
extern void	__ri_interval_i_ 	(__r_interval*, int);
extern void	__ri_interval_xl_	(__r_interval*, long long);
extern void	__ri_interval_r_ 	(__r_interval*, float);
extern void	__ri_interval_d_ 	(__r_interval*, double);
extern void	__ri_interval_q_ 	(__r_interval*, long double);
extern void	__ri_interval_ri_ 	(__r_interval*, __r_interval*);
extern void	__ri_interval_qi_ 	(__r_interval*, __q_interval*);
extern void	__ri_interval_di_ 	(__r_interval*, __d_interval*);
extern void	__ri_interval_i_i_ 	(__r_interval*, int, int);
extern void	__ri_interval_xl_xl_ 	(__r_interval*, long long, long long);
extern void	__ri_interval_r_r_ 	(__r_interval*, float, float);
extern void	__ri_interval_d_d_ 	(__r_interval*, double, double);
extern void	__ri_interval_q_q_ 	(__r_interval*, long double, long double);
extern void	__di_interval_i_ 	(__d_interval*, int);
extern void	__di_interval_xl_ 	(__d_interval*, long long);
extern void	__di_interval_r_ 	(__d_interval*, float);
extern void	__di_interval_d_ 	(__d_interval*, double);
extern void	__di_interval_q_ 	(__d_interval*, long double);
extern void	__di_interval_di_ 	(__d_interval*, __d_interval*);
extern void	__di_interval_qi_ 	(__d_interval*, __q_interval*);
extern void	__di_interval_ri_ 	(__d_interval*, __r_interval*);
extern void	__di_interval_i_i_ 	(__d_interval*, int, int);
extern void	__di_interval_xl_xl_ 	(__d_interval*, long long, long long);
extern void	__di_interval_r_r_ 	(__d_interval*, float, float);
extern void	__di_interval_d_d_ 	(__d_interval*, double, double);
extern void	__di_interval_q_q_ 	(__d_interval*, long double, long double);
extern void	__qi_interval_i_ 	(__q_interval*, int);
extern void	__qi_interval_xl_ 	(__q_interval*, long long);
extern void	__qi_interval_r_ 	(__q_interval*, float);
extern void	__qi_interval_d_ 	(__q_interval*, double);
extern void	__qi_interval_q_ 	(__q_interval*, long double);
extern void	__qi_interval_qi_ 	(__q_interval*, __q_interval*);
extern void	__qi_interval_di_ 	(__q_interval*, __d_interval*);
extern void	__qi_interval_ri_ 	(__q_interval*, __r_interval*);
extern void	__qi_interval_i_i_ 	(__q_interval*, int, int);
extern void	__qi_interval_xl_xl_ 	(__q_interval*, long long, long long);
extern void	__qi_interval_r_r_ 	(__q_interval*, float, float);
extern void	__qi_interval_d_d_ 	(__q_interval*, double, double);
extern void	__qi_interval_q_q_ 	(__q_interval*, long double, long double);

/* Interval Addition */
extern __r_interval	__ri_add	(__r_interval, __r_interval);
extern __d_interval	__di_add	(__d_interval, __d_interval);
extern __q_interval	__qi_add	(__q_interval, __q_interval);

/* Interval Subtraction */
extern __r_interval	__ri_sub	(__r_interval, __r_interval);
extern __d_interval	__di_sub	(__d_interval, __d_interval);
extern __q_interval	__qi_sub	(__q_interval, __q_interval);

/* Interval Multiplication */
extern __r_interval	__ri_mul	(__r_interval, __r_interval);
extern __d_interval	__di_mul	(__d_interval, __d_interval);
extern __q_interval	__qi_mul	(__q_interval, __q_interval);
extern __r_interval	__ri_mul_nornd	(__r_interval, __r_interval);
extern __d_interval	__di_mul_nornd	(__d_interval, __d_interval);
extern __q_interval	__qi_mul_nornd	(__q_interval, __q_interval);

/* Interval Division */
extern __r_interval	__ri_div	(__r_interval, __r_interval);
extern __d_interval	__di_div	(__d_interval, __d_interval);
extern __q_interval	__qi_div	(__q_interval, __q_interval);
extern __r_interval	__ri_div_nornd	(__r_interval, __r_interval);
extern __d_interval	__di_div_nornd	(__d_interval, __d_interval);
extern __q_interval	__qi_div_nornd	(__q_interval, __q_interval);
extern __r_interval	__ri_divx	(__r_interval, __r_interval, __r_interval);
extern __d_interval	__di_divx	(__d_interval, __d_interval, __d_interval);
extern __q_interval	__qi_divx	(__q_interval, __q_interval, __q_interval);

/* Interval Negation */
extern __r_interval	__ri_neg	(__r_interval);
extern __d_interval	__di_neg	(__d_interval);
extern __q_interval	__qi_neg	(__q_interval);

/* Infimim, supremum */
extern float 		__ri_inf	(__r_interval);
extern double		__di_inf	(__d_interval);
extern long double	__qi_inf	(__q_interval);
extern float		__ri_sup	(__r_interval);
extern double		__di_sup	(__d_interval);
extern long double	__qi_sup	(__q_interval);

/* Test for an empty interval */
extern int	__ri_isempty	(__r_interval);
extern int	__di_isempty	(__d_interval);
extern int 	__qi_isempty	(__q_interval);

/* Intersection hull */
extern __r_interval	__ri_ix	(__r_interval, __r_interval);
extern __d_interval	__di_ix	(__d_interval, __d_interval);
extern __q_interval	__qi_ix	(__q_interval, __q_interval);

/* Interval hull */
extern __r_interval	__ri_ih	(__r_interval, __r_interval);
extern __d_interval	__di_ih	(__d_interval, __d_interval);
extern __q_interval	__qi_ih	(__q_interval, __q_interval);

/* Test for disjoint intervals */
extern int	__ri_dj	(__r_interval, __r_interval);
extern int	__di_dj	(__d_interval, __d_interval);
extern int	__qi_dj	(__q_interval, __q_interval);

/* "In interior" relation */
extern int	__ri_int	(__r_interval, __r_interval);
extern int	__di_int	(__d_interval, __d_interval);
extern int	__qi_int	(__q_interval, __q_interval);

/* "In" relation */
extern int	__i_in_ri	(int, 		__r_interval);
extern int	__xl_in_ri	(long long, 	__r_interval);
extern int	__r_in_ri	(float, 		__r_interval);
extern int	__d_in_ri	(double, 		__r_interval);
extern int	__q_in_ri	(long double, 	__r_interval);
extern int	__i_in_di	(int, 		__d_interval);
extern int	__xl_in_di	(long long, 	__d_interval);
extern int	__r_in_di	(float, 		__d_interval);
extern int	__d_in_di	(double, 		__d_interval);
extern int	__q_in_di	(long double, 	__d_interval);
extern int	__i_in_qi	(int, 		__q_interval);
extern int	__xl_in_qi	(long long, 	__q_interval);
extern int	__r_in_qi	(float, 		__q_interval);
extern int	__d_in_qi	(double, 		__q_interval);
extern int	__q_in_qi	(long double, 	__q_interval);

/* Subset, Superset and Proper Subset, Proper Superset */
extern int	__ri_sp		(__r_interval, __r_interval);
extern int	__di_sp		(__d_interval, __d_interval);
extern int	__qi_sp		(__q_interval, __q_interval);
extern int	__ri_psp	(__r_interval, __r_interval);
extern int	__di_psp	(__d_interval, __d_interval);
extern int	__qi_psp	(__q_interval, __q_interval);
extern int	__ri_sb		(__r_interval, __r_interval);
extern int	__di_sb		(__d_interval, __d_interval);
extern int	__qi_sb		(__q_interval, __q_interval);
extern int	__ri_psb	(__r_interval, __r_interval);
extern int	__di_psb	(__d_interval, __d_interval);
extern int	__qi_psb	(__q_interval, __q_interval);

/* Set relations */
extern int	__ri_seq	(__r_interval, __r_interval);
extern int	__di_seq	(__d_interval, __d_interval);
extern int	__qi_seq	(__q_interval, __q_interval);
extern int	__ri_sne	(__r_interval, __r_interval);
extern int	__di_sne	(__d_interval, __d_interval);
extern int	__qi_sne	(__q_interval, __q_interval);
extern int	__ri_slt	(__r_interval, __r_interval);
extern int	__di_slt	(__d_interval, __d_interval);
extern int	__qi_slt	(__q_interval, __q_interval);
extern int	__ri_sle	(__r_interval, __r_interval);
extern int	__di_sle	(__d_interval, __d_interval);
extern int	__qi_sle	(__q_interval, __q_interval);
extern int	__ri_sgt	(__r_interval, __r_interval);
extern int	__di_sgt	(__d_interval, __d_interval);
extern int	__qi_sgt	(__q_interval, __q_interval);
extern int	__ri_sge	(__r_interval, __r_interval);
extern int	__di_sge	(__d_interval, __d_interval);
extern int	__qi_sge	(__q_interval, __q_interval);

/* Certainly relations */
extern int	__ri_clt	(__r_interval, __r_interval);
extern int	__di_clt	(__d_interval, __d_interval);
extern int	__qi_clt	(__q_interval, __q_interval);
extern int	__ri_cle	(__r_interval, __r_interval);
extern int	__di_cle	(__d_interval, __d_interval);
extern int	__qi_cle	(__q_interval, __q_interval);
extern int	__ri_cgt	(__r_interval, __r_interval);
extern int	__di_cgt	(__d_interval, __d_interval);
extern int	__qi_cgt	(__q_interval, __q_interval);
extern int	__ri_cge	(__r_interval, __r_interval);
extern int	__di_cge	(__d_interval, __d_interval);
extern int	__qi_cge	(__q_interval, __q_interval);
extern int	__ri_ceq	(__r_interval, __r_interval);
extern int	__di_ceq	(__d_interval, __d_interval);
extern int	__qi_ceq	(__q_interval, __q_interval);
extern int	__ri_cne	(__r_interval, __r_interval);
extern int	__di_cne	(__d_interval, __d_interval);
extern int	__qi_cne	(__q_interval, __q_interval);

/* Possibly relations */
extern int	__ri_plt	(__r_interval, __r_interval);
extern int	__di_plt	(__d_interval, __d_interval);
extern int	__qi_plt	(__q_interval, __q_interval);
extern int	__ri_ple	(__r_interval, __r_interval);
extern int	__di_ple	(__d_interval, __d_interval);
extern int	__qi_ple	(__q_interval, __q_interval);
extern int	__ri_pgt	(__r_interval, __r_interval);
extern int	__di_pgt	(__d_interval, __d_interval);
extern int	__qi_pgt	(__q_interval, __q_interval);
extern int	__ri_pge	(__r_interval, __r_interval);
extern int	__di_pge	(__d_interval, __d_interval);
extern int	__qi_pge	(__q_interval, __q_interval);
extern int	__ri_peq	(__r_interval, __r_interval);
extern int	__di_peq	(__d_interval, __d_interval);
extern int	__qi_peq	(__q_interval, __q_interval);
extern int	__ri_pne	(__r_interval, __r_interval);
extern int	__di_pne	(__d_interval, __d_interval);
extern int	__qi_pne	(__q_interval, __q_interval);

/* Min, Max */
extern __r_interval	__ri_max	(__r_interval, __r_interval);
extern __d_interval	__di_max	(__d_interval, __d_interval);
extern __q_interval	__qi_max	(__q_interval, __q_interval);
extern __r_interval	__ri_min	(__r_interval, __r_interval);
extern __d_interval	__di_min	(__d_interval, __d_interval);
extern __q_interval	__qi_min	(__q_interval, __q_interval);

/* Special interval functions */
extern float		__ri_mig	(__r_interval);
extern double		__di_mig	(__d_interval);
extern long double	__qi_mig	(__q_interval);
extern float		__ri_mag	(__r_interval);
extern double		__di_mag	(__d_interval);
extern long double	__qi_mag	(__q_interval);
extern float		__ri_mid	(__r_interval);
extern double		__di_mid	(__d_interval);
extern long double	__qi_mid	(__q_interval);
extern float		__ri_wid	(__r_interval);
extern double		__di_wid	(__d_interval);
extern long double	__qi_wid	(__q_interval);

/* Int, Aint, Anint */
extern __r_interval	__ri_aint	(__r_interval);
extern __d_interval	__di_aint	(__d_interval);
extern __q_interval 	__qi_aint	(__q_interval);
extern __r_interval	__ri_anint	(__r_interval);
extern __d_interval	__di_anint	(__d_interval);
extern __q_interval	__qi_anint	(__q_interval);
extern int		__ri_int_i	(__r_interval);
extern int		__di_int_i	(__d_interval);
extern int		__qi_int_i	(__q_interval);
extern long long	__ri_int_xl	(__r_interval);
extern long long	__di_int_xl	(__d_interval);
extern long long	__qi_int_xl	(__q_interval);

/* Ndigits */
extern int	__ri_ndigits	(__r_interval);
extern int	__di_ndigits	(__d_interval);
extern int	__qi_ndigits	(__q_interval);

/* Pow */
extern __r_interval	__ri_pow_i	(__r_interval, int);
extern __r_interval	__ri_pow_xl	(__r_interval, long long);
extern __d_interval	__di_pow_i	(__d_interval, int);
extern __d_interval	__di_pow_xl	(__d_interval, long long);
extern __q_interval	__qi_pow_xl	(__q_interval, long long);
extern __q_interval	__qi_pow_i	(__q_interval, int);
extern __r_interval	__ri_pow	(__r_interval, __r_interval);
extern __d_interval	__di_pow	(__d_interval, __d_interval);
extern __q_interval	__qi_pow	(__q_interval, __q_interval);

/* Interval constructor */
extern __r_interval	__ri_interval_i		(int);
extern __r_interval	__ri_interval_xl	(long long);
extern __r_interval	__ri_interval_r		(float);
extern __r_interval	__ri_interval_d		(double);
extern __r_interval	__ri_interval_q		(long double);
extern __r_interval	__ri_interval_ri	(__r_interval);
extern __r_interval	__ri_interval_qi	(__q_interval);
extern __r_interval	__ri_interval_di	(__d_interval);
extern __r_interval	__ri_interval_i_i	(int, int);
extern __r_interval	__ri_interval_xl_xl	(long long, long long);
extern __r_interval	__ri_interval_r_r	(float, float);
extern __r_interval	__ri_interval_d_d	(double, double);
extern __r_interval	__ri_interval_q_q	(long double, long double);
extern __d_interval	__di_interval_i		(int);
extern __d_interval	__di_interval_xl	(long long);
extern __d_interval	__di_interval_r		(float);
extern __d_interval	__di_interval_d		(double);
extern __d_interval	__di_interval_q		(long double);
extern __d_interval	__di_interval_di	(__d_interval);
extern __d_interval	__di_interval_qi	(__q_interval);
extern __d_interval	__di_interval_ri	(__r_interval);
extern __d_interval	__di_interval_i_i	(int, int);
extern __d_interval	__di_interval_xl_xl	(long long, long long);
extern __d_interval	__di_interval_r_r	(float, float);
extern __d_interval	__di_interval_d_d	(double, double);
extern __d_interval	__di_interval_q_q	(long double, long double);
extern __q_interval	__qi_interval_i		(int);
extern __q_interval	__qi_interval_xl	(long long);
extern __q_interval	__qi_interval_r		(float);
extern __q_interval	__qi_interval_d		(double);
extern __q_interval	__qi_interval_q		(long double);
extern __q_interval	__qi_interval_qi	(__q_interval);
extern __q_interval	__qi_interval_di	(__d_interval);
extern __q_interval	__qi_interval_ri	(__r_interval);
extern __q_interval	__qi_interval_i_i	(int, int);
extern __q_interval	__qi_interval_xl_xl	(long long, long long);
extern __q_interval	__qi_interval_r_r	(float, float);
extern __q_interval	__qi_interval_d_d	(double, double);
extern __q_interval	__qi_interval_q_q	(long double, long double);

} /* extern "C" */

#endif	/* !defined(__SUNINTERVALIMPL_H) */
