/*
 * Copyright (c) 2004,2005 by Sun Microsystems, Inc.
 * All rights reserved.
 */

#ifndef __SYS_AMMINTRIN_INTRIN_H
#define __SYS_AMMINTRIN_INTRIN_H

#pragma ident   "@(#)ammintrin.h 1.1 07/05/24"

/*----------------------------------------------------------
      Intrinsics available under SSE4A platform
  ----------------------------------------------------------*/


#ifdef __cplusplus
extern "C" {
#endif

#include <sys/pmmintrin.h>

/*-------------------------------*/
/*   Insert/Extract              */
/*-------------------------------*/

__m128i _mm_extracti_si64(__m128i p1, int p2, int p3);
__m128i _mm_extract_si64(__m128i p1, __m128i p2);

__m128i _mm_inserti_si64(__m128i p1, __m128i p2, int p3, int p4);
__m128i _mm_insert_si64(__m128i p1, __m128i p2);

/*-------------------------------*/
/*   Non-temporal Moves		 */
/*-------------------------------*/

void _mm_stream_ss(float *p1, __m128 p2);
void _mm_stream_sd(double *p1, __m128d p2);

#ifdef __cplusplus
}
#endif

#endif
