/*
 * Copyright (c) 2004,2005 by Sun Microsystems, Inc.
 * All rights reserved.
 */

#ifndef __SYS_TMMINTRIN_INTRIN_H
#define __SYS_TMMINTRIN_INTRIN_H

#pragma ident   "@(#)tmmintrin.h 1.1 07/09/26"

#ifdef __cplusplus
extern "C" {
#endif

#include <pmmintrin.h>

/*-----------------------------------*/
/*   Packed Absolute Operations      */
/*-----------------------------------*/
extern __m64 _mm_abs_pi8 (__m64 p);
extern __m64 _mm_abs_pi16 (__m64 p);
extern __m64 _mm_abs_pi32 (__m64 p);
extern __m128i _mm_abs_epi8 (__m128i p);
extern __m128i _mm_abs_epi16 (__m128i p);
extern __m128i _mm_abs_epi32 (__m128i p);

/*---------------------------------------*/
/*   Packed Align with Shift Operations  */
/*---------------------------------------*/
extern __m64 _mm_alignr_pi8 (__m64 p1, __m64 p2, int immd);
extern __m128i _mm_alignr_epi8 (__m128i p1, __m128i p2, int immd);

/*-------------------------------*/
/*   Horizontal Add Operations   */
/*-------------------------------*/

extern __m64 _mm_hadd_pi16 (__m64 p1, __m64 p2);
extern __m64 _mm_hadd_pi32 (__m64 p1, __m64 p2);
extern __m64 _mm_hadds_pi16 (__m64 p1, __m64 p2);
extern __m128i _mm_hadd_epi16 (__m128i p1, __m128i p2);
extern __m128i _mm_hadd_epi32 (__m128i p1, __m128i p2);
extern __m128i _mm_hadds_epi16 (__m128i p1, __m128i p2);

/*-----------------------------------*/
/*   Horizontal Subtract Operations  */
/*-----------------------------------*/

extern __m64 _mm_hsub_pi16 (__m64 p1, __m64 p2);
extern __m64 _mm_hsub_pi32 (__m64 p1, __m64 p2);
extern __m64 _mm_hsubs_pi16 (__m64 p1, __m64 p2);
extern __m128i _mm_hsub_epi16 (__m128i p1, __m128i p2);
extern __m128i _mm_hsub_epi32 (__m128i p1, __m128i p2);
extern __m128i _mm_hsubs_epi16 (__m128i p1, __m128i p2);

/*-----------------------------------*/
/*   Multiply and Add Operations     */
/*-----------------------------------*/

extern __m64 _mm_maddubs_pi16 (__m64 p1, __m64 p2);
extern __m128i _mm_maddubs_epi16 (__m128i p1, __m128i p2);

/*-----------------------------------*/
/*   Packed Multiply High Operations */
/*-----------------------------------*/

extern __m64 _mm_mulhrs_pi16 (__m64 p1, __m64 p2);
extern __m128i _mm_mulhrs_epi16 (__m128i p1, __m128i p2);

/*-----------------------------------*/
/*   Packed Shuffle Operations       */
/*-----------------------------------*/

extern __m64 _mm_shuffle_pi8 (__m64 p1, __m64 p2);
extern __m128i _mm_shuffle_epi8 (__m128i p1, __m128i p2);

/*-----------------------------------*/
/*   Packed Sign Operations          */
/*-----------------------------------*/

extern __m64 _mm_sign_pi8 (__m64 p1, __m64 p2);
extern __m64 _mm_sign_pi16 (__m64 p1, __m64 p2);
extern __m64 _mm_sign_pi32 (__m64 p1, __m64 p2);
extern __m128i _mm_sign_epi8 (__m128i p1, __m128i p2);
extern __m128i _mm_sign_epi16 (__m128i p1, __m128i p2);
extern __m128i _mm_sign_epi32 (__m128i p1, __m128i p2);

#ifdef __cplusplus
};
#endif

#endif
