/*
 * Copyright 11/30/01 Sun Microsystems, Inc.  All Rights Reserved.
 */

#ifndef _SUNPERF_H

#define _SUNPERF_H

#ifdef __cplusplus
extern "C" {
#endif

#ifdef __STDC__
#define __P(p) p
#else
#define __P(p) ()
#endif

#ifdef complex

#define floatcomplex float complex
#define doublecomplex double complex
#define cdotci ___pl_cdotci_c99
#define cdotc ___pl_cdotc_c99
#define cdotui ___pl_cdotui_c99
#define cdotu ___pl_cdotu_c99
#define cladiv ___pl_cladiv_c99
#define zdotci ___pl_zdotci_c99
#define zdotc ___pl_zdotc_c99
#define zdotui ___pl_zdotui_c99
#define zdotu ___pl_zdotu_c99

#if defined (__sparcv9) || (defined (__x86_64) && defined(__amd64))

#define cdotci_64 ___pl_cdotci_c99_64
#define cdotc_64 ___pl_cdotc_c99_64
#define cdotui_64 ___pl_cdotui_c99_64
#define cdotu_64 ___pl_cdotu_c99_64
#define cladiv_64 ___pl_cladiv_c99_64
#define zdotci_64 ___pl_zdotci_c99_64
#define zdotc_64 ___pl_zdotc_c99_64
#define zdotui_64 ___pl_zdotui_c99_64
#define zdotu_64 ___pl_zdotu_c99_64

#endif /* defined (__sparcv9) || (defined (__x86_64) && defined(__amd64)) */

#else

#ifndef _SUNPERF_COMPLEX

#define _SUNPERF_COMPLEX
#define floatcomplex complex
#define doublecomplex doublecomplex
typedef struct {
        float r;
        float i;
} floatcomplex;
typedef struct {
        double r;
        double i;
} doublecomplex;

#endif /* !defined(_SUNPERF_COMPLEX) */

#endif /* define complex */

extern void available_threads __P((int*, int*));
extern void available_threads_ __P((int*, int*));
extern void blas_dpermute_ __P((const int*, const int*, const int*, double*, const int*));
extern void blas_dsortv_ __P((const int*, const int*, double*, const int*, int*, const int*));
extern void blas_dsort_ __P((const int*, const int*, double*, const int*));
extern void blas_ipermute_ __P((const int*, const int*, const int*, int*, const int*));
extern void blas_isortv_ __P((const int*, const int*, int*, const int*, int*, const int*));
extern void blas_isort_ __P((const int*, const int*, int*, const int*));
extern void blas_spermute_ __P((const int*, const int*, const int*, float*, const int*));
extern void blas_ssortv_ __P((const int*, const int*, float*, const int*, int*, const int*));
extern void blas_ssort_ __P((const int*, const int*, float*, const int*));
extern void caxpyi __P((const int, const floatcomplex*, const floatcomplex*, const int*, floatcomplex*));
extern void caxpyi_ __P((const int*, const floatcomplex*, const floatcomplex*, const int*, floatcomplex*));
extern void caxpy __P((const int, const floatcomplex*, const floatcomplex*, const int, floatcomplex*, const int));
extern void caxpy_ __P((const int*, const floatcomplex*, const floatcomplex*, const int*, floatcomplex*, const int*));
extern void cbcomm __P((const int, const int, const int, const int, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cbcomm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cbdimm __P((const int, const int, const int, const int, const floatcomplex*, const int*, const floatcomplex*, const int, const int*, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cbdimm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cbdism __P((const int, const int, const int, const int, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int, const int*, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cbdism_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cbdsqr __P((const char, const int, const int, const int, const int, float*, float*, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cbdsqr_ __P((const char*, const int*, const int*, const int*, const int*, float*, float*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, const int));
extern void cbelmm __P((const int, const int, const int, const int, const floatcomplex*, const int*, const floatcomplex*, const int*, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cbelmm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cbelsm __P((const int, const int, const int, const int, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cbelsm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cbscmm __P((const int, const int, const int, const int, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cbscmm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cbscsm __P((const int, const int, const int, const int, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cbscsm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cbsrmm __P((const int, const int, const int, const int, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cbsrmm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cbsrsm __P((const int, const int, const int, const int, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cbsrsm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void ccnvcor2 __P((const char, const char, const char, const char, const char, const char, const int, const int, const floatcomplex*, const int, const int, const int, const int, const int, const floatcomplex*, const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int));
extern void ccnvcor2_ __P((const char*, const char*, const char*, const char*, const char*, const char*, const int*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, const int, const int, const int, const int, const int, const int));
extern void ccnvcor __P((const char, const char, const int, const floatcomplex*, const int, const int, const int, const int, const int, const floatcomplex*, const int, const int, const int, const int, const int, floatcomplex*, const int, const int, const int, floatcomplex*, const int));
extern void ccnvcor_ __P((const char*, const char*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const int*, floatcomplex*, const int*, const int*, const int*, floatcomplex*, const int*, const int, const int));
extern void ccoomm __P((const int, const int, const int, const int, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void ccoomm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void ccopy __P((const int, const floatcomplex*, const int, floatcomplex*, const int));
extern void ccopy_ __P((const int*, const floatcomplex*, const int*, floatcomplex*, const int*));
extern void ccscmm __P((const int, const int, const int, const int, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void ccscmm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void ccscsm __P((const int, const int, const int, const int, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void ccscsm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void ccsrmm __P((const int, const int, const int, const int, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void ccsrmm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void ccsrsm __P((const int, const int, const int, const int, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void ccsrsm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cdiamm __P((const int, const int, const int, const int, const floatcomplex*, const int*, const floatcomplex*, const int, const int*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cdiamm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cdiasm __P((const int, const int, const int, const int, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int, const int*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cdiasm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern floatcomplex cdotci __P((const int, const floatcomplex*, const int*, const floatcomplex*));
extern floatcomplex cdotc __P((const int, const floatcomplex*, const int, const floatcomplex*, const int));
extern floatcomplex cdotui __P((const int, const floatcomplex*, const int*, const floatcomplex*));
extern floatcomplex cdotu __P((const int, const floatcomplex*, const int, const floatcomplex*, const int));
extern void cellmm __P((const int, const int, const int, const int, const floatcomplex*, const int*, const floatcomplex*, const int*, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cellmm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cellsm __P((const int, const int, const int, const int, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cellsm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cfft2b __P((const int, const int, floatcomplex*, const int, const float*, const int));
extern void cfft2b_ __P((const int*, const int*, floatcomplex*, const int*, const float*, const int*));
extern void cfft2f __P((const int, const int, floatcomplex*, const int, const float*, const int));
extern void cfft2f_ __P((const int*, const int*, floatcomplex*, const int*, const float*, const int*));
extern void cfft2i __P((const int, const int, float*));
extern void cfft2i_ __P((const int*, const int*, float*));
extern void cfft3b __P((const int, const int, const int, floatcomplex*, const int, const int, const float*, const int));
extern void cfft3b_ __P((const int*, const int*, const int*, floatcomplex*, const int*, const int*, const float*, const int*));
extern void cfft3f __P((const int, const int, const int, floatcomplex*, const int, const int, const float*, const int));
extern void cfft3f_ __P((const int*, const int*, const int*, floatcomplex*, const int*, const int*, const float*, const int*));
extern void cfft3i __P((const int, const int, const int, float*));
extern void cfft3i_ __P((const int*, const int*, const int*, float*));
extern void cfftb __P((const int, floatcomplex*, float*));
extern void cfftb_ __P((const int*, floatcomplex*, float*));
extern void cfftc2_ __P((const int*, const int*, const int*, const float*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, float*, const int*, int*));
extern void cfftc3_ __P((const int*, const int*, const int*, const int*, const float*, const floatcomplex*, const int*, const int*, floatcomplex*, const int*, const int*, float*, int*, float*, const int*, int*));
extern void cfftcm_ __P((const int*, const int*, const int*, const float*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, float*, const int*, int*));
extern void cfftc_ __P((const int*, const int*, const float*, const floatcomplex*, floatcomplex*, float*, int*, float*, const int*, int*));
extern void cfftf __P((const int, floatcomplex*, const float*));
extern void cfftf_ __P((const int*, floatcomplex*, const float*));
extern void cffti __P((const int, float*));
extern void cffti_ __P((const int*, float*));
extern int cfftopt __P((const int));
extern int cfftopt_ __P((const int*));
extern void cffts2_ __P((const int*, const int*, const int*, const float*, const floatcomplex*, const int*, float*, const int*, float*, int*, float*, const int*, int*));
extern void cffts3_ __P((const int*, const int*, const int*, const int*, const float*, const floatcomplex*, const int*, const int*, float*, const int*, const int*, float*, int*, float*, const int*, int*));
extern void cfftsm_ __P((const int*, const int*, const int*, const float*, const floatcomplex*, const int*, float*, const int*, float*, int*, float*, const int*, int*));
extern void cffts_ __P((const int*, const int*, const float*, const floatcomplex*, float*, float*, int*, float*, const int*, int*));
extern void cgbbrd __P((const char, const int, const int, const int, const int, const int, floatcomplex*, const int, float*, float*, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cgbbrd_ __P((const char*, const int*, const int*, const int*, const int*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, float*, int*, const int));
extern void cgbcon __P((const char, const int, const int, const int, const floatcomplex*, const int, const int*, const float, float*, int*));
extern void cgbcon_ __P((const char*, const int*, const int*, const int*, const floatcomplex*, const int*, const int*, const float*, float*, floatcomplex*, float*, int*, const int));
extern void cgbequ __P((const int, const int, const int, const int, const floatcomplex*, const int, float*, float*, float*, float*, float*, int*));
extern void cgbequ_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, float*, float*, float*, float*, float*, int*));
extern void cgbmv __P((const char, const int, const int, const int, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cgbmv_ __P((const char*, const int*, const int*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, const int));
extern void cgbrfs __P((const char, const int, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, const int, const int*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, int*));
extern void cgbrfs_ __P((const char*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int));
extern void cgbsvx __P((const char, const char, const int, const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, int*, char*, float*, float*, floatcomplex*, const int, floatcomplex*, const int, float*, float*, float*, int*));
extern void cgbsvx_ __P((const char*, const char*, const int*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, char*, float*, float*, floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, float*, floatcomplex*, float*, int*, const int, const int, const int));
extern void cgbsv __P((const int, const int, const int, const int, floatcomplex*, const int, int*, floatcomplex*, const int, int*));
extern void cgbsv_ __P((const int*, const int*, const int*, const int*, floatcomplex*, const int*, int*, floatcomplex*, const int*, int*));
extern void cgbtf2 __P((const int, const int, const int, const int, floatcomplex*, const int, int*, int*));
extern void cgbtf2_ __P((const int*, const int*, const int*, const int*, floatcomplex*, const int*, int*, int*));
extern void cgbtrf __P((const int, const int, const int, const int, floatcomplex*, const int, int*, int*));
extern void cgbtrf_ __P((const int*, const int*, const int*, const int*, floatcomplex*, const int*, int*, int*));
extern void cgbtrs __P((const char, const int, const int, const int, const int, const floatcomplex*, const int, const int*, floatcomplex*, const int, int*));
extern void cgbtrs_ __P((const char*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const int*, floatcomplex*, const int*, int*, const int));
extern void cgebak __P((const char, const char, const int, const int, const int, const float*, const int, floatcomplex*, const int, int*));
extern void cgebak_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const int*, floatcomplex*, const int*, int*, const int, const int));
extern void cgebal __P((const char, const int, floatcomplex*, const int, int*, int*, float*, int*));
extern void cgebal_ __P((const char*, const int*, floatcomplex*, const int*, int*, int*, float*, int*, const int));
extern void cgebrd __P((const int, const int, floatcomplex*, const int, float*, float*, floatcomplex*, floatcomplex*, int*));
extern void cgebrd_ __P((const int*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, floatcomplex*, floatcomplex*, const int*, int*));
extern void cgecon __P((const char, const int, const floatcomplex*, const int, const float, float*, int*));
extern void cgecon_ __P((const char*, const int*, const floatcomplex*, const int*, const float*, float*, floatcomplex*, float*, int*, const int));
extern void cgeequ __P((const int, const int, const floatcomplex*, const int, float*, float*, float*, float*, float*, int*));
extern void cgeequ_ __P((const int*, const int*, const floatcomplex*, const int*, float*, float*, float*, float*, float*, int*));
extern void cgeesx __P((const char, const char, const int(*select)(floatcomplex*), const char, const int, floatcomplex*, const int, int*, floatcomplex*, floatcomplex*, const int, float*, float*, int*));
extern void cgeesx_ __P((const char*, const char*, const int(*select)(floatcomplex*), const char*, const int*, floatcomplex*, const int*, int*, floatcomplex*, floatcomplex*, const int*, float*, float*, floatcomplex*, const int*, float*, int*, int*, const int, const int, const int));
extern void cgees __P((const char, const char, const int(*select)(floatcomplex*), const int, floatcomplex*, const int, int*, floatcomplex*, floatcomplex*, const int, int*));
extern void cgees_ __P((const char*, const char*, const int(*select)(floatcomplex*), const int*, floatcomplex*, const int*, int*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, int*, const int, const int));
extern void cgeevx __P((const char, const char, const char, const char, const int, floatcomplex*, const int, floatcomplex*, floatcomplex*, const int, floatcomplex*, const int, int*, int*, float*, float*, float*, float*, int*));
extern void cgeevx_ __P((const char*, const char*, const char*, const char*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, int*, int*, float*, float*, float*, float*, floatcomplex*, const int*, float*, int*, const int, const int, const int, const int));
extern void cgeev __P((const char, const char, const int, floatcomplex*, const int, floatcomplex*, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cgeev_ __P((const char*, const char*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, const int, const int));
extern void cgegs __P((const char, const char, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, floatcomplex*, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cgegs_ __P((const char*, const char*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, const int, const int));
extern void cgegv __P((const char, const char, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, floatcomplex*, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cgegv_ __P((const char*, const char*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, const int, const int));
extern void cgehrd __P((const int, const int, const int, floatcomplex*, const int, floatcomplex*, int*));
extern void cgehrd_ __P((const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, int*));
extern void cgelqf __P((const int, const int, floatcomplex*, const int, floatcomplex*, int*));
extern void cgelqf_ __P((const int*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, int*));
extern void cgelsd __P((const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, float*, const float, int*, int*));
extern void cgelsd_ __P((const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, const float*, int*, floatcomplex*, const int*, float*, int*, int*));
extern void cgelss __P((const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, float*, const float, int*, int*));
extern void cgelss_ __P((const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, const float*, int*, floatcomplex*, const int*, float*, int*));
extern void cgelsx __P((const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, int*, const float, int*, int*));
extern void cgelsx_ __P((const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const float*, int*, floatcomplex*, float*, int*));
extern void cgelsy __P((const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, int*, const float, int*, int*));
extern void cgelsy_ __P((const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const float*, int*, floatcomplex*, const int*, float*, int*));
extern void cgels __P((const char, const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cgels_ __P((const char*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int));
extern void cgemm __P((const char, const char, const int, const int, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cgemm_ __P((const char*, const char*, const int*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, const int, const int));
extern void cgemv __P((const char, const int, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cgemv_ __P((const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, const int));
extern void cgeqlf __P((const int, const int, floatcomplex*, const int, floatcomplex*, int*));
extern void cgeqlf_ __P((const int*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, int*));
extern void cgeqp3 __P((const int, const int, floatcomplex*, const int, int*, floatcomplex*, int*));
extern void cgeqp3_ __P((const int*, const int*, floatcomplex*, const int*, int*, floatcomplex*, floatcomplex*, const int*, float*, int*));
extern void cgeqpf __P((const int, const int, floatcomplex*, const int, int*, floatcomplex*, int*));
extern void cgeqpf_ __P((const int*, const int*, floatcomplex*, const int*, int*, floatcomplex*, floatcomplex*, float*, int*));
extern void cgeqrf __P((const int, const int, floatcomplex*, const int, floatcomplex*, int*));
extern void cgeqrf_ __P((const int*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, int*));
extern void cgerc __P((const int, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, floatcomplex*, const int));
extern void cgerc_ __P((const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*));
extern void cgerfs __P((const char, const int, const int, const floatcomplex*, const int, const floatcomplex*, const int, const int*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, int*));
extern void cgerfs_ __P((const char*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int));
extern void cgerqf __P((const int, const int, floatcomplex*, const int, floatcomplex*, int*));
extern void cgerqf_ __P((const int*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, int*));
extern void cgeru __P((const int, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, floatcomplex*, const int));
extern void cgeru_ __P((const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*));
extern void cgesdd __P((const char, const int, const int, floatcomplex*, const int, float*, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cgesdd_ __P((const char*, const int*, const int*, floatcomplex*, const int*, float*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, int*, const int));
extern void cgesvd __P((const char, const char, const int, const int, floatcomplex*, const int, float*, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cgesvd_ __P((const char*, const char*, const int*, const int*, floatcomplex*, const int*, float*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, const int, const int));
extern void cgesvx __P((const char, const char, const int, const int, floatcomplex*, const int, floatcomplex*, const int, int*, char*, float*, float*, floatcomplex*, const int, floatcomplex*, const int, float*, float*, float*, int*));
extern void cgesvx_ __P((const char*, const char*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, char*, float*, float*, floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, float*, floatcomplex*, float*, int*, const int, const int, const int));
extern void cgesv __P((const int, const int, floatcomplex*, const int, int*, floatcomplex*, const int, int*));
extern void cgesv_ __P((const int*, const int*, floatcomplex*, const int*, int*, floatcomplex*, const int*, int*));
extern void cgetf2 __P((const int, const int, floatcomplex*, const int, int*, int*));
extern void cgetf2_ __P((const int*, const int*, floatcomplex*, const int*, int*, int*));
extern void cgetrf __P((const int, const int, floatcomplex*, const int, int*, int*));
extern void cgetrf_ __P((const int*, const int*, floatcomplex*, const int*, int*, int*));
extern void cgetri __P((const int, floatcomplex*, const int, const int*, int*));
extern void cgetri_ __P((const int*, floatcomplex*, const int*, const int*, floatcomplex*, const int*, int*));
extern void cgetrs __P((const char, const int, const int, const floatcomplex*, const int, const int*, floatcomplex*, const int, int*));
extern void cgetrs_ __P((const char*, const int*, const int*, const floatcomplex*, const int*, const int*, floatcomplex*, const int*, int*, const int));
extern void cggbak __P((const char, const char, const int, const int, const int, const float*, const float*, const int, floatcomplex*, const int, int*));
extern void cggbak_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const float*, const int*, floatcomplex*, const int*, int*, const int, const int));
extern void cggbal __P((const char, const int, floatcomplex*, const int, floatcomplex*, const int, int*, int*, const float*, const float*, int*));
extern void cggbal_ __P((const char*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, int*, const float*, const float*, float*, int*, const int));
extern void cggesx __P((const char, const char, const char, const int(*selctg)(floatcomplex*,floatcomplex*), const char, const int, floatcomplex*, const int, floatcomplex*, const int, int*, floatcomplex*, floatcomplex*, floatcomplex*, const int, floatcomplex*, const int, float*, float*, int*));
extern void cggesx_ __P((const char*, const char*, const char*, const int(*selctg)(floatcomplex*,floatcomplex*), const char*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, floatcomplex*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, const int*, float*, int*, const int*, int*, int*, const int, const int, const int, const int));
extern void cgges __P((const char, const char, const char, const int(*selctg)(floatcomplex*,floatcomplex*), const int, floatcomplex*, const int, floatcomplex*, const int, int*, floatcomplex*, floatcomplex*, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cgges_ __P((const char*, const char*, const char*, const int(*selctg)(floatcomplex*,floatcomplex*), const int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, floatcomplex*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, int*, const int, const int, const int));
extern void cggevx __P((const char, const char, const char, const char, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, floatcomplex*, floatcomplex*, const int, floatcomplex*, const int, int*, int*, float*, float*, float*, float*, float*, float*, int*));
extern void cggevx_ __P((const char*, const char*, const char*, const char*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, int*, int*, float*, float*, float*, float*, float*, float*, floatcomplex*, const int*, float*, int*, int*, int*, const int, const int, const int, const int));
extern void cggev __P((const char, const char, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, floatcomplex*, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cggev_ __P((const char*, const char*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, const int, const int));
extern void cggglm __P((const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, floatcomplex*, floatcomplex*, int*));
extern void cggglm_ __P((const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, const int*, int*));
extern void cgghrd __P((const char, const char, const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cgghrd_ __P((const char*, const char*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int, const int));
extern void cgglse __P((const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, floatcomplex*, floatcomplex*, int*));
extern void cgglse_ __P((const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, const int*, int*));
extern void cggqrf __P((const int, const int, const int, floatcomplex*, const int, floatcomplex*, floatcomplex*, const int, floatcomplex*, int*));
extern void cggqrf_ __P((const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, int*));
extern void cggrqf __P((const int, const int, const int, floatcomplex*, const int, floatcomplex*, floatcomplex*, const int, floatcomplex*, int*));
extern void cggrqf_ __P((const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, int*));
extern void cggsvd __P((const char, const char, const char, const int, const int, const int, int*, int*, floatcomplex*, const int, floatcomplex*, const int, float*, float*, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, const int, int*, int*));
extern void cggsvd_ __P((const char*, const char*, const char*, const int*, const int*, const int*, int*, int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, float*, int*, int*, const int, const int, const int));
extern void cggsvp __P((const char, const char, const char, const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, const float, const float, int*, int*, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cggsvp_ __P((const char*, const char*, const char*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, const float*, const float*, int*, int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, float*, floatcomplex*, floatcomplex*, int*, const int, const int, const int));
extern void cgssco_ __P((float*, double*, int*));
extern void cgssda_ __P((double*, int*));
extern void cgssfa_ __P((const int*, const int*, const int*, const floatcomplex*, double*, int*));
extern void cgssfs_ __P((const char*, const char*, const int*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, const char*, const int*, const int*, double*, int*, const int, const int, const int));
extern void cgssin_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const int*, double*, int*, const int, const int));
extern void cgssor_ __P((const char*, double*, int*, const int));
extern void cgssps_ __P((double*, int*));
extern void cgssrp_ __P((int*, double*, int*));
extern void cgsssl_ __P((const int*, floatcomplex*, const int*, double*, int*));
extern void cgssuo_ __P((const int*, double*, int*));
extern void cgtcon __P((const char, const int, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int*, const float, float*, int*));
extern void cgtcon_ __P((const char*, const int*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int*, const float*, float*, floatcomplex*, int*, const int));
extern void cgthrz __P((const int, floatcomplex*, floatcomplex*, const int*));
extern void cgthrz_ __P((const int*, floatcomplex*, floatcomplex*, const int*));
extern void cgthr __P((const int, const floatcomplex*, floatcomplex*, const int*));
extern void cgthr_ __P((const int*, const floatcomplex*, floatcomplex*, const int*));
extern void cgtrfs __P((const char, const int, const int, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, int*));
extern void cgtrfs_ __P((const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int));
extern void cgtsvx __P((const char, const char, const int, const int, const floatcomplex*, const floatcomplex*, const floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, int*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, float*, int*));
extern void cgtsvx_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, float*, floatcomplex*, float*, int*, const int, const int));
extern void cgtsv __P((const int, const int, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, const int, int*));
extern void cgtsv_ __P((const int*, const int*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, const int*, int*));
extern void cgttrf __P((const int, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, int*, int*));
extern void cgttrf_ __P((const int*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, int*, int*));
extern void cgttrs __P((const char, const int, const int, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int*, floatcomplex*, const int, int*));
extern void cgttrs_ __P((const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int*, floatcomplex*, const int*, int*, const int));
extern void chbevd __P((const char, const char, const int, const int, floatcomplex*, const int, float*, floatcomplex*, const int, int*));
extern void chbevd_ __P((const char*, const char*, const int*, const int*, floatcomplex*, const int*, float*, floatcomplex*, const int*, floatcomplex*, const int*, float*, const int*, int*, const int*, int*, const int, const int));
extern void chbevx __P((const char, const char, const char, const int, const int, floatcomplex*, const int, floatcomplex*, const int, const float, const float, const int, const int, const float, int*, float*, floatcomplex*, const int, int*, int*));
extern void chbevx_ __P((const char*, const char*, const char*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, const float*, const float*, const int*, const int*, const float*, int*, float*, floatcomplex*, const int*, floatcomplex*, float*, int*, int*, int*, const int, const int, const int));
extern void chbev __P((const char, const char, const int, const int, floatcomplex*, const int, float*, floatcomplex*, const int, int*));
extern void chbev_ __P((const char*, const char*, const int*, const int*, floatcomplex*, const int*, float*, floatcomplex*, const int*, floatcomplex*, float*, int*, const int, const int));
extern void chbgst __P((const char, const char, const int, const int, const int, floatcomplex*, const int, const floatcomplex*, const int, floatcomplex*, const int, int*));
extern void chbgst_ __P((const char*, const char*, const int*, const int*, const int*, floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, float*, int*, const int, const int));
extern void chbgvd __P((const char, const char, const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, float*, floatcomplex*, const int, int*));
extern void chbgvd_ __P((const char*, const char*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, floatcomplex*, const int*, floatcomplex*, const int*, float*, const int*, int*, const int*, int*, const int, const int));
extern void chbgvx __P((const char, const char, const char, const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, const int, const float, const float, const int, const int, const float, int*, float*, floatcomplex*, const int, int*, int*));
extern void chbgvx_ __P((const char*, const char*, const char*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, const float*, const float*, const int*, const int*, const float*, int*, float*, floatcomplex*, const int*, floatcomplex*, float*, int*, int*, int*, const int, const int, const int));
extern void chbgv __P((const char, const char, const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, float*, floatcomplex*, const int, int*));
extern void chbgv_ __P((const char*, const char*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, floatcomplex*, const int*, floatcomplex*, float*, int*, const int, const int));
extern void chbmv __P((const char, const int, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void chbmv_ __P((const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, const int));
extern void chbtrd __P((const char, const char, const int, const int, floatcomplex*, const int, float*, float*, floatcomplex*, const int, int*));
extern void chbtrd_ __P((const char*, const char*, const int*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, const int*, floatcomplex*, int*, const int, const int));
extern void checon __P((const char, const int, const floatcomplex*, const int, const int*, const float, float*, int*));
extern void checon_ __P((const char*, const int*, const floatcomplex*, const int*, const int*, const float*, float*, floatcomplex*, int*, const int));
extern void cheevd __P((const char, const char, const int, floatcomplex*, const int, float*, int*));
extern void cheevd_ __P((const char*, const char*, const int*, floatcomplex*, const int*, float*, floatcomplex*, const int*, float*, const int*, int*, const int*, int*, const int, const int));
extern void cheevr __P((const char, const char, const char, const int, floatcomplex*, const int, const float, const float, const int, const int, const float, int*, float*, floatcomplex*, const int, int*, int*));
extern void cheevr_ __P((const char*, const char*, const char*, const int*, floatcomplex*, const int*, const float*, const float*, const int*, const int*, const float*, int*, float*, floatcomplex*, const int*, int*, floatcomplex*, const int*, float*, const int*, int*, const int*, int*, const int, const int, const int));
extern void cheevx __P((const char, const char, const char, const int, floatcomplex*, const int, const float, const float, const int, const int, const float, int*, float*, floatcomplex*, const int, int*, int*));
extern void cheevx_ __P((const char*, const char*, const char*, const int*, floatcomplex*, const int*, const float*, const float*, const int*, const int*, const float*, int*, float*, floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, int*, int*, const int, const int, const int));
extern void cheev __P((const char, const char, const int, floatcomplex*, const int, float*, int*));
extern void cheev_ __P((const char*, const char*, const int*, floatcomplex*, const int*, float*, floatcomplex*, const int*, float*, int*, const int, const int));
extern void chegs2 __P((const int, const char, const int, floatcomplex*, const int, const floatcomplex*, const int, int*));
extern void chegs2_ __P((const int*, const char*, const int*, floatcomplex*, const int*, const floatcomplex*, const int*, int*, const int));
extern void chegst __P((const int, const char, const int, floatcomplex*, const int, const floatcomplex*, const int, int*));
extern void chegst_ __P((const int*, const char*, const int*, floatcomplex*, const int*, const floatcomplex*, const int*, int*, const int));
extern void chegvd __P((const int, const char, const char, const int, floatcomplex*, const int, floatcomplex*, const int, float*, int*));
extern void chegvd_ __P((const int*, const char*, const char*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, floatcomplex*, const int*, float*, const int*, int*, const int*, int*, const int, const int));
extern void chegvx __P((const int, const char, const char, const char, const int, floatcomplex*, const int, floatcomplex*, const int, const float, const float, const int, const int, const float, int*, float*, floatcomplex*, const int, int*, int*));
extern void chegvx_ __P((const int*, const char*, const char*, const char*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, const float*, const float*, const int*, const int*, const float*, int*, float*, floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, int*, int*, const int, const int, const int));
extern void chegv __P((const int, const char, const char, const int, floatcomplex*, const int, floatcomplex*, const int, float*, int*));
extern void chegv_ __P((const int*, const char*, const char*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, floatcomplex*, const int*, float*, int*, const int, const int));
extern void chemm __P((const char, const char, const int, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void chemm_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, const int, const int));
extern void chemv __P((const char, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void chemv_ __P((const char*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, const int));
extern void cher2k __P((const char, const char, const int, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, const float, floatcomplex*, const int));
extern void cher2k_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const float*, floatcomplex*, const int*, const int, const int));
extern void cher2 __P((const char, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, floatcomplex*, const int));
extern void cher2_ __P((const char*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, const int));
extern void cherfs __P((const char, const int, const int, const floatcomplex*, const int, const floatcomplex*, const int, const int*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, int*));
extern void cherfs_ __P((const char*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int));
extern void cherk __P((const char, const char, const int, const int, const float, const floatcomplex*, const int, const float, floatcomplex*, const int));
extern void cherk_ __P((const char*, const char*, const int*, const int*, const float*, const floatcomplex*, const int*, const float*, floatcomplex*, const int*, const int, const int));
extern void cher __P((const char, const int, const float, const floatcomplex*, const int, floatcomplex*, const int));
extern void cher_ __P((const char*, const int*, const float*, const floatcomplex*, const int*, floatcomplex*, const int*, const int));
extern void chesvx __P((const char, const char, const int, const int, const floatcomplex*, const int, floatcomplex*, const int, int*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, float*, int*));
extern void chesvx_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, float*, floatcomplex*, const int*, float*, int*, const int, const int));
extern void chesv __P((const char, const int, const int, floatcomplex*, const int, int*, floatcomplex*, const int, int*));
extern void chesv_ __P((const char*, const int*, const int*, floatcomplex*, const int*, int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int));
extern void chetf2 __P((const char, const int, floatcomplex*, const int, int*, int*));
extern void chetf2_ __P((const char*, const int*, floatcomplex*, const int*, int*, int*, const int));
extern void chetrd __P((const char, const int, floatcomplex*, const int, float*, float*, floatcomplex*, int*));
extern void chetrd_ __P((const char*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, floatcomplex*, const int*, int*, const int));
extern void chetrf __P((const char, const int, floatcomplex*, const int, int*, int*));
extern void chetrf_ __P((const char*, const int*, floatcomplex*, const int*, int*, floatcomplex*, const int*, int*, const int));
extern void chetri __P((const char, const int, floatcomplex*, const int, const int*, int*));
extern void chetri_ __P((const char*, const int*, floatcomplex*, const int*, const int*, floatcomplex*, int*, const int));
extern void chetrs __P((const char, const int, const int, const floatcomplex*, const int, const int*, floatcomplex*, const int, int*));
extern void chetrs_ __P((const char*, const int*, const int*, const floatcomplex*, const int*, const int*, floatcomplex*, const int*, int*, const int));
extern void chgeqz __P((const char, const char, const char, const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, floatcomplex*, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void chgeqz_ __P((const char*, const char*, const char*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, const int, const int, const int));
extern void chpcon __P((const char, const int, const floatcomplex*, const int*, const float, float*, int*));
extern void chpcon_ __P((const char*, const int*, const floatcomplex*, const int*, const float*, float*, floatcomplex*, int*, const int));
extern void chpevd __P((const char, const char, const int, floatcomplex*, float*, floatcomplex*, const int, int*));
extern void chpevd_ __P((const char*, const char*, const int*, floatcomplex*, float*, floatcomplex*, const int*, floatcomplex*, const int*, float*, const int*, int*, const int*, int*, const int, const int));
extern void chpevx __P((const char, const char, const char, const int, floatcomplex*, const float, const float, const int, const int, const float, int*, float*, floatcomplex*, const int, int*, int*));
extern void chpevx_ __P((const char*, const char*, const char*, const int*, floatcomplex*, const float*, const float*, const int*, const int*, const float*, int*, float*, floatcomplex*, const int*, floatcomplex*, float*, int*, int*, int*, const int, const int, const int));
extern void chpev __P((const char, const char, const int, floatcomplex*, float*, floatcomplex*, const int, int*));
extern void chpev_ __P((const char*, const char*, const int*, floatcomplex*, float*, floatcomplex*, const int*, floatcomplex*, float*, int*, const int, const int));
extern void chpgst __P((const int, const char, const int, floatcomplex*, const floatcomplex*, int*));
extern void chpgst_ __P((const int*, const char*, const int*, floatcomplex*, const floatcomplex*, int*, const int));
extern void chpgvd __P((const int, const char, const char, const int, floatcomplex*, floatcomplex*, float*, floatcomplex*, const int, int*));
extern void chpgvd_ __P((const int*, const char*, const char*, const int*, floatcomplex*, floatcomplex*, float*, floatcomplex*, const int*, floatcomplex*, const int*, float*, const int*, int*, const int*, int*, const int, const int));
extern void chpgvx __P((const int, const char, const char, const char, const int, floatcomplex*, floatcomplex*, const float, const float, const int, const int, const float, int*, float*, floatcomplex*, const int, int*, int*));
extern void chpgvx_ __P((const int*, const char*, const char*, const char*, const int*, floatcomplex*, floatcomplex*, const float*, const float*, const int*, const int*, const float*, int*, float*, floatcomplex*, const int*, floatcomplex*, float*, int*, int*, int*, const int, const int, const int));
extern void chpgv __P((const int, const char, const char, const int, floatcomplex*, floatcomplex*, float*, floatcomplex*, const int, int*));
extern void chpgv_ __P((const int*, const char*, const char*, const int*, floatcomplex*, floatcomplex*, float*, floatcomplex*, const int*, floatcomplex*, float*, int*, const int, const int));
extern void chpmv __P((const char, const int, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void chpmv_ __P((const char*, const int*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, const int));
extern void chpr2 __P((const char, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, floatcomplex*));
extern void chpr2_ __P((const char*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int));
extern void chprfs __P((const char, const int, const int, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, int*));
extern void chprfs_ __P((const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int));
extern void chpr __P((const char, const int, const float, const floatcomplex*, const int, floatcomplex*));
extern void chpr_ __P((const char*, const int*, const float*, const floatcomplex*, const int*, floatcomplex*, const int));
extern void chpsvx __P((const char, const char, const int, const int, const floatcomplex*, floatcomplex*, int*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, float*, int*));
extern void chpsvx_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, floatcomplex*, int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, float*, floatcomplex*, float*, int*, const int, const int));
extern void chpsv __P((const char, const int, const int, floatcomplex*, int*, floatcomplex*, const int, int*));
extern void chpsv_ __P((const char*, const int*, const int*, floatcomplex*, int*, floatcomplex*, const int*, int*, const int));
extern void chptrd __P((const char, const int, floatcomplex*, float*, float*, floatcomplex*, int*));
extern void chptrd_ __P((const char*, const int*, floatcomplex*, float*, float*, floatcomplex*, int*, const int));
extern void chptrf __P((const char, const int, floatcomplex*, int*, int*));
extern void chptrf_ __P((const char*, const int*, floatcomplex*, int*, int*, const int));
extern void chptri __P((const char, const int, floatcomplex*, const int*, int*));
extern void chptri_ __P((const char*, const int*, floatcomplex*, const int*, floatcomplex*, int*, const int));
extern void chptrs __P((const char, const int, const int, const floatcomplex*, const int*, floatcomplex*, const int, int*));
extern void chptrs_ __P((const char*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, int*, const int));
extern void chsein __P((const char, const char, const char, const int*, const int, const floatcomplex*, const int, floatcomplex*, floatcomplex*, const int, floatcomplex*, const int, const int, int*, int*, int*, int*));
extern void chsein_ __P((const char*, const char*, const char*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, const int*, int*, floatcomplex*, float*, int*, int*, int*, const int, const int, const int));
extern void chseqr __P((const char, const char, const int, const int, const int, floatcomplex*, const int, floatcomplex*, floatcomplex*, const int, int*));
extern void chseqr_ __P((const char*, const char*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int, const int));
extern void cjadmm __P((const int, const int, const int, const int, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int, const int*, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cjadmm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cjadrp __P((const int, const int, const int, const floatcomplex*, const int*, int*, const int, const int*));
extern void cjadrp_ __P((const int*, const int*, const int*, const floatcomplex*, const int*, int*, const int*, const int*, int*, const int*));
extern void cjadsm __P((const int, const int, const int, const int, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int, const int*, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cjadsm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern floatcomplex cladiv __P((const floatcomplex*, const floatcomplex*));
extern void clarzb __P((const char, const char, const char, const char, const int, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, const int, floatcomplex*, const int, const int));
extern void clarzb_ __P((const char*, const char*, const char*, const char*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, const int, const int, const int, const int));
extern void clarzt __P((const char, const char, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void clarzt_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, const int, const int));
extern void clarz __P((const char, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void clarz_ __P((const char*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int));
extern void clatzm __P((const char, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, floatcomplex*, const int));
extern void clatzm_ __P((const char*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int));
extern void cosqb __P((const int, float*, const float*));
extern void cosqb_ __P((const int*, float*, const float*));
extern void cosqf __P((const int, float*, const float*));
extern void cosqf_ __P((const int*, float*, const float*));
extern void cosqi __P((const int, float*));
extern void cosqi_ __P((const int*, float*));
extern void costi __P((const int, float*));
extern void costi_ __P((const int*, float*));
extern void cost __P((const int, float*, const float*));
extern void cost_ __P((const int*, float*, const float*));
extern void cpbcon __P((const char, const int, const int, const floatcomplex*, const int, const float, float*, int*));
extern void cpbcon_ __P((const char*, const int*, const int*, const floatcomplex*, const int*, const float*, float*, floatcomplex*, float*, int*, const int));
extern void cpbequ __P((const char, const int, const int, const floatcomplex*, const int, float*, float*, float*, int*));
extern void cpbequ_ __P((const char*, const int*, const int*, const floatcomplex*, const int*, float*, float*, float*, int*, const int));
extern void cpbrfs __P((const char, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, int*));
extern void cpbrfs_ __P((const char*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int));
extern void cpbstf __P((const char, const int, const int, floatcomplex*, const int, int*));
extern void cpbstf_ __P((const char*, const int*, const int*, floatcomplex*, const int*, int*, const int));
extern void cpbsvx __P((const char, const char, const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, char*, float*, floatcomplex*, const int, floatcomplex*, const int, float*, float*, float*, int*));
extern void cpbsvx_ __P((const char*, const char*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, char*, float*, floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, float*, floatcomplex*, float*, int*, const int, const int, const int));
extern void cpbsv __P((const char, const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cpbsv_ __P((const char*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int));
extern void cpbtf2 __P((const char, const int, const int, floatcomplex*, const int, int*));
extern void cpbtf2_ __P((const char*, const int*, const int*, floatcomplex*, const int*, int*, const int));
extern void cpbtrf __P((const char, const int, const int, floatcomplex*, const int, int*));
extern void cpbtrf_ __P((const char*, const int*, const int*, floatcomplex*, const int*, int*, const int));
extern void cpbtrs __P((const char, const int, const int, const int, const floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cpbtrs_ __P((const char*, const int*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, int*, const int));
extern void cpocon __P((const char, const int, const floatcomplex*, const int, const float, float*, int*));
extern void cpocon_ __P((const char*, const int*, const floatcomplex*, const int*, const float*, float*, floatcomplex*, float*, int*, const int));
extern void cpoequ __P((const int, const floatcomplex*, const int, float*, float*, float*, int*));
extern void cpoequ_ __P((const int*, const floatcomplex*, const int*, float*, float*, float*, int*));
extern void cporfs __P((const char, const int, const int, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, int*));
extern void cporfs_ __P((const char*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int));
extern void cposvx __P((const char, const char, const int, const int, floatcomplex*, const int, floatcomplex*, const int, char*, float*, floatcomplex*, const int, floatcomplex*, const int, float*, float*, float*, int*));
extern void cposvx_ __P((const char*, const char*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, char*, float*, floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, float*, floatcomplex*, float*, int*, const int, const int, const int));
extern void cposv __P((const char, const int, const int, floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cposv_ __P((const char*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int));
extern void cpotf2 __P((const char, const int, floatcomplex*, const int, int*));
extern void cpotf2_ __P((const char*, const int*, floatcomplex*, const int*, int*, const int));
extern void cpotrf __P((const char, const int, floatcomplex*, const int, int*));
extern void cpotrf_ __P((const char*, const int*, floatcomplex*, const int*, int*, const int));
extern void cpotri __P((const char, const int, floatcomplex*, const int, int*));
extern void cpotri_ __P((const char*, const int*, floatcomplex*, const int*, int*, const int));
extern void cpotrs __P((const char, const int, const int, const floatcomplex*, const int, floatcomplex*, const int, int*));
extern void cpotrs_ __P((const char*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, int*, const int));
extern void cppcon __P((const char, const int, const floatcomplex*, const float, float*, int*));
extern void cppcon_ __P((const char*, const int*, const floatcomplex*, const float*, float*, floatcomplex*, float*, int*, const int));
extern void cppequ __P((const char, const int, const floatcomplex*, float*, float*, float*, int*));
extern void cppequ_ __P((const char*, const int*, const floatcomplex*, float*, float*, float*, int*, const int));
extern void cpprfs __P((const char, const int, const int, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, int*));
extern void cpprfs_ __P((const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int));
extern void cppsvx __P((const char, const char, const int, const int, floatcomplex*, floatcomplex*, char*, float*, floatcomplex*, const int, floatcomplex*, const int, float*, float*, float*, int*));
extern void cppsvx_ __P((const char*, const char*, const int*, const int*, floatcomplex*, floatcomplex*, char*, float*, floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, float*, floatcomplex*, float*, int*, const int, const int, const int));
extern void cppsv __P((const char, const int, const int, floatcomplex*, floatcomplex*, const int, int*));
extern void cppsv_ __P((const char*, const int*, const int*, floatcomplex*, floatcomplex*, const int*, int*, const int));
extern void cpptrf __P((const char, const int, floatcomplex*, int*));
extern void cpptrf_ __P((const char*, const int*, floatcomplex*, int*, const int));
extern void cpptri __P((const char, const int, floatcomplex*, int*));
extern void cpptri_ __P((const char*, const int*, floatcomplex*, int*, const int));
extern void cpptrs __P((const char, const int, const int, const floatcomplex*, floatcomplex*, const int, int*));
extern void cpptrs_ __P((const char*, const int*, const int*, const floatcomplex*, floatcomplex*, const int*, int*, const int));
extern void cptcon __P((const int, const float*, const floatcomplex*, const float, float*, int*));
extern void cptcon_ __P((const int*, const float*, const floatcomplex*, const float*, float*, float*, int*));
extern void cpteqr __P((const char, const int, float*, float*, floatcomplex*, const int, int*));
extern void cpteqr_ __P((const char*, const int*, float*, float*, floatcomplex*, const int*, float*, int*, const int));
extern void cptrfs __P((const char, const int, const int, const float*, const floatcomplex*, const float*, const floatcomplex*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, int*));
extern void cptrfs_ __P((const char*, const int*, const int*, const float*, const floatcomplex*, const float*, const floatcomplex*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int));
extern void cptsvx __P((const char, const int, const int, const float*, const floatcomplex*, float*, floatcomplex*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, float*, int*));
extern void cptsvx_ __P((const char*, const int*, const int*, const float*, const floatcomplex*, float*, floatcomplex*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, float*, floatcomplex*, float*, int*, const int));
extern void cptsv __P((const int, const int, float*, floatcomplex*, floatcomplex*, const int, int*));
extern void cptsv_ __P((const int*, const int*, float*, floatcomplex*, floatcomplex*, const int*, int*));
extern void cpttrf __P((const int, float*, floatcomplex*, int*));
extern void cpttrf_ __P((const int*, float*, floatcomplex*, int*));
extern void cpttrs __P((const char, const int, const int, const float*, floatcomplex*, floatcomplex*, const int, int*));
extern void cpttrs_ __P((const char*, const int*, const int*, const float*, floatcomplex*, floatcomplex*, const int*, int*, const int));
extern void cptts2 __P((const int, const int, const int, const float*, const floatcomplex*, floatcomplex*, const int));
extern void cptts2_ __P((const int*, const int*, const int*, const float*, const floatcomplex*, floatcomplex*, const int*));
extern void crotg __P((floatcomplex*, const floatcomplex*, float*, floatcomplex*));
extern void crotg_ __P((floatcomplex*, const floatcomplex*, float*, floatcomplex*));
extern void crot __P((const int, floatcomplex*, const int, floatcomplex*, const int, const float, const floatcomplex*));
extern void crot_ __P((const int*, floatcomplex*, const int*, floatcomplex*, const int*, const float*, const floatcomplex*));
extern void cscal __P((const int, const floatcomplex*, floatcomplex*, const int));
extern void cscal_ __P((const int*, const floatcomplex*, floatcomplex*, const int*));
extern void csctr __P((const int, const floatcomplex*, const int*, floatcomplex*));
extern void csctr_ __P((const int*, const floatcomplex*, const int*, floatcomplex*));
extern void cskymm __P((const int, const int, const int, const int, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cskymm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cskysm __P((const int, const int, const int, const int, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cskysm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cspcon __P((const char, const int, const floatcomplex*, const int*, const float, float*, int*));
extern void cspcon_ __P((const char*, const int*, const floatcomplex*, const int*, const float*, float*, floatcomplex*, int*, const int));
extern void cspmv __P((const char, const int, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cspmv_ __P((const char*, const int*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, const int));
extern void csprfs __P((const char, const int, const int, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, int*));
extern void csprfs_ __P((const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int));
extern void cspsvx __P((const char, const char, const int, const int, const floatcomplex*, floatcomplex*, int*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, float*, int*));
extern void cspsvx_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, floatcomplex*, int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, float*, floatcomplex*, float*, int*, const int, const int));
extern void cspsv __P((const char, const int, const int, floatcomplex*, int*, floatcomplex*, const int, int*));
extern void cspsv_ __P((const char*, const int*, const int*, floatcomplex*, int*, floatcomplex*, const int*, int*, const int));
extern void csptrf __P((const char, const int, floatcomplex*, int*, int*));
extern void csptrf_ __P((const char*, const int*, floatcomplex*, int*, int*, const int));
extern void csptri __P((const char, const int, floatcomplex*, const int*, int*));
extern void csptri_ __P((const char*, const int*, floatcomplex*, const int*, floatcomplex*, int*, const int));
extern void csptrs __P((const char, const int, const int, const floatcomplex*, const int*, floatcomplex*, const int, int*));
extern void csptrs_ __P((const char*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, int*, const int));
extern void csrot __P((const int, floatcomplex*, const int, floatcomplex*, const int, const float, const float));
extern void csrot_ __P((const int*, floatcomplex*, const int*, floatcomplex*, const int*, const float*, const float*));
extern void csscal __P((const int, const float, floatcomplex*, const int));
extern void csscal_ __P((const int*, const float*, floatcomplex*, const int*));
extern void cstedc __P((const char, const int, float*, float*, floatcomplex*, const int, int*));
extern void cstedc_ __P((const char*, const int*, float*, float*, floatcomplex*, const int*, floatcomplex*, const int*, float*, const int*, int*, const int*, int*, const int));
extern void cstegr __P((const char, const char, const int, float*, float*, const float, const float, const int, const int, const float, int*, float*, floatcomplex*, const int, int*, int*));
extern void cstegr_ __P((const char*, const char*, const int*, float*, float*, const float*, const float*, const int*, const int*, const float*, int*, float*, floatcomplex*, const int*, int*, float*, const int*, int*, const int*, int*, const int, const int));
extern void cstein __P((const int, const float*, const float*, const int, const float*, const int*, const int*, floatcomplex*, const int, int*, int*));
extern void cstein_ __P((const int*, const float*, const float*, const int*, const float*, const int*, const int*, floatcomplex*, const int*, float*, int*, int*, int*));
extern void csteqr __P((const char, const int, float*, float*, floatcomplex*, const int, int*));
extern void csteqr_ __P((const char*, const int*, float*, float*, floatcomplex*, const int*, float*, int*, const int));
extern void cstsv __P((const int, const int, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, const int, int*, int*));
extern void cstsv_ __P((const int*, const int*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, const int*, int*, int*));
extern void csttrf __P((const int, floatcomplex*, floatcomplex*, floatcomplex*, int*, int*));
extern void csttrf_ __P((const int*, floatcomplex*, floatcomplex*, floatcomplex*, int*, int*));
extern void csttrs __P((const int, const int, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int, int*, int*));
extern void csttrs_ __P((const int*, const int*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const int*, int*, int*));
extern void cswap __P((const int, floatcomplex*, const int, floatcomplex*, const int));
extern void cswap_ __P((const int*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void csycon __P((const char, const int, const floatcomplex*, const int, const int*, const float, float*, int*));
extern void csycon_ __P((const char*, const int*, const floatcomplex*, const int*, const int*, const float*, float*, floatcomplex*, int*, const int));
extern void csymm __P((const char, const char, const int, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void csymm_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, const int, const int));
extern void csyr2k __P((const char, const char, const int, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void csyr2k_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, const int, const int));
extern void csyrfs __P((const char, const int, const int, const floatcomplex*, const int, const floatcomplex*, const int, const int*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, int*));
extern void csyrfs_ __P((const char*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int));
extern void csyrk __P((const char, const char, const int, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void csyrk_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, const int, const int));
extern void csysvx __P((const char, const char, const int, const int, const floatcomplex*, const int, floatcomplex*, const int, int*, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, float*, int*));
extern void csysvx_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, float*, floatcomplex*, const int*, float*, int*, const int, const int));
extern void csysv __P((const char, const int, const int, floatcomplex*, const int, int*, floatcomplex*, const int, int*));
extern void csysv_ __P((const char*, const int*, const int*, floatcomplex*, const int*, int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int));
extern void csytf2 __P((const char, const int, floatcomplex*, const int, int*, int*));
extern void csytf2_ __P((const char*, const int*, floatcomplex*, const int*, int*, int*, const int));
extern void csytrf __P((const char, const int, floatcomplex*, const int, int*, int*));
extern void csytrf_ __P((const char*, const int*, floatcomplex*, const int*, int*, floatcomplex*, const int*, int*, const int));
extern void csytri __P((const char, const int, floatcomplex*, const int, const int*, int*));
extern void csytri_ __P((const char*, const int*, floatcomplex*, const int*, const int*, floatcomplex*, int*, const int));
extern void csytrs __P((const char, const int, const int, const floatcomplex*, const int, const int*, floatcomplex*, const int, int*));
extern void csytrs_ __P((const char*, const int*, const int*, const floatcomplex*, const int*, const int*, floatcomplex*, const int*, int*, const int));
extern void ctbcon __P((const char, const char, const char, const int, const int, const floatcomplex*, const int, float*, int*));
extern void ctbcon_ __P((const char*, const char*, const char*, const int*, const int*, const floatcomplex*, const int*, float*, floatcomplex*, float*, int*, const int, const int, const int));
extern void ctbmv __P((const char, const char, const char, const int, const int, const floatcomplex*, const int, floatcomplex*, const int));
extern void ctbmv_ __P((const char*, const char*, const char*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, const int, const int, const int));
extern void ctbrfs __P((const char, const char, const char, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, const int, float*, float*, int*));
extern void ctbrfs_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int, const int, const int));
extern void ctbsv __P((const char, const char, const char, const int, const int, const floatcomplex*, const int, floatcomplex*, const int));
extern void ctbsv_ __P((const char*, const char*, const char*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, const int, const int, const int));
extern void ctbtrs __P((const char, const char, const char, const int, const int, const int, const floatcomplex*, const int, floatcomplex*, const int, int*));
extern void ctbtrs_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, int*, const int, const int, const int));
extern void ctgevc __P((const char, const char, const int*, const int, const floatcomplex*, const int, const floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, const int, const int, int*, int*));
extern void ctgevc_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, const int*, int*, floatcomplex*, float*, int*, const int, const int));
extern void ctgexc __P((const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, const int, int*, int*, int*));
extern void ctgexc_ __P((const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, int*, int*, int*));
extern void ctgsen __P((const int, const int, const int, const int*, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, floatcomplex*, floatcomplex*, const int, floatcomplex*, const int, int*, float*, float*, float*, int*));
extern void ctgsen_ __P((const int*, const int*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, int*, float*, float*, float*, floatcomplex*, const int*, int*, const int*, int*));
extern void ctgsja __P((const char, const char, const char, const int, const int, const int, const int, const int, floatcomplex*, const int, floatcomplex*, const int, const float, const float, float*, float*, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, const int, int*, int*));
extern void ctgsja_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, const float*, const float*, float*, float*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, int*, int*, const int, const int, const int));
extern void ctgsna __P((const char, const char, const int*, const int, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, const int, float*, float*, const int, int*, int*));
extern void ctgsna_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, float*, float*, const int*, int*, floatcomplex*, const int*, int*, int*, const int, const int));
extern void ctgsyl __P((const char, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, const int, floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, const int, floatcomplex*, const int, float*, float*, int*));
extern void ctgsyl_ __P((const char*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, float*, floatcomplex*, const int*, int*, int*, const int));
extern void ctpcon __P((const char, const char, const char, const int, const floatcomplex*, float*, int*));
extern void ctpcon_ __P((const char*, const char*, const char*, const int*, const floatcomplex*, float*, floatcomplex*, float*, int*, const int, const int, const int));
extern void ctpmv __P((const char, const char, const char, const int, const floatcomplex*, floatcomplex*, const int));
extern void ctpmv_ __P((const char*, const char*, const char*, const int*, const floatcomplex*, floatcomplex*, const int*, const int, const int, const int));
extern void ctprfs __P((const char, const char, const char, const int, const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, float*, float*, int*));
extern void ctprfs_ __P((const char*, const char*, const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int, const int, const int));
extern void ctpsv __P((const char, const char, const char, const int, const floatcomplex*, floatcomplex*, const int));
extern void ctpsv_ __P((const char*, const char*, const char*, const int*, const floatcomplex*, floatcomplex*, const int*, const int, const int, const int));
extern void ctptri __P((const char, const char, const int, floatcomplex*, int*));
extern void ctptri_ __P((const char*, const char*, const int*, floatcomplex*, int*, const int, const int));
extern void ctptrs __P((const char, const char, const char, const int, const int, const floatcomplex*, floatcomplex*, const int, int*));
extern void ctptrs_ __P((const char*, const char*, const char*, const int*, const int*, const floatcomplex*, floatcomplex*, const int*, int*, const int, const int, const int));
extern void ctrans __P((const char, const floatcomplex*, floatcomplex*, const int, const int, floatcomplex*));
extern void ctrans_ __P((const char*, const floatcomplex*, floatcomplex*, const int*, const int*, floatcomplex*, const int));
extern void ctrcon __P((const char, const char, const char, const int, const floatcomplex*, const int, float*, int*));
extern void ctrcon_ __P((const char*, const char*, const char*, const int*, const floatcomplex*, const int*, float*, floatcomplex*, float*, int*, const int, const int, const int));
extern void ctrevc __P((const char, const char, int*, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, const int, const int, int*, int*));
extern void ctrevc_ __P((const char*, const char*, int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, const int*, int*, floatcomplex*, float*, int*, const int, const int));
extern void ctrexc __P((const char, const int, floatcomplex*, const int, floatcomplex*, const int, const int, const int, int*));
extern void ctrexc_ __P((const char*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, const int*, const int*, int*, const int));
extern void ctrmm __P((const char, const char, const char, const char, const int, const int, const floatcomplex*, const floatcomplex*, const int, floatcomplex*, const int));
extern void ctrmm_ __P((const char*, const char*, const char*, const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, floatcomplex*, const int*, const int, const int, const int, const int));
extern void ctrmv __P((const char, const char, const char, const int, const floatcomplex*, const int, floatcomplex*, const int));
extern void ctrmv_ __P((const char*, const char*, const char*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, const int, const int, const int));
extern void ctrrfs __P((const char, const char, const char, const int, const int, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, const int, float*, float*, int*));
extern void ctrrfs_ __P((const char*, const char*, const char*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, float*, float*, floatcomplex*, float*, int*, const int, const int, const int));
extern void ctrsen __P((const char, const char, const int*, const int, floatcomplex*, const int, floatcomplex*, const int, floatcomplex*, int*, float*, float*, int*));
extern void ctrsen_ __P((const char*, const char*, const int*, const int*, floatcomplex*, const int*, floatcomplex*, const int*, floatcomplex*, int*, float*, float*, floatcomplex*, const int*, int*, const int, const int));
extern void ctrsm __P((const char, const char, const char, const char, const int, const int, const floatcomplex*, const floatcomplex*, const int, floatcomplex*, const int));
extern void ctrsm_ __P((const char*, const char*, const char*, const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, floatcomplex*, const int*, const int, const int, const int, const int));
extern void ctrsna __P((const char, const char, const int*, const int, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, const int, float*, float*, const int, int*, const int, int*));
extern void ctrsna_ __P((const char*, const char*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, float*, float*, const int*, int*, floatcomplex*, const int*, float*, int*, const int, const int));
extern void ctrsv __P((const char, const char, const char, const int, const floatcomplex*, const int, floatcomplex*, const int));
extern void ctrsv_ __P((const char*, const char*, const char*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, const int, const int, const int));
extern void ctrsyl __P((const char, const char, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, const int, floatcomplex*, const int, float*, int*));
extern void ctrsyl_ __P((const char*, const char*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, float*, int*, const int, const int));
extern void ctrti2 __P((const char, const char, const int, floatcomplex*, const int, int*));
extern void ctrti2_ __P((const char*, const char*, const int*, floatcomplex*, const int*, int*, const int, const int));
extern void ctrtri __P((const char, const char, const int, floatcomplex*, const int, int*));
extern void ctrtri_ __P((const char*, const char*, const int*, floatcomplex*, const int*, int*, const int, const int));
extern void ctrtrs __P((const char, const char, const char, const int, const int, const floatcomplex*, const int, floatcomplex*, const int, int*));
extern void ctrtrs_ __P((const char*, const char*, const char*, const int*, const int*, const floatcomplex*, const int*, floatcomplex*, const int*, int*, const int, const int, const int));
extern void ctzrqf __P((const int, const int, floatcomplex*, const int, floatcomplex*, int*));
extern void ctzrqf_ __P((const int*, const int*, floatcomplex*, const int*, floatcomplex*, int*));
extern void ctzrzf __P((const int, const int, floatcomplex*, const int, floatcomplex*, int*));
extern void ctzrzf_ __P((const int*, const int*, floatcomplex*, const int*, floatcomplex*, floatcomplex*, const int*, int*));
extern void cung2l __P((const int, const int, const int, floatcomplex*, const int, const floatcomplex*, int*));
extern void cung2l_ __P((const int*, const int*, const int*, floatcomplex*, const int*, const floatcomplex*, floatcomplex*, int*));
extern void cung2r __P((const int, const int, const int, floatcomplex*, const int, const floatcomplex*, int*));
extern void cung2r_ __P((const int*, const int*, const int*, floatcomplex*, const int*, const floatcomplex*, floatcomplex*, int*));
extern void cungbr __P((const char, const int, const int, const int, floatcomplex*, const int, const floatcomplex*, int*));
extern void cungbr_ __P((const char*, const int*, const int*, const int*, floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, int*, const int));
extern void cunghr __P((const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, int*));
extern void cunghr_ __P((const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, int*));
extern void cungl2 __P((const int, const int, const int, floatcomplex*, const int, const floatcomplex*, int*));
extern void cungl2_ __P((const int*, const int*, const int*, floatcomplex*, const int*, const floatcomplex*, floatcomplex*, int*));
extern void cunglq __P((const int, const int, const int, floatcomplex*, const int, const floatcomplex*, int*));
extern void cunglq_ __P((const int*, const int*, const int*, floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, int*));
extern void cungql __P((const int, const int, const int, floatcomplex*, const int, const floatcomplex*, int*));
extern void cungql_ __P((const int*, const int*, const int*, floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, int*));
extern void cungqr __P((const int, const int, const int, floatcomplex*, const int, const floatcomplex*, int*));
extern void cungqr_ __P((const int*, const int*, const int*, floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, int*));
extern void cungr2 __P((const int, const int, const int, floatcomplex*, const int, const floatcomplex*, int*));
extern void cungr2_ __P((const int*, const int*, const int*, floatcomplex*, const int*, const floatcomplex*, floatcomplex*, int*));
extern void cungrq __P((const int, const int, const int, floatcomplex*, const int, const floatcomplex*, int*));
extern void cungrq_ __P((const int*, const int*, const int*, floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, int*));
extern void cungtr __P((const char, const int, floatcomplex*, const int, const floatcomplex*, int*));
extern void cungtr_ __P((const char*, const int*, floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, int*, const int));
extern void cunmbr __P((const char, const char, const char, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int, int*));
extern void cunmbr_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int, const int, const int));
extern void cunmhr __P((const char, const char, const int, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int, int*));
extern void cunmhr_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int, const int));
extern void cunml2 __P((const char, const char, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int, int*));
extern void cunml2_ __P((const char*, const char*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, int*, const int, const int));
extern void cunmlq __P((const char, const char, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int, int*));
extern void cunmlq_ __P((const char*, const char*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int, const int));
extern void cunmql __P((const char, const char, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int, int*));
extern void cunmql_ __P((const char*, const char*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int, const int));
extern void cunmqr __P((const char, const char, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int, int*));
extern void cunmqr_ __P((const char*, const char*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int, const int));
extern void cunmr2 __P((const char, const char, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int, int*));
extern void cunmr2_ __P((const char*, const char*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, int*, const int, const int));
extern void cunmrq __P((const char, const char, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int, int*));
extern void cunmrq_ __P((const char*, const char*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int, const int));
extern void cunmrz __P((const char, const char, const int, const int, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int, int*));
extern void cunmrz_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int, const int));
extern void cunmtr __P((const char, const char, const char, const int, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int, int*));
extern void cunmtr_ __P((const char*, const char*, const char*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*, int*, const int, const int, const int));
extern void cupgtr __P((const char, const int, const floatcomplex*, const floatcomplex*, floatcomplex*, const int, int*));
extern void cupgtr_ __P((const char*, const int*, const floatcomplex*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, int*, const int));
extern void cupmtr __P((const char, const char, const char, const int, const int, const floatcomplex*, const floatcomplex*, floatcomplex*, const int, int*));
extern void cupmtr_ __P((const char*, const char*, const char*, const int*, const int*, const floatcomplex*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, int*, const int, const int, const int));
extern void cvbrmm __P((const int, const int, const int, const int, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const int*, const int*, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cvbrmm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cvbrsm __P((const int, const int, const int, const int, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const int*, const int*, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cvbrsm_ __P((const int*, const int*, const int*, const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const int*, const int*, const int*, const int*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*, floatcomplex*, const int*));
extern void cvmul __P((const int, const floatcomplex*, const floatcomplex*, const int, const floatcomplex*, const int, const floatcomplex*, floatcomplex*, const int));
extern void cvmul_ __P((const int*, const floatcomplex*, const floatcomplex*, const int*, const floatcomplex*, const int*, const floatcomplex*, floatcomplex*, const int*));
extern double dasum __P((const int, const double*, const int));
extern double dasum_ __P((const int*, const double*, const int*));
extern void daxpyi __P((const int, const double, const double*, const int*, double*));
extern void daxpyi_ __P((const int*, const double*, const double*, const int*, double*));
extern void daxpy __P((const int, const double, const double*, const int, double*, const int));
extern void daxpy_ __P((const int*, const double*, const double*, const int*, double*, const int*));
extern void dbcomm __P((const int, const int, const int, const int, const double, const int*, const double*, const int*, const int*, const int, const int, const double*, const int, const double, double*, const int));
extern void dbcomm_ __P((const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dbdimm __P((const int, const int, const int, const int, const double, const int*, const double*, const int, const int*, const int, const int, const double*, const int, const double, double*, const int));
extern void dbdimm_ __P((const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dbdism __P((const int, const int, const int, const int, const double*, const double, const int*, const double*, const int, const int*, const int, const int, const double*, const int, const double, double*, const int));
extern void dbdism_ __P((const int*, const int*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dbdsdc __P((const char, const char, const int, double*, double*, double*, const int, double*, const int, double*, int*, int*));
extern void dbdsdc_ __P((const char*, const char*, const int*, double*, double*, double*, const int*, double*, const int*, double*, int*, double*, int*, int*, const int, const int));
extern void dbdsqr __P((const char, const int, const int, const int, const int, double*, double*, double*, const int, double*, const int, double*, const int, int*));
extern void dbdsqr_ __P((const char*, const int*, const int*, const int*, const int*, double*, double*, double*, const int*, double*, const int*, double*, const int*, double*, int*, const int));
extern void dbelmm __P((const int, const int, const int, const int, const double, const int*, const double*, const int*, const int, const int, const int, const double*, const int, const double, double*, const int));
extern void dbelmm_ __P((const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dbelsm __P((const int, const int, const int, const int, const double*, const double, const int*, const double*, const int*, const int, const int, const int, const double*, const int, const double, double*, const int));
extern void dbelsm_ __P((const int*, const int*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dbscmm __P((const int, const int, const int, const int, const double, const int*, const double*, const int*, const int*, const int*, const int, const double*, const int, const double, double*, const int));
extern void dbscmm_ __P((const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dbscsm __P((const int, const int, const int, const int, const double*, const double, const int*, const double*, const int*, const int*, const int*, const int, const double*, const int, const double, double*, const int));
extern void dbscsm_ __P((const int*, const int*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dbsrmm __P((const int, const int, const int, const int, const double, const int*, const double*, const int*, const int*, const int*, const int, const double*, const int, const double, double*, const int));
extern void dbsrmm_ __P((const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dbsrsm __P((const int, const int, const int, const int, const double*, const double, const int*, const double*, const int*, const int*, const int*, const int, const double*, const int, const double, double*, const int));
extern void dbsrsm_ __P((const int*, const int*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern double dcabs1 __P((const doublecomplex*));
extern double dcabs1_ __P((const doublecomplex*));
extern void dcnvcor2 __P((const char, const char, const char, const char, const char, const char, const int, const int, const double*, const int, const int, const int, const int, const int, const double*, const int, const int, const int, double*, const int, doublecomplex*, const int));
extern void dcnvcor2_ __P((const char*, const char*, const char*, const char*, const char*, const char*, const int*, const int*, const double*, const int*, const int*, const int*, const int*, const int*, const double*, const int*, const int*, const int*, double*, const int*, doublecomplex*, const int*, const int, const int, const int, const int, const int, const int));
extern void dcnvcor __P((const char, const char, const int, const double*, const int, const int, const int, const int, const int, const double*, const int, const int, const int, const int, const int, double*, const int, const int, const int, double*, const int));
extern void dcnvcor_ __P((const char*, const char*, const int*, const double*, const int*, const int*, const int*, const int*, const int*, const double*, const int*, const int*, const int*, const int*, const int*, double*, const int*, const int*, const int*, double*, const int*, const int, const int));
extern void dcoomm __P((const int, const int, const int, const int, const double, const int*, const double*, const int*, const int*, const int, const double*, const int, const double, double*, const int));
extern void dcoomm_ __P((const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dcopy __P((const int, const double*, const int, double*, const int));
extern void dcopy_ __P((const int*, const double*, const int*, double*, const int*));
extern void dcosqb __P((const int, double*, const double*));
extern void dcosqb_ __P((const int*, double*, const double*));
extern void dcosqf __P((const int, double*, const double*));
extern void dcosqf_ __P((const int*, double*, const double*));
extern void dcosqi __P((const int, double*));
extern void dcosqi_ __P((const int*, double*));
extern void dcosti __P((const int, double*));
extern void dcosti_ __P((const int*, double*));
extern void dcost __P((const int, double*, const double*));
extern void dcost_ __P((const int*, double*, const double*));
extern void dcscmm __P((const int, const int, const int, const int, const double, const int*, const double*, const int*, const int*, const int*, const double*, const int, const double, double*, const int));
extern void dcscmm_ __P((const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dcscsm __P((const int, const int, const int, const int, const double*, const double, const int*, const double*, const int*, const int*, const int*, const double*, const int, const double, double*, const int));
extern void dcscsm_ __P((const int*, const int*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dcsrmm __P((const int, const int, const int, const int, const double, const int*, const double*, const int*, const int*, const int*, const double*, const int, const double, double*, const int));
extern void dcsrmm_ __P((const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dcsrsm __P((const int, const int, const int, const int, const double*, const double, const int*, const double*, const int*, const int*, const int*, const double*, const int, const double, double*, const int));
extern void dcsrsm_ __P((const int*, const int*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void ddiamm __P((const int, const int, const int, const int, const double, const int*, const double*, const int, const int*, const int, const double*, const int, const double, double*, const int));
extern void ddiamm_ __P((const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void ddiasm __P((const int, const int, const int, const int, const double*, const double, const int*, const double*, const int, const int*, const int, const double*, const int, const double, double*, const int));
extern void ddiasm_ __P((const int*, const int*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void ddisna __P((const char, const int, const int, const double*, double*, int*));
extern void ddisna_ __P((const char*, const int*, const int*, const double*, double*, int*, const int));
extern double ddoti __P((const int, const double*, const int*, const double*));
extern double ddoti_ __P((const int*, const double*, const int*, const double*));
extern double ddot __P((const int, const double*, const int, const double*, const int));
extern double ddot_ __P((const int*, const double*, const int*, const double*, const int*));
extern void dellmm __P((const int, const int, const int, const int, const double, const int*, const double*, const int*, const int, const int, const double*, const int, const double, double*, const int));
extern void dellmm_ __P((const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dellsm __P((const int, const int, const int, const int, const double*, const double, const int*, const double*, const int*, const int, const int, const double*, const int, const double, double*, const int));
extern void dellsm_ __P((const int*, const int*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dezftb __P((const int, double*, const double, const double*, const double*, double*));
extern void dezftb_ __P((const int*, double*, const double*, const double*, const double*, double*));
extern void dezftf __P((const int, double*, const double, const double*, const double*, double*));
extern void dezftf_ __P((const int*, double*, const double*, const double*, const double*, double*));
extern void dezfti __P((const int, double*));
extern void dezfti_ __P((const int*, double*));
extern void dfft2b __P((const char, const int, const int, double*, const int, double*, const int, double*, const int));
extern void dfft2b_ __P((const char*, const int*, const int*, double*, const int*, double*, const int*, double*, const int*, const int));
extern void dfft2f __P((const char, const char, const int, const int, double*, const int, double*, const int, double*, const int));
extern void dfft2f_ __P((const char*, const char*, const int*, const int*, double*, const int*, double*, const int*, double*, const int*, const int, const int));
extern void dfft2i __P((const int, const int, double*));
extern void dfft2i_ __P((const int*, const int*, double*));
extern void dfft3b __P((const char, const int, const int, const int, double*, const int, double*, const int, double*, const int));
extern void dfft3b_ __P((const char*, const int*, const int*, const int*, double*, const int*, double*, const int*, double*, const int*, const int));
extern void dfft3f __P((const char, const char, const int, const int, const int, double*, const int, double*, const int, double*, const int));
extern void dfft3f_ __P((const char*, const char*, const int*, const int*, const int*, double*, const int*, double*, const int*, double*, const int*, const int, const int));
extern void dfft3i __P((const int, const int, const int, double*));
extern void dfft3i_ __P((const int*, const int*, const int*, double*));
extern void dfftb __P((const int, double*, const double*));
extern void dfftb_ __P((const int*, double*, const double*));
extern void dfftf __P((const int, double*, const double*));
extern void dfftf_ __P((const int*, double*, const double*));
extern void dffti __P((const int, double*));
extern void dffti_ __P((const int*, double*));
extern int dfftopt __P((const int));
extern int dfftopt_ __P((const int*));
extern void dfftz2_ __P((const int*, const int*, const int*, const double*, const double*, const int*, doublecomplex*, const int*, double*, int*, double*, const int*, int*));
extern void dfftz3_ __P((const int*, const int*, const int*, const int*, const double*, const double*, const int*, const int*, doublecomplex*, const int*, const int*, double*, int*, double*, const int*, int*));
extern void dfftzm_ __P((const int*, const int*, const int*, const double*, const double*, const int*, doublecomplex*, const int*, double*, int*, double*, const int*, int*));
extern void dfftz_ __P((const int*, const int*, const double*, const double*, doublecomplex*, double*, int*, double*, const int*, int*));
extern void dgbbrd __P((const char, const int, const int, const int, const int, const int, double*, const int, double*, double*, double*, const int, double*, const int, double*, const int, int*));
extern void dgbbrd_ __P((const char*, const int*, const int*, const int*, const int*, const int*, double*, const int*, double*, double*, double*, const int*, double*, const int*, double*, const int*, double*, int*, const int));
extern void dgbcon __P((const char, const int, const int, const int, const double*, const int, const int*, const double, double*, int*));
extern void dgbcon_ __P((const char*, const int*, const int*, const int*, const double*, const int*, const int*, const double*, double*, double*, int*, int*, const int));
extern void dgbequ __P((const int, const int, const int, const int, const double*, const int, double*, double*, double*, double*, double*, int*));
extern void dgbequ_ __P((const int*, const int*, const int*, const int*, const double*, const int*, double*, double*, double*, double*, double*, int*));
extern void dgbmv __P((const char, const int, const int, const int, const int, const double, const double*, const int, const double*, const int, const double, double*, const int));
extern void dgbmv_ __P((const char*, const int*, const int*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const double*, double*, const int*, const int));
extern void dgbrfs __P((const char, const int, const int, const int, const int, const double*, const int, const double*, const int, const int*, const double*, const int, double*, const int, double*, double*, int*));
extern void dgbrfs_ __P((const char*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const double*, const int*, double*, const int*, double*, double*, double*, int*, int*, const int));
extern void dgbsvx __P((const char, const char, const int, const int, const int, const int, double*, const int, double*, const int, int*, char*, double*, double*, double*, const int, double*, const int, double*, double*, double*, int*));
extern void dgbsvx_ __P((const char*, const char*, const int*, const int*, const int*, const int*, double*, const int*, double*, const int*, int*, char*, double*, double*, double*, const int*, double*, const int*, double*, double*, double*, double*, int*, int*, const int, const int, const int));
extern void dgbsv __P((const int, const int, const int, const int, double*, const int, int*, double*, const int, int*));
extern void dgbsv_ __P((const int*, const int*, const int*, const int*, double*, const int*, int*, double*, const int*, int*));
extern void dgbtf2 __P((const int, const int, const int, const int, double*, const int, int*, int*));
extern void dgbtf2_ __P((const int*, const int*, const int*, const int*, double*, const int*, int*, int*));
extern void dgbtrf __P((const int, const int, const int, const int, double*, const int, int*, int*));
extern void dgbtrf_ __P((const int*, const int*, const int*, const int*, double*, const int*, int*, int*));
extern void dgbtrs __P((const char, const int, const int, const int, const int, const double*, const int, const int*, double*, const int, int*));
extern void dgbtrs_ __P((const char*, const int*, const int*, const int*, const int*, const double*, const int*, const int*, double*, const int*, int*, const int));
extern void dgebak __P((const char, const char, const int, const int, const int, const double*, const int, double*, const int, int*));
extern void dgebak_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const int*, double*, const int*, int*, const int, const int));
extern void dgebal __P((const char, const int, double*, const int, int*, int*, double*, int*));
extern void dgebal_ __P((const char*, const int*, double*, const int*, int*, int*, double*, int*, const int));
extern void dgebrd __P((const int, const int, double*, const int, double*, double*, double*, double*, int*));
extern void dgebrd_ __P((const int*, const int*, double*, const int*, double*, double*, double*, double*, double*, const int*, int*));
extern void dgecon __P((const char, const int, const double*, const int, const double, double*, int*));
extern void dgecon_ __P((const char*, const int*, const double*, const int*, const double*, double*, double*, int*, int*, const int));
extern void dgeequ __P((const int, const int, const double*, const int, double*, double*, double*, double*, double*, int*));
extern void dgeequ_ __P((const int*, const int*, const double*, const int*, double*, double*, double*, double*, double*, int*));
extern void dgeesx __P((const char, const char, const int(*select)(double,double), const char, const int, double*, const int, int*, double*, double*, double*, const int, double*, double*, int*));
extern void dgeesx_ __P((const char*, const char*, const int(*select)(double,double), const char*, const int*, double*, const int*, int*, double*, double*, double*, const int*, double*, double*, double*, const int*, int*, const int*, int*, int*, const int, const int, const int));
extern void dgees __P((const char, const char, const int(*select)(double,double), const int, double*, const int, int*, double*, double*, double*, const int, int*));
extern void dgees_ __P((const char*, const char*, const int(*select)(double,double), const int*, double*, const int*, int*, double*, double*, double*, const int*, double*, const int*, int*, int*, const int, const int));
extern void dgeevx __P((const char, const char, const char, const char, const int, double*, const int, double*, double*, double*, const int, double*, const int, int*, int*, double*, double*, double*, double*, int*));
extern void dgeevx_ __P((const char*, const char*, const char*, const char*, const int*, double*, const int*, double*, double*, double*, const int*, double*, const int*, int*, int*, double*, double*, double*, double*, double*, const int*, int*, int*, const int, const int, const int, const int));
extern void dgeev __P((const char, const char, const int, double*, const int, double*, double*, double*, const int, double*, const int, int*));
extern void dgeev_ __P((const char*, const char*, const int*, double*, const int*, double*, double*, double*, const int*, double*, const int*, double*, const int*, int*, const int, const int));
extern void dgegs __P((const char, const char, const int, double*, const int, double*, const int, double*, double*, double*, double*, const int, double*, const int, int*));
extern void dgegs_ __P((const char*, const char*, const int*, double*, const int*, double*, const int*, double*, double*, double*, double*, const int*, double*, const int*, double*, const int*, int*, const int, const int));
extern void dgegv __P((const char, const char, const int, double*, const int, double*, const int, double*, double*, double*, double*, const int, double*, const int, int*));
extern void dgegv_ __P((const char*, const char*, const int*, double*, const int*, double*, const int*, double*, double*, double*, double*, const int*, double*, const int*, double*, const int*, int*, const int, const int));
extern void dgehrd __P((const int, const int, const int, double*, const int, double*, int*));
extern void dgehrd_ __P((const int*, const int*, const int*, double*, const int*, double*, double*, const int*, int*));
extern void dgelqf __P((const int, const int, double*, const int, double*, int*));
extern void dgelqf_ __P((const int*, const int*, double*, const int*, double*, double*, const int*, int*));
extern void dgelsd __P((const int, const int, const int, double*, const int, double*, const int, double*, const double, int*, int*));
extern void dgelsd_ __P((const int*, const int*, const int*, double*, const int*, double*, const int*, double*, const double*, int*, double*, const int*, int*, int*));
extern void dgelss __P((const int, const int, const int, double*, const int, double*, const int, double*, const double, int*, int*));
extern void dgelss_ __P((const int*, const int*, const int*, double*, const int*, double*, const int*, double*, const double*, int*, double*, const int*, int*));
extern void dgelsx __P((const int, const int, const int, double*, const int, double*, const int, int*, const double, int*, int*));
extern void dgelsx_ __P((const int*, const int*, const int*, double*, const int*, double*, const int*, int*, const double*, int*, double*, int*));
extern void dgelsy __P((const int, const int, const int, double*, const int, double*, const int, int*, const double, int*, int*));
extern void dgelsy_ __P((const int*, const int*, const int*, double*, const int*, double*, const int*, int*, const double*, int*, double*, const int*, int*));
extern void dgels __P((const char, const int, const int, const int, double*, const int, double*, const int, int*));
extern void dgels_ __P((const char*, const int*, const int*, const int*, double*, const int*, double*, const int*, double*, const int*, int*, const int));
extern void dgemm __P((const char, const char, const int, const int, const int, const double, const double*, const int, const double*, const int, const double, double*, const int));
extern void dgemm_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const double*, double*, const int*, const int, const int));
extern void dgemv __P((const char, const int, const int, const double, const double*, const int, const double*, const int, const double, double*, const int));
extern void dgemv_ __P((const char*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const double*, double*, const int*, const int));
extern void dgeqlf __P((const int, const int, double*, const int, double*, int*));
extern void dgeqlf_ __P((const int*, const int*, double*, const int*, double*, double*, const int*, int*));
extern void dgeqp3 __P((const int, const int, double*, const int, int*, double*, int*));
extern void dgeqp3_ __P((const int*, const int*, double*, const int*, int*, double*, double*, const int*, int*));
extern void dgeqpf __P((const int, const int, double*, const int, int*, double*, int*));
extern void dgeqpf_ __P((const int*, const int*, double*, const int*, int*, double*, double*, int*));
extern void dgeqrf __P((const int, const int, double*, const int, double*, int*));
extern void dgeqrf_ __P((const int*, const int*, double*, const int*, double*, double*, const int*, int*));
extern void dgerfs __P((const char, const int, const int, const double*, const int, const double*, const int, const int*, const double*, const int, double*, const int, double*, double*, int*));
extern void dgerfs_ __P((const char*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const double*, const int*, double*, const int*, double*, double*, double*, int*, int*, const int));
extern void dgerqf __P((const int, const int, double*, const int, double*, int*));
extern void dgerqf_ __P((const int*, const int*, double*, const int*, double*, double*, const int*, int*));
extern void dger __P((const int, const int, const double, const double*, const int, const double*, const int, double*, const int));
extern void dger_ __P((const int*, const int*, const double*, const double*, const int*, const double*, const int*, double*, const int*));
extern void dgesdd __P((const char, const int, const int, double*, const int, double*, double*, const int, double*, const int, int*));
extern void dgesdd_ __P((const char*, const int*, const int*, double*, const int*, double*, double*, const int*, double*, const int*, double*, const int*, int*, int*, const int));
extern void dgesvd __P((const char, const char, const int, const int, double*, const int, double*, double*, const int, double*, const int, int*));
extern void dgesvd_ __P((const char*, const char*, const int*, const int*, double*, const int*, double*, double*, const int*, double*, const int*, double*, const int*, int*, const int, const int));
extern void dgesvx __P((const char, const char, const int, const int, double*, const int, double*, const int, int*, char*, double*, double*, double*, const int, double*, const int, double*, double*, double*, int*));
extern void dgesvx_ __P((const char*, const char*, const int*, const int*, double*, const int*, double*, const int*, int*, char*, double*, double*, double*, const int*, double*, const int*, double*, double*, double*, double*, int*, int*, const int, const int, const int));
extern void dgesv __P((const int, const int, double*, const int, int*, double*, const int, int*));
extern void dgesv_ __P((const int*, const int*, double*, const int*, int*, double*, const int*, int*));
extern void dgetf2 __P((const int, const int, double*, const int, int*, int*));
extern void dgetf2_ __P((const int*, const int*, double*, const int*, int*, int*));
extern void dgetrf __P((const int, const int, double*, const int, int*, int*));
extern void dgetrf_ __P((const int*, const int*, double*, const int*, int*, int*));
extern void dgetri __P((const int, double*, const int, const int*, int*));
extern void dgetri_ __P((const int*, double*, const int*, const int*, double*, const int*, int*));
extern void dgetrs __P((const char, const int, const int, const double*, const int, const int*, double*, const int, int*));
extern void dgetrs_ __P((const char*, const int*, const int*, const double*, const int*, const int*, double*, const int*, int*, const int));
extern void dggbak __P((const char, const char, const int, const int, const int, const double*, const double*, const int, double*, const int, int*));
extern void dggbak_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const double*, const int*, double*, const int*, int*, const int, const int));
extern void dggbal __P((const char, const int, double*, const int, double*, const int, int*, int*, const double*, const double*, int*));
extern void dggbal_ __P((const char*, const int*, double*, const int*, double*, const int*, int*, int*, const double*, const double*, double*, int*, const int));
extern void dggesx __P((const char, const char, const char, const int(*delctg)(double,double,double), const char, const int, double*, const int, double*, const int, int*, double*, double*, double*, double*, const int, double*, const int, double*, double*, int*));
extern void dggesx_ __P((const char*, const char*, const char*, const int(*delctg)(double,double,double), const char*, const int*, double*, const int*, double*, const int*, int*, double*, double*, double*, double*, const int*, double*, const int*, double*, double*, double*, const int*, int*, const int*, int*, int*, const int, const int, const int, const int));
extern void dgges __P((const char, const char, const char, const int(*delctg)(double,double,double), const int, double*, const int, double*, const int, int*, double*, double*, double*, double*, const int, double*, const int, int*));
extern void dgges_ __P((const char*, const char*, const char*, const int(*delctg)(double,double,double), const int*, double*, const int*, double*, const int*, int*, double*, double*, double*, double*, const int*, double*, const int*, double*, const int*, int*, int*, const int, const int, const int));
extern void dggevx __P((const char, const char, const char, const char, const int, double*, const int, double*, const int, double*, double*, double*, double*, const int, double*, const int, int*, int*, double*, double*, double*, double*, double*, double*, int*));
extern void dggevx_ __P((const char*, const char*, const char*, const char*, const int*, double*, const int*, double*, const int*, double*, double*, double*, double*, const int*, double*, const int*, int*, int*, double*, double*, double*, double*, double*, double*, double*, const int*, int*, int*, int*, const int, const int, const int, const int));
extern void dggev __P((const char, const char, const int, double*, const int, double*, const int, double*, double*, double*, double*, const int, double*, const int, int*));
extern void dggev_ __P((const char*, const char*, const int*, double*, const int*, double*, const int*, double*, double*, double*, double*, const int*, double*, const int*, double*, const int*, int*, const int, const int));
extern void dggglm __P((const int, const int, const int, double*, const int, double*, const int, double*, double*, double*, int*));
extern void dggglm_ __P((const int*, const int*, const int*, double*, const int*, double*, const int*, double*, double*, double*, double*, const int*, int*));
extern void dgghrd __P((const char, const char, const int, const int, const int, double*, const int, double*, const int, double*, const int, double*, const int, int*));
extern void dgghrd_ __P((const char*, const char*, const int*, const int*, const int*, double*, const int*, double*, const int*, double*, const int*, double*, const int*, int*, const int, const int));
extern void dgglse __P((const int, const int, const int, double*, const int, double*, const int, double*, double*, double*, int*));
extern void dgglse_ __P((const int*, const int*, const int*, double*, const int*, double*, const int*, double*, double*, double*, double*, const int*, int*));
extern void dggqrf __P((const int, const int, const int, double*, const int, double*, double*, const int, double*, int*));
extern void dggqrf_ __P((const int*, const int*, const int*, double*, const int*, double*, double*, const int*, double*, double*, const int*, int*));
extern void dggrqf __P((const int, const int, const int, double*, const int, double*, double*, const int, double*, int*));
extern void dggrqf_ __P((const int*, const int*, const int*, double*, const int*, double*, double*, const int*, double*, double*, const int*, int*));
extern void dggsvd __P((const char, const char, const char, const int, const int, const int, int*, int*, double*, const int, double*, const int, double*, double*, double*, const int, double*, const int, double*, const int, int*, int*));
extern void dggsvd_ __P((const char*, const char*, const char*, const int*, const int*, const int*, int*, int*, double*, const int*, double*, const int*, double*, double*, double*, const int*, double*, const int*, double*, const int*, double*, int*, int*, const int, const int, const int));
extern void dggsvp __P((const char, const char, const char, const int, const int, const int, double*, const int, double*, const int, const double, const double, int*, int*, double*, const int, double*, const int, double*, const int, int*));
extern void dggsvp_ __P((const char*, const char*, const char*, const int*, const int*, const int*, double*, const int*, double*, const int*, const double*, const double*, int*, int*, double*, const int*, double*, const int*, double*, const int*, int*, double*, double*, int*, const int, const int, const int));
extern void dgssco_ __P((double*, double*, int*));
extern void dgssda_ __P((double*, int*));
extern void dgssfa_ __P((const int*, const int*, const int*, const double*, double*, int*));
extern void dgssfs_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const int*, double*, const int*, const char*, const int*, const int*, double*, int*, const int, const int, const int));
extern void dgssin_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const int*, double*, int*, const int, const int));
extern void dgssor_ __P((const char*, double*, int*, const int));
extern void dgssps_ __P((double*, int*));
extern void dgssrp_ __P((int*, double*, int*));
extern void dgsssl_ __P((const int*, double*, const int*, double*, int*));
extern void dgssuo_ __P((const int*, double*, int*));
extern void dgtcon __P((const char, const int, const double*, const double*, const double*, const double*, const int*, const double, double*, int*));
extern void dgtcon_ __P((const char*, const int*, const double*, const double*, const double*, const double*, const int*, const double*, double*, double*, int*, int*, const int));
extern void dgthrz __P((const int, double*, double*, const int*));
extern void dgthrz_ __P((const int*, double*, double*, const int*));
extern void dgthr __P((const int, const double*, double*, const int*));
extern void dgthr_ __P((const int*, const double*, double*, const int*));
extern void dgtrfs __P((const char, const int, const int, const double*, const double*, const double*, const double*, const double*, const double*, const double*, const int*, const double*, const int, double*, const int, double*, double*, int*));
extern void dgtrfs_ __P((const char*, const int*, const int*, const double*, const double*, const double*, const double*, const double*, const double*, const double*, const int*, const double*, const int*, double*, const int*, double*, double*, double*, int*, int*, const int));
extern void dgtsvx __P((const char, const char, const int, const int, const double*, const double*, double*, double*, double*, double*, double*, int*, const double*, const int, double*, const int, double*, double*, double*, int*));
extern void dgtsvx_ __P((const char*, const char*, const int*, const int*, const double*, const double*, double*, double*, double*, double*, double*, int*, const double*, const int*, double*, const int*, double*, double*, double*, double*, int*, int*, const int, const int));
extern void dgtsv __P((const int, const int, double*, double*, double*, double*, const int, int*));
extern void dgtsv_ __P((const int*, const int*, double*, double*, double*, double*, const int*, int*));
extern void dgttrf __P((const int, double*, double*, double*, double*, int*, int*));
extern void dgttrf_ __P((const int*, double*, double*, double*, double*, int*, int*));
extern void dgttrs __P((const char, const int, const int, const double*, const double*, const double*, const double*, const int*, double*, const int, int*));
extern void dgttrs_ __P((const char*, const int*, const int*, const double*, const double*, const double*, const double*, const int*, double*, const int*, int*, const int));
extern void dhgeqz __P((const char, const char, const char, const int, const int, const int, double*, const int, double*, const int, double*, double*, double*, double*, const int, double*, const int, int*));
extern void dhgeqz_ __P((const char*, const char*, const char*, const int*, const int*, const int*, double*, const int*, double*, const int*, double*, double*, double*, double*, const int*, double*, const int*, double*, const int*, int*, const int, const int, const int));
extern void dhsein __P((const char, const char, const char, int*, const int, const double*, const int, double*, const double*, double*, const int, double*, const int, const int, int*, int*, int*, int*));
extern void dhsein_ __P((const char*, const char*, const char*, int*, const int*, const double*, const int*, double*, const double*, double*, const int*, double*, const int*, const int*, int*, double*, int*, int*, int*, const int, const int, const int));
extern void dhseqr __P((const char, const char, const int, const int, const int, double*, const int, double*, double*, double*, const int, int*));
extern void dhseqr_ __P((const char*, const char*, const int*, const int*, const int*, double*, const int*, double*, double*, double*, const int*, double*, const int*, int*, const int, const int));
extern void djadmm __P((const int, const int, const int, const int, const double, const int*, const double*, const int*, const int*, const int, const int*, const double*, const int, const double, double*, const int));
extern void djadmm_ __P((const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void djadrp __P((const int, const int, const int, const double*, const int*, int*, const int, const int*));
extern void djadrp_ __P((const int*, const int*, const int*, const double*, const int*, int*, const int*, const int*, int*, const int*));
extern void djadsm __P((const int, const int, const int, const int, const double*, const double, const int*, const double*, const int*, const int*, const int, const int*, const double*, const int, const double, double*, const int));
extern void djadsm_ __P((const int*, const int*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dlaeda __P((const int, const int, const int, const int, const int*, const int*, const int*, const int*, const double*, const double*, const int*, double*, int*));
extern void dlaeda_ __P((const int*, const int*, const int*, const int*, const int*, const int*, const int*, const int*, const double*, const double*, const int*, double*, double*, int*));
extern void dlagtf __P((const int, double*, const double, double*, double*, const double, double*, int*, int*));
extern void dlagtf_ __P((const int*, double*, const double*, double*, double*, const double*, double*, int*, int*));
extern double dlamch __P((const char));
extern double dlamch_ __P((const char*, const int));
extern void dlamrg __P((const int, const int, const double*, const int, const int, int*));
extern void dlamrg_ __P((const int*, const int*, const double*, const int*, const int*, int*));
extern void dlanv2 __P((double*, double*, double*, double*, double*, double*, double*, double*, double*, double*));
extern void dlanv2_ __P((double*, double*, double*, double*, double*, double*, double*, double*, double*, double*));
extern void dlarzb __P((const char, const char, const char, const char, const int, const int, const int, const int, const double*, const int, const double*, const int, double*, const int, const int));
extern void dlarzb_ __P((const char*, const char*, const char*, const char*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, double*, const int*, double*, const int*, const int, const int, const int, const int));
extern void dlarzt __P((const char, const char, const int, const int, const double*, const int, const double*, double*, const int));
extern void dlarzt_ __P((const char*, const char*, const int*, const int*, const double*, const int*, const double*, double*, const int*, const int, const int));
extern void dlarz __P((const char, const int, const int, const int, const double*, const int, const double, double*, const int));
extern void dlarz_ __P((const char*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int));
extern void dlasq1 __P((const int, double*, double*, int*));
extern void dlasq1_ __P((const int*, double*, double*, double*, int*));
extern void dlasq2 __P((const int, double*, int*));
extern void dlasq2_ __P((const int*, double*, int*));
extern void dlasrt __P((const char, const int, double*, int*));
extern void dlasrt_ __P((const char*, const int*, double*, int*, const int));
extern void dlatzm __P((const char, const int, const int, const double*, const int, const double, double*, double*, const int));
extern void dlatzm_ __P((const char*, const int*, const int*, const double*, const int*, const double*, double*, double*, const int*, double*, const int));
extern double dnrm2 __P((const int, const double*, const int));
extern double dnrm2_ __P((const int*, const double*, const int*));
extern void dopgtr __P((const char, const int, const double*, const double*, double*, const int, int*));
extern void dopgtr_ __P((const char*, const int*, const double*, const double*, double*, const int*, double*, int*, const int));
extern void dopmtr __P((const char, const char, const char, const int, const int, const double*, const double*, double*, const int, int*));
extern void dopmtr_ __P((const char*, const char*, const char*, const int*, const int*, const double*, const double*, double*, const int*, double*, int*, const int, const int, const int));
extern void dorg2l __P((const int, const int, const int, double*, const int, const double*, int*));
extern void dorg2l_ __P((const int*, const int*, const int*, double*, const int*, const double*, double*, int*));
extern void dorg2r __P((const int, const int, const int, double*, const int, const double*, int*));
extern void dorg2r_ __P((const int*, const int*, const int*, double*, const int*, const double*, double*, int*));
extern void dorgbr __P((const char, const int, const int, const int, double*, const int, const double*, int*));
extern void dorgbr_ __P((const char*, const int*, const int*, const int*, double*, const int*, const double*, double*, const int*, int*, const int));
extern void dorghr __P((const int, const int, const int, double*, const int, const double*, int*));
extern void dorghr_ __P((const int*, const int*, const int*, double*, const int*, const double*, double*, const int*, int*));
extern void dorgl2 __P((const int, const int, const int, double*, const int, const double*, int*));
extern void dorgl2_ __P((const int*, const int*, const int*, double*, const int*, const double*, double*, int*));
extern void dorglq __P((const int, const int, const int, double*, const int, const double*, int*));
extern void dorglq_ __P((const int*, const int*, const int*, double*, const int*, const double*, double*, const int*, int*));
extern void dorgql __P((const int, const int, const int, double*, const int, const double*, int*));
extern void dorgql_ __P((const int*, const int*, const int*, double*, const int*, const double*, double*, const int*, int*));
extern void dorgqr __P((const int, const int, const int, double*, const int, const double*, int*));
extern void dorgqr_ __P((const int*, const int*, const int*, double*, const int*, const double*, double*, const int*, int*));
extern void dorgr2 __P((const int, const int, const int, double*, const int, const double*, int*));
extern void dorgr2_ __P((const int*, const int*, const int*, double*, const int*, const double*, double*, int*));
extern void dorgrq __P((const int, const int, const int, double*, const int, const double*, int*));
extern void dorgrq_ __P((const int*, const int*, const int*, double*, const int*, const double*, double*, const int*, int*));
extern void dorgtr __P((const char, const int, double*, const int, const double*, int*));
extern void dorgtr_ __P((const char*, const int*, double*, const int*, const double*, double*, const int*, int*, const int));
extern void dorm2l __P((const char, const char, const int, const int, const int, const double*, const int, const double*, double*, const int, int*));
extern void dorm2l_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, int*, const int, const int));
extern void dorm2r __P((const char, const char, const int, const int, const int, double*, const int, const double*, double*, const int, int*));
extern void dorm2r_ __P((const char*, const char*, const int*, const int*, const int*, double*, const int*, const double*, double*, const int*, double*, int*, const int, const int));
extern void dormbr __P((const char, const char, const char, const int, const int, const int, const double*, const int, const double*, double*, const int, int*));
extern void dormbr_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*, int*, const int, const int, const int));
extern void dormhr __P((const char, const char, const int, const int, const int, const int, const double*, const int, const double*, double*, const int, int*));
extern void dormhr_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*, int*, const int, const int));
extern void dorml2 __P((const char, const char, const int, const int, const int, const double*, const int, const double*, double*, const int, int*));
extern void dorml2_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, int*, const int, const int));
extern void dormlq __P((const char, const char, const int, const int, const int, const double*, const int, const double*, double*, const int, int*));
extern void dormlq_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*, int*, const int, const int));
extern void dormql __P((const char, const char, const int, const int, const int, const double*, const int, const double*, double*, const int, int*));
extern void dormql_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*, int*, const int, const int));
extern void dormqr __P((const char, const char, const int, const int, const int, const double*, const int, const double*, double*, const int, int*));
extern void dormqr_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*, int*, const int, const int));
extern void dormr2 __P((const char, const char, const int, const int, const int, const double*, const int, const double*, double*, const int, int*));
extern void dormr2_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, int*, const int, const int));
extern void dormr3 __P((const char, const char, const int, const int, const int, const int, const double*, const int, const double*, double*, const int, int*));
extern void dormr3_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, int*, const int, const int));
extern void dormrq __P((const char, const char, const int, const int, const int, const double*, const int, const double*, double*, const int, int*));
extern void dormrq_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*, int*, const int, const int));
extern void dormrz __P((const char, const char, const int, const int, const int, const int, const double*, const int, const double*, double*, const int, int*));
extern void dormrz_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*, int*, const int, const int));
extern void dormtr __P((const char, const char, const char, const int, const int, const double*, const int, const double*, double*, const int, int*));
extern void dormtr_ __P((const char*, const char*, const char*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*, int*, const int, const int, const int));
extern void dpbcon __P((const char, const int, const int, const double*, const int, const double, double*, int*));
extern void dpbcon_ __P((const char*, const int*, const int*, const double*, const int*, const double*, double*, double*, int*, int*, const int));
extern void dpbequ __P((const char, const int, const int, const double*, const int, double*, double*, double*, int*));
extern void dpbequ_ __P((const char*, const int*, const int*, const double*, const int*, double*, double*, double*, int*, const int));
extern void dpbrfs __P((const char, const int, const int, const int, const double*, const int, const double*, const int, const double*, const int, double*, const int, double*, double*, int*));
extern void dpbrfs_ __P((const char*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const double*, const int*, double*, const int*, double*, double*, double*, int*, int*, const int));
extern void dpbstf __P((const char, const int, const int, double*, const int, int*));
extern void dpbstf_ __P((const char*, const int*, const int*, double*, const int*, int*, const int));
extern void dpbsvx __P((const char, const char, const int, const int, const int, double*, const int, double*, const int, char*, double*, double*, const int, double*, const int, double*, double*, double*, int*));
extern void dpbsvx_ __P((const char*, const char*, const int*, const int*, const int*, double*, const int*, double*, const int*, char*, double*, double*, const int*, double*, const int*, double*, double*, double*, double*, int*, int*, const int, const int, const int));
extern void dpbsv __P((const char, const int, const int, const int, double*, const int, double*, const int, int*));
extern void dpbsv_ __P((const char*, const int*, const int*, const int*, double*, const int*, double*, const int*, int*, const int));
extern void dpbtf2 __P((const char, const int, const int, double*, const int, int*));
extern void dpbtf2_ __P((const char*, const int*, const int*, double*, const int*, int*, const int));
extern void dpbtrf __P((const char, const int, const int, double*, const int, int*));
extern void dpbtrf_ __P((const char*, const int*, const int*, double*, const int*, int*, const int));
extern void dpbtrs __P((const char, const int, const int, const int, const double*, const int, double*, const int, int*));
extern void dpbtrs_ __P((const char*, const int*, const int*, const int*, const double*, const int*, double*, const int*, int*, const int));
extern void dpocon __P((const char, const int, const double*, const int, const double, double*, int*));
extern void dpocon_ __P((const char*, const int*, const double*, const int*, const double*, double*, double*, int*, int*, const int));
extern void dpoequ __P((const int, const double*, const int, double*, double*, double*, int*));
extern void dpoequ_ __P((const int*, const double*, const int*, double*, double*, double*, int*));
extern void dporfs __P((const char, const int, const int, const double*, const int, const double*, const int, const double*, const int, double*, const int, double*, double*, int*));
extern void dporfs_ __P((const char*, const int*, const int*, const double*, const int*, const double*, const int*, const double*, const int*, double*, const int*, double*, double*, double*, int*, int*, const int));
extern void dposvx __P((const char, const char, const int, const int, double*, const int, double*, const int, char*, double*, double*, const int, double*, const int, double*, double*, double*, int*));
extern void dposvx_ __P((const char*, const char*, const int*, const int*, double*, const int*, double*, const int*, char*, double*, double*, const int*, double*, const int*, double*, double*, double*, double*, int*, int*, const int, const int, const int));
extern void dposv __P((const char, const int, const int, double*, const int, double*, const int, int*));
extern void dposv_ __P((const char*, const int*, const int*, double*, const int*, double*, const int*, int*, const int));
extern void dpotf2 __P((const char, const int, double*, const int, int*));
extern void dpotf2_ __P((const char*, const int*, double*, const int*, int*, const int));
extern void dpotrf __P((const char, const int, double*, const int, int*));
extern void dpotrf_ __P((const char*, const int*, double*, const int*, int*, const int));
extern void dpotri __P((const char, const int, double*, const int, int*));
extern void dpotri_ __P((const char*, const int*, double*, const int*, int*, const int));
extern void dpotrs __P((const char, const int, const int, const double*, const int, double*, const int, int*));
extern void dpotrs_ __P((const char*, const int*, const int*, const double*, const int*, double*, const int*, int*, const int));
extern void dppcon __P((const char, const int, const double*, const double, double*, int*));
extern void dppcon_ __P((const char*, const int*, const double*, const double*, double*, double*, int*, int*, const int));
extern void dppequ __P((const char, const int, const double*, double*, double*, double*, int*));
extern void dppequ_ __P((const char*, const int*, const double*, double*, double*, double*, int*, const int));
extern void dpprfs __P((const char, const int, const int, const double*, const double*, const double*, const int, double*, const int, double*, double*, int*));
extern void dpprfs_ __P((const char*, const int*, const int*, const double*, const double*, const double*, const int*, double*, const int*, double*, double*, double*, int*, int*, const int));
extern void dppsvx __P((const char, const char, const int, const int, double*, double*, char*, double*, double*, const int, double*, const int, double*, double*, double*, int*));
extern void dppsvx_ __P((const char*, const char*, const int*, const int*, double*, double*, char*, double*, double*, const int*, double*, const int*, double*, double*, double*, double*, int*, int*, const int, const int, const int));
extern void dppsv __P((const char, const int, const int, double*, double*, const int, int*));
extern void dppsv_ __P((const char*, const int*, const int*, double*, double*, const int*, int*, const int));
extern void dpptrf __P((const char, const int, double*, int*));
extern void dpptrf_ __P((const char*, const int*, double*, int*, const int));
extern void dpptri __P((const char, const int, double*, int*));
extern void dpptri_ __P((const char*, const int*, double*, int*, const int));
extern void dpptrs __P((const char, const int, const int, const double*, double*, const int, int*));
extern void dpptrs_ __P((const char*, const int*, const int*, const double*, double*, const int*, int*, const int));
extern void dptcon __P((const int, const double*, const double*, const double, double*, int*));
extern void dptcon_ __P((const int*, const double*, const double*, const double*, double*, double*, int*));
extern void dpteqr __P((const char, const int, double*, double*, double*, const int, int*));
extern void dpteqr_ __P((const char*, const int*, double*, double*, double*, const int*, double*, int*, const int));
extern void dptrfs __P((const int, const int, const double*, const double*, const double*, const double*, const double*, const int, double*, const int, double*, double*, int*));
extern void dptrfs_ __P((const int*, const int*, const double*, const double*, const double*, const double*, const double*, const int*, double*, const int*, double*, double*, double*, int*));
extern void dptsvx __P((const char, const int, const int, const double*, const double*, double*, double*, const double*, const int, double*, const int, double*, double*, double*, int*));
extern void dptsvx_ __P((const char*, const int*, const int*, const double*, const double*, double*, double*, const double*, const int*, double*, const int*, double*, double*, double*, double*, int*, const int));
extern void dptsv __P((const int, const int, double*, double*, double*, const int, int*));
extern void dptsv_ __P((const int*, const int*, double*, double*, double*, const int*, int*));
extern void dpttrf __P((const int, double*, double*, int*));
extern void dpttrf_ __P((const int*, double*, double*, int*));
extern void dpttrs __P((const int, const int, const double*, double*, double*, const int, int*));
extern void dpttrs_ __P((const int*, const int*, const double*, double*, double*, const int*, int*));
extern void dptts2 __P((const int, const int, const double*, const double*, double*, const int));
extern void dptts2_ __P((const int*, const int*, const double*, const double*, double*, const int*));
extern double dqdota __P((const int, const double, long double*, const double*, const int, const double*, const int));
extern double dqdota_ __P((const int*, const double*, long double*, const double*, const int*, const double*, const int*));
extern double dqdoti __P((const int, const double, long double*, const double*, const int, const double*, const int));
extern double dqdoti_ __P((const int*, const double*, long double*, const double*, const int*, const double*, const int*));
extern void drotg __P((double*, double*, double*, double*));
extern void drotg_ __P((double*, double*, double*, double*));
extern void droti __P((const int, const double*, const int*, double*, const double, const double));
extern void droti_ __P((const int*, const double*, const int*, double*, const double*, const double*));
extern void drotmg __P((double*, double*, double*, const double, double*));
extern void drotmg_ __P((double*, double*, double*, const double*, double*));
extern void drotm __P((const int, const double*, const int, double*, const int, const double*));
extern void drotm_ __P((const int*, const double*, const int*, double*, const int*, const double*));
extern void drot __P((const int, double*, const int, double*, const int, const double, const double));
extern void drot_ __P((const int*, double*, const int*, double*, const int*, const double*, const double*));
extern void dsbevd __P((const char, const char, const int, const int, double*, const int, double*, double*, const int, int*));
extern void dsbevd_ __P((const char*, const char*, const int*, const int*, double*, const int*, double*, double*, const int*, double*, const int*, int*, const int*, int*, const int, const int));
extern void dsbevx __P((const char, const char, const char, const int, const int, double*, const int, double*, const int, const double, const double, const int, const int, const double, int*, double*, double*, const int, int*, int*));
extern void dsbevx_ __P((const char*, const char*, const char*, const int*, const int*, double*, const int*, double*, const int*, const double*, const double*, const int*, const int*, const double*, int*, double*, double*, const int*, double*, int*, int*, int*, const int, const int, const int));
extern void dsbev __P((const char, const char, const int, const int, double*, const int, double*, double*, const int, int*));
extern void dsbev_ __P((const char*, const char*, const int*, const int*, double*, const int*, double*, double*, const int*, double*, int*, const int, const int));
extern void dsbgst __P((const char, const char, const int, const int, const int, double*, const int, const double*, const int, double*, const int, int*));
extern void dsbgst_ __P((const char*, const char*, const int*, const int*, const int*, double*, const int*, const double*, const int*, double*, const int*, double*, int*, const int, const int));
extern void dsbgvd __P((const char, const char, const int, const int, const int, double*, const int, double*, const int, double*, double*, const int, int*));
extern void dsbgvd_ __P((const char*, const char*, const int*, const int*, const int*, double*, const int*, double*, const int*, double*, double*, const int*, double*, const int*, int*, const int*, int*, const int, const int));
extern void dsbgvx __P((const char, const char, const char, const int, const int, const int, double*, const int, double*, const int, double*, const int, const double, const double, const int, const int, const double, int*, double*, double*, const int, int*, int*));
extern void dsbgvx_ __P((const char*, const char*, const char*, const int*, const int*, const int*, double*, const int*, double*, const int*, double*, const int*, const double*, const double*, const int*, const int*, const double*, int*, double*, double*, const int*, double*, int*, int*, int*, const int, const int, const int));
extern void dsbgv __P((const char, const char, const int, const int, const int, double*, const int, double*, const int, double*, double*, const int, int*));
extern void dsbgv_ __P((const char*, const char*, const int*, const int*, const int*, double*, const int*, double*, const int*, double*, double*, const int*, double*, int*, const int, const int));
extern void dsbmv __P((const char, const int, const int, const double, const double*, const int, const double*, const int, const double, double*, const int));
extern void dsbmv_ __P((const char*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const double*, double*, const int*, const int));
extern void dsbtrd __P((const char, const char, const int, const int, double*, const int, double*, double*, double*, const int, int*));
extern void dsbtrd_ __P((const char*, const char*, const int*, const int*, double*, const int*, double*, double*, double*, const int*, double*, int*, const int, const int));
extern void dscal __P((const int, const double, double*, const int));
extern void dscal_ __P((const int*, const double*, double*, const int*));
extern void dsctr __P((const int, const double*, const int*, double*));
extern void dsctr_ __P((const int*, const double*, const int*, double*));
extern double dsdot __P((const int, const float*, const int, const float*, const int));
extern double dsdot_ __P((const int*, const float*, const int*, const float*, const int*));
extern double dsecnd __P((void));
extern double dsecnd_ __P((void));
extern void dsinqb __P((const int, double*, const double*));
extern void dsinqb_ __P((const int*, double*, const double*));
extern void dsinqf __P((const int, double*, const double*));
extern void dsinqf_ __P((const int*, double*, const double*));
extern void dsinqi __P((const int, double*));
extern void dsinqi_ __P((const int*, double*));
extern void dsinti __P((const int, double*));
extern void dsinti_ __P((const int*, double*));
extern void dsint __P((const int, double*, double*));
extern void dsint_ __P((const int*, double*, double*));
extern void dskymm __P((const int, const int, const int, const int, const double, const int*, const double*, const int*, const double*, const int, const double, double*, const int));
extern void dskymm_ __P((const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dskysm __P((const int, const int, const int, const int, const double*, const double, const int*, const double*, const int*, const double*, const int, const double, double*, const int));
extern void dskysm_ __P((const int*, const int*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dspcon __P((const char, const int, const double*, const int*, const double, double*, int*));
extern void dspcon_ __P((const char*, const int*, const double*, const int*, const double*, double*, double*, int*, int*, const int));
extern void dspevd __P((const char, const char, const int, double*, double*, double*, const int, int*));
extern void dspevd_ __P((const char*, const char*, const int*, double*, double*, double*, const int*, double*, const int*, int*, const int*, int*, const int, const int));
extern void dspevx __P((const char, const char, const char, const int, double*, const double, const double, const int, const int, const double, int*, double*, double*, const int, int*, int*));
extern void dspevx_ __P((const char*, const char*, const char*, const int*, double*, const double*, const double*, const int*, const int*, const double*, int*, double*, double*, const int*, double*, int*, int*, int*, const int, const int, const int));
extern void dspev __P((const char, const char, const int, double*, double*, double*, const int, int*));
extern void dspev_ __P((const char*, const char*, const int*, double*, double*, double*, const int*, double*, int*, const int, const int));
extern void dspgst __P((const int, const char, const int, double*, const double*, int*));
extern void dspgst_ __P((const int*, const char*, const int*, double*, const double*, int*, const int));
extern void dspgvd __P((const int, const char, const char, const int, double*, double*, double*, double*, const int, int*));
extern void dspgvd_ __P((const int*, const char*, const char*, const int*, double*, double*, double*, double*, const int*, double*, const int*, int*, const int*, int*, const int, const int));
extern void dspgvx __P((const int, const char, const char, const char, const int, double*, double*, const double, const double, const int, const int, const double, int*, double*, double*, const int, int*, int*));
extern void dspgvx_ __P((const int*, const char*, const char*, const char*, const int*, double*, double*, const double*, const double*, const int*, const int*, const double*, int*, double*, double*, const int*, double*, int*, int*, int*, const int, const int, const int));
extern void dspgv __P((const int, const char, const char, const int, double*, double*, double*, double*, const int, int*));
extern void dspgv_ __P((const int*, const char*, const char*, const int*, double*, double*, double*, double*, const int*, double*, int*, const int, const int));
extern void dspmv __P((const char, const int, const double, const double*, const double*, const int, const double, double*, const int));
extern void dspmv_ __P((const char*, const int*, const double*, const double*, const double*, const int*, const double*, double*, const int*, const int));
extern void dspr2 __P((const char, const int, const double, const double*, const int, const double*, const int, double*));
extern void dspr2_ __P((const char*, const int*, const double*, const double*, const int*, const double*, const int*, double*, const int));
extern void dsprfs __P((const char, const int, const int, const double*, const double*, const int*, const double*, const int, double*, const int, double*, double*, int*));
extern void dsprfs_ __P((const char*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, double*, const int*, double*, double*, double*, int*, int*, const int));
extern void dspr __P((const char, const int, const double, const double*, const int, double*));
extern void dspr_ __P((const char*, const int*, const double*, const double*, const int*, double*, const int));
extern void dspsvx __P((const char, const char, const int, const int, const double*, double*, int*, const double*, const int, double*, const int, double*, double*, double*, int*));
extern void dspsvx_ __P((const char*, const char*, const int*, const int*, const double*, double*, int*, const double*, const int*, double*, const int*, double*, double*, double*, double*, int*, int*, const int, const int));
extern void dspsv __P((const char, const int, const int, double*, int*, double*, const int, int*));
extern void dspsv_ __P((const char*, const int*, const int*, double*, int*, double*, const int*, int*, const int));
extern void dsptrd __P((const char, const int, double*, double*, double*, double*, int*));
extern void dsptrd_ __P((const char*, const int*, double*, double*, double*, double*, int*, const int));
extern void dsptrf __P((const char, const int, double*, int*, int*));
extern void dsptrf_ __P((const char*, const int*, double*, int*, int*, const int));
extern void dsptri __P((const char, const int, double*, const int*, int*));
extern void dsptri_ __P((const char*, const int*, double*, const int*, double*, int*, const int));
extern void dsptrs __P((const char, const int, const int, const double*, const int*, double*, const int, int*));
extern void dsptrs_ __P((const char*, const int*, const int*, const double*, const int*, double*, const int*, int*, const int));
extern void dss_memerr __P((const char*, const int));
extern void dss_memerr_ __P((const char*, const int*, const int));
extern void dstebz __P((const char, const char, const int, const double, const double, const int, const int, const double, const double*, const double*, int*, int*, double*, int*, int*, int*));
extern void dstebz_ __P((const char*, const char*, const int*, const double*, const double*, const int*, const int*, const double*, const double*, const double*, int*, int*, double*, int*, int*, double*, int*, int*, const int, const int));
extern void dstedc __P((const char, const int, double*, double*, double*, const int, int*));
extern void dstedc_ __P((const char*, const int*, double*, double*, double*, const int*, double*, const int*, int*, const int*, int*, const int));
extern void dstegr __P((const char, const char, const int, double*, double*, const double, const double, const int, const int, const double, int*, double*, double*, const int, int*, int*));
extern void dstegr_ __P((const char*, const char*, const int*, double*, double*, const double*, const double*, const int*, const int*, const double*, int*, double*, double*, const int*, int*, double*, const int*, int*, const int*, int*, const int, const int));
extern void dstein __P((const int, const double*, const double*, const int, const double*, const int*, const int*, double*, const int, int*, int*));
extern void dstein_ __P((const int*, const double*, const double*, const int*, const double*, const int*, const int*, double*, const int*, double*, int*, int*, int*));
extern void dsteqr __P((const char, const int, double*, double*, double*, const int, int*));
extern void dsteqr_ __P((const char*, const int*, double*, double*, double*, const int*, double*, int*, const int));
extern void dsterf __P((const int, double*, double*, int*));
extern void dsterf_ __P((const int*, double*, double*, int*));
extern void dstevd __P((const char, const int, double*, double*, double*, const int, int*));
extern void dstevd_ __P((const char*, const int*, double*, double*, double*, const int*, double*, const int*, int*, const int*, int*, const int));
extern void dstevr __P((const char, const char, const int, double*, double*, const double, const double, const int, const int, const double, int*, double*, double*, const int, int*, int*));
extern void dstevr_ __P((const char*, const char*, const int*, double*, double*, const double*, const double*, const int*, const int*, const double*, int*, double*, double*, const int*, int*, double*, const int*, int*, const int*, int*, const int, const int));
extern void dstevx __P((const char, const char, const int, double*, double*, const double, const double, const int, const int, const double, int*, double*, double*, const int, int*, int*));
extern void dstevx_ __P((const char*, const char*, const int*, double*, double*, const double*, const double*, const int*, const int*, const double*, int*, double*, double*, const int*, double*, int*, int*, int*, const int, const int));
extern void dstev __P((const char, const int, double*, double*, double*, const int, int*));
extern void dstev_ __P((const char*, const int*, double*, double*, double*, const int*, double*, int*, const int));
extern void dstsv __P((const int, const int, double*, double*, double*, double*, const int, int*, int*));
extern void dstsv_ __P((const int*, const int*, double*, double*, double*, double*, const int*, int*, int*));
extern void dsttrf __P((const int, double*, double*, double*, int*, int*));
extern void dsttrf_ __P((const int*, double*, double*, double*, int*, int*));
extern void dsttrs __P((const int, const int, const double*, const double*, const double*, const double*, const int, int*, int*));
extern void dsttrs_ __P((const int*, const int*, const double*, const double*, const double*, const double*, const int*, int*, int*));
extern void dswap __P((const int, double*, const int, double*, const int));
extern void dswap_ __P((const int*, double*, const int*, double*, const int*));
extern void dsycon __P((const char, const int, const double*, const int, const int*, const double, double*, int*));
extern void dsycon_ __P((const char*, const int*, const double*, const int*, const int*, const double*, double*, double*, int*, int*, const int));
extern void dsyevd __P((const char, const char, const int, double*, const int, double*, int*));
extern void dsyevd_ __P((const char*, const char*, const int*, double*, const int*, double*, double*, const int*, int*, const int*, int*, const int, const int));
extern void dsyevr __P((const char, const char, const char, const int, double*, const int, const double, const double, const int, const int, const double, int*, double*, double*, const int, int*, int*));
extern void dsyevr_ __P((const char*, const char*, const char*, const int*, double*, const int*, const double*, const double*, const int*, const int*, const double*, int*, double*, double*, const int*, int*, double*, const int*, int*, const int*, int*, const int, const int, const int));
extern void dsyevx __P((const char, const char, const char, const int, double*, const int, const double, const double, const int, const int, const double, int*, double*, double*, const int, int*, int*));
extern void dsyevx_ __P((const char*, const char*, const char*, const int*, double*, const int*, const double*, const double*, const int*, const int*, const double*, int*, double*, double*, const int*, double*, const int*, int*, int*, int*, const int, const int, const int));
extern void dsyev __P((const char, const char, const int, double*, const int, double*, int*));
extern void dsyev_ __P((const char*, const char*, const int*, double*, const int*, double*, double*, const int*, int*, const int, const int));
extern void dsygs2 __P((const int, const char, const int, double*, const int, const double*, const int, int*));
extern void dsygs2_ __P((const int*, const char*, const int*, double*, const int*, const double*, const int*, int*, const int));
extern void dsygst __P((const int, const char, const int, double*, const int, const double*, const int, int*));
extern void dsygst_ __P((const int*, const char*, const int*, double*, const int*, const double*, const int*, int*, const int));
extern void dsygvd __P((const int, const char, const char, const int, double*, const int, double*, const int, double*, int*));
extern void dsygvd_ __P((const int*, const char*, const char*, const int*, double*, const int*, double*, const int*, double*, double*, const int*, int*, const int*, int*, const int, const int));
extern void dsygvx __P((const int, const char, const char, const char, const int, double*, const int, double*, const int, const double, const double, const int, const int, const double, int*, double*, double*, const int, int*, int*));
extern void dsygvx_ __P((const int*, const char*, const char*, const char*, const int*, double*, const int*, double*, const int*, const double*, const double*, const int*, const int*, const double*, int*, double*, double*, const int*, double*, const int*, int*, int*, int*, const int, const int, const int));
extern void dsygv __P((const int, const char, const char, const int, double*, const int, double*, const int, double*, int*));
extern void dsygv_ __P((const int*, const char*, const char*, const int*, double*, const int*, double*, const int*, double*, double*, const int*, int*, const int, const int));
extern void dsymm __P((const char, const char, const int, const int, const double, const double*, const int, const double*, const int, const double, double*, const int));
extern void dsymm_ __P((const char*, const char*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const double*, double*, const int*, const int, const int));
extern void dsymv __P((const char, const int, const double, const double*, const int, const double*, const int, const double, double*, const int));
extern void dsymv_ __P((const char*, const int*, const double*, const double*, const int*, const double*, const int*, const double*, double*, const int*, const int));
extern void dsyr2k __P((const char, const char, const int, const int, const double, const double*, const int, const double*, const int, const double, double*, const int));
extern void dsyr2k_ __P((const char*, const char*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const double*, double*, const int*, const int, const int));
extern void dsyr2 __P((const char, const int, const double, const double*, const int, const double*, const int, double*, const int));
extern void dsyr2_ __P((const char*, const int*, const double*, const double*, const int*, const double*, const int*, double*, const int*, const int));
extern void dsyrfs __P((const char, const int, const int, const double*, const int, const double*, const int, const int*, const double*, const int, double*, const int, double*, double*, int*));
extern void dsyrfs_ __P((const char*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const double*, const int*, double*, const int*, double*, double*, double*, int*, int*, const int));
extern void dsyrk __P((const char, const char, const int, const int, const double, const double*, const int, const double, double*, const int));
extern void dsyrk_ __P((const char*, const char*, const int*, const int*, const double*, const double*, const int*, const double*, double*, const int*, const int, const int));
extern void dsyr __P((const char, const int, const double, const double*, const int, double*, const int));
extern void dsyr_ __P((const char*, const int*, const double*, const double*, const int*, double*, const int*, const int));
extern void dsysvx __P((const char, const char, const int, const int, const double*, const int, double*, const int, int*, const double*, const int, double*, const int, double*, double*, double*, int*));
extern void dsysvx_ __P((const char*, const char*, const int*, const int*, const double*, const int*, double*, const int*, int*, const double*, const int*, double*, const int*, double*, double*, double*, double*, const int*, int*, int*, const int, const int));
extern void dsysv __P((const char, const int, const int, double*, const int, int*, double*, const int, int*));
extern void dsysv_ __P((const char*, const int*, const int*, double*, const int*, int*, double*, const int*, double*, const int*, int*, const int));
extern void dsytd2 __P((const char, const int, double*, const int, double*, double*, double*, int*));
extern void dsytd2_ __P((const char*, const int*, double*, const int*, double*, double*, double*, int*, const int));
extern void dsytf2 __P((const char, const int, double*, const int, int*, int*));
extern void dsytf2_ __P((const char*, const int*, double*, const int*, int*, int*, const int));
extern void dsytrd __P((const char, const int, double*, const int, double*, double*, double*, int*));
extern void dsytrd_ __P((const char*, const int*, double*, const int*, double*, double*, double*, double*, const int*, int*, const int));
extern void dsytrf __P((const char, const int, double*, const int, int*, int*));
extern void dsytrf_ __P((const char*, const int*, double*, const int*, int*, double*, const int*, int*, const int));
extern void dsytri __P((const char, const int, double*, const int, const int*, int*));
extern void dsytri_ __P((const char*, const int*, double*, const int*, const int*, double*, int*, const int));
extern void dsytrs __P((const char, const int, const int, const double*, const int, const int*, double*, const int, int*));
extern void dsytrs_ __P((const char*, const int*, const int*, const double*, const int*, const int*, double*, const int*, int*, const int));
extern void dtbcon __P((const char, const char, const char, const int, const int, const double*, const int, double*, int*));
extern void dtbcon_ __P((const char*, const char*, const char*, const int*, const int*, const double*, const int*, double*, double*, int*, int*, const int, const int, const int));
extern void dtbmv __P((const char, const char, const char, const int, const int, const double*, const int, double*, const int));
extern void dtbmv_ __P((const char*, const char*, const char*, const int*, const int*, const double*, const int*, double*, const int*, const int, const int, const int));
extern void dtbrfs __P((const char, const char, const char, const int, const int, const int, const double*, const int, const double*, const int, const double*, const int, double*, double*, int*));
extern void dtbrfs_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const double*, const int*, double*, double*, double*, int*, int*, const int, const int, const int));
extern void dtbsv __P((const char, const char, const char, const int, const int, const double*, const int, double*, const int));
extern void dtbsv_ __P((const char*, const char*, const char*, const int*, const int*, const double*, const int*, double*, const int*, const int, const int, const int));
extern void dtbtrs __P((const char, const char, const char, const int, const int, const int, const double*, const int, double*, const int, int*));
extern void dtbtrs_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const double*, const int*, double*, const int*, int*, const int, const int, const int));
extern void dtgevc __P((const char, const char, const int*, const int, const double*, const int, const double*, const int, double*, const int, double*, const int, const int, int*, int*));
extern void dtgevc_ __P((const char*, const char*, const int*, const int*, const double*, const int*, const double*, const int*, double*, const int*, double*, const int*, const int*, int*, double*, int*, const int, const int));
extern void dtgexc __P((const int, const int, const int, double*, const int, double*, const int, double*, const int, double*, const int, int*, int*, int*));
extern void dtgexc_ __P((const int*, const int*, const int*, double*, const int*, double*, const int*, double*, const int*, double*, const int*, int*, int*, double*, const int*, int*));
extern void dtgsen __P((const int, const int, const int, const int*, const int, double*, const int, double*, const int, double*, double*, double*, double*, const int, double*, const int, int*, double*, double*, double*, int*));
extern void dtgsen_ __P((const int*, const int*, const int*, const int*, const int*, double*, const int*, double*, const int*, double*, double*, double*, double*, const int*, double*, const int*, int*, double*, double*, double*, double*, const int*, int*, const int*, int*));
extern void dtgsja __P((const char, const char, const char, const int, const int, const int, const int, const int, double*, const int, double*, const int, const double, const double, double*, double*, double*, const int, double*, const int, double*, const int, int*, int*));
extern void dtgsja_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const int*, const int*, double*, const int*, double*, const int*, const double*, const double*, double*, double*, double*, const int*, double*, const int*, double*, const int*, double*, int*, int*, const int, const int, const int));
extern void dtgsna __P((const char, const char, const int*, const int, const double*, const int, const double*, const int, const double*, const int, const double*, const int, double*, double*, const int, int*, int*));
extern void dtgsna_ __P((const char*, const char*, const int*, const int*, const double*, const int*, const double*, const int*, const double*, const int*, const double*, const int*, double*, double*, const int*, int*, double*, const int*, int*, int*, const int, const int));
extern void dtgsyl __P((const char, const int, const int, const int, const double*, const int, const double*, const int, double*, const int, const double*, const int, const double*, const int, double*, const int, double*, double*, int*));
extern void dtgsyl_ __P((const char*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, double*, const int*, const double*, const int*, const double*, const int*, double*, const int*, double*, double*, double*, const int*, int*, int*, const int));
extern void dtpcon __P((const char, const char, const char, const int, const double*, double*, int*));
extern void dtpcon_ __P((const char*, const char*, const char*, const int*, const double*, double*, double*, int*, int*, const int, const int, const int));
extern void dtpmv __P((const char, const char, const char, const int, const double*, double*, const int));
extern void dtpmv_ __P((const char*, const char*, const char*, const int*, const double*, double*, const int*, const int, const int, const int));
extern void dtprfs __P((const char, const char, const char, const int, const int, const double*, const double*, const int, const double*, const int, double*, double*, int*));
extern void dtprfs_ __P((const char*, const char*, const char*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, double*, double*, double*, int*, int*, const int, const int, const int));
extern void dtpsv __P((const char, const char, const char, const int, const double*, double*, const int));
extern void dtpsv_ __P((const char*, const char*, const char*, const int*, const double*, double*, const int*, const int, const int, const int));
extern void dtptri __P((const char, const char, const int, double*, int*));
extern void dtptri_ __P((const char*, const char*, const int*, double*, int*, const int, const int));
extern void dtptrs __P((const char, const char, const char, const int, const int, const double*, double*, const int, int*));
extern void dtptrs_ __P((const char*, const char*, const char*, const int*, const int*, const double*, double*, const int*, int*, const int, const int, const int));
extern void dtrans __P((const char, const double, double*, const int, const int, double*));
extern void dtrans_ __P((const char*, const double*, double*, const int*, const int*, double*, const int));
extern void dtrcon __P((const char, const char, const char, const int, const double*, const int, double*, int*));
extern void dtrcon_ __P((const char*, const char*, const char*, const int*, const double*, const int*, double*, double*, int*, int*, const int, const int, const int));
extern void dtrevc __P((const char, const char, int*, const int, double*, const int, double*, const int, double*, const int, const int, int*, int*));
extern void dtrevc_ __P((const char*, const char*, int*, const int*, double*, const int*, double*, const int*, double*, const int*, const int*, int*, double*, int*, const int, const int));
extern void dtrexc __P((const char, const int, double*, const int, double*, const int, int*, int*, int*));
extern void dtrexc_ __P((const char*, const int*, double*, const int*, double*, const int*, int*, int*, double*, int*, const int));
extern void dtrmm __P((const char, const char, const char, const char, const int, const int, const double, const double*, const int, double*, const int));
extern void dtrmm_ __P((const char*, const char*, const char*, const char*, const int*, const int*, const double*, const double*, const int*, double*, const int*, const int, const int, const int, const int));
extern void dtrmv __P((const char, const char, const char, const int, const double*, const int, double*, const int));
extern void dtrmv_ __P((const char*, const char*, const char*, const int*, const double*, const int*, double*, const int*, const int, const int, const int));
extern void dtrrfs __P((const char, const char, const char, const int, const int, const double*, const int, const double*, const int, const double*, const int, double*, double*, int*));
extern void dtrrfs_ __P((const char*, const char*, const char*, const int*, const int*, const double*, const int*, const double*, const int*, const double*, const int*, double*, double*, double*, int*, int*, const int, const int, const int));
extern void dtrsen __P((const char, const char, const int*, const int, double*, const int, double*, const int, double*, double*, int*, double*, double*, int*));
extern void dtrsen_ __P((const char*, const char*, const int*, const int*, double*, const int*, double*, const int*, double*, double*, int*, double*, double*, double*, const int*, int*, const int*, int*, const int, const int));
extern void dtrsm __P((const char, const char, const char, const char, const int, const int, const double, const double*, const int, double*, const int));
extern void dtrsm_ __P((const char*, const char*, const char*, const char*, const int*, const int*, const double*, const double*, const int*, double*, const int*, const int, const int, const int, const int));
extern void dtrsna __P((const char, const char, const int*, const int, const double*, const int, const double*, const int, const double*, const int, double*, double*, const int, int*, const int, int*));
extern void dtrsna_ __P((const char*, const char*, const int*, const int*, const double*, const int*, const double*, const int*, const double*, const int*, double*, double*, const int*, int*, double*, const int*, int*, int*, const int, const int));
extern void dtrsv __P((const char, const char, const char, const int, const double*, const int, double*, const int));
extern void dtrsv_ __P((const char*, const char*, const char*, const int*, const double*, const int*, double*, const int*, const int, const int, const int));
extern void dtrsyl __P((const char, const char, const int, const int, const int, const double*, const int, const double*, const int, double*, const int, double*, int*));
extern void dtrsyl_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, double*, const int*, double*, int*, const int, const int));
extern void dtrti2 __P((const char, const char, const int, double*, const int, int*));
extern void dtrti2_ __P((const char*, const char*, const int*, double*, const int*, int*, const int, const int));
extern void dtrtri __P((const char, const char, const int, double*, const int, int*));
extern void dtrtri_ __P((const char*, const char*, const int*, double*, const int*, int*, const int, const int));
extern void dtrtrs __P((const char, const char, const char, const int, const int, const double*, const int, double*, const int, int*));
extern void dtrtrs_ __P((const char*, const char*, const char*, const int*, const int*, const double*, const int*, double*, const int*, int*, const int, const int, const int));
extern void dtzrqf __P((const int, const int, double*, const int, double*, int*));
extern void dtzrqf_ __P((const int*, const int*, double*, const int*, double*, int*));
extern void dtzrzf __P((const int, const int, double*, const int, double*, int*));
extern void dtzrzf_ __P((const int*, const int*, double*, const int*, double*, double*, const int*, int*));
extern void dvbrmm __P((const int, const int, const int, const int, const double, const int*, const double*, const int*, const int*, const int*, const int*, const int*, const int*, const double*, const int, const double, double*, const int));
extern void dvbrmm_ __P((const int*, const int*, const int*, const int*, const double*, const int*, const double*, const int*, const int*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dvbrsm __P((const int, const int, const int, const int, const double*, const double, const int*, const double*, const int*, const int*, const int*, const int*, const int*, const int*, const double*, const int, const double, double*, const int));
extern void dvbrsm_ __P((const int*, const int*, const int*, const int*, const double*, const double*, const int*, const double*, const int*, const int*, const int*, const int*, const int*, const int*, const double*, const int*, const double*, double*, const int*, double*, const int*));
extern void dwiener __P((const int, const double*, const double*, double*, const double*, int*, int*));
extern void dwiener_ __P((const int*, const double*, const double*, double*, const double*, int*, int*));
extern double dzasum __P((const int, const doublecomplex*, const int));
extern double dzasum_ __P((const int*, const doublecomplex*, const int*));
extern double dznrm2 __P((const int, const doublecomplex*, const int));
extern double dznrm2_ __P((const int*, const doublecomplex*, const int*));
extern void ezfftb __P((const int, float*, const float, const float*, const float*, const float*));
extern void ezfftb_ __P((const int*, float*, const float*, const float*, const float*, const float*));
extern void ezfftf __P((const int, const float*, float*, float*, float*, const float*));
extern void ezfftf_ __P((const int*, const float*, float*, float*, float*, const float*));
extern void ezffti __P((const int, float*));
extern void ezffti_ __P((const int*, float*));
extern int icamax __P((const int, const floatcomplex*, const int));
extern int icamax_ __P((const int*, const floatcomplex*, const int*));
extern int idamax __P((const int, const double*, const int));
extern int idamax_ __P((const int*, const double*, const int*));
extern int ieeeck __P((const int, const float, const float));
extern int ieeeck_ __P((const int*, const float*, const float*));
extern int ilaenv __P((const int, const char*, const char*, const int, const int, const int, const int));
extern int ilaenv_ __P((const int*, const char*, const char*, const int*, const int*, const int*, const int*, const int, const int));
extern int isamax __P((const int, const float*, const int));
extern int isamax_ __P((const int*, const float*, const int*));
extern int izamax __P((const int, const doublecomplex*, const int));
extern int izamax_ __P((const int*, const doublecomplex*, const int*));
extern int lsame __P((const char, const char));
extern int lsame_ __P((const char*, const char*, const int, const int));
extern void rfft2b __P((const char, const int, const int, float*, const int, float*, const int, float*, const int));
extern void rfft2b_ __P((const char*, const int*, const int*, float*, const int*, float*, const int*, float*, const int*, const int));
extern void rfft2f __P((const char, const char, const int, const int, float*, const int, float*, const int, float*, const int));
extern void rfft2f_ __P((const char*, const char*, const int*, const int*, float*, const int*, float*, const int*, float*, const int*, const int, const int));
extern void rfft2i __P((const int, const int, float*));
extern void rfft2i_ __P((const int*, const int*, float*));
extern void rfft3b __P((const char, const int, const int, const int, float*, const int, float*, const int, float*, const int));
extern void rfft3b_ __P((const char*, const int*, const int*, const int*, float*, const int*, float*, const int*, float*, const int*, const int));
extern void rfft3f __P((const char, const char, const int, const int, const int, float*, const int, float*, const int, float*, const int));
extern void rfft3f_ __P((const char*, const char*, const int*, const int*, const int*, float*, const int*, float*, const int*, float*, const int*, const int, const int));
extern void rfft3i __P((const int, const int, const int, float*));
extern void rfft3i_ __P((const int*, const int*, const int*, float*));
extern void rfftb __P((const int, float*, const float*));
extern void rfftb_ __P((const int*, float*, const float*));
extern void rfftf __P((const int, float*, const float*));
extern void rfftf_ __P((const int*, float*, const float*));
extern void rffti __P((const int, float*));
extern void rffti_ __P((const int*, float*));
extern int rfftopt __P((const int));
extern int rfftopt_ __P((const int*));
extern float sasum __P((const int, const float*, const int));
extern float sasum_ __P((const int*, const float*, const int*));
extern void saxpyi __P((const int, const float, const float*, const int*, float*));
extern void saxpyi_ __P((const int*, const float*, const float*, const int*, float*));
extern void saxpy __P((const int, const float, const float*, const int, float*, const int));
extern void saxpy_ __P((const int*, const float*, const float*, const int*, float*, const int*));
extern void sbcomm __P((const int, const int, const int, const int, const float, const int*, const float*, const int*, const int*, const int, const int, const float*, const int, const float, float*, const int));
extern void sbcomm_ __P((const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sbdimm __P((const int, const int, const int, const int, const float, const int*, const float*, const int, const int*, const int, const int, const float*, const int, const float, float*, const int));
extern void sbdimm_ __P((const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sbdism __P((const int, const int, const int, const int, const float*, const float, const int*, const float*, const int, const int*, const int, const int, const float*, const int, const float, float*, const int));
extern void sbdism_ __P((const int*, const int*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sbdsdc __P((const char, const char, const int, float*, float*, float*, const int, float*, const int, float*, int*, int*));
extern void sbdsdc_ __P((const char*, const char*, const int*, float*, float*, float*, const int*, float*, const int*, float*, int*, float*, int*, int*, const int, const int));
extern void sbdsqr __P((const char, const int, const int, const int, const int, float*, float*, float*, const int, float*, const int, float*, const int, int*));
extern void sbdsqr_ __P((const char*, const int*, const int*, const int*, const int*, float*, float*, float*, const int*, float*, const int*, float*, const int*, float*, int*, const int));
extern void sbelmm __P((const int, const int, const int, const int, const float, const int*, const float*, const int*, const int, const int, const int, const float*, const int, const float, float*, const int));
extern void sbelmm_ __P((const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sbelsm __P((const int, const int, const int, const int, const float*, const float, const int*, const float*, const int*, const int, const int, const int, const float*, const int, const float, float*, const int));
extern void sbelsm_ __P((const int*, const int*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sbscmm __P((const int, const int, const int, const int, const float, const int*, const float*, const int*, const int*, const int*, const int, const float*, const int, const float, float*, const int));
extern void sbscmm_ __P((const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sbscsm __P((const int, const int, const int, const int, const float*, const float, const int*, const float*, const int*, const int*, const int*, const int, const float*, const int, const float, float*, const int));
extern void sbscsm_ __P((const int*, const int*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sbsrmm __P((const int, const int, const int, const int, const float, const int*, const float*, const int*, const int*, const int*, const int, const float*, const int, const float, float*, const int));
extern void sbsrmm_ __P((const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sbsrsm __P((const int, const int, const int, const int, const float*, const float, const int*, const float*, const int*, const int*, const int*, const int, const float*, const int, const float, float*, const int));
extern void sbsrsm_ __P((const int*, const int*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern float scasum __P((const int, const floatcomplex*, const int));
extern float scasum_ __P((const int*, const floatcomplex*, const int*));
extern float scnrm2 __P((const int, const floatcomplex*, const int));
extern float scnrm2_ __P((const int*, const floatcomplex*, const int*));
extern void scnvcor2 __P((const char, const char, const char, const char, const char, const char, const int, const int, const float*, const int, const int, const int, const int, const int, const float*, const int, const int, const int, float*, const int, floatcomplex*, const int));
extern void scnvcor2_ __P((const char*, const char*, const char*, const char*, const char*, const char*, const int*, const int*, const float*, const int*, const int*, const int*, const int*, const int*, const float*, const int*, const int*, const int*, float*, const int*, floatcomplex*, const int*, const int, const int, const int, const int, const int, const int));
extern void scnvcor __P((const char, const char, const int, const float*, const int, const int, const int, const int, const int, const float*, const int, const int, const int, const int, const int, float*, const int, const int, const int, float*, const int));
extern void scnvcor_ __P((const char*, const char*, const int*, const float*, const int*, const int*, const int*, const int*, const int*, const float*, const int*, const int*, const int*, const int*, const int*, float*, const int*, const int*, const int*, float*, const int*, const int, const int));
extern void scoomm __P((const int, const int, const int, const int, const float, const int*, const float*, const int*, const int*, const int, const float*, const int, const float, float*, const int));
extern void scoomm_ __P((const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void scopy __P((const int, const float*, const int, float*, const int));
extern void scopy_ __P((const int*, const float*, const int*, float*, const int*));
extern void scscmm __P((const int, const int, const int, const int, const float, const int*, const float*, const int*, const int*, const int*, const float*, const int, const float, float*, const int));
extern void scscmm_ __P((const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void scscsm __P((const int, const int, const int, const int, const float*, const float, const int*, const float*, const int*, const int*, const int*, const float*, const int, const float, float*, const int));
extern void scscsm_ __P((const int*, const int*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void scsrmm __P((const int, const int, const int, const int, const float, const int*, const float*, const int*, const int*, const int*, const float*, const int, const float, float*, const int));
extern void scsrmm_ __P((const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void scsrsm __P((const int, const int, const int, const int, const float*, const float, const int*, const float*, const int*, const int*, const int*, const float*, const int, const float, float*, const int));
extern void scsrsm_ __P((const int*, const int*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sdiamm __P((const int, const int, const int, const int, const float, const int*, const float*, const int, const int*, const int, const float*, const int, const float, float*, const int));
extern void sdiamm_ __P((const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sdiasm __P((const int, const int, const int, const int, const float*, const float, const int*, const float*, const int, const int*, const int, const float*, const int, const float, float*, const int));
extern void sdiasm_ __P((const int*, const int*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sdisna __P((const char, const int, const int, const float*, float*, int*));
extern void sdisna_ __P((const char*, const int*, const int*, const float*, float*, int*, const int));
extern float sdoti __P((const int, const float*, const int*, const float*));
extern float sdoti_ __P((const int*, const float*, const int*, const float*));
extern float sdot __P((const int, const float*, const int, const float*, const int));
extern float sdot_ __P((const int*, const float*, const int*, const float*, const int*));
extern float sdsdot __P((const int, const float, const float*, const int, const float*, const int));
extern float sdsdot_ __P((const int*, const float*, const float*, const int*, const float*, const int*));
extern float second __P((void));
extern float second_ __P((void));
extern void sellmm __P((const int, const int, const int, const int, const float, const int*, const float*, const int*, const int, const int, const float*, const int, const float, float*, const int));
extern void sellmm_ __P((const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sellsm __P((const int, const int, const int, const int, const float*, const float, const int*, const float*, const int*, const int, const int, const float*, const int, const float, float*, const int));
extern void sellsm_ __P((const int*, const int*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sfftc2_ __P((const int*, const int*, const int*, const float*, const float*, const int*, floatcomplex*, const int*, float*, int*, float*, const int*, int*));
extern void sfftc3_ __P((const int*, const int*, const int*, const int*, const float*, const float*, const int*, const int*, floatcomplex*, const int*, const int*, float*, int*, float*, const int*, int*));
extern void sfftcm_ __P((const int*, const int*, const int*, const float*, const float*, const int*, floatcomplex*, const int*, float*, int*, float*, const int*, int*));
extern void sfftc_ __P((const int*, const int*, const float*, const float*, floatcomplex*, float*, int*, float*, const int*, int*));
extern void sgbbrd __P((const char, const int, const int, const int, const int, const int, float*, const int, float*, float*, float*, const int, float*, const int, float*, const int, int*));
extern void sgbbrd_ __P((const char*, const int*, const int*, const int*, const int*, const int*, float*, const int*, float*, float*, float*, const int*, float*, const int*, float*, const int*, float*, int*, const int));
extern void sgbcon __P((const char, const int, const int, const int, const float*, const int, const int*, const float, float*, int*));
extern void sgbcon_ __P((const char*, const int*, const int*, const int*, const float*, const int*, const int*, const float*, float*, float*, int*, int*, const int));
extern void sgbequ __P((const int, const int, const int, const int, const float*, const int, float*, float*, float*, float*, float*, int*));
extern void sgbequ_ __P((const int*, const int*, const int*, const int*, const float*, const int*, float*, float*, float*, float*, float*, int*));
extern void sgbmv __P((const char, const int, const int, const int, const int, const float, const float*, const int, const float*, const int, const float, float*, const int));
extern void sgbmv_ __P((const char*, const int*, const int*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const float*, float*, const int*, const int));
extern void sgbrfs __P((const char, const int, const int, const int, const int, const float*, const int, const float*, const int, const int*, const float*, const int, float*, const int, float*, float*, int*));
extern void sgbrfs_ __P((const char*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const float*, const int*, float*, const int*, float*, float*, float*, int*, int*, const int));
extern void sgbsvx __P((const char, const char, const int, const int, const int, const int, float*, const int, float*, const int, int*, char*, float*, float*, float*, const int, float*, const int, float*, float*, float*, int*));
extern void sgbsvx_ __P((const char*, const char*, const int*, const int*, const int*, const int*, float*, const int*, float*, const int*, int*, char*, float*, float*, float*, const int*, float*, const int*, float*, float*, float*, float*, int*, int*, const int, const int, const int));
extern void sgbsv __P((const int, const int, const int, const int, float*, const int, int*, float*, const int, int*));
extern void sgbsv_ __P((const int*, const int*, const int*, const int*, float*, const int*, int*, float*, const int*, int*));
extern void sgbtf2 __P((const int, const int, const int, const int, float*, const int, int*, int*));
extern void sgbtf2_ __P((const int*, const int*, const int*, const int*, float*, const int*, int*, int*));
extern void sgbtrf __P((const int, const int, const int, const int, float*, const int, int*, int*));
extern void sgbtrf_ __P((const int*, const int*, const int*, const int*, float*, const int*, int*, int*));
extern void sgbtrs __P((const char, const int, const int, const int, const int, const float*, const int, const int*, float*, const int, int*));
extern void sgbtrs_ __P((const char*, const int*, const int*, const int*, const int*, const float*, const int*, const int*, float*, const int*, int*, const int));
extern void sgebak __P((const char, const char, const int, const int, const int, const float*, const int, float*, const int, int*));
extern void sgebak_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const int*, float*, const int*, int*, const int, const int));
extern void sgebal __P((const char, const int, float*, const int, int*, int*, float*, int*));
extern void sgebal_ __P((const char*, const int*, float*, const int*, int*, int*, float*, int*, const int));
extern void sgebrd __P((const int, const int, float*, const int, float*, float*, float*, float*, int*));
extern void sgebrd_ __P((const int*, const int*, float*, const int*, float*, float*, float*, float*, float*, const int*, int*));
extern void sgecon __P((const char, const int, const float*, const int, const float, float*, int*));
extern void sgecon_ __P((const char*, const int*, const float*, const int*, const float*, float*, float*, int*, int*, const int));
extern void sgeequ __P((const int, const int, const float*, const int, float*, float*, float*, float*, float*, int*));
extern void sgeequ_ __P((const int*, const int*, const float*, const int*, float*, float*, float*, float*, float*, int*));
extern void sgeesx __P((const char, const char, const int(*select)(float,float), const char, const int, float*, const int, int*, float*, float*, float*, const int, float*, float*, int*));
extern void sgeesx_ __P((const char*, const char*, const int(*select)(float,float), const char*, const int*, float*, const int*, int*, float*, float*, float*, const int*, float*, float*, float*, const int*, int*, const int*, int*, int*, const int, const int, const int));
extern void sgees __P((const char, const char, const int(*select)(float,float), const int, float*, const int, int*, float*, float*, float*, const int, int*));
extern void sgees_ __P((const char*, const char*, const int(*select)(float,float), const int*, float*, const int*, int*, float*, float*, float*, const int*, float*, const int*, int*, int*, const int, const int));
extern void sgeevx __P((const char, const char, const char, const char, const int, float*, const int, float*, float*, float*, const int, float*, const int, int*, int*, float*, float*, float*, float*, int*));
extern void sgeevx_ __P((const char*, const char*, const char*, const char*, const int*, float*, const int*, float*, float*, float*, const int*, float*, const int*, int*, int*, float*, float*, float*, float*, double*, const int*, int*, int*, const int, const int, const int, const int));
extern void sgeev __P((const char, const char, const int, float*, const int, float*, float*, float*, const int, float*, const int, int*));
extern void sgeev_ __P((const char*, const char*, const int*, float*, const int*, float*, float*, float*, const int*, float*, const int*, float*, const int*, int*, const int, const int));
extern void sgegs __P((const char, const char, const int, float*, const int, float*, const int, float*, float*, float*, float*, const int, float*, const int, int*));
extern void sgegs_ __P((const char*, const char*, const int*, float*, const int*, float*, const int*, float*, float*, float*, float*, const int*, float*, const int*, float*, const int*, int*, const int, const int));
extern void sgegv __P((const char, const char, const int, float*, const int, float*, const int, float*, float*, float*, float*, const int, float*, const int, int*));
extern void sgegv_ __P((const char*, const char*, const int*, float*, const int*, float*, const int*, float*, float*, float*, float*, const int*, float*, const int*, float*, const int*, int*, const int, const int));
extern void sgehrd __P((const int, const int, const int, float*, const int, float*, int*));
extern void sgehrd_ __P((const int*, const int*, const int*, float*, const int*, float*, float*, const int*, int*));
extern void sgelqf __P((const int, const int, float*, const int, float*, int*));
extern void sgelqf_ __P((const int*, const int*, float*, const int*, float*, float*, const int*, int*));
extern void sgelsd __P((const int, const int, const int, float*, const int, float*, const int, float*, const float, int*, int*));
extern void sgelsd_ __P((const int*, const int*, const int*, float*, const int*, float*, const int*, float*, const float*, int*, float*, const int*, int*, int*));
extern void sgelss __P((const int, const int, const int, float*, const int, float*, const int, float*, const float, int*, int*));
extern void sgelss_ __P((const int*, const int*, const int*, float*, const int*, float*, const int*, float*, const float*, int*, float*, const int*, int*));
extern void sgelsx __P((const int, const int, const int, float*, const int, float*, const int, int*, const float, int*, int*));
extern void sgelsx_ __P((const int*, const int*, const int*, float*, const int*, float*, const int*, int*, const float*, int*, float*, int*));
extern void sgelsy __P((const int, const int, const int, float*, const int, float*, const int, int*, const float, int*, int*));
extern void sgelsy_ __P((const int*, const int*, const int*, float*, const int*, float*, const int*, int*, const float*, int*, float*, const int*, int*));
extern void sgels __P((const char, const int, const int, const int, float*, const int, float*, const int, int*));
extern void sgels_ __P((const char*, const int*, const int*, const int*, float*, const int*, float*, const int*, float*, const int*, int*, const int));
extern void sgemm __P((const char, const char, const int, const int, const int, const float, const float*, const int, const float*, const int, const float, float*, const int));
extern void sgemm_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const float*, float*, const int*, const int, const int));
extern void sgemv __P((const char, const int, const int, const float, const float*, const int, const float*, const int, const float, float*, const int));
extern void sgemv_ __P((const char*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const float*, float*, const int*, const int));
extern void sgeqlf __P((const int, const int, float*, const int, float*, int*));
extern void sgeqlf_ __P((const int*, const int*, float*, const int*, float*, float*, const int*, int*));
extern void sgeqp3 __P((const int, const int, float*, const int, int*, float*, int*));
extern void sgeqp3_ __P((const int*, const int*, float*, const int*, int*, float*, float*, const int*, int*));
extern void sgeqpf __P((const int, const int, float*, const int, int*, float*, int*));
extern void sgeqpf_ __P((const int*, const int*, float*, const int*, int*, float*, float*, int*));
extern void sgeqrf __P((const int, const int, float*, const int, float*, int*));
extern void sgeqrf_ __P((const int*, const int*, float*, const int*, float*, float*, const int*, int*));
extern void sgerfs __P((const char, const int, const int, const float*, const int, const float*, const int, const int*, const float*, const int, float*, const int, float*, float*, int*));
extern void sgerfs_ __P((const char*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const float*, const int*, float*, const int*, float*, float*, float*, int*, int*, const int));
extern void sgerqf __P((const int, const int, float*, const int, float*, int*));
extern void sgerqf_ __P((const int*, const int*, float*, const int*, float*, float*, const int*, int*));
extern void sger __P((const int, const int, const float, const float*, const int, const float*, const int, float*, const int));
extern void sger_ __P((const int*, const int*, const float*, const float*, const int*, const float*, const int*, float*, const int*));
extern void sgesdd __P((const char, const int, const int, float*, const int, float*, float*, const int, float*, const int, int*));
extern void sgesdd_ __P((const char*, const int*, const int*, float*, const int*, float*, float*, const int*, float*, const int*, float*, const int*, int*, int*, const int));
extern void sgesvd __P((const char, const char, const int, const int, float*, const int, float*, float*, const int, float*, const int, int*));
extern void sgesvd_ __P((const char*, const char*, const int*, const int*, float*, const int*, float*, float*, const int*, float*, const int*, float*, const int*, int*, const int, const int));
extern void sgesvx __P((const char, const char, const int, const int, float*, const int, float*, const int, int*, char*, float*, float*, float*, const int, float*, const int, float*, float*, float*, int*));
extern void sgesvx_ __P((const char*, const char*, const int*, const int*, float*, const int*, float*, const int*, int*, char*, float*, float*, float*, const int*, float*, const int*, float*, float*, float*, float*, int*, int*, const int, const int, const int));
extern void sgesv __P((const int, const int, float*, const int, int*, float*, const int, int*));
extern void sgesv_ __P((const int*, const int*, float*, const int*, int*, float*, const int*, int*));
extern void sgetf2 __P((const int, const int, float*, const int, int*, int*));
extern void sgetf2_ __P((const int*, const int*, float*, const int*, int*, int*));
extern void sgetrf __P((const int, const int, float*, const int, int*, int*));
extern void sgetrf_ __P((const int*, const int*, float*, const int*, int*, int*));
extern void sgetri __P((const int, float*, const int, const int*, int*));
extern void sgetri_ __P((const int*, float*, const int*, const int*, float*, const int*, int*));
extern void sgetrs __P((const char, const int, const int, const float*, const int, const int*, float*, const int, int*));
extern void sgetrs_ __P((const char*, const int*, const int*, const float*, const int*, const int*, float*, const int*, int*, const int));
extern void sggbak __P((const char, const char, const int, const int, const int, const float*, const float*, const int, float*, const int, int*));
extern void sggbak_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const float*, const int*, float*, const int*, int*, const int, const int));
extern void sggbal __P((const char, const int, float*, const int, float*, const int, int*, int*, const float*, const float*, int*));
extern void sggbal_ __P((const char*, const int*, float*, const int*, float*, const int*, int*, int*, const float*, const float*, float*, int*, const int));
extern void sggesx __P((const char, const char, const char, const int(*selctg)(float,float,float), const char, const int, float*, const int, float*, const int, int*, float*, float*, float*, float*, const int, float*, const int, float*, float*, int*));
extern void sggesx_ __P((const char*, const char*, const char*, const int(*selctg)(float,float,float), const char*, const int*, float*, const int*, float*, const int*, int*, float*, float*, float*, float*, const int*, float*, const int*, float*, float*, float*, const int*, int*, const int*, int*, int*, const int, const int, const int, const int));
extern void sgges __P((const char, const char, const char, const int(*selctg)(float,float,float), const int, float*, const int, float*, const int, int*, float*, float*, float*, float*, const int, float*, const int, int*));
extern void sgges_ __P((const char*, const char*, const char*, const int(*selctg)(float,float,float), const int*, float*, const int*, float*, const int*, int*, float*, float*, float*, float*, const int*, float*, const int*, float*, const int*, int*, int*, const int, const int, const int));
extern void sggevx __P((const char, const char, const char, const char, const int, float*, const int, float*, const int, float*, float*, float*, float*, const int, float*, const int, int*, int*, float*, float*, float*, float*, float*, float*, int*));
extern void sggevx_ __P((const char*, const char*, const char*, const char*, const int*, float*, const int*, float*, const int*, float*, float*, float*, float*, const int*, float*, const int*, int*, int*, float*, float*, float*, float*, float*, float*, float*, const int*, int*, int*, int*, const int, const int, const int, const int));
extern void sggev __P((const char, const char, const int, float*, const int, float*, const int, float*, float*, float*, float*, const int, float*, const int, int*));
extern void sggev_ __P((const char*, const char*, const int*, float*, const int*, float*, const int*, float*, float*, float*, float*, const int*, float*, const int*, float*, const int*, int*, const int, const int));
extern void sggglm __P((const int, const int, const int, float*, const int, float*, const int, float*, float*, float*, int*));
extern void sggglm_ __P((const int*, const int*, const int*, float*, const int*, float*, const int*, float*, float*, float*, float*, const int*, int*));
extern void sgghrd __P((const char, const char, const int, const int, const int, float*, const int, float*, const int, float*, const int, float*, const int, int*));
extern void sgghrd_ __P((const char*, const char*, const int*, const int*, const int*, float*, const int*, float*, const int*, float*, const int*, float*, const int*, int*, const int, const int));
extern void sgglse __P((const int, const int, const int, float*, const int, float*, const int, float*, float*, float*, int*));
extern void sgglse_ __P((const int*, const int*, const int*, float*, const int*, float*, const int*, float*, float*, float*, float*, const int*, int*));
extern void sggqrf __P((const int, const int, const int, float*, const int, float*, float*, const int, float*, int*));
extern void sggqrf_ __P((const int*, const int*, const int*, float*, const int*, float*, float*, const int*, float*, float*, const int*, int*));
extern void sggrqf __P((const int, const int, const int, float*, const int, float*, float*, const int, float*, int*));
extern void sggrqf_ __P((const int*, const int*, const int*, float*, const int*, float*, float*, const int*, float*, float*, const int*, int*));
extern void sggsvd __P((const char, const char, const char, const int, const int, const int, int*, int*, float*, const int, float*, const int, float*, float*, float*, const int, float*, const int, float*, const int, int*, int*));
extern void sggsvd_ __P((const char*, const char*, const char*, const int*, const int*, const int*, int*, int*, float*, const int*, float*, const int*, float*, float*, float*, const int*, float*, const int*, float*, const int*, float*, int*, int*, const int, const int, const int));
extern void sggsvp __P((const char, const char, const char, const int, const int, const int, float*, const int, float*, const int, const float, const float, int*, int*, float*, const int, float*, const int, float*, const int, int*));
extern void sggsvp_ __P((const char*, const char*, const char*, const int*, const int*, const int*, float*, const int*, float*, const int*, const float*, const float*, int*, int*, float*, const int*, float*, const int*, float*, const int*, int*, float*, float*, int*, const int, const int, const int));
extern void sgssco_ __P((float*, double*, int*));
extern void sgssda_ __P((double*, int*));
extern void sgssfa_ __P((const int*, const int*, const int*, const float*, double*, int*));
extern void sgssfs_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const int*, float*, const int*, const char*, const int*, const int*, double*, int*, const int, const int, const int));
extern void sgssin_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const int*, double*, int*, const int, const int));
extern void sgssor_ __P((const char*, double*, int*, const int));
extern void sgssps_ __P((double*, int*));
extern void sgssrp_ __P((int*, double*, int*));
extern void sgsssl_ __P((const int*, float*, const int*, double*, int*));
extern void sgssuo_ __P((const int*, double*, int*));
extern void sgtcon __P((const char, const int, const float*, const float*, const float*, const float*, const int*, const float, float*, int*));
extern void sgtcon_ __P((const char*, const int*, const float*, const float*, const float*, const float*, const int*, const float*, float*, float*, int*, int*, const int));
extern void sgthrz __P((const int, float*, float*, const int*));
extern void sgthrz_ __P((const int*, float*, float*, const int*));
extern void sgthr __P((const int, const float*, float*, const int*));
extern void sgthr_ __P((const int*, const float*, float*, const int*));
extern void sgtrfs __P((const char, const int, const int, const float*, const float*, const float*, const float*, const float*, const float*, const float*, const int*, const float*, const int, float*, const int, float*, float*, int*));
extern void sgtrfs_ __P((const char*, const int*, const int*, const float*, const float*, const float*, const float*, const float*, const float*, const float*, const int*, const float*, const int*, float*, const int*, float*, float*, float*, int*, int*, const int));
extern void sgtsvx __P((const char, const char, const int, const int, const float*, const float*, float*, float*, float*, float*, float*, int*, const float*, const int, float*, const int, float*, float*, float*, int*));
extern void sgtsvx_ __P((const char*, const char*, const int*, const int*, const float*, const float*, float*, float*, float*, float*, float*, int*, const float*, const int*, float*, const int*, float*, float*, float*, float*, int*, int*, const int, const int));
extern void sgtsv __P((const int, const int, float*, float*, float*, float*, const int, int*));
extern void sgtsv_ __P((const int*, const int*, float*, float*, float*, float*, const int*, int*));
extern void sgttrf __P((const int, float*, float*, float*, float*, int*, int*));
extern void sgttrf_ __P((const int*, float*, float*, float*, float*, int*, int*));
extern void sgttrs __P((const char, const int, const int, const float*, const float*, const float*, const float*, const int*, float*, const int, int*));
extern void sgttrs_ __P((const char*, const int*, const int*, const float*, const float*, const float*, const float*, const int*, float*, const int*, int*, const int));
extern void shgeqz __P((const char, const char, const char, const int, const int, const int, float*, const int, float*, const int, float*, float*, float*, float*, const int, float*, const int, int*));
extern void shgeqz_ __P((const char*, const char*, const char*, const int*, const int*, const int*, float*, const int*, float*, const int*, float*, float*, float*, float*, const int*, float*, const int*, float*, const int*, int*, const int, const int, const int));
extern void shsein __P((const char, const char, const char, int*, const int, const float*, const int, float*, const float*, float*, const int, float*, const int, const int, int*, int*, int*, int*));
extern void shsein_ __P((const char*, const char*, const char*, int*, const int*, const float*, const int*, float*, const float*, float*, const int*, float*, const int*, const int*, int*, float*, int*, int*, int*, const int, const int, const int));
extern void shseqr __P((const char, const char, const int, const int, const int, float*, const int, float*, float*, float*, const int, int*));
extern void shseqr_ __P((const char*, const char*, const int*, const int*, const int*, float*, const int*, float*, float*, float*, const int*, float*, const int*, int*, const int, const int));
extern void sinqb __P((const int, float*, const float*));
extern void sinqb_ __P((const int*, float*, const float*));
extern void sinqf __P((const int, float*, const float*));
extern void sinqf_ __P((const int*, float*, const float*));
extern void sinqi __P((const int, float*));
extern void sinqi_ __P((const int*, float*));
extern void sinti __P((const int, float*));
extern void sinti_ __P((const int*, float*));
extern void sint __P((const int, float*, float*));
extern void sint_ __P((const int*, float*, float*));
extern void sjadmm __P((const int, const int, const int, const int, const float, const int*, const float*, const int*, const int*, const int, const int*, const float*, const int, const float, float*, const int));
extern void sjadmm_ __P((const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sjadrp __P((const int, const int, const int, const float*, const int*, int*, const int, const int*));
extern void sjadrp_ __P((const int*, const int*, const int*, const float*, const int*, int*, const int*, const int*, int*, const int*));
extern void sjadsm __P((const int, const int, const int, const int, const float*, const float, const int*, const float*, const int*, const int*, const int, const int*, const float*, const int, const float, float*, const int));
extern void sjadsm_ __P((const int*, const int*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sladiv __P((const float, const float, const float, const float, float*, float*));
extern void sladiv_ __P((const float*, const float*, const float*, const float*, float*, float*));
extern void slaeda __P((const int, const int, const int, const int, const int*, const int*, const int*, const int*, const float*, const float*, const int*, float*, int*));
extern void slaeda_ __P((const int*, const int*, const int*, const int*, const int*, const int*, const int*, const int*, const float*, const float*, const int*, float*, float*, int*));
extern void slagtf __P((const int, float*, const float, float*, float*, const float, float*, int*, int*));
extern void slagtf_ __P((const int*, float*, const float*, float*, float*, const float*, float*, int*, int*));
extern float slamch __P((const char));
extern float slamch_ __P((const char*, const int));
extern void slamrg __P((const int, const int, const float*, const int, const int, int*));
extern void slamrg_ __P((const int*, const int*, const float*, const int*, const int*, int*));
extern void slanv2 __P((float*, float*, float*, float*, float*, float*, float*, float*, float*, float*));
extern void slanv2_ __P((float*, float*, float*, float*, float*, float*, float*, float*, float*, float*));
extern void slarzb __P((const char, const char, const char, const char, const int, const int, const int, const int, const float*, const int, const float*, const int, float*, const int, const int));
extern void slarzb_ __P((const char*, const char*, const char*, const char*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, float*, const int*, float*, const int*, const int, const int, const int, const int));
extern void slarzt __P((const char, const char, const int, const int, const float*, const int, const float*, float*, const int));
extern void slarzt_ __P((const char*, const char*, const int*, const int*, const float*, const int*, const float*, float*, const int*, const int, const int));
extern void slarz __P((const char, const int, const int, const int, const float*, const int, const float, float*, const int));
extern void slarz_ __P((const char*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int));
extern void slasq1 __P((const int, float*, float*, int*));
extern void slasq1_ __P((const int*, float*, float*, float*, int*));
extern void slasq2 __P((const int, float*, int*));
extern void slasq2_ __P((const int*, float*, int*));
extern void slasrt __P((const char, const int, float*, int*));
extern void slasrt_ __P((const char*, const int*, float*, int*, const int));
extern void slatzm __P((const char, const int, const int, const float*, const int, const float, float*, float*, const int));
extern void slatzm_ __P((const char*, const int*, const int*, const float*, const int*, const float*, float*, float*, const int*, float*, const int));
extern float snrm2 __P((const int, const float*, const int));
extern float snrm2_ __P((const int*, const float*, const int*));
extern void sopgtr __P((const char, const int, const float*, const float*, float*, const int, int*));
extern void sopgtr_ __P((const char*, const int*, const float*, const float*, float*, const int*, float*, int*, const int));
extern void sopmtr __P((const char, const char, const char, const int, const int, const float*, const float*, float*, const int, int*));
extern void sopmtr_ __P((const char*, const char*, const char*, const int*, const int*, const float*, const float*, float*, const int*, float*, int*, const int, const int, const int));
extern void sorg2l __P((const int, const int, const int, float*, const int, const float*, int*));
extern void sorg2l_ __P((const int*, const int*, const int*, float*, const int*, const float*, float*, int*));
extern void sorg2r __P((const int, const int, const int, float*, const int, const float*, int*));
extern void sorg2r_ __P((const int*, const int*, const int*, float*, const int*, const float*, float*, int*));
extern void sorgbr __P((const char, const int, const int, const int, float*, const int, const float*, int*));
extern void sorgbr_ __P((const char*, const int*, const int*, const int*, float*, const int*, const float*, float*, const int*, int*, const int));
extern void sorghr __P((const int, const int, const int, float*, const int, const float*, int*));
extern void sorghr_ __P((const int*, const int*, const int*, float*, const int*, const float*, float*, const int*, int*));
extern void sorgl2 __P((const int, const int, const int, float*, const int, const float*, int*));
extern void sorgl2_ __P((const int*, const int*, const int*, float*, const int*, const float*, float*, int*));
extern void sorglq __P((const int, const int, const int, float*, const int, const float*, int*));
extern void sorglq_ __P((const int*, const int*, const int*, float*, const int*, const float*, float*, const int*, int*));
extern void sorgql __P((const int, const int, const int, float*, const int, const float*, int*));
extern void sorgql_ __P((const int*, const int*, const int*, float*, const int*, const float*, float*, const int*, int*));
extern void sorgqr __P((const int, const int, const int, float*, const int, const float*, int*));
extern void sorgqr_ __P((const int*, const int*, const int*, float*, const int*, const float*, float*, const int*, int*));
extern void sorgr2 __P((const int, const int, const int, float*, const int, const float*, int*));
extern void sorgr2_ __P((const int*, const int*, const int*, float*, const int*, const float*, float*, int*));
extern void sorgrq __P((const int, const int, const int, float*, const int, const float*, int*));
extern void sorgrq_ __P((const int*, const int*, const int*, float*, const int*, const float*, float*, const int*, int*));
extern void sorgtr __P((const char, const int, float*, const int, const float*, int*));
extern void sorgtr_ __P((const char*, const int*, float*, const int*, const float*, float*, const int*, int*, const int));
extern void sorm2l __P((const char, const char, const int, const int, const int, const float*, const int, const float*, float*, const int, int*));
extern void sorm2l_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, int*, const int, const int));
extern void sorm2r __P((const char, const char, const int, const int, const int, float*, const int, const float*, float*, const int, int*));
extern void sorm2r_ __P((const char*, const char*, const int*, const int*, const int*, float*, const int*, const float*, float*, const int*, float*, int*, const int, const int));
extern void sormbr __P((const char, const char, const char, const int, const int, const int, const float*, const int, const float*, float*, const int, int*));
extern void sormbr_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*, int*, const int, const int, const int));
extern void sormhr __P((const char, const char, const int, const int, const int, const int, const float*, const int, const float*, float*, const int, int*));
extern void sormhr_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*, int*, const int, const int));
extern void sorml2 __P((const char, const char, const int, const int, const int, const float*, const int, const float*, float*, const int, int*));
extern void sorml2_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, int*, const int, const int));
extern void sormlq __P((const char, const char, const int, const int, const int, const float*, const int, const float*, float*, const int, int*));
extern void sormlq_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*, int*, const int, const int));
extern void sormql __P((const char, const char, const int, const int, const int, const float*, const int, const float*, float*, const int, int*));
extern void sormql_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*, int*, const int, const int));
extern void sormqr __P((const char, const char, const int, const int, const int, const float*, const int, const float*, float*, const int, int*));
extern void sormqr_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*, int*, const int, const int));
extern void sormr2 __P((const char, const char, const int, const int, const int, const float*, const int, const float*, float*, const int, int*));
extern void sormr2_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, int*, const int, const int));
extern void sormr3 __P((const char, const char, const int, const int, const int, const int, const float*, const int, const float*, float*, const int, int*));
extern void sormr3_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, int*, const int, const int));
extern void sormrq __P((const char, const char, const int, const int, const int, const float*, const int, const float*, float*, const int, int*));
extern void sormrq_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*, int*, const int, const int));
extern void sormrz __P((const char, const char, const int, const int, const int, const int, const float*, const int, const float*, float*, const int, int*));
extern void sormrz_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*, int*, const int, const int));
extern void sormtr __P((const char, const char, const char, const int, const int, const float*, const int, const float*, float*, const int, int*));
extern void sormtr_ __P((const char*, const char*, const char*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*, int*, const int, const int, const int));
extern void spbcon __P((const char, const int, const int, const float*, const int, const float, float*, int*));
extern void spbcon_ __P((const char*, const int*, const int*, const float*, const int*, const float*, float*, float*, int*, int*, const int));
extern void spbequ __P((const char, const int, const int, const float*, const int, float*, float*, float*, int*));
extern void spbequ_ __P((const char*, const int*, const int*, const float*, const int*, float*, float*, float*, int*, const int));
extern void spbrfs __P((const char, const int, const int, const int, const float*, const int, const float*, const int, const float*, const int, float*, const int, float*, float*, int*));
extern void spbrfs_ __P((const char*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const float*, const int*, float*, const int*, float*, float*, float*, int*, int*, const int));
extern void spbstf __P((const char, const int, const int, float*, const int, int*));
extern void spbstf_ __P((const char*, const int*, const int*, float*, const int*, int*, const int));
extern void spbsvx __P((const char, const char, const int, const int, const int, float*, const int, float*, const int, char*, float*, float*, const int, float*, const int, float*, float*, float*, int*));
extern void spbsvx_ __P((const char*, const char*, const int*, const int*, const int*, float*, const int*, float*, const int*, char*, float*, float*, const int*, float*, const int*, float*, float*, float*, float*, int*, int*, const int, const int, const int));
extern void spbsv __P((const char, const int, const int, const int, float*, const int, float*, const int, int*));
extern void spbsv_ __P((const char*, const int*, const int*, const int*, float*, const int*, float*, const int*, int*, const int));
extern void spbtf2 __P((const char, const int, const int, float*, const int, int*));
extern void spbtf2_ __P((const char*, const int*, const int*, float*, const int*, int*, const int));
extern void spbtrf __P((const char, const int, const int, float*, const int, int*));
extern void spbtrf_ __P((const char*, const int*, const int*, float*, const int*, int*, const int));
extern void spbtrs __P((const char, const int, const int, const int, const float*, const int, float*, const int, int*));
extern void spbtrs_ __P((const char*, const int*, const int*, const int*, const float*, const int*, float*, const int*, int*, const int));
extern void spocon __P((const char, const int, const float*, const int, const float, float*, int*));
extern void spocon_ __P((const char*, const int*, const float*, const int*, const float*, float*, float*, int*, int*, const int));
extern void spoequ __P((const int, const float*, const int, float*, float*, float*, int*));
extern void spoequ_ __P((const int*, const float*, const int*, float*, float*, float*, int*));
extern void sporfs __P((const char, const int, const int, const float*, const int, const float*, const int, const float*, const int, float*, const int, float*, float*, int*));
extern void sporfs_ __P((const char*, const int*, const int*, const float*, const int*, const float*, const int*, const float*, const int*, float*, const int*, float*, float*, float*, int*, int*, const int));
extern void sposvx __P((const char, const char, const int, const int, float*, const int, float*, const int, char*, float*, float*, const int, float*, const int, float*, float*, float*, int*));
extern void sposvx_ __P((const char*, const char*, const int*, const int*, float*, const int*, float*, const int*, char*, float*, float*, const int*, float*, const int*, float*, float*, float*, float*, int*, int*, const int, const int, const int));
extern void sposv __P((const char, const int, const int, float*, const int, float*, const int, int*));
extern void sposv_ __P((const char*, const int*, const int*, float*, const int*, float*, const int*, int*, const int));
extern void spotf2 __P((const char, const int, float*, const int, int*));
extern void spotf2_ __P((const char*, const int*, float*, const int*, int*, const int));
extern void spotrf __P((const char, const int, float*, const int, int*));
extern void spotrf_ __P((const char*, const int*, float*, const int*, int*, const int));
extern void spotri __P((const char, const int, float*, const int, int*));
extern void spotri_ __P((const char*, const int*, float*, const int*, int*, const int));
extern void spotrs __P((const char, const int, const int, const float*, const int, float*, const int, int*));
extern void spotrs_ __P((const char*, const int*, const int*, const float*, const int*, float*, const int*, int*, const int));
extern void sppcon __P((const char, const int, const float*, const float, float*, int*));
extern void sppcon_ __P((const char*, const int*, const float*, const float*, float*, float*, int*, int*, const int));
extern void sppequ __P((const char, const int, const float*, float*, float*, float*, int*));
extern void sppequ_ __P((const char*, const int*, const float*, float*, float*, float*, int*, const int));
extern void spprfs __P((const char, const int, const int, const float*, const float*, const float*, const int, float*, const int, float*, float*, int*));
extern void spprfs_ __P((const char*, const int*, const int*, const float*, const float*, const float*, const int*, float*, const int*, float*, float*, float*, int*, int*, const int));
extern void sppsvx __P((const char, const char, const int, const int, float*, float*, char*, float*, float*, const int, float*, const int, float*, float*, float*, int*));
extern void sppsvx_ __P((const char*, const char*, const int*, const int*, float*, float*, char*, float*, float*, const int*, float*, const int*, float*, float*, float*, float*, int*, int*, const int, const int, const int));
extern void sppsv __P((const char, const int, const int, float*, float*, const int, int*));
extern void sppsv_ __P((const char*, const int*, const int*, float*, float*, const int*, int*, const int));
extern void spptrf __P((const char, const int, float*, int*));
extern void spptrf_ __P((const char*, const int*, float*, int*, const int));
extern void spptri __P((const char, const int, float*, int*));
extern void spptri_ __P((const char*, const int*, float*, int*, const int));
extern void spptrs __P((const char, const int, const int, const float*, float*, const int, int*));
extern void spptrs_ __P((const char*, const int*, const int*, const float*, float*, const int*, int*, const int));
extern void sptcon __P((const int, const float*, const float*, const float, float*, int*));
extern void sptcon_ __P((const int*, const float*, const float*, const float*, float*, float*, int*));
extern void spteqr __P((const char, const int, float*, float*, float*, const int, int*));
extern void spteqr_ __P((const char*, const int*, float*, float*, float*, const int*, float*, int*, const int));
extern void sptrfs __P((const int, const int, const float*, const float*, const float*, const float*, const float*, const int, float*, const int, float*, float*, int*));
extern void sptrfs_ __P((const int*, const int*, const float*, const float*, const float*, const float*, const float*, const int*, float*, const int*, float*, float*, float*, int*));
extern void sptsvx __P((const char, const int, const int, const float*, const float*, float*, float*, const float*, const int, float*, const int, float*, float*, float*, int*));
extern void sptsvx_ __P((const char*, const int*, const int*, const float*, const float*, float*, float*, const float*, const int*, float*, const int*, float*, float*, float*, float*, int*, const int));
extern void sptsv __P((const int, const int, float*, float*, float*, const int, int*));
extern void sptsv_ __P((const int*, const int*, float*, float*, float*, const int*, int*));
extern void spttrf __P((const int, float*, float*, int*));
extern void spttrf_ __P((const int*, float*, float*, int*));
extern void spttrs __P((const int, const int, const float*, float*, float*, const int, int*));
extern void spttrs_ __P((const int*, const int*, const float*, float*, float*, const int*, int*));
extern void sptts2 __P((const int, const int, const float*, const float*, float*, const int));
extern void sptts2_ __P((const int*, const int*, const float*, const float*, float*, const int*));
extern void srotg __P((float*, float*, float*, float*));
extern void srotg_ __P((float*, float*, float*, float*));
extern void sroti __P((const int, const float*, const int*, float*, const float, const float));
extern void sroti_ __P((const int*, const float*, const int*, float*, const float*, const float*));
extern void srotmg __P((float*, float*, float*, const float, float*));
extern void srotmg_ __P((float*, float*, float*, const float*, float*));
extern void srotm __P((const int, const float*, const int, float*, const int, const float*));
extern void srotm_ __P((const int*, const float*, const int*, float*, const int*, const float*));
extern void srot __P((const int, float*, const int, float*, const int, const float, const float));
extern void srot_ __P((const int*, float*, const int*, float*, const int*, const float*, const float*));
extern void ssbevd __P((const char, const char, const int, const int, float*, const int, float*, float*, const int, int*));
extern void ssbevd_ __P((const char*, const char*, const int*, const int*, float*, const int*, float*, float*, const int*, float*, const int*, int*, const int*, int*, const int, const int));
extern void ssbevx __P((const char, const char, const char, const int, const int, float*, const int, float*, const int, const float, const float, const int, const int, const float, int*, float*, float*, const int, int*, int*));
extern void ssbevx_ __P((const char*, const char*, const char*, const int*, const int*, float*, const int*, float*, const int*, const float*, const float*, const int*, const int*, const float*, int*, float*, float*, const int*, float*, int*, int*, int*, const int, const int, const int));
extern void ssbev __P((const char, const char, const int, const int, float*, const int, float*, float*, const int, int*));
extern void ssbev_ __P((const char*, const char*, const int*, const int*, float*, const int*, float*, float*, const int*, float*, int*, const int, const int));
extern void ssbgst __P((const char, const char, const int, const int, const int, float*, const int, const float*, const int, float*, const int, int*));
extern void ssbgst_ __P((const char*, const char*, const int*, const int*, const int*, float*, const int*, const float*, const int*, float*, const int*, float*, int*, const int, const int));
extern void ssbgvd __P((const char, const char, const int, const int, const int, float*, const int, float*, const int, float*, float*, const int, int*));
extern void ssbgvd_ __P((const char*, const char*, const int*, const int*, const int*, float*, const int*, float*, const int*, float*, float*, const int*, float*, const int*, int*, const int*, int*, const int, const int));
extern void ssbgvx __P((const char, const char, const char, const int, const int, const int, float*, const int, float*, const int, float*, const int, const float, const float, const int, const int, const float, int*, float*, float*, const int, int*, int*));
extern void ssbgvx_ __P((const char*, const char*, const char*, const int*, const int*, const int*, float*, const int*, float*, const int*, float*, const int*, const float*, const float*, const int*, const int*, const float*, int*, float*, float*, const int*, float*, int*, int*, int*, const int, const int, const int));
extern void ssbgv __P((const char, const char, const int, const int, const int, float*, const int, float*, const int, float*, float*, const int, int*));
extern void ssbgv_ __P((const char*, const char*, const int*, const int*, const int*, float*, const int*, float*, const int*, float*, float*, const int*, float*, int*, const int, const int));
extern void ssbmv __P((const char, const int, const int, const float, const float*, const int, const float*, const int, const float, float*, const int));
extern void ssbmv_ __P((const char*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const float*, float*, const int*, const int));
extern void ssbtrd __P((const char, const char, const int, const int, float*, const int, float*, float*, float*, const int, int*));
extern void ssbtrd_ __P((const char*, const char*, const int*, const int*, float*, const int*, float*, float*, float*, const int*, float*, int*, const int, const int));
extern void sscal __P((const int, const float, float*, const int));
extern void sscal_ __P((const int*, const float*, float*, const int*));
extern void ssctr __P((const int, const float*, const int*, float*));
extern void ssctr_ __P((const int*, const float*, const int*, float*));
extern void sskymm __P((const int, const int, const int, const int, const float, const int*, const float*, const int*, const float*, const int, const float, float*, const int));
extern void sskymm_ __P((const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sskysm __P((const int, const int, const int, const int, const float*, const float, const int*, const float*, const int*, const float*, const int, const float, float*, const int));
extern void sskysm_ __P((const int*, const int*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void sspcon __P((const char, const int, const float*, const int*, const float, float*, int*));
extern void sspcon_ __P((const char*, const int*, const float*, const int*, const float*, float*, float*, int*, int*, const int));
extern void sspevd __P((const char, const char, const int, float*, float*, float*, const int, int*));
extern void sspevd_ __P((const char*, const char*, const int*, float*, float*, float*, const int*, float*, const int*, int*, const int*, int*, const int, const int));
extern void sspevx __P((const char, const char, const char, const int, float*, const float, const float, const int, const int, const float, int*, float*, float*, const int, int*, int*));
extern void sspevx_ __P((const char*, const char*, const char*, const int*, float*, const float*, const float*, const int*, const int*, const float*, int*, float*, float*, const int*, float*, int*, int*, int*, const int, const int, const int));
extern void sspev __P((const char, const char, const int, float*, float*, float*, const int, int*));
extern void sspev_ __P((const char*, const char*, const int*, float*, float*, float*, const int*, float*, int*, const int, const int));
extern void sspgst __P((const int, const char, const int, float*, const float*, int*));
extern void sspgst_ __P((const int*, const char*, const int*, float*, const float*, int*, const int));
extern void sspgvd __P((const int, const char, const char, const int, float*, float*, float*, float*, const int, int*));
extern void sspgvd_ __P((const int*, const char*, const char*, const int*, float*, float*, float*, float*, const int*, float*, const int*, int*, const int*, int*, const int, const int));
extern void sspgvx __P((const int, const char, const char, const char, const int, float*, float*, const float, const float, const int, const int, const float, int*, float*, float*, const int, int*, int*));
extern void sspgvx_ __P((const int*, const char*, const char*, const char*, const int*, float*, float*, const float*, const float*, const int*, const int*, const float*, int*, float*, float*, const int*, float*, int*, int*, int*, const int, const int, const int));
extern void sspgv __P((const int, const char, const char, const int, float*, float*, float*, float*, const int, int*));
extern void sspgv_ __P((const int*, const char*, const char*, const int*, float*, float*, float*, float*, const int*, float*, int*, const int, const int));
extern void sspmv __P((const char, const int, const float, const float*, const float*, const int, const float, float*, const int));
extern void sspmv_ __P((const char*, const int*, const float*, const float*, const float*, const int*, const float*, float*, const int*, const int));
extern void sspr2 __P((const char, const int, const float, const float*, const int, const float*, const int, float*));
extern void sspr2_ __P((const char*, const int*, const float*, const float*, const int*, const float*, const int*, float*, const int));
extern void ssprfs __P((const char, const int, const int, const float*, const float*, const int*, const float*, const int, float*, const int, float*, float*, int*));
extern void ssprfs_ __P((const char*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, float*, const int*, float*, float*, float*, int*, int*, const int));
extern void sspr __P((const char, const int, const float, const float*, const int, float*));
extern void sspr_ __P((const char*, const int*, const float*, const float*, const int*, float*, const int));
extern void sspsvx __P((const char, const char, const int, const int, const float*, float*, int*, const float*, const int, float*, const int, float*, float*, float*, int*));
extern void sspsvx_ __P((const char*, const char*, const int*, const int*, const float*, float*, int*, const float*, const int*, float*, const int*, float*, float*, float*, float*, int*, int*, const int, const int));
extern void sspsv __P((const char, const int, const int, float*, int*, float*, const int, int*));
extern void sspsv_ __P((const char*, const int*, const int*, float*, int*, float*, const int*, int*, const int));
extern void ssptrd __P((const char, const int, float*, float*, float*, float*, int*));
extern void ssptrd_ __P((const char*, const int*, float*, float*, float*, float*, int*, const int));
extern void ssptrf __P((const char, const int, float*, int*, int*));
extern void ssptrf_ __P((const char*, const int*, float*, int*, int*, const int));
extern void ssptri __P((const char, const int, float*, const int*, int*));
extern void ssptri_ __P((const char*, const int*, float*, const int*, float*, int*, const int));
extern void ssptrs __P((const char, const int, const int, const float*, const int*, float*, const int, int*));
extern void ssptrs_ __P((const char*, const int*, const int*, const float*, const int*, float*, const int*, int*, const int));
extern void sstebz __P((const char, const char, const int, const float, const float, const int, const int, const float, const float*, const float*, int*, int*, float*, int*, int*, int*));
extern void sstebz_ __P((const char*, const char*, const int*, const float*, const float*, const int*, const int*, const float*, const float*, const float*, int*, int*, float*, int*, int*, float*, int*, int*, const int, const int));
extern void sstedc __P((const char, const int, float*, float*, float*, const int, int*));
extern void sstedc_ __P((const char*, const int*, float*, float*, float*, const int*, float*, const int*, int*, const int*, int*, const int));
extern void sstegr __P((const char, const char, const int, float*, float*, const float, const float, const int, const int, const float, int*, float*, float*, const int, int*, int*));
extern void sstegr_ __P((const char*, const char*, const int*, float*, float*, const float*, const float*, const int*, const int*, const float*, int*, float*, float*, const int*, int*, float*, const int*, int*, const int*, int*, const int, const int));
extern void sstein __P((const int, const float*, const float*, const int, const float*, const int*, const int*, float*, const int, int*, int*));
extern void sstein_ __P((const int*, const float*, const float*, const int*, const float*, const int*, const int*, float*, const int*, float*, int*, int*, int*));
extern void ssteqr __P((const char, const int, float*, float*, float*, const int, int*));
extern void ssteqr_ __P((const char*, const int*, float*, float*, float*, const int*, float*, int*, const int));
extern void ssterf __P((const int, float*, float*, int*));
extern void ssterf_ __P((const int*, float*, float*, int*));
extern void sstevd __P((const char, const int, float*, float*, float*, const int, int*));
extern void sstevd_ __P((const char*, const int*, float*, float*, float*, const int*, float*, const int*, int*, const int*, int*, const int));
extern void sstevr __P((const char, const char, const int, float*, float*, const float, const float, const int, const int, const float, int*, float*, float*, const int, int*, int*));
extern void sstevr_ __P((const char*, const char*, const int*, float*, float*, const float*, const float*, const int*, const int*, const float*, int*, float*, float*, const int*, int*, float*, const int*, int*, const int*, int*, const int, const int));
extern void sstevx __P((const char, const char, const int, float*, float*, const float, const float, const int, const int, const float, int*, float*, float*, const int, int*, int*));
extern void sstevx_ __P((const char*, const char*, const int*, float*, float*, const float*, const float*, const int*, const int*, const float*, int*, float*, float*, const int*, float*, int*, int*, int*, const int, const int));
extern void sstev __P((const char, const int, float*, float*, float*, const int, int*));
extern void sstev_ __P((const char*, const int*, float*, float*, float*, const int*, float*, int*, const int));
extern void sstsv __P((const int, const int, float*, float*, float*, float*, const int, int*, int*));
extern void sstsv_ __P((const int*, const int*, float*, float*, float*, float*, const int*, int*, int*));
extern void ssttrf __P((const int, float*, float*, float*, int*, int*));
extern void ssttrf_ __P((const int*, float*, float*, float*, int*, int*));
extern void ssttrs __P((const int, const int, const float*, const float*, const float*, const float*, const int, int*, int*));
extern void ssttrs_ __P((const int*, const int*, const float*, const float*, const float*, const float*, const int*, int*, int*));
extern void sswap __P((const int, float*, const int, float*, const int));
extern void sswap_ __P((const int*, float*, const int*, float*, const int*));
extern void ssycon __P((const char, const int, const float*, const int, const int*, const float, float*, int*));
extern void ssycon_ __P((const char*, const int*, const float*, const int*, const int*, const float*, float*, float*, int*, int*, const int));
extern void ssyevd __P((const char, const char, const int, float*, const int, float*, int*));
extern void ssyevd_ __P((const char*, const char*, const int*, float*, const int*, float*, float*, const int*, int*, const int*, int*, const int, const int));
extern void ssyevr __P((const char, const char, const char, const int, float*, const int, const float, const float, const int, const int, const float, int*, float*, float*, const int, int*, int*));
extern void ssyevr_ __P((const char*, const char*, const char*, const int*, float*, const int*, const float*, const float*, const int*, const int*, const float*, int*, float*, float*, const int*, int*, float*, const int*, int*, const int*, int*, const int, const int, const int));
extern void ssyevx __P((const char, const char, const char, const int, float*, const int, const float, const float, const int, const int, const float, int*, float*, float*, const int, int*, int*));
extern void ssyevx_ __P((const char*, const char*, const char*, const int*, float*, const int*, const float*, const float*, const int*, const int*, const float*, int*, float*, float*, const int*, float*, const int*, int*, int*, int*, const int, const int, const int));
extern void ssyev __P((const char, const char, const int, float*, const int, float*, int*));
extern void ssyev_ __P((const char*, const char*, const int*, float*, const int*, float*, float*, const int*, int*, const int, const int));
extern void ssygs2 __P((const int, const char, const int, float*, const int, const float*, const int, int*));
extern void ssygs2_ __P((const int*, const char*, const int*, float*, const int*, const float*, const int*, int*, const int));
extern void ssygst __P((const int, const char, const int, float*, const int, const float*, const int, int*));
extern void ssygst_ __P((const int*, const char*, const int*, float*, const int*, const float*, const int*, int*, const int));
extern void ssygvd __P((const int, const char, const char, const int, float*, const int, float*, const int, float*, int*));
extern void ssygvd_ __P((const int*, const char*, const char*, const int*, float*, const int*, float*, const int*, float*, float*, const int*, int*, const int*, int*, const int, const int));
extern void ssygvx __P((const int, const char, const char, const char, const int, float*, const int, float*, const int, const float, const float, const int, const int, const float, int*, float*, float*, const int, int*, int*));
extern void ssygvx_ __P((const int*, const char*, const char*, const char*, const int*, float*, const int*, float*, const int*, const float*, const float*, const int*, const int*, const float*, int*, float*, float*, const int*, float*, const int*, int*, int*, int*, const int, const int, const int));
extern void ssygv __P((const int, const char, const char, const int, float*, const int, float*, const int, float*, int*));
extern void ssygv_ __P((const int*, const char*, const char*, const int*, float*, const int*, float*, const int*, float*, float*, const int*, int*, const int, const int));
extern void ssymm __P((const char, const char, const int, const int, const float, const float*, const int, const float*, const int, const float, float*, const int));
extern void ssymm_ __P((const char*, const char*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const float*, float*, const int*, const int, const int));
extern void ssymv __P((const char, const int, const float, const float*, const int, const float*, const int, const float, float*, const int));
extern void ssymv_ __P((const char*, const int*, const float*, const float*, const int*, const float*, const int*, const float*, float*, const int*, const int));
extern void ssyr2k __P((const char, const char, const int, const int, const float, const float*, const int, const float*, const int, const float, float*, const int));
extern void ssyr2k_ __P((const char*, const char*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const float*, float*, const int*, const int, const int));
extern void ssyr2 __P((const char, const int, const float, const float*, const int, const float*, const int, float*, const int));
extern void ssyr2_ __P((const char*, const int*, const float*, const float*, const int*, const float*, const int*, float*, const int*, const int));
extern void ssyrfs __P((const char, const int, const int, const float*, const int, const float*, const int, const int*, const float*, const int, float*, const int, float*, float*, int*));
extern void ssyrfs_ __P((const char*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const float*, const int*, float*, const int*, float*, float*, float*, int*, int*, const int));
extern void ssyrk __P((const char, const char, const int, const int, const float, const float*, const int, const float, float*, const int));
extern void ssyrk_ __P((const char*, const char*, const int*, const int*, const float*, const float*, const int*, const float*, float*, const int*, const int, const int));
extern void ssyr __P((const char, const int, const float, const float*, const int, float*, const int));
extern void ssyr_ __P((const char*, const int*, const float*, const float*, const int*, float*, const int*, const int));
extern void ssysvx __P((const char, const char, const int, const int, const float*, const int, float*, const int, int*, const float*, const int, float*, const int, float*, float*, float*, int*));
extern void ssysvx_ __P((const char*, const char*, const int*, const int*, const float*, const int*, float*, const int*, int*, const float*, const int*, float*, const int*, float*, float*, float*, float*, const int*, int*, int*, const int, const int));
extern void ssysv __P((const char, const int, const int, float*, const int, int*, float*, const int, int*));
extern void ssysv_ __P((const char*, const int*, const int*, float*, const int*, int*, float*, const int*, float*, const int*, int*, const int));
extern void ssytd2 __P((const char, const int, float*, const int, float*, float*, float*, int*));
extern void ssytd2_ __P((const char*, const int*, float*, const int*, float*, float*, float*, int*, const int));
extern void ssytf2 __P((const char, const int, float*, const int, int*, int*));
extern void ssytf2_ __P((const char*, const int*, float*, const int*, int*, int*, const int));
extern void ssytrd __P((const char, const int, float*, const int, float*, float*, float*, int*));
extern void ssytrd_ __P((const char*, const int*, float*, const int*, float*, float*, float*, float*, const int*, int*, const int));
extern void ssytrf __P((const char, const int, float*, const int, int*, int*));
extern void ssytrf_ __P((const char*, const int*, float*, const int*, int*, float*, const int*, int*, const int));
extern void ssytri __P((const char, const int, float*, const int, const int*, int*));
extern void ssytri_ __P((const char*, const int*, float*, const int*, const int*, float*, int*, const int));
extern void ssytrs __P((const char, const int, const int, const float*, const int, const int*, float*, const int, int*));
extern void ssytrs_ __P((const char*, const int*, const int*, const float*, const int*, const int*, float*, const int*, int*, const int));
extern void stbcon __P((const char, const char, const char, const int, const int, const float*, const int, float*, int*));
extern void stbcon_ __P((const char*, const char*, const char*, const int*, const int*, const float*, const int*, float*, float*, int*, int*, const int, const int, const int));
extern void stbmv __P((const char, const char, const char, const int, const int, const float*, const int, float*, const int));
extern void stbmv_ __P((const char*, const char*, const char*, const int*, const int*, const float*, const int*, float*, const int*, const int, const int, const int));
extern void stbrfs __P((const char, const char, const char, const int, const int, const int, const float*, const int, const float*, const int, const float*, const int, float*, float*, int*));
extern void stbrfs_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const float*, const int*, float*, float*, float*, int*, int*, const int, const int, const int));
extern void stbsv __P((const char, const char, const char, const int, const int, const float*, const int, float*, const int));
extern void stbsv_ __P((const char*, const char*, const char*, const int*, const int*, const float*, const int*, float*, const int*, const int, const int, const int));
extern void stbtrs __P((const char, const char, const char, const int, const int, const int, const float*, const int, float*, const int, int*));
extern void stbtrs_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const float*, const int*, float*, const int*, int*, const int, const int, const int));
extern void stgevc __P((const char, const char, const int*, const int, const float*, const int, const float*, const int, float*, const int, float*, const int, const int, int*, int*));
extern void stgevc_ __P((const char*, const char*, const int*, const int*, const float*, const int*, const float*, const int*, float*, const int*, float*, const int*, const int*, int*, float*, int*, const int, const int));
extern void stgexc __P((const int, const int, const int, float*, const int, float*, const int, float*, const int, float*, const int, int*, int*, int*));
extern void stgexc_ __P((const int*, const int*, const int*, float*, const int*, float*, const int*, float*, const int*, float*, const int*, int*, int*, float*, const int*, int*));
extern void stgsen __P((const int, const int, const int, const int*, const int, float*, const int, float*, const int, float*, float*, float*, float*, const int, float*, const int, int*, float*, float*, float*, int*));
extern void stgsen_ __P((const int*, const int*, const int*, const int*, const int*, float*, const int*, float*, const int*, float*, float*, float*, float*, const int*, float*, const int*, int*, float*, float*, float*, float*, const int*, int*, const int*, int*));
extern void stgsja __P((const char, const char, const char, const int, const int, const int, const int, const int, float*, const int, float*, const int, const float, const float, float*, float*, float*, const int, float*, const int, float*, const int, int*, int*));
extern void stgsja_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const int*, const int*, float*, const int*, float*, const int*, const float*, const float*, float*, float*, float*, const int*, float*, const int*, float*, const int*, float*, int*, int*, const int, const int, const int));
extern void stgsna __P((const char, const char, const int*, const int, const float*, const int, const float*, const int, const float*, const int, const float*, const int, float*, float*, const int, int*, int*));
extern void stgsna_ __P((const char*, const char*, const int*, const int*, const float*, const int*, const float*, const int*, const float*, const int*, const float*, const int*, float*, float*, const int*, int*, float*, const int*, int*, int*, const int, const int));
extern void stgsyl __P((const char, const int, const int, const int, const float*, const int, const float*, const int, float*, const int, const float*, const int, const float*, const int, float*, const int, float*, float*, int*));
extern void stgsyl_ __P((const char*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, float*, const int*, const float*, const int*, const float*, const int*, float*, const int*, float*, float*, float*, const int*, int*, int*, const int));
extern void stpcon __P((const char, const char, const char, const int, const float*, float*, int*));
extern void stpcon_ __P((const char*, const char*, const char*, const int*, const float*, float*, float*, int*, int*, const int, const int, const int));
extern void stpmv __P((const char, const char, const char, const int, const float*, float*, const int));
extern void stpmv_ __P((const char*, const char*, const char*, const int*, const float*, float*, const int*, const int, const int, const int));
extern void stprfs __P((const char, const char, const char, const int, const int, const float*, const float*, const int, const float*, const int, float*, float*, int*));
extern void stprfs_ __P((const char*, const char*, const char*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, float*, float*, float*, int*, int*, const int, const int, const int));
extern void stpsv __P((const char, const char, const char, const int, const float*, float*, const int));
extern void stpsv_ __P((const char*, const char*, const char*, const int*, const float*, float*, const int*, const int, const int, const int));
extern void stptri __P((const char, const char, const int, float*, int*));
extern void stptri_ __P((const char*, const char*, const int*, float*, int*, const int, const int));
extern void stptrs __P((const char, const char, const char, const int, const int, const float*, float*, const int, int*));
extern void stptrs_ __P((const char*, const char*, const char*, const int*, const int*, const float*, float*, const int*, int*, const int, const int, const int));
extern void strans __P((const char, const float, float*, const int, const int, float*));
extern void strans_ __P((const char*, const float*, float*, const int*, const int*, float*, const int));
extern void strcon __P((const char, const char, const char, const int, const float*, const int, float*, int*));
extern void strcon_ __P((const char*, const char*, const char*, const int*, const float*, const int*, float*, float*, int*, int*, const int, const int, const int));
extern void strevc __P((const char, const char, int*, const int, float*, const int, float*, const int, float*, const int, const int, int*, int*));
extern void strevc_ __P((const char*, const char*, int*, const int*, float*, const int*, float*, const int*, float*, const int*, const int*, int*, float*, int*, const int, const int));
extern void strexc __P((const char, const int, float*, const int, float*, const int, int*, int*, int*));
extern void strexc_ __P((const char*, const int*, float*, const int*, float*, const int*, int*, int*, float*, int*, const int));
extern void strmm __P((const char, const char, const char, const char, const int, const int, const float, const float*, const int, float*, const int));
extern void strmm_ __P((const char*, const char*, const char*, const char*, const int*, const int*, const float*, const float*, const int*, float*, const int*, const int, const int, const int, const int));
extern void strmv __P((const char, const char, const char, const int, const float*, const int, float*, const int));
extern void strmv_ __P((const char*, const char*, const char*, const int*, const float*, const int*, float*, const int*, const int, const int, const int));
extern void strrfs __P((const char, const char, const char, const int, const int, const float*, const int, const float*, const int, const float*, const int, float*, float*, int*));
extern void strrfs_ __P((const char*, const char*, const char*, const int*, const int*, const float*, const int*, const float*, const int*, const float*, const int*, float*, float*, float*, int*, int*, const int, const int, const int));
extern void strsen __P((const char, const char, const int*, const int, float*, const int, float*, const int, float*, float*, int*, float*, float*, int*));
extern void strsen_ __P((const char*, const char*, const int*, const int*, float*, const int*, float*, const int*, float*, float*, int*, float*, float*, float*, const int*, int*, const int*, int*, const int, const int));
extern void strsm __P((const char, const char, const char, const char, const int, const int, const float, const float*, const int, float*, const int));
extern void strsm_ __P((const char*, const char*, const char*, const char*, const int*, const int*, const float*, const float*, const int*, float*, const int*, const int, const int, const int, const int));
extern void strsna __P((const char, const char, const int*, const int, const float*, const int, const float*, const int, const float*, const int, float*, float*, const int, int*, const int, int*));
extern void strsna_ __P((const char*, const char*, const int*, const int*, const float*, const int*, const float*, const int*, const float*, const int*, float*, float*, const int*, int*, float*, const int*, int*, int*, const int, const int));
extern void strsv __P((const char, const char, const char, const int, const float*, const int, float*, const int));
extern void strsv_ __P((const char*, const char*, const char*, const int*, const float*, const int*, float*, const int*, const int, const int, const int));
extern void strsyl __P((const char, const char, const int, const int, const int, const float*, const int, const float*, const int, float*, const int, float*, int*));
extern void strsyl_ __P((const char*, const char*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, float*, const int*, float*, int*, const int, const int));
extern void strti2 __P((const char, const char, const int, float*, const int, int*));
extern void strti2_ __P((const char*, const char*, const int*, float*, const int*, int*, const int, const int));
extern void strtri __P((const char, const char, const int, float*, const int, int*));
extern void strtri_ __P((const char*, const char*, const int*, float*, const int*, int*, const int, const int));
extern void strtrs __P((const char, const char, const char, const int, const int, const float*, const int, float*, const int, int*));
extern void strtrs_ __P((const char*, const char*, const char*, const int*, const int*, const float*, const int*, float*, const int*, int*, const int, const int, const int));
extern void stzrqf __P((const int, const int, float*, const int, float*, int*));
extern void stzrqf_ __P((const int*, const int*, float*, const int*, float*, int*));
extern void stzrzf __P((const int, const int, float*, const int, float*, int*));
extern void stzrzf_ __P((const int*, const int*, float*, const int*, float*, float*, const int*, int*));
extern char * sunperf_version __P((int*, int*, int*));
extern void sunperf_version_ __P((int*, int*, int*));
extern void svbrmm __P((const int, const int, const int, const int, const float, const int*, const float*, const int*, const int*, const int*, const int*, const int*, const int*, const float*, const int, const float, float*, const int));
extern void svbrmm_ __P((const int*, const int*, const int*, const int*, const float*, const int*, const float*, const int*, const int*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void svbrsm __P((const int, const int, const int, const int, const float*, const float, const int*, const float*, const int*, const int*, const int*, const int*, const int*, const int*, const float*, const int, const float, float*, const int));
extern void svbrsm_ __P((const int*, const int*, const int*, const int*, const float*, const float*, const int*, const float*, const int*, const int*, const int*, const int*, const int*, const int*, const float*, const int*, const float*, float*, const int*, float*, const int*));
extern void swiener __P((const int, const float*, const float*, float*, const float*, int*, int*));
extern void swiener_ __P((const int*, const float*, const float*, float*, const float*, int*, int*));
extern void use_threads __P((const int));
extern void use_threads_ __P((const int*));
extern int using_threads __P((void));
extern int using_threads_ __P((void));
extern void vcfftb __P((const int, const int, floatcomplex*, const floatcomplex*, const int, const char, const floatcomplex*));
extern void vcfftb_ __P((const int*, const int*, floatcomplex*, const floatcomplex*, const int*, const char*, const floatcomplex*, const int));
extern void vcfftf __P((const int, const int, floatcomplex*, const floatcomplex*, const int, const char, const floatcomplex*));
extern void vcfftf_ __P((const int*, const int*, floatcomplex*, const floatcomplex*, const int*, const char*, const floatcomplex*, const int));
extern void vcffti __P((const int, floatcomplex*));
extern void vcffti_ __P((const int*, floatcomplex*));
extern void vcosqb __P((const int, const int, float*, const float*, const int, const float*));
extern void vcosqb_ __P((const int*, const int*, float*, const float*, const int*, const float*));
extern void vcosqf __P((const int, const int, float*, const float*, const int, const float*));
extern void vcosqf_ __P((const int*, const int*, float*, const float*, const int*, const float*));
extern void vcosqi __P((const int, float*));
extern void vcosqi_ __P((const int*, float*));
extern void vcosti __P((const int, float*));
extern void vcosti_ __P((const int*, float*));
extern void vcost __P((const int, const int, float*, const float*, const int, const float*));
extern void vcost_ __P((const int*, const int*, float*, const float*, const int*, const float*));
extern void vdcosqb __P((const int, const int, double*, const double*, const int, const double*));
extern void vdcosqb_ __P((const int*, const int*, double*, const double*, const int*, const double*));
extern void vdcosqf __P((const int, const int, double*, const double*, const int, const double*));
extern void vdcosqf_ __P((const int*, const int*, double*, const double*, const int*, const double*));
extern void vdcosqi __P((const int, double*));
extern void vdcosqi_ __P((const int*, double*));
extern void vdcosti __P((const int, double*));
extern void vdcosti_ __P((const int*, double*));
extern void vdcost __P((const int, const int, double*, const double*, const int, const double*));
extern void vdcost_ __P((const int*, const int*, double*, const double*, const int*, const double*));
extern void vdfftb __P((const int, const int, double*, const double*, const int, const double*));
extern void vdfftb_ __P((const int*, const int*, double*, const double*, const int*, const double*));
extern void vdfftf __P((const int, const int, double*, const double*, const int, const double*));
extern void vdfftf_ __P((const int*, const int*, double*, const double*, const int*, const double*));
extern void vdffti __P((const int, double*));
extern void vdffti_ __P((const int*, double*));
extern void vdsinqb __P((const int, const int, double*, const double*, const int, const double*));
extern void vdsinqb_ __P((const int*, const int*, double*, const double*, const int*, const double*));
extern void vdsinqf __P((const int, const int, double*, const double*, const int, const double*));
extern void vdsinqf_ __P((const int*, const int*, double*, const double*, const int*, const double*));
extern void vdsinqi __P((const int, double*));
extern void vdsinqi_ __P((const int*, double*));
extern void vdsinti __P((const int, double*));
extern void vdsinti_ __P((const int*, double*));
extern void vdsint __P((const int, const int, double*, double*, const int, const double*));
extern void vdsint_ __P((const int*, const int*, double*, double*, const int*, const double*));
extern void vrfftb __P((const int, const int, float*, const float*, const int, float*));
extern void vrfftb_ __P((const int*, const int*, float*, const float*, const int*, float*));
extern void vrfftf __P((const int, const int, float*, const float*, const int, const float*));
extern void vrfftf_ __P((const int*, const int*, float*, const float*, const int*, const float*));
extern void vrffti __P((const int, float*));
extern void vrffti_ __P((const int*, float*));
extern void vsinqb __P((const int, const int, float*, const float*, const int, const float*));
extern void vsinqb_ __P((const int*, const int*, float*, const float*, const int*, const float*));
extern void vsinqf __P((const int, const int, float*, const float*, const int, const float*));
extern void vsinqf_ __P((const int*, const int*, float*, const float*, const int*, const float*));
extern void vsinqi __P((const int, float*));
extern void vsinqi_ __P((const int*, float*));
extern void vsinti __P((const int, float*));
extern void vsinti_ __P((const int*, float*));
extern void vsint __P((const int, const int, float*, float*, const int, const float*));
extern void vsint_ __P((const int*, const int*, float*, float*, const int*, const float*));
extern void vzfftb __P((const int, const int, doublecomplex*, const doublecomplex*, const int, const char, doublecomplex*));
extern void vzfftb_ __P((const int*, const int*, doublecomplex*, const doublecomplex*, const int*, const char*, doublecomplex*, const int));
extern void vzfftf __P((const int, const int, doublecomplex*, const doublecomplex*, const int, const char, const doublecomplex*));
extern void vzfftf_ __P((const int*, const int*, doublecomplex*, const doublecomplex*, const int*, const char*, const doublecomplex*, const int));
extern void vzffti __P((const int, doublecomplex*));
extern void vzffti_ __P((const int*, doublecomplex*));
extern void xerbla __P((const char*, const int));
extern void xerbla_ __P((const char*, const int*, const int));
extern void zaxpyi __P((const int, const doublecomplex*, const doublecomplex*, const int*, doublecomplex*));
extern void zaxpyi_ __P((const int*, const doublecomplex*, const doublecomplex*, const int*, doublecomplex*));
extern void zaxpy __P((const int, const doublecomplex*, const doublecomplex*, const int, doublecomplex*, const int));
extern void zaxpy_ __P((const int*, const doublecomplex*, const doublecomplex*, const int*, doublecomplex*, const int*));
extern void zbcomm __P((const int, const int, const int, const int, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zbcomm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zbdimm __P((const int, const int, const int, const int, const doublecomplex*, const int*, const doublecomplex*, const int, const int*, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zbdimm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zbdism __P((const int, const int, const int, const int, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int, const int*, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zbdism_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zbdsqr __P((const char, const int, const int, const int, const int, double*, double*, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zbdsqr_ __P((const char*, const int*, const int*, const int*, const int*, double*, double*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, const int));
extern void zbelmm __P((const int, const int, const int, const int, const doublecomplex*, const int*, const doublecomplex*, const int*, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zbelmm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zbelsm __P((const int, const int, const int, const int, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zbelsm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zbscmm __P((const int, const int, const int, const int, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zbscmm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zbscsm __P((const int, const int, const int, const int, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zbscsm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zbsrmm __P((const int, const int, const int, const int, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zbsrmm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zbsrsm __P((const int, const int, const int, const int, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zbsrsm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zcnvcor2 __P((const char, const char, const char, const char, const char, const char, const int, const int, const doublecomplex*, const int, const int, const int, const int, const int, const doublecomplex*, const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int));
extern void zcnvcor2_ __P((const char*, const char*, const char*, const char*, const char*, const char*, const int*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, const int, const int, const int, const int, const int, const int));
extern void zcnvcor __P((const char, const char, const int, const doublecomplex*, const int, const int, const int, const int, const int, const doublecomplex*, const int, const int, const int, const int, const int, doublecomplex*, const int, const int, const int, doublecomplex*, const int));
extern void zcnvcor_ __P((const char*, const char*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const int*, doublecomplex*, const int*, const int*, const int*, doublecomplex*, const int*, const int, const int));
extern void zcoomm __P((const int, const int, const int, const int, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zcoomm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zcopy __P((const int, const doublecomplex*, const int, doublecomplex*, const int));
extern void zcopy_ __P((const int*, const doublecomplex*, const int*, doublecomplex*, const int*));
extern void zcscmm __P((const int, const int, const int, const int, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zcscmm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zcscsm __P((const int, const int, const int, const int, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zcscsm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zcsrmm __P((const int, const int, const int, const int, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zcsrmm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zcsrsm __P((const int, const int, const int, const int, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zcsrsm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zdiamm __P((const int, const int, const int, const int, const doublecomplex*, const int*, const doublecomplex*, const int, const int*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zdiamm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zdiasm __P((const int, const int, const int, const int, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int, const int*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zdiasm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern doublecomplex zdotci __P((const int, const doublecomplex*, const int*, const doublecomplex*));
extern doublecomplex zdotc __P((const int, const doublecomplex*, const int, const doublecomplex*, const int));
extern doublecomplex zdotui __P((const int, const doublecomplex*, const int*, const doublecomplex*));
extern doublecomplex zdotu __P((const int, const doublecomplex*, const int, const doublecomplex*, const int));
extern void zdrot __P((const int, doublecomplex*, const int, doublecomplex*, const int, const double, const double));
extern void zdrot_ __P((const int*, doublecomplex*, const int*, doublecomplex*, const int*, const double*, const double*));
extern void zdscal __P((const int, const double, doublecomplex*, const int));
extern void zdscal_ __P((const int*, const double*, doublecomplex*, const int*));
extern void zellmm __P((const int, const int, const int, const int, const doublecomplex*, const int*, const doublecomplex*, const int*, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zellmm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zellsm __P((const int, const int, const int, const int, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zellsm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zfft2b __P((const int, const int, doublecomplex*, const int, const double*, const int));
extern void zfft2b_ __P((const int*, const int*, doublecomplex*, const int*, const double*, const int*));
extern void zfft2f __P((const int, const int, doublecomplex*, const int, const double*, const int));
extern void zfft2f_ __P((const int*, const int*, doublecomplex*, const int*, const double*, const int*));
extern void zfft2i __P((const int, const int, double*));
extern void zfft2i_ __P((const int*, const int*, double*));
extern void zfft3b __P((const int, const int, const int, doublecomplex*, const int, const int, const double*, const int));
extern void zfft3b_ __P((const int*, const int*, const int*, doublecomplex*, const int*, const int*, const double*, const int*));
extern void zfft3f __P((const int, const int, const int, doublecomplex*, const int, const int, const double*, const int));
extern void zfft3f_ __P((const int*, const int*, const int*, doublecomplex*, const int*, const int*, const double*, const int*));
extern void zfft3i __P((const int, const int, const int, double*));
extern void zfft3i_ __P((const int*, const int*, const int*, double*));
extern void zfftb __P((const int, doublecomplex*, double*));
extern void zfftb_ __P((const int*, doublecomplex*, double*));
extern void zfftd2_ __P((const int*, const int*, const int*, const double*, const doublecomplex*, const int*, double*, const int*, double*, int*, double*, const int*, int*));
extern void zfftd3_ __P((const int*, const int*, const int*, const int*, const double*, const doublecomplex*, const int*, const int*, double*, const int*, const int*, double*, int*, double*, const int*, int*));
extern void zfftdm_ __P((const int*, const int*, const int*, const double*, const doublecomplex*, const int*, double*, const int*, double*, int*, double*, const int*, int*));
extern void zfftd_ __P((const int*, const int*, const double*, const doublecomplex*, double*, double*, int*, double*, const int*, int*));
extern void zfftf __P((const int, doublecomplex*, const double*));
extern void zfftf_ __P((const int*, doublecomplex*, const double*));
extern void zffti __P((const int, double*));
extern void zffti_ __P((const int*, double*));
extern int zfftopt __P((const int));
extern int zfftopt_ __P((const int*));
extern void zfftz2_ __P((const int*, const int*, const int*, const double*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, double*, const int*, int*));
extern void zfftz3_ __P((const int*, const int*, const int*, const int*, const double*, const doublecomplex*, const int*, const int*, doublecomplex*, const int*, const int*, double*, int*, double*, const int*, int*));
extern void zfftzm_ __P((const int*, const int*, const int*, const double*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, double*, const int*, int*));
extern void zfftz_ __P((const int*, const int*, const double*, const doublecomplex*, doublecomplex*, double*, int*, double*, const int*, int*));
extern void zgbbrd __P((const char, const int, const int, const int, const int, const int, doublecomplex*, const int, double*, double*, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zgbbrd_ __P((const char*, const int*, const int*, const int*, const int*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, double*, int*, const int));
extern void zgbcon __P((const char, const int, const int, const int, const doublecomplex*, const int, const int*, const double, double*, int*));
extern void zgbcon_ __P((const char*, const int*, const int*, const int*, const doublecomplex*, const int*, const int*, const double*, double*, doublecomplex*, double*, int*, const int));
extern void zgbequ __P((const int, const int, const int, const int, const doublecomplex*, const int, double*, double*, double*, double*, double*, int*));
extern void zgbequ_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, double*, double*, double*, double*, double*, int*));
extern void zgbmv __P((const char, const int, const int, const int, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zgbmv_ __P((const char*, const int*, const int*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, const int));
extern void zgbrfs __P((const char, const int, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, const int, const int*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, int*));
extern void zgbrfs_ __P((const char*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int));
extern void zgbsvx __P((const char, const char, const int, const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, int*, char*, double*, double*, doublecomplex*, const int, doublecomplex*, const int, double*, double*, double*, int*));
extern void zgbsvx_ __P((const char*, const char*, const int*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, char*, double*, double*, doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, double*, doublecomplex*, double*, int*, const int, const int, const int));
extern void zgbsv __P((const int, const int, const int, const int, doublecomplex*, const int, int*, doublecomplex*, const int, int*));
extern void zgbsv_ __P((const int*, const int*, const int*, const int*, doublecomplex*, const int*, int*, doublecomplex*, const int*, int*));
extern void zgbtf2 __P((const int, const int, const int, const int, doublecomplex*, const int, int*, int*));
extern void zgbtf2_ __P((const int*, const int*, const int*, const int*, doublecomplex*, const int*, int*, int*));
extern void zgbtrf __P((const int, const int, const int, const int, doublecomplex*, const int, int*, int*));
extern void zgbtrf_ __P((const int*, const int*, const int*, const int*, doublecomplex*, const int*, int*, int*));
extern void zgbtrs __P((const char, const int, const int, const int, const int, const doublecomplex*, const int, const int*, doublecomplex*, const int, int*));
extern void zgbtrs_ __P((const char*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const int*, doublecomplex*, const int*, int*, const int));
extern void zgebak __P((const char, const char, const int, const int, const int, const double*, const int, doublecomplex*, const int, int*));
extern void zgebak_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const int*, doublecomplex*, const int*, int*, const int, const int));
extern void zgebal __P((const char, const int, doublecomplex*, const int, int*, int*, double*, int*));
extern void zgebal_ __P((const char*, const int*, doublecomplex*, const int*, int*, int*, double*, int*, const int));
extern void zgebrd __P((const int, const int, doublecomplex*, const int, double*, double*, doublecomplex*, doublecomplex*, int*));
extern void zgebrd_ __P((const int*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, doublecomplex*, doublecomplex*, const int*, int*));
extern void zgecon __P((const char, const int, const doublecomplex*, const int, const double, double*, int*));
extern void zgecon_ __P((const char*, const int*, const doublecomplex*, const int*, const double*, double*, doublecomplex*, double*, int*, const int));
extern void zgeequ __P((const int, const int, const doublecomplex*, const int, double*, double*, double*, double*, double*, int*));
extern void zgeequ_ __P((const int*, const int*, const doublecomplex*, const int*, double*, double*, double*, double*, double*, int*));
extern void zgeesx __P((const char, const char, const int(*select)(doublecomplex*), const char, const int, doublecomplex*, const int, int*, doublecomplex*, doublecomplex*, const int, double*, double*, int*));
extern void zgeesx_ __P((const char*, const char*, const int(*select)(doublecomplex*), const char*, const int*, doublecomplex*, const int*, int*, doublecomplex*, doublecomplex*, const int*, double*, double*, doublecomplex*, const int*, double*, int*, int*, const int, const int, const int));
extern void zgees __P((const char, const char, const int(*select)(doublecomplex*), const int, doublecomplex*, const int, int*, doublecomplex*, doublecomplex*, const int, int*));
extern void zgees_ __P((const char*, const char*, const int(*select)(doublecomplex*), const int*, doublecomplex*, const int*, int*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, int*, const int, const int));
extern void zgeevx __P((const char, const char, const char, const char, const int, doublecomplex*, const int, doublecomplex*, doublecomplex*, const int, doublecomplex*, const int, int*, int*, double*, double*, double*, double*, int*));
extern void zgeevx_ __P((const char*, const char*, const char*, const char*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, int*, int*, double*, double*, double*, double*, doublecomplex*, const int*, double*, int*, const int, const int, const int, const int));
extern void zgeev __P((const char, const char, const int, doublecomplex*, const int, doublecomplex*, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zgeev_ __P((const char*, const char*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, const int, const int));
extern void zgegs __P((const char, const char, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, doublecomplex*, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zgegs_ __P((const char*, const char*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, const int, const int));
extern void zgegv __P((const char, const char, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, doublecomplex*, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zgegv_ __P((const char*, const char*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, const int, const int));
extern void zgehrd __P((const int, const int, const int, doublecomplex*, const int, doublecomplex*, int*));
extern void zgehrd_ __P((const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, int*));
extern void zgelqf __P((const int, const int, doublecomplex*, const int, doublecomplex*, int*));
extern void zgelqf_ __P((const int*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, int*));
extern void zgelsd __P((const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, double*, const double, int*, int*));
extern void zgelsd_ __P((const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, const double*, int*, doublecomplex*, const int*, double*, int*, int*));
extern void zgelss __P((const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, double*, const double, int*, int*));
extern void zgelss_ __P((const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, const double*, int*, doublecomplex*, const int*, double*, int*));
extern void zgelsx __P((const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, int*, const double, int*, int*));
extern void zgelsx_ __P((const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const double*, int*, doublecomplex*, double*, int*));
extern void zgelsy __P((const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, int*, const double, int*, int*));
extern void zgelsy_ __P((const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const double*, int*, doublecomplex*, const int*, double*, int*));
extern void zgels __P((const char, const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zgels_ __P((const char*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int));
extern void zgemm __P((const char, const char, const int, const int, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zgemm_ __P((const char*, const char*, const int*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, const int, const int));
extern void zgemv __P((const char, const int, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zgemv_ __P((const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, const int));
extern void zgeqlf __P((const int, const int, doublecomplex*, const int, doublecomplex*, int*));
extern void zgeqlf_ __P((const int*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, int*));
extern void zgeqp3 __P((const int, const int, doublecomplex*, const int, int*, doublecomplex*, int*));
extern void zgeqp3_ __P((const int*, const int*, doublecomplex*, const int*, int*, doublecomplex*, doublecomplex*, const int*, double*, int*));
extern void zgeqpf __P((const int, const int, doublecomplex*, const int, int*, doublecomplex*, int*));
extern void zgeqpf_ __P((const int*, const int*, doublecomplex*, const int*, int*, doublecomplex*, doublecomplex*, double*, int*));
extern void zgeqrf __P((const int, const int, doublecomplex*, const int, doublecomplex*, int*));
extern void zgeqrf_ __P((const int*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, int*));
extern void zgerc __P((const int, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, doublecomplex*, const int));
extern void zgerc_ __P((const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*));
extern void zgerfs __P((const char, const int, const int, const doublecomplex*, const int, const doublecomplex*, const int, const int*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, int*));
extern void zgerfs_ __P((const char*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int));
extern void zgerqf __P((const int, const int, doublecomplex*, const int, doublecomplex*, int*));
extern void zgerqf_ __P((const int*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, int*));
extern void zgeru __P((const int, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, doublecomplex*, const int));
extern void zgeru_ __P((const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*));
extern void zgesdd __P((const char, const int, const int, doublecomplex*, const int, double*, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zgesdd_ __P((const char*, const int*, const int*, doublecomplex*, const int*, double*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, int*, const int));
extern void zgesvd __P((const char, const char, const int, const int, doublecomplex*, const int, double*, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zgesvd_ __P((const char*, const char*, const int*, const int*, doublecomplex*, const int*, double*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, const int, const int));
extern void zgesvx __P((const char, const char, const int, const int, doublecomplex*, const int, doublecomplex*, const int, int*, char*, double*, double*, doublecomplex*, const int, doublecomplex*, const int, double*, double*, double*, int*));
extern void zgesvx_ __P((const char*, const char*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, char*, double*, double*, doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, double*, doublecomplex*, double*, int*, const int, const int, const int));
extern void zgesv __P((const int, const int, doublecomplex*, const int, int*, doublecomplex*, const int, int*));
extern void zgesv_ __P((const int*, const int*, doublecomplex*, const int*, int*, doublecomplex*, const int*, int*));
extern void zgetf2 __P((const int, const int, doublecomplex*, const int, int*, int*));
extern void zgetf2_ __P((const int*, const int*, doublecomplex*, const int*, int*, int*));
extern void zgetrf __P((const int, const int, doublecomplex*, const int, int*, int*));
extern void zgetrf_ __P((const int*, const int*, doublecomplex*, const int*, int*, int*));
extern void zgetri __P((const int, doublecomplex*, const int, const int*, int*));
extern void zgetri_ __P((const int*, doublecomplex*, const int*, const int*, doublecomplex*, const int*, int*));
extern void zgetrs __P((const char, const int, const int, const doublecomplex*, const int, const int*, doublecomplex*, const int, int*));
extern void zgetrs_ __P((const char*, const int*, const int*, const doublecomplex*, const int*, const int*, doublecomplex*, const int*, int*, const int));
extern void zggbak __P((const char, const char, const int, const int, const int, const double*, const double*, const int, doublecomplex*, const int, int*));
extern void zggbak_ __P((const char*, const char*, const int*, const int*, const int*, const double*, const double*, const int*, doublecomplex*, const int*, int*, const int, const int));
extern void zggbal __P((const char, const int, doublecomplex*, const int, doublecomplex*, const int, int*, int*, const double*, const double*, int*));
extern void zggbal_ __P((const char*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, int*, const double*, const double*, double*, int*, const int));
extern void zggesx __P((const char, const char, const char, const int(*delctg)(doublecomplex*,doublecomplex*), const char, const int, doublecomplex*, const int, doublecomplex*, const int, int*, doublecomplex*, doublecomplex*, doublecomplex*, const int, doublecomplex*, const int, double*, double*, int*));
extern void zggesx_ __P((const char*, const char*, const char*, const int(*delctg)(doublecomplex*,doublecomplex*), const char*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, doublecomplex*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, const int*, double*, int*, const int*, int*, int*, const int, const int, const int, const int));
extern void zgges __P((const char, const char, const char, const int(*delztg)(doublecomplex*,doublecomplex*), const int, doublecomplex*, const int, doublecomplex*, const int, int*, doublecomplex*, doublecomplex*, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zgges_ __P((const char*, const char*, const char*, const int(*delztg)(doublecomplex*,doublecomplex*), const int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, doublecomplex*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, int*, const int, const int, const int));
extern void zggevx __P((const char, const char, const char, const char, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, doublecomplex*, doublecomplex*, const int, doublecomplex*, const int, int*, int*, double*, double*, double*, double*, double*, double*, int*));
extern void zggevx_ __P((const char*, const char*, const char*, const char*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, int*, int*, double*, double*, double*, double*, double*, double*, doublecomplex*, const int*, double*, int*, int*, int*, const int, const int, const int, const int));
extern void zggev __P((const char, const char, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, doublecomplex*, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zggev_ __P((const char*, const char*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, const int, const int));
extern void zggglm __P((const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, doublecomplex*, doublecomplex*, int*));
extern void zggglm_ __P((const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, const int*, int*));
extern void zgghrd __P((const char, const char, const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zgghrd_ __P((const char*, const char*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int, const int));
extern void zgglse __P((const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, doublecomplex*, doublecomplex*, int*));
extern void zgglse_ __P((const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, const int*, int*));
extern void zggqrf __P((const int, const int, const int, doublecomplex*, const int, doublecomplex*, doublecomplex*, const int, doublecomplex*, int*));
extern void zggqrf_ __P((const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, int*));
extern void zggrqf __P((const int, const int, const int, doublecomplex*, const int, doublecomplex*, doublecomplex*, const int, doublecomplex*, int*));
extern void zggrqf_ __P((const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, int*));
extern void zggsvd __P((const char, const char, const char, const int, const int, const int, int*, int*, doublecomplex*, const int, doublecomplex*, const int, double*, double*, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, const int, int*, int*));
extern void zggsvd_ __P((const char*, const char*, const char*, const int*, const int*, const int*, int*, int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, double*, int*, int*, const int, const int, const int));
extern void zggsvp __P((const char, const char, const char, const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, const double, const double, int*, int*, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zggsvp_ __P((const char*, const char*, const char*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, const double*, const double*, int*, int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, double*, doublecomplex*, doublecomplex*, int*, const int, const int, const int));
extern void zgssco_ __P((double*, double*, int*));
extern void zgssda_ __P((double*, int*));
extern void zgssfa_ __P((const int*, const int*, const int*, const doublecomplex*, double*, int*));
extern void zgssfs_ __P((const char*, const char*, const int*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, const char*, const int*, const int*, double*, int*, const int, const int, const int));
extern void zgssin_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const int*, double*, int*, const int, const int));
extern void zgssor_ __P((const char*, double*, int*, const int));
extern void zgssps_ __P((double*, int*));
extern void zgssrp_ __P((int*, double*, int*));
extern void zgsssl_ __P((const int*, doublecomplex*, const int*, double*, int*));
extern void zgssuo_ __P((const int*, double*, int*));
extern void zgtcon __P((const char, const int, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int*, const double, double*, int*));
extern void zgtcon_ __P((const char*, const int*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int*, const double*, double*, doublecomplex*, int*, const int));
extern void zgthrz __P((const int, doublecomplex*, doublecomplex*, const int*));
extern void zgthrz_ __P((const int*, doublecomplex*, doublecomplex*, const int*));
extern void zgthr __P((const int, const doublecomplex*, doublecomplex*, const int*));
extern void zgthr_ __P((const int*, const doublecomplex*, doublecomplex*, const int*));
extern void zgtrfs __P((const char, const int, const int, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, int*));
extern void zgtrfs_ __P((const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int));
extern void zgtsvx __P((const char, const char, const int, const int, const doublecomplex*, const doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, int*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, double*, int*));
extern void zgtsvx_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, double*, doublecomplex*, double*, int*, const int, const int));
extern void zgtsv __P((const int, const int, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, const int, int*));
extern void zgtsv_ __P((const int*, const int*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, const int*, int*));
extern void zgttrf __P((const int, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, int*, int*));
extern void zgttrf_ __P((const int*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, int*, int*));
extern void zgttrs __P((const char, const int, const int, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int*, doublecomplex*, const int, int*));
extern void zgttrs_ __P((const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int*, doublecomplex*, const int*, int*, const int));
extern void zhbevd __P((const char, const char, const int, const int, doublecomplex*, const int, double*, doublecomplex*, const int, int*));
extern void zhbevd_ __P((const char*, const char*, const int*, const int*, doublecomplex*, const int*, double*, doublecomplex*, const int*, doublecomplex*, const int*, double*, const int*, int*, const int*, int*, const int, const int));
extern void zhbevx __P((const char, const char, const char, const int, const int, doublecomplex*, const int, doublecomplex*, const int, const double, const double, const int, const int, const double, int*, double*, doublecomplex*, const int, int*, int*));
extern void zhbevx_ __P((const char*, const char*, const char*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, const double*, const double*, const int*, const int*, const double*, int*, double*, doublecomplex*, const int*, doublecomplex*, double*, int*, int*, int*, const int, const int, const int));
extern void zhbev __P((const char, const char, const int, const int, doublecomplex*, const int, double*, doublecomplex*, const int, int*));
extern void zhbev_ __P((const char*, const char*, const int*, const int*, doublecomplex*, const int*, double*, doublecomplex*, const int*, doublecomplex*, double*, int*, const int, const int));
extern void zhbgst __P((const char, const char, const int, const int, const int, doublecomplex*, const int, const doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zhbgst_ __P((const char*, const char*, const int*, const int*, const int*, doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, double*, int*, const int, const int));
extern void zhbgvd __P((const char, const char, const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, double*, doublecomplex*, const int, int*));
extern void zhbgvd_ __P((const char*, const char*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, doublecomplex*, const int*, doublecomplex*, const int*, double*, const int*, int*, const int*, int*, const int, const int));
extern void zhbgvx __P((const char, const char, const char, const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, const int, const double, const double, const int, const int, const double, int*, double*, doublecomplex*, const int, int*, int*));
extern void zhbgvx_ __P((const char*, const char*, const char*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, const double*, const double*, const int*, const int*, const double*, int*, double*, doublecomplex*, const int*, doublecomplex*, double*, int*, int*, int*, const int, const int, const int));
extern void zhbgv __P((const char, const char, const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, double*, doublecomplex*, const int, int*));
extern void zhbgv_ __P((const char*, const char*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, doublecomplex*, const int*, doublecomplex*, double*, int*, const int, const int));
extern void zhbmv __P((const char, const int, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zhbmv_ __P((const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, const int));
extern void zhbtrd __P((const char, const char, const int, const int, doublecomplex*, const int, double*, double*, doublecomplex*, const int, int*));
extern void zhbtrd_ __P((const char*, const char*, const int*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, const int*, doublecomplex*, int*, const int, const int));
extern void zhecon __P((const char, const int, const doublecomplex*, const int, const int*, const double, double*, int*));
extern void zhecon_ __P((const char*, const int*, const doublecomplex*, const int*, const int*, const double*, double*, doublecomplex*, int*, const int));
extern void zheevd __P((const char, const char, const int, doublecomplex*, const int, double*, int*));
extern void zheevd_ __P((const char*, const char*, const int*, doublecomplex*, const int*, double*, doublecomplex*, const int*, double*, const int*, int*, const int*, int*, const int, const int));
extern void zheevr __P((const char, const char, const char, const int, doublecomplex*, const int, const double, const double, const int, const int, const double, int*, double*, doublecomplex*, const int, int*, int*));
extern void zheevr_ __P((const char*, const char*, const char*, const int*, doublecomplex*, const int*, const double*, const double*, const int*, const int*, const double*, int*, double*, doublecomplex*, const int*, int*, doublecomplex*, const int*, double*, const int*, int*, const int*, int*, const int, const int, const int));
extern void zheevx __P((const char, const char, const char, const int, doublecomplex*, const int, const double, const double, const int, const int, const double, int*, double*, doublecomplex*, const int, int*, int*));
extern void zheevx_ __P((const char*, const char*, const char*, const int*, doublecomplex*, const int*, const double*, const double*, const int*, const int*, const double*, int*, double*, doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, int*, int*, const int, const int, const int));
extern void zheev __P((const char, const char, const int, doublecomplex*, const int, double*, int*));
extern void zheev_ __P((const char*, const char*, const int*, doublecomplex*, const int*, double*, doublecomplex*, const int*, double*, int*, const int, const int));
extern void zhegs2 __P((const int, const char, const int, doublecomplex*, const int, const doublecomplex*, const int, int*));
extern void zhegs2_ __P((const int*, const char*, const int*, doublecomplex*, const int*, const doublecomplex*, const int*, int*, const int));
extern void zhegst __P((const int, const char, const int, doublecomplex*, const int, const doublecomplex*, const int, int*));
extern void zhegst_ __P((const int*, const char*, const int*, doublecomplex*, const int*, const doublecomplex*, const int*, int*, const int));
extern void zhegvd __P((const int, const char, const char, const int, doublecomplex*, const int, doublecomplex*, const int, double*, int*));
extern void zhegvd_ __P((const int*, const char*, const char*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, doublecomplex*, const int*, double*, const int*, int*, const int*, int*, const int, const int));
extern void zhegvx __P((const int, const char, const char, const char, const int, doublecomplex*, const int, doublecomplex*, const int, const double, const double, const int, const int, const double, int*, double*, doublecomplex*, const int, int*, int*));
extern void zhegvx_ __P((const int*, const char*, const char*, const char*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, const double*, const double*, const int*, const int*, const double*, int*, double*, doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, int*, int*, const int, const int, const int));
extern void zhegv __P((const int, const char, const char, const int, doublecomplex*, const int, doublecomplex*, const int, double*, int*));
extern void zhegv_ __P((const int*, const char*, const char*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, doublecomplex*, const int*, double*, int*, const int, const int));
extern void zhemm __P((const char, const char, const int, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zhemm_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, const int, const int));
extern void zhemv __P((const char, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zhemv_ __P((const char*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, const int));
extern void zher2k __P((const char, const char, const int, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, const double, doublecomplex*, const int));
extern void zher2k_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const double*, doublecomplex*, const int*, const int, const int));
extern void zher2 __P((const char, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, doublecomplex*, const int));
extern void zher2_ __P((const char*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, const int));
extern void zherfs __P((const char, const int, const int, const doublecomplex*, const int, const doublecomplex*, const int, const int*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, int*));
extern void zherfs_ __P((const char*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int));
extern void zherk __P((const char, const char, const int, const int, const double, const doublecomplex*, const int, const double, doublecomplex*, const int));
extern void zherk_ __P((const char*, const char*, const int*, const int*, const double*, const doublecomplex*, const int*, const double*, doublecomplex*, const int*, const int, const int));
extern void zher __P((const char, const int, const double, const doublecomplex*, const int, doublecomplex*, const int));
extern void zher_ __P((const char*, const int*, const double*, const doublecomplex*, const int*, doublecomplex*, const int*, const int));
extern void zhesvx __P((const char, const char, const int, const int, const doublecomplex*, const int, doublecomplex*, const int, int*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, double*, int*));
extern void zhesvx_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, double*, doublecomplex*, const int*, double*, int*, const int, const int));
extern void zhesv __P((const char, const int, const int, doublecomplex*, const int, int*, doublecomplex*, const int, int*));
extern void zhesv_ __P((const char*, const int*, const int*, doublecomplex*, const int*, int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int));
extern void zhetf2 __P((const char, const int, doublecomplex*, const int, int*, int*));
extern void zhetf2_ __P((const char*, const int*, doublecomplex*, const int*, int*, int*, const int));
extern void zhetrd __P((const char, const int, doublecomplex*, const int, double*, double*, doublecomplex*, int*));
extern void zhetrd_ __P((const char*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, doublecomplex*, const int*, int*, const int));
extern void zhetrf __P((const char, const int, doublecomplex*, const int, int*, int*));
extern void zhetrf_ __P((const char*, const int*, doublecomplex*, const int*, int*, doublecomplex*, const int*, int*, const int));
extern void zhetri __P((const char, const int, doublecomplex*, const int, const int*, int*));
extern void zhetri_ __P((const char*, const int*, doublecomplex*, const int*, const int*, doublecomplex*, int*, const int));
extern void zhetrs __P((const char, const int, const int, const doublecomplex*, const int, const int*, doublecomplex*, const int, int*));
extern void zhetrs_ __P((const char*, const int*, const int*, const doublecomplex*, const int*, const int*, doublecomplex*, const int*, int*, const int));
extern void zhgeqz __P((const char, const char, const char, const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, doublecomplex*, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zhgeqz_ __P((const char*, const char*, const char*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, const int, const int, const int));
extern void zhpcon __P((const char, const int, const doublecomplex*, const int*, const double, double*, int*));
extern void zhpcon_ __P((const char*, const int*, const doublecomplex*, const int*, const double*, double*, doublecomplex*, int*, const int));
extern void zhpevd __P((const char, const char, const int, doublecomplex*, double*, doublecomplex*, const int, int*));
extern void zhpevd_ __P((const char*, const char*, const int*, doublecomplex*, double*, doublecomplex*, const int*, doublecomplex*, const int*, double*, const int*, int*, const int*, int*, const int, const int));
extern void zhpevx __P((const char, const char, const char, const int, doublecomplex*, const double, const double, const int, const int, const double, int*, double*, doublecomplex*, const int, int*, int*));
extern void zhpevx_ __P((const char*, const char*, const char*, const int*, doublecomplex*, const double*, const double*, const int*, const int*, const double*, int*, double*, doublecomplex*, const int*, doublecomplex*, double*, int*, int*, int*, const int, const int, const int));
extern void zhpev __P((const char, const char, const int, doublecomplex*, double*, doublecomplex*, const int, int*));
extern void zhpev_ __P((const char*, const char*, const int*, doublecomplex*, double*, doublecomplex*, const int*, doublecomplex*, double*, int*, const int, const int));
extern void zhpgst __P((const int, const char, const int, doublecomplex*, const doublecomplex*, int*));
extern void zhpgst_ __P((const int*, const char*, const int*, doublecomplex*, const doublecomplex*, int*, const int));
extern void zhpgvd __P((const int, const char, const char, const int, doublecomplex*, doublecomplex*, double*, doublecomplex*, const int, int*));
extern void zhpgvd_ __P((const int*, const char*, const char*, const int*, doublecomplex*, doublecomplex*, double*, doublecomplex*, const int*, doublecomplex*, const int*, double*, const int*, int*, const int*, int*, const int, const int));
extern void zhpgvx __P((const int, const char, const char, const char, const int, doublecomplex*, doublecomplex*, const double, const double, const int, const int, const double, int*, double*, doublecomplex*, const int, int*, int*));
extern void zhpgvx_ __P((const int*, const char*, const char*, const char*, const int*, doublecomplex*, doublecomplex*, const double*, const double*, const int*, const int*, const double*, int*, double*, doublecomplex*, const int*, doublecomplex*, double*, int*, int*, int*, const int, const int, const int));
extern void zhpgv __P((const int, const char, const char, const int, doublecomplex*, doublecomplex*, double*, doublecomplex*, const int, int*));
extern void zhpgv_ __P((const int*, const char*, const char*, const int*, doublecomplex*, doublecomplex*, double*, doublecomplex*, const int*, doublecomplex*, double*, int*, const int, const int));
extern void zhpmv __P((const char, const int, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zhpmv_ __P((const char*, const int*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, const int));
extern void zhpr2 __P((const char, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, doublecomplex*));
extern void zhpr2_ __P((const char*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int));
extern void zhprfs __P((const char, const int, const int, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, int*));
extern void zhprfs_ __P((const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int));
extern void zhpr __P((const char, const int, const double, const doublecomplex*, const int, doublecomplex*));
extern void zhpr_ __P((const char*, const int*, const double*, const doublecomplex*, const int*, doublecomplex*, const int));
extern void zhpsvx __P((const char, const char, const int, const int, const doublecomplex*, doublecomplex*, int*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, double*, int*));
extern void zhpsvx_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, doublecomplex*, int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, double*, doublecomplex*, double*, int*, const int, const int));
extern void zhpsv __P((const char, const int, const int, doublecomplex*, int*, doublecomplex*, const int, int*));
extern void zhpsv_ __P((const char*, const int*, const int*, doublecomplex*, int*, doublecomplex*, const int*, int*, const int));
extern void zhptrd __P((const char, const int, doublecomplex*, double*, double*, doublecomplex*, int*));
extern void zhptrd_ __P((const char*, const int*, doublecomplex*, double*, double*, doublecomplex*, int*, const int));
extern void zhptrf __P((const char, const int, doublecomplex*, int*, int*));
extern void zhptrf_ __P((const char*, const int*, doublecomplex*, int*, int*, const int));
extern void zhptri __P((const char, const int, doublecomplex*, const int*, int*));
extern void zhptri_ __P((const char*, const int*, doublecomplex*, const int*, doublecomplex*, int*, const int));
extern void zhptrs __P((const char, const int, const int, const doublecomplex*, const int*, doublecomplex*, const int, int*));
extern void zhptrs_ __P((const char*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, int*, const int));
extern void zhsein __P((const char, const char, const char, const int*, const int, const doublecomplex*, const int, doublecomplex*, doublecomplex*, const int, doublecomplex*, const int, const int, int*, int*, int*, int*));
extern void zhsein_ __P((const char*, const char*, const char*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, const int*, int*, doublecomplex*, double*, int*, int*, int*, const int, const int, const int));
extern void zhseqr __P((const char, const char, const int, const int, const int, doublecomplex*, const int, doublecomplex*, doublecomplex*, const int, int*));
extern void zhseqr_ __P((const char*, const char*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int, const int));
extern void zjadmm __P((const int, const int, const int, const int, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int, const int*, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zjadmm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zjadrp __P((const int, const int, const int, const doublecomplex*, const int*, int*, const int, const int*));
extern void zjadrp_ __P((const int*, const int*, const int*, const doublecomplex*, const int*, int*, const int*, const int*, int*, const int*));
extern void zjadsm __P((const int, const int, const int, const int, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int, const int*, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zjadsm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zlarzb __P((const char, const char, const char, const char, const int, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, const int, doublecomplex*, const int, const int));
extern void zlarzb_ __P((const char*, const char*, const char*, const char*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, const int, const int, const int, const int));
extern void zlarzt __P((const char, const char, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zlarzt_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, const int, const int));
extern void zlarz __P((const char, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zlarz_ __P((const char*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int));
extern void zlatzm __P((const char, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, doublecomplex*, const int));
extern void zlatzm_ __P((const char*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int));
extern void zpbcon __P((const char, const int, const int, const doublecomplex*, const int, const double, double*, int*));
extern void zpbcon_ __P((const char*, const int*, const int*, const doublecomplex*, const int*, const double*, double*, doublecomplex*, double*, int*, const int));
extern void zpbequ __P((const char, const int, const int, const doublecomplex*, const int, double*, double*, double*, int*));
extern void zpbequ_ __P((const char*, const int*, const int*, const doublecomplex*, const int*, double*, double*, double*, int*, const int));
extern void zpbrfs __P((const char, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, int*));
extern void zpbrfs_ __P((const char*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int));
extern void zpbstf __P((const char, const int, const int, doublecomplex*, const int, int*));
extern void zpbstf_ __P((const char*, const int*, const int*, doublecomplex*, const int*, int*, const int));
extern void zpbsvx __P((const char, const char, const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, char*, double*, doublecomplex*, const int, doublecomplex*, const int, double*, double*, double*, int*));
extern void zpbsvx_ __P((const char*, const char*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, char*, double*, doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, double*, doublecomplex*, double*, int*, const int, const int, const int));
extern void zpbsv __P((const char, const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zpbsv_ __P((const char*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int));
extern void zpbtf2 __P((const char, const int, const int, doublecomplex*, const int, int*));
extern void zpbtf2_ __P((const char*, const int*, const int*, doublecomplex*, const int*, int*, const int));
extern void zpbtrf __P((const char, const int, const int, doublecomplex*, const int, int*));
extern void zpbtrf_ __P((const char*, const int*, const int*, doublecomplex*, const int*, int*, const int));
extern void zpbtrs __P((const char, const int, const int, const int, const doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zpbtrs_ __P((const char*, const int*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, int*, const int));
extern void zpocon __P((const char, const int, const doublecomplex*, const int, const double, double*, int*));
extern void zpocon_ __P((const char*, const int*, const doublecomplex*, const int*, const double*, double*, doublecomplex*, double*, int*, const int));
extern void zpoequ __P((const int, const doublecomplex*, const int, double*, double*, double*, int*));
extern void zpoequ_ __P((const int*, const doublecomplex*, const int*, double*, double*, double*, int*));
extern void zporfs __P((const char, const int, const int, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, int*));
extern void zporfs_ __P((const char*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int));
extern void zposvx __P((const char, const char, const int, const int, doublecomplex*, const int, doublecomplex*, const int, char*, double*, doublecomplex*, const int, doublecomplex*, const int, double*, double*, double*, int*));
extern void zposvx_ __P((const char*, const char*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, char*, double*, doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, double*, doublecomplex*, double*, int*, const int, const int, const int));
extern void zposv __P((const char, const int, const int, doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zposv_ __P((const char*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int));
extern void zpotf2 __P((const char, const int, doublecomplex*, const int, int*));
extern void zpotf2_ __P((const char*, const int*, doublecomplex*, const int*, int*, const int));
extern void zpotrf __P((const char, const int, doublecomplex*, const int, int*));
extern void zpotrf_ __P((const char*, const int*, doublecomplex*, const int*, int*, const int));
extern void zpotri __P((const char, const int, doublecomplex*, const int, int*));
extern void zpotri_ __P((const char*, const int*, doublecomplex*, const int*, int*, const int));
extern void zpotrs __P((const char, const int, const int, const doublecomplex*, const int, doublecomplex*, const int, int*));
extern void zpotrs_ __P((const char*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, int*, const int));
extern void zppcon __P((const char, const int, const doublecomplex*, const double, double*, int*));
extern void zppcon_ __P((const char*, const int*, const doublecomplex*, const double*, double*, doublecomplex*, double*, int*, const int));
extern void zppequ __P((const char, const int, const doublecomplex*, double*, double*, double*, int*));
extern void zppequ_ __P((const char*, const int*, const doublecomplex*, double*, double*, double*, int*, const int));
extern void zpprfs __P((const char, const int, const int, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, int*));
extern void zpprfs_ __P((const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int));
extern void zppsvx __P((const char, const char, const int, const int, doublecomplex*, doublecomplex*, char*, double*, doublecomplex*, const int, doublecomplex*, const int, double*, double*, double*, int*));
extern void zppsvx_ __P((const char*, const char*, const int*, const int*, doublecomplex*, doublecomplex*, char*, double*, doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, double*, doublecomplex*, double*, int*, const int, const int, const int));
extern void zppsv __P((const char, const int, const int, doublecomplex*, doublecomplex*, const int, int*));
extern void zppsv_ __P((const char*, const int*, const int*, doublecomplex*, doublecomplex*, const int*, int*, const int));
extern void zpptrf __P((const char, const int, doublecomplex*, int*));
extern void zpptrf_ __P((const char*, const int*, doublecomplex*, int*, const int));
extern void zpptri __P((const char, const int, doublecomplex*, int*));
extern void zpptri_ __P((const char*, const int*, doublecomplex*, int*, const int));
extern void zpptrs __P((const char, const int, const int, const doublecomplex*, doublecomplex*, const int, int*));
extern void zpptrs_ __P((const char*, const int*, const int*, const doublecomplex*, doublecomplex*, const int*, int*, const int));
extern void zptcon __P((const int, const double*, const doublecomplex*, const double, double*, int*));
extern void zptcon_ __P((const int*, const double*, const doublecomplex*, const double*, double*, double*, int*));
extern void zpteqr __P((const char, const int, double*, double*, doublecomplex*, const int, int*));
extern void zpteqr_ __P((const char*, const int*, double*, double*, doublecomplex*, const int*, double*, int*, const int));
extern void zptrfs __P((const char, const int, const int, const double*, const doublecomplex*, const double*, const doublecomplex*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, int*));
extern void zptrfs_ __P((const char*, const int*, const int*, const double*, const doublecomplex*, const double*, const doublecomplex*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int));
extern void zptsvx __P((const char, const int, const int, const double*, const doublecomplex*, double*, doublecomplex*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, double*, int*));
extern void zptsvx_ __P((const char*, const int*, const int*, const double*, const doublecomplex*, double*, doublecomplex*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, double*, doublecomplex*, double*, int*, const int));
extern void zptsv __P((const int, const int, double*, doublecomplex*, doublecomplex*, const int, int*));
extern void zptsv_ __P((const int*, const int*, double*, doublecomplex*, doublecomplex*, const int*, int*));
extern void zpttrf __P((const int, double*, doublecomplex*, int*));
extern void zpttrf_ __P((const int*, double*, doublecomplex*, int*));
extern void zpttrs __P((const char, const int, const int, const double*, doublecomplex*, doublecomplex*, const int, int*));
extern void zpttrs_ __P((const char*, const int*, const int*, const double*, doublecomplex*, doublecomplex*, const int*, int*, const int));
extern void zptts2 __P((const int, const int, const int, const double*, const doublecomplex*, doublecomplex*, const int));
extern void zptts2_ __P((const int*, const int*, const int*, const double*, const doublecomplex*, doublecomplex*, const int*));
extern void zrotg __P((doublecomplex*, const doublecomplex*, double*, doublecomplex*));
extern void zrotg_ __P((doublecomplex*, const doublecomplex*, double*, doublecomplex*));
extern void zrot __P((const int, doublecomplex*, const int, doublecomplex*, const int, const double, const doublecomplex*));
extern void zrot_ __P((const int*, doublecomplex*, const int*, doublecomplex*, const int*, const double*, const doublecomplex*));
extern void zscal __P((const int, const doublecomplex*, doublecomplex*, const int));
extern void zscal_ __P((const int*, const doublecomplex*, doublecomplex*, const int*));
extern void zsctr __P((const int, const doublecomplex*, const int*, doublecomplex*));
extern void zsctr_ __P((const int*, const doublecomplex*, const int*, doublecomplex*));
extern void zskymm __P((const int, const int, const int, const int, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zskymm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zskysm __P((const int, const int, const int, const int, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zskysm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zspcon __P((const char, const int, const doublecomplex*, const int*, const double, double*, int*));
extern void zspcon_ __P((const char*, const int*, const doublecomplex*, const int*, const double*, double*, doublecomplex*, int*, const int));
extern void zspmv __P((const char, const int, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zspmv_ __P((const char*, const int*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, const int));
extern void zsprfs __P((const char, const int, const int, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, int*));
extern void zsprfs_ __P((const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int));
extern void zspsvx __P((const char, const char, const int, const int, const doublecomplex*, doublecomplex*, int*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, double*, int*));
extern void zspsvx_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, doublecomplex*, int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, double*, doublecomplex*, double*, int*, const int, const int));
extern void zspsv __P((const char, const int, const int, doublecomplex*, int*, doublecomplex*, const int, int*));
extern void zspsv_ __P((const char*, const int*, const int*, doublecomplex*, int*, doublecomplex*, const int*, int*, const int));
extern void zsptrf __P((const char, const int, doublecomplex*, int*, int*));
extern void zsptrf_ __P((const char*, const int*, doublecomplex*, int*, int*, const int));
extern void zsptri __P((const char, const int, doublecomplex*, const int*, int*));
extern void zsptri_ __P((const char*, const int*, doublecomplex*, const int*, doublecomplex*, int*, const int));
extern void zsptrs __P((const char, const int, const int, const doublecomplex*, const int*, doublecomplex*, const int, int*));
extern void zsptrs_ __P((const char*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, int*, const int));
extern void zstedc __P((const char, const int, double*, double*, doublecomplex*, const int, int*));
extern void zstedc_ __P((const char*, const int*, double*, double*, doublecomplex*, const int*, doublecomplex*, const int*, double*, const int*, int*, const int*, int*, const int));
extern void zstegr __P((const char, const char, const int, double*, double*, const double, const double, const int, const int, const double, int*, double*, doublecomplex*, const int, int*, int*));
extern void zstegr_ __P((const char*, const char*, const int*, double*, double*, const double*, const double*, const int*, const int*, const double*, int*, double*, doublecomplex*, const int*, int*, double*, const int*, int*, const int*, int*, const int, const int));
extern void zstein __P((const int, const double*, const double*, const int, const double*, const int*, const int*, doublecomplex*, const int, int*, int*));
extern void zstein_ __P((const int*, const double*, const double*, const int*, const double*, const int*, const int*, doublecomplex*, const int*, double*, int*, int*, int*));
extern void zsteqr __P((const char, const int, double*, double*, doublecomplex*, const int, int*));
extern void zsteqr_ __P((const char*, const int*, double*, double*, doublecomplex*, const int*, double*, int*, const int));
extern void zstsv __P((const int, const int, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, const int, int*, int*));
extern void zstsv_ __P((const int*, const int*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, const int*, int*, int*));
extern void zsttrf __P((const int, doublecomplex*, doublecomplex*, doublecomplex*, int*, int*));
extern void zsttrf_ __P((const int*, doublecomplex*, doublecomplex*, doublecomplex*, int*, int*));
extern void zsttrs __P((const int, const int, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int, int*, int*));
extern void zsttrs_ __P((const int*, const int*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const int*, int*, int*));
extern void zswap __P((const int, doublecomplex*, const int, doublecomplex*, const int));
extern void zswap_ __P((const int*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zsycon __P((const char, const int, const doublecomplex*, const int, const int*, const double, double*, int*));
extern void zsycon_ __P((const char*, const int*, const doublecomplex*, const int*, const int*, const double*, double*, doublecomplex*, int*, const int));
extern void zsymm __P((const char, const char, const int, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zsymm_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, const int, const int));
extern void zsyr2k __P((const char, const char, const int, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zsyr2k_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, const int, const int));
extern void zsyrfs __P((const char, const int, const int, const doublecomplex*, const int, const doublecomplex*, const int, const int*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, int*));
extern void zsyrfs_ __P((const char*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int));
extern void zsyrk __P((const char, const char, const int, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zsyrk_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, const int, const int));
extern void zsysvx __P((const char, const char, const int, const int, const doublecomplex*, const int, doublecomplex*, const int, int*, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, double*, int*));
extern void zsysvx_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, double*, doublecomplex*, const int*, double*, int*, const int, const int));
extern void zsysv __P((const char, const int, const int, doublecomplex*, const int, int*, doublecomplex*, const int, int*));
extern void zsysv_ __P((const char*, const int*, const int*, doublecomplex*, const int*, int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int));
extern void zsytf2 __P((const char, const int, doublecomplex*, const int, int*, int*));
extern void zsytf2_ __P((const char*, const int*, doublecomplex*, const int*, int*, int*, const int));
extern void zsytrf __P((const char, const int, doublecomplex*, const int, int*, int*));
extern void zsytrf_ __P((const char*, const int*, doublecomplex*, const int*, int*, doublecomplex*, const int*, int*, const int));
extern void zsytri __P((const char, const int, doublecomplex*, const int, const int*, int*));
extern void zsytri_ __P((const char*, const int*, doublecomplex*, const int*, const int*, doublecomplex*, int*, const int));
extern void zsytrs __P((const char, const int, const int, const doublecomplex*, const int, const int*, doublecomplex*, const int, int*));
extern void zsytrs_ __P((const char*, const int*, const int*, const doublecomplex*, const int*, const int*, doublecomplex*, const int*, int*, const int));
extern void ztbcon __P((const char, const char, const char, const int, const int, const doublecomplex*, const int, double*, int*));
extern void ztbcon_ __P((const char*, const char*, const char*, const int*, const int*, const doublecomplex*, const int*, double*, doublecomplex*, double*, int*, const int, const int, const int));
extern void ztbmv __P((const char, const char, const char, const int, const int, const doublecomplex*, const int, doublecomplex*, const int));
extern void ztbmv_ __P((const char*, const char*, const char*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, const int, const int, const int));
extern void ztbrfs __P((const char, const char, const char, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, const int, double*, double*, int*));
extern void ztbrfs_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int, const int, const int));
extern void ztbsv __P((const char, const char, const char, const int, const int, const doublecomplex*, const int, doublecomplex*, const int));
extern void ztbsv_ __P((const char*, const char*, const char*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, const int, const int, const int));
extern void ztbtrs __P((const char, const char, const char, const int, const int, const int, const doublecomplex*, const int, doublecomplex*, const int, int*));
extern void ztbtrs_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, int*, const int, const int, const int));
extern void ztgevc __P((const char, const char, const int*, const int, const doublecomplex*, const int, const doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, const int, const int, int*, int*));
extern void ztgevc_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, const int*, int*, doublecomplex*, double*, int*, const int, const int));
extern void ztgexc __P((const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, const int, int*, int*, int*));
extern void ztgexc_ __P((const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, int*, int*, int*));
extern void ztgsen __P((const int, const int, const int, const int*, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, doublecomplex*, doublecomplex*, const int, doublecomplex*, const int, int*, double*, double*, double*, int*));
extern void ztgsen_ __P((const int*, const int*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, int*, double*, double*, double*, doublecomplex*, const int*, int*, const int*, int*));
extern void ztgsja __P((const char, const char, const char, const int, const int, const int, const int, const int, doublecomplex*, const int, doublecomplex*, const int, const double, const double, double*, double*, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, const int, int*, int*));
extern void ztgsja_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, const double*, const double*, double*, double*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, int*, int*, const int, const int, const int));
extern void ztgsna __P((const char, const char, const int*, const int, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, const int, double*, double*, const int, int*, int*));
extern void ztgsna_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, double*, double*, const int*, int*, doublecomplex*, const int*, int*, int*, const int, const int));
extern void ztgsyl __P((const char, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, const int, doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, const int, doublecomplex*, const int, double*, double*, int*));
extern void ztgsyl_ __P((const char*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, double*, doublecomplex*, const int*, int*, int*, const int));
extern void ztpcon __P((const char, const char, const char, const int, const doublecomplex*, double*, int*));
extern void ztpcon_ __P((const char*, const char*, const char*, const int*, const doublecomplex*, double*, doublecomplex*, double*, int*, const int, const int, const int));
extern void ztpmv __P((const char, const char, const char, const int, const doublecomplex*, doublecomplex*, const int));
extern void ztpmv_ __P((const char*, const char*, const char*, const int*, const doublecomplex*, doublecomplex*, const int*, const int, const int, const int));
extern void ztprfs __P((const char, const char, const char, const int, const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, double*, double*, int*));
extern void ztprfs_ __P((const char*, const char*, const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int, const int, const int));
extern void ztpsv __P((const char, const char, const char, const int, const doublecomplex*, doublecomplex*, const int));
extern void ztpsv_ __P((const char*, const char*, const char*, const int*, const doublecomplex*, doublecomplex*, const int*, const int, const int, const int));
extern void ztptri __P((const char, const char, const int, doublecomplex*, int*));
extern void ztptri_ __P((const char*, const char*, const int*, doublecomplex*, int*, const int, const int));
extern void ztptrs __P((const char, const char, const char, const int, const int, const doublecomplex*, doublecomplex*, const int, int*));
extern void ztptrs_ __P((const char*, const char*, const char*, const int*, const int*, const doublecomplex*, doublecomplex*, const int*, int*, const int, const int, const int));
extern void ztrans __P((const char, const doublecomplex*, doublecomplex*, const int, const int, doublecomplex*));
extern void ztrans_ __P((const char*, const doublecomplex*, doublecomplex*, const int*, const int*, doublecomplex*, const int));
extern void ztrcon __P((const char, const char, const char, const int, const doublecomplex*, const int, double*, int*));
extern void ztrcon_ __P((const char*, const char*, const char*, const int*, const doublecomplex*, const int*, double*, doublecomplex*, double*, int*, const int, const int, const int));
extern void ztrevc __P((const char, const char, int*, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, const int, const int, int*, int*));
extern void ztrevc_ __P((const char*, const char*, int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, const int*, int*, doublecomplex*, double*, int*, const int, const int));
extern void ztrexc __P((const char, const int, doublecomplex*, const int, doublecomplex*, const int, const int, const int, int*));
extern void ztrexc_ __P((const char*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, const int*, const int*, int*, const int));
extern void ztrmm __P((const char, const char, const char, const char, const int, const int, const doublecomplex*, const doublecomplex*, const int, doublecomplex*, const int));
extern void ztrmm_ __P((const char*, const char*, const char*, const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, doublecomplex*, const int*, const int, const int, const int, const int));
extern void ztrmv __P((const char, const char, const char, const int, const doublecomplex*, const int, doublecomplex*, const int));
extern void ztrmv_ __P((const char*, const char*, const char*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, const int, const int, const int));
extern void ztrrfs __P((const char, const char, const char, const int, const int, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, const int, double*, double*, int*));
extern void ztrrfs_ __P((const char*, const char*, const char*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, double*, double*, doublecomplex*, double*, int*, const int, const int, const int));
extern void ztrsen __P((const char, const char, const int*, const int, doublecomplex*, const int, doublecomplex*, const int, doublecomplex*, int*, double*, double*, int*));
extern void ztrsen_ __P((const char*, const char*, const int*, const int*, doublecomplex*, const int*, doublecomplex*, const int*, doublecomplex*, int*, double*, double*, doublecomplex*, const int*, int*, const int, const int));
extern void ztrsm __P((const char, const char, const char, const char, const int, const int, const doublecomplex*, const doublecomplex*, const int, doublecomplex*, const int));
extern void ztrsm_ __P((const char*, const char*, const char*, const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, doublecomplex*, const int*, const int, const int, const int, const int));
extern void ztrsna __P((const char, const char, const int*, const int, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, const int, double*, double*, const int, int*, const int, int*));
extern void ztrsna_ __P((const char*, const char*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, double*, double*, const int*, int*, doublecomplex*, const int*, double*, int*, const int, const int));
extern void ztrsv __P((const char, const char, const char, const int, const doublecomplex*, const int, doublecomplex*, const int));
extern void ztrsv_ __P((const char*, const char*, const char*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, const int, const int, const int));
extern void ztrsyl __P((const char, const char, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, const int, doublecomplex*, const int, double*, int*));
extern void ztrsyl_ __P((const char*, const char*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, double*, int*, const int, const int));
extern void ztrti2 __P((const char, const char, const int, doublecomplex*, const int, int*));
extern void ztrti2_ __P((const char*, const char*, const int*, doublecomplex*, const int*, int*, const int, const int));
extern void ztrtri __P((const char, const char, const int, doublecomplex*, const int, int*));
extern void ztrtri_ __P((const char*, const char*, const int*, doublecomplex*, const int*, int*, const int, const int));
extern void ztrtrs __P((const char, const char, const char, const int, const int, const doublecomplex*, const int, doublecomplex*, const int, int*));
extern void ztrtrs_ __P((const char*, const char*, const char*, const int*, const int*, const doublecomplex*, const int*, doublecomplex*, const int*, int*, const int, const int, const int));
extern void ztzrqf __P((const int, const int, doublecomplex*, const int, doublecomplex*, int*));
extern void ztzrqf_ __P((const int*, const int*, doublecomplex*, const int*, doublecomplex*, int*));
extern void ztzrzf __P((const int, const int, doublecomplex*, const int, doublecomplex*, int*));
extern void ztzrzf_ __P((const int*, const int*, doublecomplex*, const int*, doublecomplex*, doublecomplex*, const int*, int*));
extern void zung2l __P((const int, const int, const int, doublecomplex*, const int, const doublecomplex*, int*));
extern void zung2l_ __P((const int*, const int*, const int*, doublecomplex*, const int*, const doublecomplex*, doublecomplex*, int*));
extern void zung2r __P((const int, const int, const int, doublecomplex*, const int, const doublecomplex*, int*));
extern void zung2r_ __P((const int*, const int*, const int*, doublecomplex*, const int*, const doublecomplex*, doublecomplex*, int*));
extern void zungbr __P((const char, const int, const int, const int, doublecomplex*, const int, const doublecomplex*, int*));
extern void zungbr_ __P((const char*, const int*, const int*, const int*, doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, int*, const int));
extern void zunghr __P((const int, const int, const int, doublecomplex*, const int, const doublecomplex*, int*));
extern void zunghr_ __P((const int*, const int*, const int*, doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, int*));
extern void zungl2 __P((const int, const int, const int, doublecomplex*, const int, const doublecomplex*, int*));
extern void zungl2_ __P((const int*, const int*, const int*, doublecomplex*, const int*, const doublecomplex*, doublecomplex*, int*));
extern void zunglq __P((const int, const int, const int, doublecomplex*, const int, const doublecomplex*, int*));
extern void zunglq_ __P((const int*, const int*, const int*, doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, int*));
extern void zungql __P((const int, const int, const int, doublecomplex*, const int, const doublecomplex*, int*));
extern void zungql_ __P((const int*, const int*, const int*, doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, int*));
extern void zungqr __P((const int, const int, const int, doublecomplex*, const int, const doublecomplex*, int*));
extern void zungqr_ __P((const int*, const int*, const int*, doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, int*));
extern void zungr2 __P((const int, const int, const int, doublecomplex*, const int, const doublecomplex*, int*));
extern void zungr2_ __P((const int*, const int*, const int*, doublecomplex*, const int*, const doublecomplex*, doublecomplex*, int*));
extern void zungrq __P((const int, const int, const int, doublecomplex*, const int, const doublecomplex*, int*));
extern void zungrq_ __P((const int*, const int*, const int*, doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, int*));
extern void zungtr __P((const char, const int, doublecomplex*, const int, const doublecomplex*, int*));
extern void zungtr_ __P((const char*, const int*, doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, int*, const int));
extern void zunmbr __P((const char, const char, const char, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int, int*));
extern void zunmbr_ __P((const char*, const char*, const char*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int, const int, const int));
extern void zunmhr __P((const char, const char, const int, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int, int*));
extern void zunmhr_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int, const int));
extern void zunml2 __P((const char, const char, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int, int*));
extern void zunml2_ __P((const char*, const char*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, int*, const int, const int));
extern void zunmlq __P((const char, const char, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int, int*));
extern void zunmlq_ __P((const char*, const char*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int, const int));
extern void zunmql __P((const char, const char, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int, int*));
extern void zunmql_ __P((const char*, const char*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int, const int));
extern void zunmqr __P((const char, const char, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int, int*));
extern void zunmqr_ __P((const char*, const char*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int, const int));
extern void zunmr2 __P((const char, const char, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int, int*));
extern void zunmr2_ __P((const char*, const char*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, int*, const int, const int));
extern void zunmrq __P((const char, const char, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int, int*));
extern void zunmrq_ __P((const char*, const char*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int, const int));
extern void zunmrz __P((const char, const char, const int, const int, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int, int*));
extern void zunmrz_ __P((const char*, const char*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int, const int));
extern void zunmtr __P((const char, const char, const char, const int, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int, int*));
extern void zunmtr_ __P((const char*, const char*, const char*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*, int*, const int, const int, const int));
extern void zupgtr __P((const char, const int, const doublecomplex*, const doublecomplex*, doublecomplex*, const int, int*));
extern void zupgtr_ __P((const char*, const int*, const doublecomplex*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, int*, const int));
extern void zupmtr __P((const char, const char, const char, const int, const int, const doublecomplex*, const doublecomplex*, doublecomplex*, const int, int*));
extern void zupmtr_ __P((const char*, const char*, const char*, const int*, const int*, const doublecomplex*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, int*, const int, const int, const int));
extern void zvbrmm __P((const int, const int, const int, const int, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const int*, const int*, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zvbrmm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zvbrsm __P((const int, const int, const int, const int, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const int*, const int*, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zvbrsm_ __P((const int*, const int*, const int*, const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const int*, const int*, const int*, const int*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*, doublecomplex*, const int*));
extern void zvmul __P((const int, const doublecomplex*, const doublecomplex*, const int, const doublecomplex*, const int, const doublecomplex*, doublecomplex*, const int));
extern void zvmul_ __P((const int*, const doublecomplex*, const doublecomplex*, const int*, const doublecomplex*, const int*, const doublecomplex*, doublecomplex*, const int*));

#if defined (__sparcv9) || (defined (__x86_64) && defined(__amd64))

extern void available_threads_64 __P((long*, long*));
extern void available_threads_64_ __P((long*, long*));
extern void blas_dpermute_64_ __P((const long*, const long*, const long*, double*, const long*));
extern void blas_dsortv_64_ __P((const long*, const long*, double*, const long*, long*, const long*));
extern void blas_dsort_64_ __P((const long*, const long*, double*, const long*));
extern void blas_ipermute_64_ __P((const long*, const long*, const long*, long*, const long*));
extern void blas_isortv_64_ __P((const long*, const long*, long*, const long*, long*, const long*));
extern void blas_isort_64_ __P((const long*, const long*, long*, const long*));
extern void blas_spermute_64_ __P((const long*, const long*, const long*, float*, const long*));
extern void blas_ssortv_64_ __P((const long*, const long*, float*, const long*, long*, const long*));
extern void blas_ssort_64_ __P((const long*, const long*, float*, const long*));
extern void caxpyi_64 __P((const long, const floatcomplex*, const floatcomplex*, const long*, floatcomplex*));
extern void caxpyi_64_ __P((const long*, const floatcomplex*, const floatcomplex*, const long*, floatcomplex*));
extern void caxpy_64 __P((const long, const floatcomplex*, const floatcomplex*, const long, floatcomplex*, const long));
extern void caxpy_64_ __P((const long*, const floatcomplex*, const floatcomplex*, const long*, floatcomplex*, const long*));
extern void cbcomm_64 __P((const long, const long, const long, const long, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cbcomm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cbdimm_64 __P((const long, const long, const long, const long, const floatcomplex*, const long*, const floatcomplex*, const long, const long*, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cbdimm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cbdism_64 __P((const long, const long, const long, const long, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long, const long*, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cbdism_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cbdsqr_64 __P((const char, const long, const long, const long, const long, float*, float*, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cbdsqr_64_ __P((const char*, const long*, const long*, const long*, const long*, float*, float*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, const long));
extern void cbelmm_64 __P((const long, const long, const long, const long, const floatcomplex*, const long*, const floatcomplex*, const long*, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cbelmm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cbelsm_64 __P((const long, const long, const long, const long, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cbelsm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cbscmm_64 __P((const long, const long, const long, const long, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cbscmm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cbscsm_64 __P((const long, const long, const long, const long, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cbscsm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cbsrmm_64 __P((const long, const long, const long, const long, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cbsrmm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cbsrsm_64 __P((const long, const long, const long, const long, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cbsrsm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void ccnvcor2_64 __P((const char, const char, const char, const char, const char, const char, const long, const long, const floatcomplex*, const long, const long, const long, const long, const long, const floatcomplex*, const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long));
extern void ccnvcor2_64_ __P((const char*, const char*, const char*, const char*, const char*, const char*, const long*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, const long, const long, const long, const long, const long, const long));
extern void ccnvcor_64 __P((const char, const char, const long, const floatcomplex*, const long, const long, const long, const long, const long, const floatcomplex*, const long, const long, const long, const long, const long, floatcomplex*, const long, const long, const long, floatcomplex*, const long));
extern void ccnvcor_64_ __P((const char*, const char*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const long*, floatcomplex*, const long*, const long*, const long*, floatcomplex*, const long*, const long, const long));
extern void ccoomm_64 __P((const long, const long, const long, const long, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void ccoomm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void ccopy_64 __P((const long, const floatcomplex*, const long, floatcomplex*, const long));
extern void ccopy_64_ __P((const long*, const floatcomplex*, const long*, floatcomplex*, const long*));
extern void ccscmm_64 __P((const long, const long, const long, const long, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void ccscmm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void ccscsm_64 __P((const long, const long, const long, const long, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void ccscsm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void ccsrmm_64 __P((const long, const long, const long, const long, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void ccsrmm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void ccsrsm_64 __P((const long, const long, const long, const long, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void ccsrsm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cdiamm_64 __P((const long, const long, const long, const long, const floatcomplex*, const long*, const floatcomplex*, const long, const long*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cdiamm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cdiasm_64 __P((const long, const long, const long, const long, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long, const long*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cdiasm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern floatcomplex cdotci_64 __P((const long, const floatcomplex*, const long*, const floatcomplex*));
extern floatcomplex cdotc_64 __P((const long, const floatcomplex*, const long, const floatcomplex*, const long));
extern floatcomplex cdotui_64 __P((const long, const floatcomplex*, const long*, const floatcomplex*));
extern floatcomplex cdotu_64 __P((const long, const floatcomplex*, const long, const floatcomplex*, const long));
extern void cellmm_64 __P((const long, const long, const long, const long, const floatcomplex*, const long*, const floatcomplex*, const long*, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cellmm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cellsm_64 __P((const long, const long, const long, const long, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cellsm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cfft2b_64 __P((const long, const long, floatcomplex*, const long, const float*, const long));
extern void cfft2b_64_ __P((const long*, const long*, floatcomplex*, const long*, const float*, const long*));
extern void cfft2f_64 __P((const long, const long, floatcomplex*, const long, const float*, const long));
extern void cfft2f_64_ __P((const long*, const long*, floatcomplex*, const long*, const float*, const long*));
extern void cfft2i_64 __P((const long, const long, float*));
extern void cfft2i_64_ __P((const long*, const long*, float*));
extern void cfft3b_64 __P((const long, const long, const long, floatcomplex*, const long, const long, const float*, const long));
extern void cfft3b_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, const long*, const float*, const long*));
extern void cfft3f_64 __P((const long, const long, const long, floatcomplex*, const long, const long, const float*, const long));
extern void cfft3f_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, const long*, const float*, const long*));
extern void cfft3i_64 __P((const long, const long, const long, float*));
extern void cfft3i_64_ __P((const long*, const long*, const long*, float*));
extern void cfftb_64 __P((const long, floatcomplex*, float*));
extern void cfftb_64_ __P((const long*, floatcomplex*, float*));
extern void cfftc2_64_ __P((const long*, const long*, const long*, const float*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, float*, const long*, long*));
extern void cfftc3_64_ __P((const long*, const long*, const long*, const long*, const float*, const floatcomplex*, const long*, const long*, floatcomplex*, const long*, const long*, float*, long*, float*, const long*, long*));
extern void cfftcm_64_ __P((const long*, const long*, const long*, const float*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, float*, const long*, long*));
extern void cfftc_64_ __P((const long*, const long*, const float*, const floatcomplex*, floatcomplex*, float*, long*, float*, const long*, long*));
extern void cfftf_64 __P((const long, floatcomplex*, const float*));
extern void cfftf_64_ __P((const long*, floatcomplex*, const float*));
extern void cffti_64 __P((const long, float*));
extern void cffti_64_ __P((const long*, float*));
extern long cfftopt_64 __P((const long));
extern long cfftopt_64_ __P((const long*));
extern void cffts2_64_ __P((const long*, const long*, const long*, const float*, const floatcomplex*, const long*, float*, const long*, float*, long*, float*, const long*, long*));
extern void cffts3_64_ __P((const long*, const long*, const long*, const long*, const float*, const floatcomplex*, const long*, const long*, float*, const long*, const long*, float*, long*, float*, const long*, long*));
extern void cfftsm_64_ __P((const long*, const long*, const long*, const float*, const floatcomplex*, const long*, float*, const long*, float*, long*, float*, const long*, long*));
extern void cffts_64_ __P((const long*, const long*, const float*, const floatcomplex*, float*, float*, long*, float*, const long*, long*));
extern void cgbbrd_64 __P((const char, const long, const long, const long, const long, const long, floatcomplex*, const long, float*, float*, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cgbbrd_64_ __P((const char*, const long*, const long*, const long*, const long*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, float*, long*, const long));
extern void cgbcon_64 __P((const char, const long, const long, const long, const floatcomplex*, const long, const long*, const float, float*, long*));
extern void cgbcon_64_ __P((const char*, const long*, const long*, const long*, const floatcomplex*, const long*, const long*, const float*, float*, floatcomplex*, float*, long*, const long));
extern void cgbequ_64 __P((const long, const long, const long, const long, const floatcomplex*, const long, float*, float*, float*, float*, float*, long*));
extern void cgbequ_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, float*, float*, float*, float*, float*, long*));
extern void cgbmv_64 __P((const char, const long, const long, const long, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cgbmv_64_ __P((const char*, const long*, const long*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, const long));
extern void cgbrfs_64 __P((const char, const long, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, const long, const long*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, long*));
extern void cgbrfs_64_ __P((const char*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long));
extern void cgbsvx_64 __P((const char, const char, const long, const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, long*, char*, float*, float*, floatcomplex*, const long, floatcomplex*, const long, float*, float*, float*, long*));
extern void cgbsvx_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, char*, float*, float*, floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, float*, floatcomplex*, float*, long*, const long, const long, const long));
extern void cgbsv_64 __P((const long, const long, const long, const long, floatcomplex*, const long, long*, floatcomplex*, const long, long*));
extern void cgbsv_64_ __P((const long*, const long*, const long*, const long*, floatcomplex*, const long*, long*, floatcomplex*, const long*, long*));
extern void cgbtf2_64 __P((const long, const long, const long, const long, floatcomplex*, const long, long*, long*));
extern void cgbtf2_64_ __P((const long*, const long*, const long*, const long*, floatcomplex*, const long*, long*, long*));
extern void cgbtrf_64 __P((const long, const long, const long, const long, floatcomplex*, const long, long*, long*));
extern void cgbtrf_64_ __P((const long*, const long*, const long*, const long*, floatcomplex*, const long*, long*, long*));
extern void cgbtrs_64 __P((const char, const long, const long, const long, const long, const floatcomplex*, const long, const long*, floatcomplex*, const long, long*));
extern void cgbtrs_64_ __P((const char*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const long*, floatcomplex*, const long*, long*, const long));
extern void cgebak_64 __P((const char, const char, const long, const long, const long, const float*, const long, floatcomplex*, const long, long*));
extern void cgebak_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const long*, floatcomplex*, const long*, long*, const long, const long));
extern void cgebal_64 __P((const char, const long, floatcomplex*, const long, long*, long*, float*, long*));
extern void cgebal_64_ __P((const char*, const long*, floatcomplex*, const long*, long*, long*, float*, long*, const long));
extern void cgebrd_64 __P((const long, const long, floatcomplex*, const long, float*, float*, floatcomplex*, floatcomplex*, long*));
extern void cgebrd_64_ __P((const long*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, floatcomplex*, floatcomplex*, const long*, long*));
extern void cgecon_64 __P((const char, const long, const floatcomplex*, const long, const float, float*, long*));
extern void cgecon_64_ __P((const char*, const long*, const floatcomplex*, const long*, const float*, float*, floatcomplex*, float*, long*, const long));
extern void cgeequ_64 __P((const long, const long, const floatcomplex*, const long, float*, float*, float*, float*, float*, long*));
extern void cgeequ_64_ __P((const long*, const long*, const floatcomplex*, const long*, float*, float*, float*, float*, float*, long*));
extern void cgeesx_64 __P((const char, const char, const long(*select)(floatcomplex*), const char, const long, floatcomplex*, const long, long*, floatcomplex*, floatcomplex*, const long, float*, float*, long*));
extern void cgeesx_64_ __P((const char*, const char*, const long(*select)(floatcomplex*), const char*, const long*, floatcomplex*, const long*, long*, floatcomplex*, floatcomplex*, const long*, float*, float*, floatcomplex*, const long*, float*, long*, long*, const long, const long, const long));
extern void cgees_64 __P((const char, const char, const long(*select)(floatcomplex*), const long, floatcomplex*, const long, long*, floatcomplex*, floatcomplex*, const long, long*));
extern void cgees_64_ __P((const char*, const char*, const long(*select)(floatcomplex*), const long*, floatcomplex*, const long*, long*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, long*, const long, const long));
extern void cgeevx_64 __P((const char, const char, const char, const char, const long, floatcomplex*, const long, floatcomplex*, floatcomplex*, const long, floatcomplex*, const long, long*, long*, float*, float*, float*, float*, long*));
extern void cgeevx_64_ __P((const char*, const char*, const char*, const char*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, long*, long*, float*, float*, float*, float*, floatcomplex*, const long*, float*, long*, const long, const long, const long, const long));
extern void cgeev_64 __P((const char, const char, const long, floatcomplex*, const long, floatcomplex*, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cgeev_64_ __P((const char*, const char*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, const long, const long));
extern void cgegs_64 __P((const char, const char, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, floatcomplex*, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cgegs_64_ __P((const char*, const char*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, const long, const long));
extern void cgegv_64 __P((const char, const char, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, floatcomplex*, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cgegv_64_ __P((const char*, const char*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, const long, const long));
extern void cgehrd_64 __P((const long, const long, const long, floatcomplex*, const long, floatcomplex*, long*));
extern void cgehrd_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, long*));
extern void cgelqf_64 __P((const long, const long, floatcomplex*, const long, floatcomplex*, long*));
extern void cgelqf_64_ __P((const long*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, long*));
extern void cgelsd_64 __P((const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, float*, const float, long*, long*));
extern void cgelsd_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, const float*, long*, floatcomplex*, const long*, float*, long*, long*));
extern void cgelss_64 __P((const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, float*, const float, long*, long*));
extern void cgelss_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, const float*, long*, floatcomplex*, const long*, float*, long*));
extern void cgelsx_64 __P((const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, long*, const float, long*, long*));
extern void cgelsx_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const float*, long*, floatcomplex*, float*, long*));
extern void cgelsy_64 __P((const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, long*, const float, long*, long*));
extern void cgelsy_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const float*, long*, floatcomplex*, const long*, float*, long*));
extern void cgels_64 __P((const char, const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cgels_64_ __P((const char*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long));
extern void cgemm_64 __P((const char, const char, const long, const long, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cgemm_64_ __P((const char*, const char*, const long*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, const long, const long));
extern void cgemv_64 __P((const char, const long, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cgemv_64_ __P((const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, const long));
extern void cgeqlf_64 __P((const long, const long, floatcomplex*, const long, floatcomplex*, long*));
extern void cgeqlf_64_ __P((const long*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, long*));
extern void cgeqp3_64 __P((const long, const long, floatcomplex*, const long, long*, floatcomplex*, long*));
extern void cgeqp3_64_ __P((const long*, const long*, floatcomplex*, const long*, long*, floatcomplex*, floatcomplex*, const long*, float*, long*));
extern void cgeqpf_64 __P((const long, const long, floatcomplex*, const long, long*, floatcomplex*, long*));
extern void cgeqpf_64_ __P((const long*, const long*, floatcomplex*, const long*, long*, floatcomplex*, floatcomplex*, float*, long*));
extern void cgeqrf_64 __P((const long, const long, floatcomplex*, const long, floatcomplex*, long*));
extern void cgeqrf_64_ __P((const long*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, long*));
extern void cgerc_64 __P((const long, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, floatcomplex*, const long));
extern void cgerc_64_ __P((const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*));
extern void cgerfs_64 __P((const char, const long, const long, const floatcomplex*, const long, const floatcomplex*, const long, const long*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, long*));
extern void cgerfs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long));
extern void cgerqf_64 __P((const long, const long, floatcomplex*, const long, floatcomplex*, long*));
extern void cgerqf_64_ __P((const long*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, long*));
extern void cgeru_64 __P((const long, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, floatcomplex*, const long));
extern void cgeru_64_ __P((const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*));
extern void cgesdd_64 __P((const char, const long, const long, floatcomplex*, const long, float*, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cgesdd_64_ __P((const char*, const long*, const long*, floatcomplex*, const long*, float*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, long*, const long));
extern void cgesvd_64 __P((const char, const char, const long, const long, floatcomplex*, const long, float*, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cgesvd_64_ __P((const char*, const char*, const long*, const long*, floatcomplex*, const long*, float*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, const long, const long));
extern void cgesvx_64 __P((const char, const char, const long, const long, floatcomplex*, const long, floatcomplex*, const long, long*, char*, float*, float*, floatcomplex*, const long, floatcomplex*, const long, float*, float*, float*, long*));
extern void cgesvx_64_ __P((const char*, const char*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, char*, float*, float*, floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, float*, floatcomplex*, float*, long*, const long, const long, const long));
extern void cgesv_64 __P((const long, const long, floatcomplex*, const long, long*, floatcomplex*, const long, long*));
extern void cgesv_64_ __P((const long*, const long*, floatcomplex*, const long*, long*, floatcomplex*, const long*, long*));
extern void cgetf2_64 __P((const long, const long, floatcomplex*, const long, long*, long*));
extern void cgetf2_64_ __P((const long*, const long*, floatcomplex*, const long*, long*, long*));
extern void cgetrf_64 __P((const long, const long, floatcomplex*, const long, long*, long*));
extern void cgetrf_64_ __P((const long*, const long*, floatcomplex*, const long*, long*, long*));
extern void cgetri_64 __P((const long, floatcomplex*, const long, const long*, long*));
extern void cgetri_64_ __P((const long*, floatcomplex*, const long*, const long*, floatcomplex*, const long*, long*));
extern void cgetrs_64 __P((const char, const long, const long, const floatcomplex*, const long, const long*, floatcomplex*, const long, long*));
extern void cgetrs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const long*, const long*, floatcomplex*, const long*, long*, const long));
extern void cggbak_64 __P((const char, const char, const long, const long, const long, const float*, const float*, const long, floatcomplex*, const long, long*));
extern void cggbak_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const float*, const long*, floatcomplex*, const long*, long*, const long, const long));
extern void cggbal_64 __P((const char, const long, floatcomplex*, const long, floatcomplex*, const long, long*, long*, const float*, const float*, long*));
extern void cggbal_64_ __P((const char*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, long*, const float*, const float*, float*, long*, const long));
extern void cggesx_64 __P((const char, const char, const char, const long(*selctg)(floatcomplex*,floatcomplex*), const char, const long, floatcomplex*, const long, floatcomplex*, const long, long*, floatcomplex*, floatcomplex*, floatcomplex*, const long, floatcomplex*, const long, float*, float*, long*));
extern void cggesx_64_ __P((const char*, const char*, const char*, const long(*selctg)(floatcomplex*,floatcomplex*), const char*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, floatcomplex*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, const long*, float*, long*, const long*, long*, long*, const long, const long, const long, const long));
extern void cgges_64 __P((const char, const char, const char, const long(*selctg)(floatcomplex*,floatcomplex*), const long, floatcomplex*, const long, floatcomplex*, const long, long*, floatcomplex*, floatcomplex*, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cgges_64_ __P((const char*, const char*, const char*, const long(*selctg)(floatcomplex*,floatcomplex*), const long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, floatcomplex*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, long*, const long, const long, const long));
extern void cggevx_64 __P((const char, const char, const char, const char, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, floatcomplex*, floatcomplex*, const long, floatcomplex*, const long, long*, long*, float*, float*, float*, float*, float*, float*, long*));
extern void cggevx_64_ __P((const char*, const char*, const char*, const char*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, long*, long*, float*, float*, float*, float*, float*, float*, floatcomplex*, const long*, float*, long*, long*, long*, const long, const long, const long, const long));
extern void cggev_64 __P((const char, const char, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, floatcomplex*, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cggev_64_ __P((const char*, const char*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, const long, const long));
extern void cggglm_64 __P((const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, floatcomplex*, floatcomplex*, long*));
extern void cggglm_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, const long*, long*));
extern void cgghrd_64 __P((const char, const char, const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cgghrd_64_ __P((const char*, const char*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long, const long));
extern void cgglse_64 __P((const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, floatcomplex*, floatcomplex*, long*));
extern void cgglse_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, const long*, long*));
extern void cggqrf_64 __P((const long, const long, const long, floatcomplex*, const long, floatcomplex*, floatcomplex*, const long, floatcomplex*, long*));
extern void cggqrf_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, long*));
extern void cggrqf_64 __P((const long, const long, const long, floatcomplex*, const long, floatcomplex*, floatcomplex*, const long, floatcomplex*, long*));
extern void cggrqf_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, long*));
extern void cggsvd_64 __P((const char, const char, const char, const long, const long, const long, long*, long*, floatcomplex*, const long, floatcomplex*, const long, float*, float*, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, const long, long*, long*));
extern void cggsvd_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, long*, long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, float*, long*, long*, const long, const long, const long));
extern void cggsvp_64 __P((const char, const char, const char, const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, const float, const float, long*, long*, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cggsvp_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, const float*, const float*, long*, long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, float*, floatcomplex*, floatcomplex*, long*, const long, const long, const long));
extern void cgssco_64_ __P((float*, double*, long*));
extern void cgssda_64_ __P((double*, long*));
extern void cgssfa_64_ __P((const long*, const long*, const long*, const floatcomplex*, double*, long*));
extern void cgssfs_64_ __P((const char*, const char*, const long*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, const char*, const long*, const long*, double*, long*, const long, const long, const long));
extern void cgssin_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const long*, double*, long*, const long, const long));
extern void cgssor_64_ __P((const char*, double*, long*, const long));
extern void cgssps_64_ __P((double*, long*));
extern void cgssrp_64_ __P((long*, double*, long*));
extern void cgsssl_64_ __P((const long*, floatcomplex*, const long*, double*, long*));
extern void cgssuo_64_ __P((const long*, double*, long*));
extern void cgtcon_64 __P((const char, const long, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long*, const float, float*, long*));
extern void cgtcon_64_ __P((const char*, const long*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long*, const float*, float*, floatcomplex*, long*, const long));
extern void cgthrz_64 __P((const long, floatcomplex*, floatcomplex*, const long*));
extern void cgthrz_64_ __P((const long*, floatcomplex*, floatcomplex*, const long*));
extern void cgthr_64 __P((const long, const floatcomplex*, floatcomplex*, const long*));
extern void cgthr_64_ __P((const long*, const floatcomplex*, floatcomplex*, const long*));
extern void cgtrfs_64 __P((const char, const long, const long, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, long*));
extern void cgtrfs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long));
extern void cgtsvx_64 __P((const char, const char, const long, const long, const floatcomplex*, const floatcomplex*, const floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, long*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, float*, long*));
extern void cgtsvx_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, float*, floatcomplex*, float*, long*, const long, const long));
extern void cgtsv_64 __P((const long, const long, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, const long, long*));
extern void cgtsv_64_ __P((const long*, const long*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, const long*, long*));
extern void cgttrf_64 __P((const long, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, long*, long*));
extern void cgttrf_64_ __P((const long*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, long*, long*));
extern void cgttrs_64 __P((const char, const long, const long, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long*, floatcomplex*, const long, long*));
extern void cgttrs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long*, floatcomplex*, const long*, long*, const long));
extern void chbevd_64 __P((const char, const char, const long, const long, floatcomplex*, const long, float*, floatcomplex*, const long, long*));
extern void chbevd_64_ __P((const char*, const char*, const long*, const long*, floatcomplex*, const long*, float*, floatcomplex*, const long*, floatcomplex*, const long*, float*, const long*, long*, const long*, long*, const long, const long));
extern void chbevx_64 __P((const char, const char, const char, const long, const long, floatcomplex*, const long, floatcomplex*, const long, const float, const float, const long, const long, const float, long*, float*, floatcomplex*, const long, long*, long*));
extern void chbevx_64_ __P((const char*, const char*, const char*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, const float*, const float*, const long*, const long*, const float*, long*, float*, floatcomplex*, const long*, floatcomplex*, float*, long*, long*, long*, const long, const long, const long));
extern void chbev_64 __P((const char, const char, const long, const long, floatcomplex*, const long, float*, floatcomplex*, const long, long*));
extern void chbev_64_ __P((const char*, const char*, const long*, const long*, floatcomplex*, const long*, float*, floatcomplex*, const long*, floatcomplex*, float*, long*, const long, const long));
extern void chbgst_64 __P((const char, const char, const long, const long, const long, floatcomplex*, const long, const floatcomplex*, const long, floatcomplex*, const long, long*));
extern void chbgst_64_ __P((const char*, const char*, const long*, const long*, const long*, floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, float*, long*, const long, const long));
extern void chbgvd_64 __P((const char, const char, const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, float*, floatcomplex*, const long, long*));
extern void chbgvd_64_ __P((const char*, const char*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, floatcomplex*, const long*, floatcomplex*, const long*, float*, const long*, long*, const long*, long*, const long, const long));
extern void chbgvx_64 __P((const char, const char, const char, const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, const long, const float, const float, const long, const long, const float, long*, float*, floatcomplex*, const long, long*, long*));
extern void chbgvx_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, const float*, const float*, const long*, const long*, const float*, long*, float*, floatcomplex*, const long*, floatcomplex*, float*, long*, long*, long*, const long, const long, const long));
extern void chbgv_64 __P((const char, const char, const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, float*, floatcomplex*, const long, long*));
extern void chbgv_64_ __P((const char*, const char*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, floatcomplex*, const long*, floatcomplex*, float*, long*, const long, const long));
extern void chbmv_64 __P((const char, const long, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void chbmv_64_ __P((const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, const long));
extern void chbtrd_64 __P((const char, const char, const long, const long, floatcomplex*, const long, float*, float*, floatcomplex*, const long, long*));
extern void chbtrd_64_ __P((const char*, const char*, const long*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, const long*, floatcomplex*, long*, const long, const long));
extern void checon_64 __P((const char, const long, const floatcomplex*, const long, const long*, const float, float*, long*));
extern void checon_64_ __P((const char*, const long*, const floatcomplex*, const long*, const long*, const float*, float*, floatcomplex*, long*, const long));
extern void cheevd_64 __P((const char, const char, const long, floatcomplex*, const long, float*, long*));
extern void cheevd_64_ __P((const char*, const char*, const long*, floatcomplex*, const long*, float*, floatcomplex*, const long*, float*, const long*, long*, const long*, long*, const long, const long));
extern void cheevr_64 __P((const char, const char, const char, const long, floatcomplex*, const long, const float, const float, const long, const long, const float, long*, float*, floatcomplex*, const long, long*, long*));
extern void cheevr_64_ __P((const char*, const char*, const char*, const long*, floatcomplex*, const long*, const float*, const float*, const long*, const long*, const float*, long*, float*, floatcomplex*, const long*, long*, floatcomplex*, const long*, float*, const long*, long*, const long*, long*, const long, const long, const long));
extern void cheevx_64 __P((const char, const char, const char, const long, floatcomplex*, const long, const float, const float, const long, const long, const float, long*, float*, floatcomplex*, const long, long*, long*));
extern void cheevx_64_ __P((const char*, const char*, const char*, const long*, floatcomplex*, const long*, const float*, const float*, const long*, const long*, const float*, long*, float*, floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, long*, long*, const long, const long, const long));
extern void cheev_64 __P((const char, const char, const long, floatcomplex*, const long, float*, long*));
extern void cheev_64_ __P((const char*, const char*, const long*, floatcomplex*, const long*, float*, floatcomplex*, const long*, float*, long*, const long, const long));
extern void chegs2_64 __P((const long, const char, const long, floatcomplex*, const long, const floatcomplex*, const long, long*));
extern void chegs2_64_ __P((const long*, const char*, const long*, floatcomplex*, const long*, const floatcomplex*, const long*, long*, const long));
extern void chegst_64 __P((const long, const char, const long, floatcomplex*, const long, const floatcomplex*, const long, long*));
extern void chegst_64_ __P((const long*, const char*, const long*, floatcomplex*, const long*, const floatcomplex*, const long*, long*, const long));
extern void chegvd_64 __P((const long, const char, const char, const long, floatcomplex*, const long, floatcomplex*, const long, float*, long*));
extern void chegvd_64_ __P((const long*, const char*, const char*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, floatcomplex*, const long*, float*, const long*, long*, const long*, long*, const long, const long));
extern void chegvx_64 __P((const long, const char, const char, const char, const long, floatcomplex*, const long, floatcomplex*, const long, const float, const float, const long, const long, const float, long*, float*, floatcomplex*, const long, long*, long*));
extern void chegvx_64_ __P((const long*, const char*, const char*, const char*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, const float*, const float*, const long*, const long*, const float*, long*, float*, floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, long*, long*, const long, const long, const long));
extern void chegv_64 __P((const long, const char, const char, const long, floatcomplex*, const long, floatcomplex*, const long, float*, long*));
extern void chegv_64_ __P((const long*, const char*, const char*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, floatcomplex*, const long*, float*, long*, const long, const long));
extern void chemm_64 __P((const char, const char, const long, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void chemm_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, const long, const long));
extern void chemv_64 __P((const char, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void chemv_64_ __P((const char*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, const long));
extern void cher2k_64 __P((const char, const char, const long, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, const float, floatcomplex*, const long));
extern void cher2k_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const float*, floatcomplex*, const long*, const long, const long));
extern void cher2_64 __P((const char, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, floatcomplex*, const long));
extern void cher2_64_ __P((const char*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, const long));
extern void cherfs_64 __P((const char, const long, const long, const floatcomplex*, const long, const floatcomplex*, const long, const long*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, long*));
extern void cherfs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long));
extern void cherk_64 __P((const char, const char, const long, const long, const float, const floatcomplex*, const long, const float, floatcomplex*, const long));
extern void cherk_64_ __P((const char*, const char*, const long*, const long*, const float*, const floatcomplex*, const long*, const float*, floatcomplex*, const long*, const long, const long));
extern void cher_64 __P((const char, const long, const float, const floatcomplex*, const long, floatcomplex*, const long));
extern void cher_64_ __P((const char*, const long*, const float*, const floatcomplex*, const long*, floatcomplex*, const long*, const long));
extern void chesvx_64 __P((const char, const char, const long, const long, const floatcomplex*, const long, floatcomplex*, const long, long*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, float*, long*));
extern void chesvx_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, float*, floatcomplex*, const long*, float*, long*, const long, const long));
extern void chesv_64 __P((const char, const long, const long, floatcomplex*, const long, long*, floatcomplex*, const long, long*));
extern void chesv_64_ __P((const char*, const long*, const long*, floatcomplex*, const long*, long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long));
extern void chetf2_64 __P((const char, const long, floatcomplex*, const long, long*, long*));
extern void chetf2_64_ __P((const char*, const long*, floatcomplex*, const long*, long*, long*, const long));
extern void chetrd_64 __P((const char, const long, floatcomplex*, const long, float*, float*, floatcomplex*, long*));
extern void chetrd_64_ __P((const char*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, floatcomplex*, const long*, long*, const long));
extern void chetrf_64 __P((const char, const long, floatcomplex*, const long, long*, long*));
extern void chetrf_64_ __P((const char*, const long*, floatcomplex*, const long*, long*, floatcomplex*, const long*, long*, const long));
extern void chetri_64 __P((const char, const long, floatcomplex*, const long, const long*, long*));
extern void chetri_64_ __P((const char*, const long*, floatcomplex*, const long*, const long*, floatcomplex*, long*, const long));
extern void chetrs_64 __P((const char, const long, const long, const floatcomplex*, const long, const long*, floatcomplex*, const long, long*));
extern void chetrs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const long*, const long*, floatcomplex*, const long*, long*, const long));
extern void chgeqz_64 __P((const char, const char, const char, const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, floatcomplex*, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void chgeqz_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, const long, const long, const long));
extern void chpcon_64 __P((const char, const long, const floatcomplex*, const long*, const float, float*, long*));
extern void chpcon_64_ __P((const char*, const long*, const floatcomplex*, const long*, const float*, float*, floatcomplex*, long*, const long));
extern void chpevd_64 __P((const char, const char, const long, floatcomplex*, float*, floatcomplex*, const long, long*));
extern void chpevd_64_ __P((const char*, const char*, const long*, floatcomplex*, float*, floatcomplex*, const long*, floatcomplex*, const long*, float*, const long*, long*, const long*, long*, const long, const long));
extern void chpevx_64 __P((const char, const char, const char, const long, floatcomplex*, const float, const float, const long, const long, const float, long*, float*, floatcomplex*, const long, long*, long*));
extern void chpevx_64_ __P((const char*, const char*, const char*, const long*, floatcomplex*, const float*, const float*, const long*, const long*, const float*, long*, float*, floatcomplex*, const long*, floatcomplex*, float*, long*, long*, long*, const long, const long, const long));
extern void chpev_64 __P((const char, const char, const long, floatcomplex*, float*, floatcomplex*, const long, long*));
extern void chpev_64_ __P((const char*, const char*, const long*, floatcomplex*, float*, floatcomplex*, const long*, floatcomplex*, float*, long*, const long, const long));
extern void chpgst_64 __P((const long, const char, const long, floatcomplex*, const floatcomplex*, long*));
extern void chpgst_64_ __P((const long*, const char*, const long*, floatcomplex*, const floatcomplex*, long*, const long));
extern void chpgvd_64 __P((const long, const char, const char, const long, floatcomplex*, floatcomplex*, float*, floatcomplex*, const long, long*));
extern void chpgvd_64_ __P((const long*, const char*, const char*, const long*, floatcomplex*, floatcomplex*, float*, floatcomplex*, const long*, floatcomplex*, const long*, float*, const long*, long*, const long*, long*, const long, const long));
extern void chpgvx_64 __P((const long, const char, const char, const char, const long, floatcomplex*, floatcomplex*, const float, const float, const long, const long, const float, long*, float*, floatcomplex*, const long, long*, long*));
extern void chpgvx_64_ __P((const long*, const char*, const char*, const char*, const long*, floatcomplex*, floatcomplex*, const float*, const float*, const long*, const long*, const float*, long*, float*, floatcomplex*, const long*, floatcomplex*, float*, long*, long*, long*, const long, const long, const long));
extern void chpgv_64 __P((const long, const char, const char, const long, floatcomplex*, floatcomplex*, float*, floatcomplex*, const long, long*));
extern void chpgv_64_ __P((const long*, const char*, const char*, const long*, floatcomplex*, floatcomplex*, float*, floatcomplex*, const long*, floatcomplex*, float*, long*, const long, const long));
extern void chpmv_64 __P((const char, const long, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void chpmv_64_ __P((const char*, const long*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, const long));
extern void chpr2_64 __P((const char, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, floatcomplex*));
extern void chpr2_64_ __P((const char*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long));
extern void chprfs_64 __P((const char, const long, const long, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, long*));
extern void chprfs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long));
extern void chpr_64 __P((const char, const long, const float, const floatcomplex*, const long, floatcomplex*));
extern void chpr_64_ __P((const char*, const long*, const float*, const floatcomplex*, const long*, floatcomplex*, const long));
extern void chpsvx_64 __P((const char, const char, const long, const long, const floatcomplex*, floatcomplex*, long*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, float*, long*));
extern void chpsvx_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, floatcomplex*, long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, float*, floatcomplex*, float*, long*, const long, const long));
extern void chpsv_64 __P((const char, const long, const long, floatcomplex*, long*, floatcomplex*, const long, long*));
extern void chpsv_64_ __P((const char*, const long*, const long*, floatcomplex*, long*, floatcomplex*, const long*, long*, const long));
extern void chptrd_64 __P((const char, const long, floatcomplex*, float*, float*, floatcomplex*, long*));
extern void chptrd_64_ __P((const char*, const long*, floatcomplex*, float*, float*, floatcomplex*, long*, const long));
extern void chptrf_64 __P((const char, const long, floatcomplex*, long*, long*));
extern void chptrf_64_ __P((const char*, const long*, floatcomplex*, long*, long*, const long));
extern void chptri_64 __P((const char, const long, floatcomplex*, const long*, long*));
extern void chptri_64_ __P((const char*, const long*, floatcomplex*, const long*, floatcomplex*, long*, const long));
extern void chptrs_64 __P((const char, const long, const long, const floatcomplex*, const long*, floatcomplex*, const long, long*));
extern void chptrs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, long*, const long));
extern void chsein_64 __P((const char, const char, const char, const long*, const long, const floatcomplex*, const long, floatcomplex*, floatcomplex*, const long, floatcomplex*, const long, const long, long*, long*, long*, long*));
extern void chsein_64_ __P((const char*, const char*, const char*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, const long*, long*, floatcomplex*, float*, long*, long*, long*, const long, const long, const long));
extern void chseqr_64 __P((const char, const char, const long, const long, const long, floatcomplex*, const long, floatcomplex*, floatcomplex*, const long, long*));
extern void chseqr_64_ __P((const char*, const char*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long, const long));
extern void cjadmm_64 __P((const long, const long, const long, const long, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long, const long*, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cjadmm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cjadrp_64 __P((const long, const long, const long, const floatcomplex*, const long*, long*, const long, const long*));
extern void cjadrp_64_ __P((const long*, const long*, const long*, const floatcomplex*, const long*, long*, const long*, const long*, long*, const long*));
extern void cjadsm_64 __P((const long, const long, const long, const long, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long, const long*, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cjadsm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern floatcomplex cladiv_64 __P((const floatcomplex*, const floatcomplex*));
extern void clarzb_64 __P((const char, const char, const char, const char, const long, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, const long, floatcomplex*, const long, const long));
extern void clarzb_64_ __P((const char*, const char*, const char*, const char*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, const long, const long, const long, const long));
extern void clarzt_64 __P((const char, const char, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void clarzt_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, const long, const long));
extern void clarz_64 __P((const char, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void clarz_64_ __P((const char*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long));
extern void clatzm_64 __P((const char, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, floatcomplex*, const long));
extern void clatzm_64_ __P((const char*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long));
extern void cosqb_64 __P((const long, float*, const float*));
extern void cosqb_64_ __P((const long*, float*, const float*));
extern void cosqf_64 __P((const long, float*, const float*));
extern void cosqf_64_ __P((const long*, float*, const float*));
extern void cosqi_64 __P((const long, float*));
extern void cosqi_64_ __P((const long*, float*));
extern void costi_64 __P((const long, float*));
extern void costi_64_ __P((const long*, float*));
extern void cost_64 __P((const long, float*, const float*));
extern void cost_64_ __P((const long*, float*, const float*));
extern void cpbcon_64 __P((const char, const long, const long, const floatcomplex*, const long, const float, float*, long*));
extern void cpbcon_64_ __P((const char*, const long*, const long*, const floatcomplex*, const long*, const float*, float*, floatcomplex*, float*, long*, const long));
extern void cpbequ_64 __P((const char, const long, const long, const floatcomplex*, const long, float*, float*, float*, long*));
extern void cpbequ_64_ __P((const char*, const long*, const long*, const floatcomplex*, const long*, float*, float*, float*, long*, const long));
extern void cpbrfs_64 __P((const char, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, long*));
extern void cpbrfs_64_ __P((const char*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long));
extern void cpbstf_64 __P((const char, const long, const long, floatcomplex*, const long, long*));
extern void cpbstf_64_ __P((const char*, const long*, const long*, floatcomplex*, const long*, long*, const long));
extern void cpbsvx_64 __P((const char, const char, const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, char*, float*, floatcomplex*, const long, floatcomplex*, const long, float*, float*, float*, long*));
extern void cpbsvx_64_ __P((const char*, const char*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, char*, float*, floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, float*, floatcomplex*, float*, long*, const long, const long, const long));
extern void cpbsv_64 __P((const char, const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cpbsv_64_ __P((const char*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long));
extern void cpbtf2_64 __P((const char, const long, const long, floatcomplex*, const long, long*));
extern void cpbtf2_64_ __P((const char*, const long*, const long*, floatcomplex*, const long*, long*, const long));
extern void cpbtrf_64 __P((const char, const long, const long, floatcomplex*, const long, long*));
extern void cpbtrf_64_ __P((const char*, const long*, const long*, floatcomplex*, const long*, long*, const long));
extern void cpbtrs_64 __P((const char, const long, const long, const long, const floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cpbtrs_64_ __P((const char*, const long*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, long*, const long));
extern void cpocon_64 __P((const char, const long, const floatcomplex*, const long, const float, float*, long*));
extern void cpocon_64_ __P((const char*, const long*, const floatcomplex*, const long*, const float*, float*, floatcomplex*, float*, long*, const long));
extern void cpoequ_64 __P((const long, const floatcomplex*, const long, float*, float*, float*, long*));
extern void cpoequ_64_ __P((const long*, const floatcomplex*, const long*, float*, float*, float*, long*));
extern void cporfs_64 __P((const char, const long, const long, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, long*));
extern void cporfs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long));
extern void cposvx_64 __P((const char, const char, const long, const long, floatcomplex*, const long, floatcomplex*, const long, char*, float*, floatcomplex*, const long, floatcomplex*, const long, float*, float*, float*, long*));
extern void cposvx_64_ __P((const char*, const char*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, char*, float*, floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, float*, floatcomplex*, float*, long*, const long, const long, const long));
extern void cposv_64 __P((const char, const long, const long, floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cposv_64_ __P((const char*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long));
extern void cpotf2_64 __P((const char, const long, floatcomplex*, const long, long*));
extern void cpotf2_64_ __P((const char*, const long*, floatcomplex*, const long*, long*, const long));
extern void cpotrf_64 __P((const char, const long, floatcomplex*, const long, long*));
extern void cpotrf_64_ __P((const char*, const long*, floatcomplex*, const long*, long*, const long));
extern void cpotri_64 __P((const char, const long, floatcomplex*, const long, long*));
extern void cpotri_64_ __P((const char*, const long*, floatcomplex*, const long*, long*, const long));
extern void cpotrs_64 __P((const char, const long, const long, const floatcomplex*, const long, floatcomplex*, const long, long*));
extern void cpotrs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, long*, const long));
extern void cppcon_64 __P((const char, const long, const floatcomplex*, const float, float*, long*));
extern void cppcon_64_ __P((const char*, const long*, const floatcomplex*, const float*, float*, floatcomplex*, float*, long*, const long));
extern void cppequ_64 __P((const char, const long, const floatcomplex*, float*, float*, float*, long*));
extern void cppequ_64_ __P((const char*, const long*, const floatcomplex*, float*, float*, float*, long*, const long));
extern void cpprfs_64 __P((const char, const long, const long, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, long*));
extern void cpprfs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long));
extern void cppsvx_64 __P((const char, const char, const long, const long, floatcomplex*, floatcomplex*, char*, float*, floatcomplex*, const long, floatcomplex*, const long, float*, float*, float*, long*));
extern void cppsvx_64_ __P((const char*, const char*, const long*, const long*, floatcomplex*, floatcomplex*, char*, float*, floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, float*, floatcomplex*, float*, long*, const long, const long, const long));
extern void cppsv_64 __P((const char, const long, const long, floatcomplex*, floatcomplex*, const long, long*));
extern void cppsv_64_ __P((const char*, const long*, const long*, floatcomplex*, floatcomplex*, const long*, long*, const long));
extern void cpptrf_64 __P((const char, const long, floatcomplex*, long*));
extern void cpptrf_64_ __P((const char*, const long*, floatcomplex*, long*, const long));
extern void cpptri_64 __P((const char, const long, floatcomplex*, long*));
extern void cpptri_64_ __P((const char*, const long*, floatcomplex*, long*, const long));
extern void cpptrs_64 __P((const char, const long, const long, const floatcomplex*, floatcomplex*, const long, long*));
extern void cpptrs_64_ __P((const char*, const long*, const long*, const floatcomplex*, floatcomplex*, const long*, long*, const long));
extern void cptcon_64 __P((const long, const float*, const floatcomplex*, const float, float*, long*));
extern void cptcon_64_ __P((const long*, const float*, const floatcomplex*, const float*, float*, float*, long*));
extern void cpteqr_64 __P((const char, const long, float*, float*, floatcomplex*, const long, long*));
extern void cpteqr_64_ __P((const char*, const long*, float*, float*, floatcomplex*, const long*, float*, long*, const long));
extern void cptrfs_64 __P((const char, const long, const long, const float*, const floatcomplex*, const float*, const floatcomplex*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, long*));
extern void cptrfs_64_ __P((const char*, const long*, const long*, const float*, const floatcomplex*, const float*, const floatcomplex*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long));
extern void cptsvx_64 __P((const char, const long, const long, const float*, const floatcomplex*, float*, floatcomplex*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, float*, long*));
extern void cptsvx_64_ __P((const char*, const long*, const long*, const float*, const floatcomplex*, float*, floatcomplex*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, float*, floatcomplex*, float*, long*, const long));
extern void cptsv_64 __P((const long, const long, float*, floatcomplex*, floatcomplex*, const long, long*));
extern void cptsv_64_ __P((const long*, const long*, float*, floatcomplex*, floatcomplex*, const long*, long*));
extern void cpttrf_64 __P((const long, float*, floatcomplex*, long*));
extern void cpttrf_64_ __P((const long*, float*, floatcomplex*, long*));
extern void cpttrs_64 __P((const char, const long, const long, const float*, floatcomplex*, floatcomplex*, const long, long*));
extern void cpttrs_64_ __P((const char*, const long*, const long*, const float*, floatcomplex*, floatcomplex*, const long*, long*, const long));
extern void cptts2_64 __P((const long, const long, const long, const float*, const floatcomplex*, floatcomplex*, const long));
extern void cptts2_64_ __P((const long*, const long*, const long*, const float*, const floatcomplex*, floatcomplex*, const long*));
extern void crotg_64 __P((floatcomplex*, const floatcomplex*, float*, floatcomplex*));
extern void crotg_64_ __P((floatcomplex*, const floatcomplex*, float*, floatcomplex*));
extern void crot_64 __P((const long, floatcomplex*, const long, floatcomplex*, const long, const float, const floatcomplex*));
extern void crot_64_ __P((const long*, floatcomplex*, const long*, floatcomplex*, const long*, const float*, const floatcomplex*));
extern void cscal_64 __P((const long, const floatcomplex*, floatcomplex*, const long));
extern void cscal_64_ __P((const long*, const floatcomplex*, floatcomplex*, const long*));
extern void csctr_64 __P((const long, const floatcomplex*, const long*, floatcomplex*));
extern void csctr_64_ __P((const long*, const floatcomplex*, const long*, floatcomplex*));
extern void cskymm_64 __P((const long, const long, const long, const long, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cskymm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cskysm_64 __P((const long, const long, const long, const long, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cskysm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cspcon_64 __P((const char, const long, const floatcomplex*, const long*, const float, float*, long*));
extern void cspcon_64_ __P((const char*, const long*, const floatcomplex*, const long*, const float*, float*, floatcomplex*, long*, const long));
extern void cspmv_64 __P((const char, const long, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cspmv_64_ __P((const char*, const long*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, const long));
extern void csprfs_64 __P((const char, const long, const long, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, long*));
extern void csprfs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long));
extern void cspsvx_64 __P((const char, const char, const long, const long, const floatcomplex*, floatcomplex*, long*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, float*, long*));
extern void cspsvx_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, floatcomplex*, long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, float*, floatcomplex*, float*, long*, const long, const long));
extern void cspsv_64 __P((const char, const long, const long, floatcomplex*, long*, floatcomplex*, const long, long*));
extern void cspsv_64_ __P((const char*, const long*, const long*, floatcomplex*, long*, floatcomplex*, const long*, long*, const long));
extern void csptrf_64 __P((const char, const long, floatcomplex*, long*, long*));
extern void csptrf_64_ __P((const char*, const long*, floatcomplex*, long*, long*, const long));
extern void csptri_64 __P((const char, const long, floatcomplex*, const long*, long*));
extern void csptri_64_ __P((const char*, const long*, floatcomplex*, const long*, floatcomplex*, long*, const long));
extern void csptrs_64 __P((const char, const long, const long, const floatcomplex*, const long*, floatcomplex*, const long, long*));
extern void csptrs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, long*, const long));
extern void csrot_64 __P((const long, floatcomplex*, const long, floatcomplex*, const long, const float, const float));
extern void csrot_64_ __P((const long*, floatcomplex*, const long*, floatcomplex*, const long*, const float*, const float*));
extern void csscal_64 __P((const long, const float, floatcomplex*, const long));
extern void csscal_64_ __P((const long*, const float*, floatcomplex*, const long*));
extern void cstedc_64 __P((const char, const long, float*, float*, floatcomplex*, const long, long*));
extern void cstedc_64_ __P((const char*, const long*, float*, float*, floatcomplex*, const long*, floatcomplex*, const long*, float*, const long*, long*, const long*, long*, const long));
extern void cstegr_64 __P((const char, const char, const long, float*, float*, const float, const float, const long, const long, const float, long*, float*, floatcomplex*, const long, long*, long*));
extern void cstegr_64_ __P((const char*, const char*, const long*, float*, float*, const float*, const float*, const long*, const long*, const float*, long*, float*, floatcomplex*, const long*, long*, float*, const long*, long*, const long*, long*, const long, const long));
extern void cstein_64 __P((const long, const float*, const float*, const long, const float*, const long*, const long*, floatcomplex*, const long, long*, long*));
extern void cstein_64_ __P((const long*, const float*, const float*, const long*, const float*, const long*, const long*, floatcomplex*, const long*, float*, long*, long*, long*));
extern void csteqr_64 __P((const char, const long, float*, float*, floatcomplex*, const long, long*));
extern void csteqr_64_ __P((const char*, const long*, float*, float*, floatcomplex*, const long*, float*, long*, const long));
extern void cstsv_64 __P((const long, const long, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, const long, long*, long*));
extern void cstsv_64_ __P((const long*, const long*, floatcomplex*, floatcomplex*, floatcomplex*, floatcomplex*, const long*, long*, long*));
extern void csttrf_64 __P((const long, floatcomplex*, floatcomplex*, floatcomplex*, long*, long*));
extern void csttrf_64_ __P((const long*, floatcomplex*, floatcomplex*, floatcomplex*, long*, long*));
extern void csttrs_64 __P((const long, const long, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long, long*, long*));
extern void csttrs_64_ __P((const long*, const long*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const floatcomplex*, const long*, long*, long*));
extern void cswap_64 __P((const long, floatcomplex*, const long, floatcomplex*, const long));
extern void cswap_64_ __P((const long*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void csycon_64 __P((const char, const long, const floatcomplex*, const long, const long*, const float, float*, long*));
extern void csycon_64_ __P((const char*, const long*, const floatcomplex*, const long*, const long*, const float*, float*, floatcomplex*, long*, const long));
extern void csymm_64 __P((const char, const char, const long, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void csymm_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, const long, const long));
extern void csyr2k_64 __P((const char, const char, const long, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void csyr2k_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, const long, const long));
extern void csyrfs_64 __P((const char, const long, const long, const floatcomplex*, const long, const floatcomplex*, const long, const long*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, long*));
extern void csyrfs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long));
extern void csyrk_64 __P((const char, const char, const long, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void csyrk_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, const long, const long));
extern void csysvx_64 __P((const char, const char, const long, const long, const floatcomplex*, const long, floatcomplex*, const long, long*, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, float*, long*));
extern void csysvx_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, float*, floatcomplex*, const long*, float*, long*, const long, const long));
extern void csysv_64 __P((const char, const long, const long, floatcomplex*, const long, long*, floatcomplex*, const long, long*));
extern void csysv_64_ __P((const char*, const long*, const long*, floatcomplex*, const long*, long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long));
extern void csytf2_64 __P((const char, const long, floatcomplex*, const long, long*, long*));
extern void csytf2_64_ __P((const char*, const long*, floatcomplex*, const long*, long*, long*, const long));
extern void csytrf_64 __P((const char, const long, floatcomplex*, const long, long*, long*));
extern void csytrf_64_ __P((const char*, const long*, floatcomplex*, const long*, long*, floatcomplex*, const long*, long*, const long));
extern void csytri_64 __P((const char, const long, floatcomplex*, const long, const long*, long*));
extern void csytri_64_ __P((const char*, const long*, floatcomplex*, const long*, const long*, floatcomplex*, long*, const long));
extern void csytrs_64 __P((const char, const long, const long, const floatcomplex*, const long, const long*, floatcomplex*, const long, long*));
extern void csytrs_64_ __P((const char*, const long*, const long*, const floatcomplex*, const long*, const long*, floatcomplex*, const long*, long*, const long));
extern void ctbcon_64 __P((const char, const char, const char, const long, const long, const floatcomplex*, const long, float*, long*));
extern void ctbcon_64_ __P((const char*, const char*, const char*, const long*, const long*, const floatcomplex*, const long*, float*, floatcomplex*, float*, long*, const long, const long, const long));
extern void ctbmv_64 __P((const char, const char, const char, const long, const long, const floatcomplex*, const long, floatcomplex*, const long));
extern void ctbmv_64_ __P((const char*, const char*, const char*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, const long, const long, const long));
extern void ctbrfs_64 __P((const char, const char, const char, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, const long, float*, float*, long*));
extern void ctbrfs_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long, const long, const long));
extern void ctbsv_64 __P((const char, const char, const char, const long, const long, const floatcomplex*, const long, floatcomplex*, const long));
extern void ctbsv_64_ __P((const char*, const char*, const char*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, const long, const long, const long));
extern void ctbtrs_64 __P((const char, const char, const char, const long, const long, const long, const floatcomplex*, const long, floatcomplex*, const long, long*));
extern void ctbtrs_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, long*, const long, const long, const long));
extern void ctgevc_64 __P((const char, const char, const long*, const long, const floatcomplex*, const long, const floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, const long, const long, long*, long*));
extern void ctgevc_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, const long*, long*, floatcomplex*, float*, long*, const long, const long));
extern void ctgexc_64 __P((const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, const long, long*, long*, long*));
extern void ctgexc_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, long*, long*, long*));
extern void ctgsen_64 __P((const long, const long, const long, const long*, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, floatcomplex*, floatcomplex*, const long, floatcomplex*, const long, long*, float*, float*, float*, long*));
extern void ctgsen_64_ __P((const long*, const long*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, long*, float*, float*, float*, floatcomplex*, const long*, long*, const long*, long*));
extern void ctgsja_64 __P((const char, const char, const char, const long, const long, const long, const long, const long, floatcomplex*, const long, floatcomplex*, const long, const float, const float, float*, float*, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, const long, long*, long*));
extern void ctgsja_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, const float*, const float*, float*, float*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, long*, long*, const long, const long, const long));
extern void ctgsna_64 __P((const char, const char, const long*, const long, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, const long, float*, float*, const long, long*, long*));
extern void ctgsna_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, float*, float*, const long*, long*, floatcomplex*, const long*, long*, long*, const long, const long));
extern void ctgsyl_64 __P((const char, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, const long, floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, const long, floatcomplex*, const long, float*, float*, long*));
extern void ctgsyl_64_ __P((const char*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, float*, floatcomplex*, const long*, long*, long*, const long));
extern void ctpcon_64 __P((const char, const char, const char, const long, const floatcomplex*, float*, long*));
extern void ctpcon_64_ __P((const char*, const char*, const char*, const long*, const floatcomplex*, float*, floatcomplex*, float*, long*, const long, const long, const long));
extern void ctpmv_64 __P((const char, const char, const char, const long, const floatcomplex*, floatcomplex*, const long));
extern void ctpmv_64_ __P((const char*, const char*, const char*, const long*, const floatcomplex*, floatcomplex*, const long*, const long, const long, const long));
extern void ctprfs_64 __P((const char, const char, const char, const long, const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, float*, float*, long*));
extern void ctprfs_64_ __P((const char*, const char*, const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long, const long, const long));
extern void ctpsv_64 __P((const char, const char, const char, const long, const floatcomplex*, floatcomplex*, const long));
extern void ctpsv_64_ __P((const char*, const char*, const char*, const long*, const floatcomplex*, floatcomplex*, const long*, const long, const long, const long));
extern void ctptri_64 __P((const char, const char, const long, floatcomplex*, long*));
extern void ctptri_64_ __P((const char*, const char*, const long*, floatcomplex*, long*, const long, const long));
extern void ctptrs_64 __P((const char, const char, const char, const long, const long, const floatcomplex*, floatcomplex*, const long, long*));
extern void ctptrs_64_ __P((const char*, const char*, const char*, const long*, const long*, const floatcomplex*, floatcomplex*, const long*, long*, const long, const long, const long));
extern void ctrans_64 __P((const char, const floatcomplex*, floatcomplex*, const long, const long, floatcomplex*));
extern void ctrans_64_ __P((const char*, const floatcomplex*, floatcomplex*, const long*, const long*, floatcomplex*, const long));
extern void ctrcon_64 __P((const char, const char, const char, const long, const floatcomplex*, const long, float*, long*));
extern void ctrcon_64_ __P((const char*, const char*, const char*, const long*, const floatcomplex*, const long*, float*, floatcomplex*, float*, long*, const long, const long, const long));
extern void ctrevc_64 __P((const char, const char, long*, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, const long, const long, long*, long*));
extern void ctrevc_64_ __P((const char*, const char*, long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, const long*, long*, floatcomplex*, float*, long*, const long, const long));
extern void ctrexc_64 __P((const char, const long, floatcomplex*, const long, floatcomplex*, const long, const long, const long, long*));
extern void ctrexc_64_ __P((const char*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, const long*, const long*, long*, const long));
extern void ctrmm_64 __P((const char, const char, const char, const char, const long, const long, const floatcomplex*, const floatcomplex*, const long, floatcomplex*, const long));
extern void ctrmm_64_ __P((const char*, const char*, const char*, const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, floatcomplex*, const long*, const long, const long, const long, const long));
extern void ctrmv_64 __P((const char, const char, const char, const long, const floatcomplex*, const long, floatcomplex*, const long));
extern void ctrmv_64_ __P((const char*, const char*, const char*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, const long, const long, const long));
extern void ctrrfs_64 __P((const char, const char, const char, const long, const long, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, const long, float*, float*, long*));
extern void ctrrfs_64_ __P((const char*, const char*, const char*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, float*, float*, floatcomplex*, float*, long*, const long, const long, const long));
extern void ctrsen_64 __P((const char, const char, const long*, const long, floatcomplex*, const long, floatcomplex*, const long, floatcomplex*, long*, float*, float*, long*));
extern void ctrsen_64_ __P((const char*, const char*, const long*, const long*, floatcomplex*, const long*, floatcomplex*, const long*, floatcomplex*, long*, float*, float*, floatcomplex*, const long*, long*, const long, const long));
extern void ctrsm_64 __P((const char, const char, const char, const char, const long, const long, const floatcomplex*, const floatcomplex*, const long, floatcomplex*, const long));
extern void ctrsm_64_ __P((const char*, const char*, const char*, const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, floatcomplex*, const long*, const long, const long, const long, const long));
extern void ctrsna_64 __P((const char, const char, const long*, const long, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, const long, float*, float*, const long, long*, const long, long*));
extern void ctrsna_64_ __P((const char*, const char*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, float*, float*, const long*, long*, floatcomplex*, const long*, float*, long*, const long, const long));
extern void ctrsv_64 __P((const char, const char, const char, const long, const floatcomplex*, const long, floatcomplex*, const long));
extern void ctrsv_64_ __P((const char*, const char*, const char*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, const long, const long, const long));
extern void ctrsyl_64 __P((const char, const char, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, const long, floatcomplex*, const long, float*, long*));
extern void ctrsyl_64_ __P((const char*, const char*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, float*, long*, const long, const long));
extern void ctrti2_64 __P((const char, const char, const long, floatcomplex*, const long, long*));
extern void ctrti2_64_ __P((const char*, const char*, const long*, floatcomplex*, const long*, long*, const long, const long));
extern void ctrtri_64 __P((const char, const char, const long, floatcomplex*, const long, long*));
extern void ctrtri_64_ __P((const char*, const char*, const long*, floatcomplex*, const long*, long*, const long, const long));
extern void ctrtrs_64 __P((const char, const char, const char, const long, const long, const floatcomplex*, const long, floatcomplex*, const long, long*));
extern void ctrtrs_64_ __P((const char*, const char*, const char*, const long*, const long*, const floatcomplex*, const long*, floatcomplex*, const long*, long*, const long, const long, const long));
extern void ctzrqf_64 __P((const long, const long, floatcomplex*, const long, floatcomplex*, long*));
extern void ctzrqf_64_ __P((const long*, const long*, floatcomplex*, const long*, floatcomplex*, long*));
extern void ctzrzf_64 __P((const long, const long, floatcomplex*, const long, floatcomplex*, long*));
extern void ctzrzf_64_ __P((const long*, const long*, floatcomplex*, const long*, floatcomplex*, floatcomplex*, const long*, long*));
extern void cung2l_64 __P((const long, const long, const long, floatcomplex*, const long, const floatcomplex*, long*));
extern void cung2l_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, const floatcomplex*, floatcomplex*, long*));
extern void cung2r_64 __P((const long, const long, const long, floatcomplex*, const long, const floatcomplex*, long*));
extern void cung2r_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, const floatcomplex*, floatcomplex*, long*));
extern void cungbr_64 __P((const char, const long, const long, const long, floatcomplex*, const long, const floatcomplex*, long*));
extern void cungbr_64_ __P((const char*, const long*, const long*, const long*, floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, long*, const long));
extern void cunghr_64 __P((const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, long*));
extern void cunghr_64_ __P((const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, long*));
extern void cungl2_64 __P((const long, const long, const long, floatcomplex*, const long, const floatcomplex*, long*));
extern void cungl2_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, const floatcomplex*, floatcomplex*, long*));
extern void cunglq_64 __P((const long, const long, const long, floatcomplex*, const long, const floatcomplex*, long*));
extern void cunglq_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, long*));
extern void cungql_64 __P((const long, const long, const long, floatcomplex*, const long, const floatcomplex*, long*));
extern void cungql_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, long*));
extern void cungqr_64 __P((const long, const long, const long, floatcomplex*, const long, const floatcomplex*, long*));
extern void cungqr_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, long*));
extern void cungr2_64 __P((const long, const long, const long, floatcomplex*, const long, const floatcomplex*, long*));
extern void cungr2_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, const floatcomplex*, floatcomplex*, long*));
extern void cungrq_64 __P((const long, const long, const long, floatcomplex*, const long, const floatcomplex*, long*));
extern void cungrq_64_ __P((const long*, const long*, const long*, floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, long*));
extern void cungtr_64 __P((const char, const long, floatcomplex*, const long, const floatcomplex*, long*));
extern void cungtr_64_ __P((const char*, const long*, floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, long*, const long));
extern void cunmbr_64 __P((const char, const char, const char, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long, long*));
extern void cunmbr_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long, const long, const long));
extern void cunmhr_64 __P((const char, const char, const long, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long, long*));
extern void cunmhr_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long, const long));
extern void cunml2_64 __P((const char, const char, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long, long*));
extern void cunml2_64_ __P((const char*, const char*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, long*, const long, const long));
extern void cunmlq_64 __P((const char, const char, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long, long*));
extern void cunmlq_64_ __P((const char*, const char*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long, const long));
extern void cunmql_64 __P((const char, const char, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long, long*));
extern void cunmql_64_ __P((const char*, const char*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long, const long));
extern void cunmqr_64 __P((const char, const char, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long, long*));
extern void cunmqr_64_ __P((const char*, const char*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long, const long));
extern void cunmr2_64 __P((const char, const char, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long, long*));
extern void cunmr2_64_ __P((const char*, const char*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, long*, const long, const long));
extern void cunmrq_64 __P((const char, const char, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long, long*));
extern void cunmrq_64_ __P((const char*, const char*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long, const long));
extern void cunmrz_64 __P((const char, const char, const long, const long, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long, long*));
extern void cunmrz_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long, const long));
extern void cunmtr_64 __P((const char, const char, const char, const long, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long, long*));
extern void cunmtr_64_ __P((const char*, const char*, const char*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*, long*, const long, const long, const long));
extern void cupgtr_64 __P((const char, const long, const floatcomplex*, const floatcomplex*, floatcomplex*, const long, long*));
extern void cupgtr_64_ __P((const char*, const long*, const floatcomplex*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, long*, const long));
extern void cupmtr_64 __P((const char, const char, const char, const long, const long, const floatcomplex*, const floatcomplex*, floatcomplex*, const long, long*));
extern void cupmtr_64_ __P((const char*, const char*, const char*, const long*, const long*, const floatcomplex*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, long*, const long, const long, const long));
extern void cvbrmm_64 __P((const long, const long, const long, const long, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const long*, const long*, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cvbrmm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cvbrsm_64 __P((const long, const long, const long, const long, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const long*, const long*, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cvbrsm_64_ __P((const long*, const long*, const long*, const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const long*, const long*, const long*, const long*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*, floatcomplex*, const long*));
extern void cvmul_64 __P((const long, const floatcomplex*, const floatcomplex*, const long, const floatcomplex*, const long, const floatcomplex*, floatcomplex*, const long));
extern void cvmul_64_ __P((const long*, const floatcomplex*, const floatcomplex*, const long*, const floatcomplex*, const long*, const floatcomplex*, floatcomplex*, const long*));
extern double dasum_64 __P((const long, const double*, const long));
extern double dasum_64_ __P((const long*, const double*, const long*));
extern void daxpyi_64 __P((const long, const double, const double*, const long*, double*));
extern void daxpyi_64_ __P((const long*, const double*, const double*, const long*, double*));
extern void daxpy_64 __P((const long, const double, const double*, const long, double*, const long));
extern void daxpy_64_ __P((const long*, const double*, const double*, const long*, double*, const long*));
extern void dbcomm_64 __P((const long, const long, const long, const long, const double, const long*, const double*, const long*, const long*, const long, const long, const double*, const long, const double, double*, const long));
extern void dbcomm_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dbdimm_64 __P((const long, const long, const long, const long, const double, const long*, const double*, const long, const long*, const long, const long, const double*, const long, const double, double*, const long));
extern void dbdimm_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dbdism_64 __P((const long, const long, const long, const long, const double*, const double, const long*, const double*, const long, const long*, const long, const long, const double*, const long, const double, double*, const long));
extern void dbdism_64_ __P((const long*, const long*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dbdsdc_64 __P((const char, const char, const long, double*, double*, double*, const long, double*, const long, double*, long*, long*));
extern void dbdsdc_64_ __P((const char*, const char*, const long*, double*, double*, double*, const long*, double*, const long*, double*, long*, double*, long*, long*, const long, const long));
extern void dbdsqr_64 __P((const char, const long, const long, const long, const long, double*, double*, double*, const long, double*, const long, double*, const long, long*));
extern void dbdsqr_64_ __P((const char*, const long*, const long*, const long*, const long*, double*, double*, double*, const long*, double*, const long*, double*, const long*, double*, long*, const long));
extern void dbelmm_64 __P((const long, const long, const long, const long, const double, const long*, const double*, const long*, const long, const long, const long, const double*, const long, const double, double*, const long));
extern void dbelmm_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dbelsm_64 __P((const long, const long, const long, const long, const double*, const double, const long*, const double*, const long*, const long, const long, const long, const double*, const long, const double, double*, const long));
extern void dbelsm_64_ __P((const long*, const long*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dbscmm_64 __P((const long, const long, const long, const long, const double, const long*, const double*, const long*, const long*, const long*, const long, const double*, const long, const double, double*, const long));
extern void dbscmm_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dbscsm_64 __P((const long, const long, const long, const long, const double*, const double, const long*, const double*, const long*, const long*, const long*, const long, const double*, const long, const double, double*, const long));
extern void dbscsm_64_ __P((const long*, const long*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dbsrmm_64 __P((const long, const long, const long, const long, const double, const long*, const double*, const long*, const long*, const long*, const long, const double*, const long, const double, double*, const long));
extern void dbsrmm_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dbsrsm_64 __P((const long, const long, const long, const long, const double*, const double, const long*, const double*, const long*, const long*, const long*, const long, const double*, const long, const double, double*, const long));
extern void dbsrsm_64_ __P((const long*, const long*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern double dcabs1_64 __P((const doublecomplex*));
extern double dcabs1_64_ __P((const doublecomplex*));
extern void dcnvcor2_64 __P((const char, const char, const char, const char, const char, const char, const long, const long, const double*, const long, const long, const long, const long, const long, const double*, const long, const long, const long, double*, const long, doublecomplex*, const long));
extern void dcnvcor2_64_ __P((const char*, const char*, const char*, const char*, const char*, const char*, const long*, const long*, const double*, const long*, const long*, const long*, const long*, const long*, const double*, const long*, const long*, const long*, double*, const long*, doublecomplex*, const long*, const long, const long, const long, const long, const long, const long));
extern void dcnvcor_64 __P((const char, const char, const long, const double*, const long, const long, const long, const long, const long, const double*, const long, const long, const long, const long, const long, double*, const long, const long, const long, double*, const long));
extern void dcnvcor_64_ __P((const char*, const char*, const long*, const double*, const long*, const long*, const long*, const long*, const long*, const double*, const long*, const long*, const long*, const long*, const long*, double*, const long*, const long*, const long*, double*, const long*, const long, const long));
extern void dcoomm_64 __P((const long, const long, const long, const long, const double, const long*, const double*, const long*, const long*, const long, const double*, const long, const double, double*, const long));
extern void dcoomm_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dcopy_64 __P((const long, const double*, const long, double*, const long));
extern void dcopy_64_ __P((const long*, const double*, const long*, double*, const long*));
extern void dcosqb_64 __P((const long, double*, const double*));
extern void dcosqb_64_ __P((const long*, double*, const double*));
extern void dcosqf_64 __P((const long, double*, const double*));
extern void dcosqf_64_ __P((const long*, double*, const double*));
extern void dcosqi_64 __P((const long, double*));
extern void dcosqi_64_ __P((const long*, double*));
extern void dcosti_64 __P((const long, double*));
extern void dcosti_64_ __P((const long*, double*));
extern void dcost_64 __P((const long, double*, const double*));
extern void dcost_64_ __P((const long*, double*, const double*));
extern void dcscmm_64 __P((const long, const long, const long, const long, const double, const long*, const double*, const long*, const long*, const long*, const double*, const long, const double, double*, const long));
extern void dcscmm_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dcscsm_64 __P((const long, const long, const long, const long, const double*, const double, const long*, const double*, const long*, const long*, const long*, const double*, const long, const double, double*, const long));
extern void dcscsm_64_ __P((const long*, const long*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dcsrmm_64 __P((const long, const long, const long, const long, const double, const long*, const double*, const long*, const long*, const long*, const double*, const long, const double, double*, const long));
extern void dcsrmm_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dcsrsm_64 __P((const long, const long, const long, const long, const double*, const double, const long*, const double*, const long*, const long*, const long*, const double*, const long, const double, double*, const long));
extern void dcsrsm_64_ __P((const long*, const long*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void ddiamm_64 __P((const long, const long, const long, const long, const double, const long*, const double*, const long, const long*, const long, const double*, const long, const double, double*, const long));
extern void ddiamm_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void ddiasm_64 __P((const long, const long, const long, const long, const double*, const double, const long*, const double*, const long, const long*, const long, const double*, const long, const double, double*, const long));
extern void ddiasm_64_ __P((const long*, const long*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void ddisna_64 __P((const char, const long, const long, const double*, double*, long*));
extern void ddisna_64_ __P((const char*, const long*, const long*, const double*, double*, long*, const long));
extern double ddoti_64 __P((const long, const double*, const long*, const double*));
extern double ddoti_64_ __P((const long*, const double*, const long*, const double*));
extern double ddot_64 __P((const long, const double*, const long, const double*, const long));
extern double ddot_64_ __P((const long*, const double*, const long*, const double*, const long*));
extern void dellmm_64 __P((const long, const long, const long, const long, const double, const long*, const double*, const long*, const long, const long, const double*, const long, const double, double*, const long));
extern void dellmm_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dellsm_64 __P((const long, const long, const long, const long, const double*, const double, const long*, const double*, const long*, const long, const long, const double*, const long, const double, double*, const long));
extern void dellsm_64_ __P((const long*, const long*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dezftb_64 __P((const long, double*, const double, const double*, const double*, double*));
extern void dezftb_64_ __P((const long*, double*, const double*, const double*, const double*, double*));
extern void dezftf_64 __P((const long, double*, const double, const double*, const double*, double*));
extern void dezftf_64_ __P((const long*, double*, const double*, const double*, const double*, double*));
extern void dezfti_64 __P((const long, double*));
extern void dezfti_64_ __P((const long*, double*));
extern void dfft2b_64 __P((const char, const long, const long, double*, const long, double*, const long, double*, const long));
extern void dfft2b_64_ __P((const char*, const long*, const long*, double*, const long*, double*, const long*, double*, const long*, const long));
extern void dfft2f_64 __P((const char, const char, const long, const long, double*, const long, double*, const long, double*, const long));
extern void dfft2f_64_ __P((const char*, const char*, const long*, const long*, double*, const long*, double*, const long*, double*, const long*, const long, const long));
extern void dfft2i_64 __P((const long, const long, double*));
extern void dfft2i_64_ __P((const long*, const long*, double*));
extern void dfft3b_64 __P((const char, const long, const long, const long, double*, const long, double*, const long, double*, const long));
extern void dfft3b_64_ __P((const char*, const long*, const long*, const long*, double*, const long*, double*, const long*, double*, const long*, const long));
extern void dfft3f_64 __P((const char, const char, const long, const long, const long, double*, const long, double*, const long, double*, const long));
extern void dfft3f_64_ __P((const char*, const char*, const long*, const long*, const long*, double*, const long*, double*, const long*, double*, const long*, const long, const long));
extern void dfft3i_64 __P((const long, const long, const long, double*));
extern void dfft3i_64_ __P((const long*, const long*, const long*, double*));
extern void dfftb_64 __P((const long, double*, const double*));
extern void dfftb_64_ __P((const long*, double*, const double*));
extern void dfftf_64 __P((const long, double*, const double*));
extern void dfftf_64_ __P((const long*, double*, const double*));
extern void dffti_64 __P((const long, double*));
extern void dffti_64_ __P((const long*, double*));
extern long dfftopt_64 __P((const long));
extern long dfftopt_64_ __P((const long*));
extern void dfftz2_64_ __P((const long*, const long*, const long*, const double*, const double*, const long*, doublecomplex*, const long*, double*, long*, double*, const long*, long*));
extern void dfftz3_64_ __P((const long*, const long*, const long*, const long*, const double*, const double*, const long*, const long*, doublecomplex*, const long*, const long*, double*, long*, double*, const long*, long*));
extern void dfftzm_64_ __P((const long*, const long*, const long*, const double*, const double*, const long*, doublecomplex*, const long*, double*, long*, double*, const long*, long*));
extern void dfftz_64_ __P((const long*, const long*, const double*, const double*, doublecomplex*, double*, long*, double*, const long*, long*));
extern void dgbbrd_64 __P((const char, const long, const long, const long, const long, const long, double*, const long, double*, double*, double*, const long, double*, const long, double*, const long, long*));
extern void dgbbrd_64_ __P((const char*, const long*, const long*, const long*, const long*, const long*, double*, const long*, double*, double*, double*, const long*, double*, const long*, double*, const long*, double*, long*, const long));
extern void dgbcon_64 __P((const char, const long, const long, const long, const double*, const long, const long*, const double, double*, long*));
extern void dgbcon_64_ __P((const char*, const long*, const long*, const long*, const double*, const long*, const long*, const double*, double*, double*, long*, long*, const long));
extern void dgbequ_64 __P((const long, const long, const long, const long, const double*, const long, double*, double*, double*, double*, double*, long*));
extern void dgbequ_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, double*, double*, double*, double*, double*, long*));
extern void dgbmv_64 __P((const char, const long, const long, const long, const long, const double, const double*, const long, const double*, const long, const double, double*, const long));
extern void dgbmv_64_ __P((const char*, const long*, const long*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const double*, double*, const long*, const long));
extern void dgbrfs_64 __P((const char, const long, const long, const long, const long, const double*, const long, const double*, const long, const long*, const double*, const long, double*, const long, double*, double*, long*));
extern void dgbrfs_64_ __P((const char*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const double*, const long*, double*, const long*, double*, double*, double*, long*, long*, const long));
extern void dgbsvx_64 __P((const char, const char, const long, const long, const long, const long, double*, const long, double*, const long, long*, char*, double*, double*, double*, const long, double*, const long, double*, double*, double*, long*));
extern void dgbsvx_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, double*, const long*, double*, const long*, long*, char*, double*, double*, double*, const long*, double*, const long*, double*, double*, double*, double*, long*, long*, const long, const long, const long));
extern void dgbsv_64 __P((const long, const long, const long, const long, double*, const long, long*, double*, const long, long*));
extern void dgbsv_64_ __P((const long*, const long*, const long*, const long*, double*, const long*, long*, double*, const long*, long*));
extern void dgbtf2_64 __P((const long, const long, const long, const long, double*, const long, long*, long*));
extern void dgbtf2_64_ __P((const long*, const long*, const long*, const long*, double*, const long*, long*, long*));
extern void dgbtrf_64 __P((const long, const long, const long, const long, double*, const long, long*, long*));
extern void dgbtrf_64_ __P((const long*, const long*, const long*, const long*, double*, const long*, long*, long*));
extern void dgbtrs_64 __P((const char, const long, const long, const long, const long, const double*, const long, const long*, double*, const long, long*));
extern void dgbtrs_64_ __P((const char*, const long*, const long*, const long*, const long*, const double*, const long*, const long*, double*, const long*, long*, const long));
extern void dgebak_64 __P((const char, const char, const long, const long, const long, const double*, const long, double*, const long, long*));
extern void dgebak_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const long*, double*, const long*, long*, const long, const long));
extern void dgebal_64 __P((const char, const long, double*, const long, long*, long*, double*, long*));
extern void dgebal_64_ __P((const char*, const long*, double*, const long*, long*, long*, double*, long*, const long));
extern void dgebrd_64 __P((const long, const long, double*, const long, double*, double*, double*, double*, long*));
extern void dgebrd_64_ __P((const long*, const long*, double*, const long*, double*, double*, double*, double*, double*, const long*, long*));
extern void dgecon_64 __P((const char, const long, const double*, const long, const double, double*, long*));
extern void dgecon_64_ __P((const char*, const long*, const double*, const long*, const double*, double*, double*, long*, long*, const long));
extern void dgeequ_64 __P((const long, const long, const double*, const long, double*, double*, double*, double*, double*, long*));
extern void dgeequ_64_ __P((const long*, const long*, const double*, const long*, double*, double*, double*, double*, double*, long*));
extern void dgeesx_64 __P((const char, const char, const long(*select)(double,double), const char, const long, double*, const long, long*, double*, double*, double*, const long, double*, double*, long*));
extern void dgeesx_64_ __P((const char*, const char*, const long(*select)(double,double), const char*, const long*, double*, const long*, long*, double*, double*, double*, const long*, double*, double*, double*, const long*, long*, const long*, long*, long*, const long, const long, const long));
extern void dgees_64 __P((const char, const char, const long(*select)(double,double), const long, double*, const long, long*, double*, double*, double*, const long, long*));
extern void dgees_64_ __P((const char*, const char*, const long(*select)(double,double), const long*, double*, const long*, long*, double*, double*, double*, const long*, double*, const long*, long*, long*, const long, const long));
extern void dgeevx_64 __P((const char, const char, const char, const char, const long, double*, const long, double*, double*, double*, const long, double*, const long, long*, long*, double*, double*, double*, double*, long*));
extern void dgeevx_64_ __P((const char*, const char*, const char*, const char*, const long*, double*, const long*, double*, double*, double*, const long*, double*, const long*, long*, long*, double*, double*, double*, double*, double*, const long*, long*, long*, const long, const long, const long, const long));
extern void dgeev_64 __P((const char, const char, const long, double*, const long, double*, double*, double*, const long, double*, const long, long*));
extern void dgeev_64_ __P((const char*, const char*, const long*, double*, const long*, double*, double*, double*, const long*, double*, const long*, double*, const long*, long*, const long, const long));
extern void dgegs_64 __P((const char, const char, const long, double*, const long, double*, const long, double*, double*, double*, double*, const long, double*, const long, long*));
extern void dgegs_64_ __P((const char*, const char*, const long*, double*, const long*, double*, const long*, double*, double*, double*, double*, const long*, double*, const long*, double*, const long*, long*, const long, const long));
extern void dgegv_64 __P((const char, const char, const long, double*, const long, double*, const long, double*, double*, double*, double*, const long, double*, const long, long*));
extern void dgegv_64_ __P((const char*, const char*, const long*, double*, const long*, double*, const long*, double*, double*, double*, double*, const long*, double*, const long*, double*, const long*, long*, const long, const long));
extern void dgehrd_64 __P((const long, const long, const long, double*, const long, double*, long*));
extern void dgehrd_64_ __P((const long*, const long*, const long*, double*, const long*, double*, double*, const long*, long*));
extern void dgelqf_64 __P((const long, const long, double*, const long, double*, long*));
extern void dgelqf_64_ __P((const long*, const long*, double*, const long*, double*, double*, const long*, long*));
extern void dgelsd_64 __P((const long, const long, const long, double*, const long, double*, const long, double*, const double, long*, long*));
extern void dgelsd_64_ __P((const long*, const long*, const long*, double*, const long*, double*, const long*, double*, const double*, long*, double*, const long*, long*, long*));
extern void dgelss_64 __P((const long, const long, const long, double*, const long, double*, const long, double*, const double, long*, long*));
extern void dgelss_64_ __P((const long*, const long*, const long*, double*, const long*, double*, const long*, double*, const double*, long*, double*, const long*, long*));
extern void dgelsx_64 __P((const long, const long, const long, double*, const long, double*, const long, long*, const double, long*, long*));
extern void dgelsx_64_ __P((const long*, const long*, const long*, double*, const long*, double*, const long*, long*, const double*, long*, double*, long*));
extern void dgelsy_64 __P((const long, const long, const long, double*, const long, double*, const long, long*, const double, long*, long*));
extern void dgelsy_64_ __P((const long*, const long*, const long*, double*, const long*, double*, const long*, long*, const double*, long*, double*, const long*, long*));
extern void dgels_64 __P((const char, const long, const long, const long, double*, const long, double*, const long, long*));
extern void dgels_64_ __P((const char*, const long*, const long*, const long*, double*, const long*, double*, const long*, double*, const long*, long*, const long));
extern void dgemm_64 __P((const char, const char, const long, const long, const long, const double, const double*, const long, const double*, const long, const double, double*, const long));
extern void dgemm_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const double*, double*, const long*, const long, const long));
extern void dgemv_64 __P((const char, const long, const long, const double, const double*, const long, const double*, const long, const double, double*, const long));
extern void dgemv_64_ __P((const char*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const double*, double*, const long*, const long));
extern void dgeqlf_64 __P((const long, const long, double*, const long, double*, long*));
extern void dgeqlf_64_ __P((const long*, const long*, double*, const long*, double*, double*, const long*, long*));
extern void dgeqp3_64 __P((const long, const long, double*, const long, long*, double*, long*));
extern void dgeqp3_64_ __P((const long*, const long*, double*, const long*, long*, double*, double*, const long*, long*));
extern void dgeqpf_64 __P((const long, const long, double*, const long, long*, double*, long*));
extern void dgeqpf_64_ __P((const long*, const long*, double*, const long*, long*, double*, double*, long*));
extern void dgeqrf_64 __P((const long, const long, double*, const long, double*, long*));
extern void dgeqrf_64_ __P((const long*, const long*, double*, const long*, double*, double*, const long*, long*));
extern void dgerfs_64 __P((const char, const long, const long, const double*, const long, const double*, const long, const long*, const double*, const long, double*, const long, double*, double*, long*));
extern void dgerfs_64_ __P((const char*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const double*, const long*, double*, const long*, double*, double*, double*, long*, long*, const long));
extern void dgerqf_64 __P((const long, const long, double*, const long, double*, long*));
extern void dgerqf_64_ __P((const long*, const long*, double*, const long*, double*, double*, const long*, long*));
extern void dger_64 __P((const long, const long, const double, const double*, const long, const double*, const long, double*, const long));
extern void dger_64_ __P((const long*, const long*, const double*, const double*, const long*, const double*, const long*, double*, const long*));
extern void dgesdd_64 __P((const char, const long, const long, double*, const long, double*, double*, const long, double*, const long, long*));
extern void dgesdd_64_ __P((const char*, const long*, const long*, double*, const long*, double*, double*, const long*, double*, const long*, double*, const long*, long*, long*, const long));
extern void dgesvd_64 __P((const char, const char, const long, const long, double*, const long, double*, double*, const long, double*, const long, long*));
extern void dgesvd_64_ __P((const char*, const char*, const long*, const long*, double*, const long*, double*, double*, const long*, double*, const long*, double*, const long*, long*, const long, const long));
extern void dgesvx_64 __P((const char, const char, const long, const long, double*, const long, double*, const long, long*, char*, double*, double*, double*, const long, double*, const long, double*, double*, double*, long*));
extern void dgesvx_64_ __P((const char*, const char*, const long*, const long*, double*, const long*, double*, const long*, long*, char*, double*, double*, double*, const long*, double*, const long*, double*, double*, double*, double*, long*, long*, const long, const long, const long));
extern void dgesv_64 __P((const long, const long, double*, const long, long*, double*, const long, long*));
extern void dgesv_64_ __P((const long*, const long*, double*, const long*, long*, double*, const long*, long*));
extern void dgetf2_64 __P((const long, const long, double*, const long, long*, long*));
extern void dgetf2_64_ __P((const long*, const long*, double*, const long*, long*, long*));
extern void dgetrf_64 __P((const long, const long, double*, const long, long*, long*));
extern void dgetrf_64_ __P((const long*, const long*, double*, const long*, long*, long*));
extern void dgetri_64 __P((const long, double*, const long, const long*, long*));
extern void dgetri_64_ __P((const long*, double*, const long*, const long*, double*, const long*, long*));
extern void dgetrs_64 __P((const char, const long, const long, const double*, const long, const long*, double*, const long, long*));
extern void dgetrs_64_ __P((const char*, const long*, const long*, const double*, const long*, const long*, double*, const long*, long*, const long));
extern void dggbak_64 __P((const char, const char, const long, const long, const long, const double*, const double*, const long, double*, const long, long*));
extern void dggbak_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const double*, const long*, double*, const long*, long*, const long, const long));
extern void dggbal_64 __P((const char, const long, double*, const long, double*, const long, long*, long*, const double*, const double*, long*));
extern void dggbal_64_ __P((const char*, const long*, double*, const long*, double*, const long*, long*, long*, const double*, const double*, double*, long*, const long));
extern void dggesx_64 __P((const char, const char, const char, const long(*delctg)(double,double,double), const char, const long, double*, const long, double*, const long, long*, double*, double*, double*, double*, const long, double*, const long, double*, double*, long*));
extern void dggesx_64_ __P((const char*, const char*, const char*, const long(*delctg)(double,double,double), const char*, const long*, double*, const long*, double*, const long*, long*, double*, double*, double*, double*, const long*, double*, const long*, double*, double*, double*, const long*, long*, const long*, long*, long*, const long, const long, const long, const long));
extern void dgges_64 __P((const char, const char, const char, const long(*delctg)(double,double,double), const long, double*, const long, double*, const long, long*, double*, double*, double*, double*, const long, double*, const long, long*));
extern void dgges_64_ __P((const char*, const char*, const char*, const long(*delctg)(double,double,double), const long*, double*, const long*, double*, const long*, long*, double*, double*, double*, double*, const long*, double*, const long*, double*, const long*, long*, long*, const long, const long, const long));
extern void dggevx_64 __P((const char, const char, const char, const char, const long, double*, const long, double*, const long, double*, double*, double*, double*, const long, double*, const long, long*, long*, double*, double*, double*, double*, double*, double*, long*));
extern void dggevx_64_ __P((const char*, const char*, const char*, const char*, const long*, double*, const long*, double*, const long*, double*, double*, double*, double*, const long*, double*, const long*, long*, long*, double*, double*, double*, double*, double*, double*, double*, const long*, long*, long*, long*, const long, const long, const long, const long));
extern void dggev_64 __P((const char, const char, const long, double*, const long, double*, const long, double*, double*, double*, double*, const long, double*, const long, long*));
extern void dggev_64_ __P((const char*, const char*, const long*, double*, const long*, double*, const long*, double*, double*, double*, double*, const long*, double*, const long*, double*, const long*, long*, const long, const long));
extern void dggglm_64 __P((const long, const long, const long, double*, const long, double*, const long, double*, double*, double*, long*));
extern void dggglm_64_ __P((const long*, const long*, const long*, double*, const long*, double*, const long*, double*, double*, double*, double*, const long*, long*));
extern void dgghrd_64 __P((const char, const char, const long, const long, const long, double*, const long, double*, const long, double*, const long, double*, const long, long*));
extern void dgghrd_64_ __P((const char*, const char*, const long*, const long*, const long*, double*, const long*, double*, const long*, double*, const long*, double*, const long*, long*, const long, const long));
extern void dgglse_64 __P((const long, const long, const long, double*, const long, double*, const long, double*, double*, double*, long*));
extern void dgglse_64_ __P((const long*, const long*, const long*, double*, const long*, double*, const long*, double*, double*, double*, double*, const long*, long*));
extern void dggqrf_64 __P((const long, const long, const long, double*, const long, double*, double*, const long, double*, long*));
extern void dggqrf_64_ __P((const long*, const long*, const long*, double*, const long*, double*, double*, const long*, double*, double*, const long*, long*));
extern void dggrqf_64 __P((const long, const long, const long, double*, const long, double*, double*, const long, double*, long*));
extern void dggrqf_64_ __P((const long*, const long*, const long*, double*, const long*, double*, double*, const long*, double*, double*, const long*, long*));
extern void dggsvd_64 __P((const char, const char, const char, const long, const long, const long, long*, long*, double*, const long, double*, const long, double*, double*, double*, const long, double*, const long, double*, const long, long*, long*));
extern void dggsvd_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, long*, long*, double*, const long*, double*, const long*, double*, double*, double*, const long*, double*, const long*, double*, const long*, double*, long*, long*, const long, const long, const long));
extern void dggsvp_64 __P((const char, const char, const char, const long, const long, const long, double*, const long, double*, const long, const double, const double, long*, long*, double*, const long, double*, const long, double*, const long, long*));
extern void dggsvp_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, double*, const long*, double*, const long*, const double*, const double*, long*, long*, double*, const long*, double*, const long*, double*, const long*, long*, double*, double*, long*, const long, const long, const long));
extern void dgssco_64_ __P((double*, double*, long*));
extern void dgssda_64_ __P((double*, long*));
extern void dgssfa_64_ __P((const long*, const long*, const long*, const double*, double*, long*));
extern void dgssfs_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const long*, double*, const long*, const char*, const long*, const long*, double*, long*, const long, const long, const long));
extern void dgssin_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const long*, double*, long*, const long, const long));
extern void dgssor_64_ __P((const char*, double*, long*, const long));
extern void dgssps_64_ __P((double*, long*));
extern void dgssrp_64_ __P((long*, double*, long*));
extern void dgsssl_64_ __P((const long*, double*, const long*, double*, long*));
extern void dgssuo_64_ __P((const long*, double*, long*));
extern void dgtcon_64 __P((const char, const long, const double*, const double*, const double*, const double*, const long*, const double, double*, long*));
extern void dgtcon_64_ __P((const char*, const long*, const double*, const double*, const double*, const double*, const long*, const double*, double*, double*, long*, long*, const long));
extern void dgthrz_64 __P((const long, double*, double*, const long*));
extern void dgthrz_64_ __P((const long*, double*, double*, const long*));
extern void dgthr_64 __P((const long, const double*, double*, const long*));
extern void dgthr_64_ __P((const long*, const double*, double*, const long*));
extern void dgtrfs_64 __P((const char, const long, const long, const double*, const double*, const double*, const double*, const double*, const double*, const double*, const long*, const double*, const long, double*, const long, double*, double*, long*));
extern void dgtrfs_64_ __P((const char*, const long*, const long*, const double*, const double*, const double*, const double*, const double*, const double*, const double*, const long*, const double*, const long*, double*, const long*, double*, double*, double*, long*, long*, const long));
extern void dgtsvx_64 __P((const char, const char, const long, const long, const double*, const double*, double*, double*, double*, double*, double*, long*, const double*, const long, double*, const long, double*, double*, double*, long*));
extern void dgtsvx_64_ __P((const char*, const char*, const long*, const long*, const double*, const double*, double*, double*, double*, double*, double*, long*, const double*, const long*, double*, const long*, double*, double*, double*, double*, long*, long*, const long, const long));
extern void dgtsv_64 __P((const long, const long, double*, double*, double*, double*, const long, long*));
extern void dgtsv_64_ __P((const long*, const long*, double*, double*, double*, double*, const long*, long*));
extern void dgttrf_64 __P((const long, double*, double*, double*, double*, long*, long*));
extern void dgttrf_64_ __P((const long*, double*, double*, double*, double*, long*, long*));
extern void dgttrs_64 __P((const char, const long, const long, const double*, const double*, const double*, const double*, const long*, double*, const long, long*));
extern void dgttrs_64_ __P((const char*, const long*, const long*, const double*, const double*, const double*, const double*, const long*, double*, const long*, long*, const long));
extern void dhgeqz_64 __P((const char, const char, const char, const long, const long, const long, double*, const long, double*, const long, double*, double*, double*, double*, const long, double*, const long, long*));
extern void dhgeqz_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, double*, const long*, double*, const long*, double*, double*, double*, double*, const long*, double*, const long*, double*, const long*, long*, const long, const long, const long));
extern void dhsein_64 __P((const char, const char, const char, long*, const long, const double*, const long, double*, const double*, double*, const long, double*, const long, const long, long*, long*, long*, long*));
extern void dhsein_64_ __P((const char*, const char*, const char*, long*, const long*, const double*, const long*, double*, const double*, double*, const long*, double*, const long*, const long*, long*, double*, long*, long*, long*, const long, const long, const long));
extern void dhseqr_64 __P((const char, const char, const long, const long, const long, double*, const long, double*, double*, double*, const long, long*));
extern void dhseqr_64_ __P((const char*, const char*, const long*, const long*, const long*, double*, const long*, double*, double*, double*, const long*, double*, const long*, long*, const long, const long));
extern void djadmm_64 __P((const long, const long, const long, const long, const double, const long*, const double*, const long*, const long*, const long, const long*, const double*, const long, const double, double*, const long));
extern void djadmm_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void djadrp_64 __P((const long, const long, const long, const double*, const long*, long*, const long, const long*));
extern void djadrp_64_ __P((const long*, const long*, const long*, const double*, const long*, long*, const long*, const long*, long*, const long*));
extern void djadsm_64 __P((const long, const long, const long, const long, const double*, const double, const long*, const double*, const long*, const long*, const long, const long*, const double*, const long, const double, double*, const long));
extern void djadsm_64_ __P((const long*, const long*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dlaeda_64 __P((const long, const long, const long, const long, const long*, const long*, const long*, const long*, const double*, const double*, const long*, double*, long*));
extern void dlaeda_64_ __P((const long*, const long*, const long*, const long*, const long*, const long*, const long*, const long*, const double*, const double*, const long*, double*, double*, long*));
extern void dlagtf_64 __P((const long, double*, const double, double*, double*, const double, double*, long*, long*));
extern void dlagtf_64_ __P((const long*, double*, const double*, double*, double*, const double*, double*, long*, long*));
extern double dlamch_64 __P((const char));
extern double dlamch_64_ __P((const char*, const long));
extern void dlamrg_64 __P((const long, const long, const double*, const long, const long, long*));
extern void dlamrg_64_ __P((const long*, const long*, const double*, const long*, const long*, long*));
extern void dlanv2_64 __P((double*, double*, double*, double*, double*, double*, double*, double*, double*, double*));
extern void dlanv2_64_ __P((double*, double*, double*, double*, double*, double*, double*, double*, double*, double*));
extern void dlarzb_64 __P((const char, const char, const char, const char, const long, const long, const long, const long, const double*, const long, const double*, const long, double*, const long, const long));
extern void dlarzb_64_ __P((const char*, const char*, const char*, const char*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, double*, const long*, double*, const long*, const long, const long, const long, const long));
extern void dlarzt_64 __P((const char, const char, const long, const long, const double*, const long, const double*, double*, const long));
extern void dlarzt_64_ __P((const char*, const char*, const long*, const long*, const double*, const long*, const double*, double*, const long*, const long, const long));
extern void dlarz_64 __P((const char, const long, const long, const long, const double*, const long, const double, double*, const long));
extern void dlarz_64_ __P((const char*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long));
extern void dlasq1_64 __P((const long, double*, double*, long*));
extern void dlasq1_64_ __P((const long*, double*, double*, double*, long*));
extern void dlasq2_64 __P((const long, double*, long*));
extern void dlasq2_64_ __P((const long*, double*, long*));
extern void dlasrt_64 __P((const char, const long, double*, long*));
extern void dlasrt_64_ __P((const char*, const long*, double*, long*, const long));
extern void dlatzm_64 __P((const char, const long, const long, const double*, const long, const double, double*, double*, const long));
extern void dlatzm_64_ __P((const char*, const long*, const long*, const double*, const long*, const double*, double*, double*, const long*, double*, const long));
extern double dnrm2_64 __P((const long, const double*, const long));
extern double dnrm2_64_ __P((const long*, const double*, const long*));
extern void dopgtr_64 __P((const char, const long, const double*, const double*, double*, const long, long*));
extern void dopgtr_64_ __P((const char*, const long*, const double*, const double*, double*, const long*, double*, long*, const long));
extern void dopmtr_64 __P((const char, const char, const char, const long, const long, const double*, const double*, double*, const long, long*));
extern void dopmtr_64_ __P((const char*, const char*, const char*, const long*, const long*, const double*, const double*, double*, const long*, double*, long*, const long, const long, const long));
extern void dorg2l_64 __P((const long, const long, const long, double*, const long, const double*, long*));
extern void dorg2l_64_ __P((const long*, const long*, const long*, double*, const long*, const double*, double*, long*));
extern void dorg2r_64 __P((const long, const long, const long, double*, const long, const double*, long*));
extern void dorg2r_64_ __P((const long*, const long*, const long*, double*, const long*, const double*, double*, long*));
extern void dorgbr_64 __P((const char, const long, const long, const long, double*, const long, const double*, long*));
extern void dorgbr_64_ __P((const char*, const long*, const long*, const long*, double*, const long*, const double*, double*, const long*, long*, const long));
extern void dorghr_64 __P((const long, const long, const long, double*, const long, const double*, long*));
extern void dorghr_64_ __P((const long*, const long*, const long*, double*, const long*, const double*, double*, const long*, long*));
extern void dorgl2_64 __P((const long, const long, const long, double*, const long, const double*, long*));
extern void dorgl2_64_ __P((const long*, const long*, const long*, double*, const long*, const double*, double*, long*));
extern void dorglq_64 __P((const long, const long, const long, double*, const long, const double*, long*));
extern void dorglq_64_ __P((const long*, const long*, const long*, double*, const long*, const double*, double*, const long*, long*));
extern void dorgql_64 __P((const long, const long, const long, double*, const long, const double*, long*));
extern void dorgql_64_ __P((const long*, const long*, const long*, double*, const long*, const double*, double*, const long*, long*));
extern void dorgqr_64 __P((const long, const long, const long, double*, const long, const double*, long*));
extern void dorgqr_64_ __P((const long*, const long*, const long*, double*, const long*, const double*, double*, const long*, long*));
extern void dorgr2_64 __P((const long, const long, const long, double*, const long, const double*, long*));
extern void dorgr2_64_ __P((const long*, const long*, const long*, double*, const long*, const double*, double*, long*));
extern void dorgrq_64 __P((const long, const long, const long, double*, const long, const double*, long*));
extern void dorgrq_64_ __P((const long*, const long*, const long*, double*, const long*, const double*, double*, const long*, long*));
extern void dorgtr_64 __P((const char, const long, double*, const long, const double*, long*));
extern void dorgtr_64_ __P((const char*, const long*, double*, const long*, const double*, double*, const long*, long*, const long));
extern void dorm2l_64 __P((const char, const char, const long, const long, const long, const double*, const long, const double*, double*, const long, long*));
extern void dorm2l_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, long*, const long, const long));
extern void dorm2r_64 __P((const char, const char, const long, const long, const long, double*, const long, const double*, double*, const long, long*));
extern void dorm2r_64_ __P((const char*, const char*, const long*, const long*, const long*, double*, const long*, const double*, double*, const long*, double*, long*, const long, const long));
extern void dormbr_64 __P((const char, const char, const char, const long, const long, const long, const double*, const long, const double*, double*, const long, long*));
extern void dormbr_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*, long*, const long, const long, const long));
extern void dormhr_64 __P((const char, const char, const long, const long, const long, const long, const double*, const long, const double*, double*, const long, long*));
extern void dormhr_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*, long*, const long, const long));
extern void dorml2_64 __P((const char, const char, const long, const long, const long, const double*, const long, const double*, double*, const long, long*));
extern void dorml2_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, long*, const long, const long));
extern void dormlq_64 __P((const char, const char, const long, const long, const long, const double*, const long, const double*, double*, const long, long*));
extern void dormlq_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*, long*, const long, const long));
extern void dormql_64 __P((const char, const char, const long, const long, const long, const double*, const long, const double*, double*, const long, long*));
extern void dormql_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*, long*, const long, const long));
extern void dormqr_64 __P((const char, const char, const long, const long, const long, const double*, const long, const double*, double*, const long, long*));
extern void dormqr_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*, long*, const long, const long));
extern void dormr2_64 __P((const char, const char, const long, const long, const long, const double*, const long, const double*, double*, const long, long*));
extern void dormr2_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, long*, const long, const long));
extern void dormr3_64 __P((const char, const char, const long, const long, const long, const long, const double*, const long, const double*, double*, const long, long*));
extern void dormr3_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, long*, const long, const long));
extern void dormrq_64 __P((const char, const char, const long, const long, const long, const double*, const long, const double*, double*, const long, long*));
extern void dormrq_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*, long*, const long, const long));
extern void dormrz_64 __P((const char, const char, const long, const long, const long, const long, const double*, const long, const double*, double*, const long, long*));
extern void dormrz_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*, long*, const long, const long));
extern void dormtr_64 __P((const char, const char, const char, const long, const long, const double*, const long, const double*, double*, const long, long*));
extern void dormtr_64_ __P((const char*, const char*, const char*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*, long*, const long, const long, const long));
extern void dpbcon_64 __P((const char, const long, const long, const double*, const long, const double, double*, long*));
extern void dpbcon_64_ __P((const char*, const long*, const long*, const double*, const long*, const double*, double*, double*, long*, long*, const long));
extern void dpbequ_64 __P((const char, const long, const long, const double*, const long, double*, double*, double*, long*));
extern void dpbequ_64_ __P((const char*, const long*, const long*, const double*, const long*, double*, double*, double*, long*, const long));
extern void dpbrfs_64 __P((const char, const long, const long, const long, const double*, const long, const double*, const long, const double*, const long, double*, const long, double*, double*, long*));
extern void dpbrfs_64_ __P((const char*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const double*, const long*, double*, const long*, double*, double*, double*, long*, long*, const long));
extern void dpbstf_64 __P((const char, const long, const long, double*, const long, long*));
extern void dpbstf_64_ __P((const char*, const long*, const long*, double*, const long*, long*, const long));
extern void dpbsvx_64 __P((const char, const char, const long, const long, const long, double*, const long, double*, const long, char*, double*, double*, const long, double*, const long, double*, double*, double*, long*));
extern void dpbsvx_64_ __P((const char*, const char*, const long*, const long*, const long*, double*, const long*, double*, const long*, char*, double*, double*, const long*, double*, const long*, double*, double*, double*, double*, long*, long*, const long, const long, const long));
extern void dpbsv_64 __P((const char, const long, const long, const long, double*, const long, double*, const long, long*));
extern void dpbsv_64_ __P((const char*, const long*, const long*, const long*, double*, const long*, double*, const long*, long*, const long));
extern void dpbtf2_64 __P((const char, const long, const long, double*, const long, long*));
extern void dpbtf2_64_ __P((const char*, const long*, const long*, double*, const long*, long*, const long));
extern void dpbtrf_64 __P((const char, const long, const long, double*, const long, long*));
extern void dpbtrf_64_ __P((const char*, const long*, const long*, double*, const long*, long*, const long));
extern void dpbtrs_64 __P((const char, const long, const long, const long, const double*, const long, double*, const long, long*));
extern void dpbtrs_64_ __P((const char*, const long*, const long*, const long*, const double*, const long*, double*, const long*, long*, const long));
extern void dpocon_64 __P((const char, const long, const double*, const long, const double, double*, long*));
extern void dpocon_64_ __P((const char*, const long*, const double*, const long*, const double*, double*, double*, long*, long*, const long));
extern void dpoequ_64 __P((const long, const double*, const long, double*, double*, double*, long*));
extern void dpoequ_64_ __P((const long*, const double*, const long*, double*, double*, double*, long*));
extern void dporfs_64 __P((const char, const long, const long, const double*, const long, const double*, const long, const double*, const long, double*, const long, double*, double*, long*));
extern void dporfs_64_ __P((const char*, const long*, const long*, const double*, const long*, const double*, const long*, const double*, const long*, double*, const long*, double*, double*, double*, long*, long*, const long));
extern void dposvx_64 __P((const char, const char, const long, const long, double*, const long, double*, const long, char*, double*, double*, const long, double*, const long, double*, double*, double*, long*));
extern void dposvx_64_ __P((const char*, const char*, const long*, const long*, double*, const long*, double*, const long*, char*, double*, double*, const long*, double*, const long*, double*, double*, double*, double*, long*, long*, const long, const long, const long));
extern void dposv_64 __P((const char, const long, const long, double*, const long, double*, const long, long*));
extern void dposv_64_ __P((const char*, const long*, const long*, double*, const long*, double*, const long*, long*, const long));
extern void dpotf2_64 __P((const char, const long, double*, const long, long*));
extern void dpotf2_64_ __P((const char*, const long*, double*, const long*, long*, const long));
extern void dpotrf_64 __P((const char, const long, double*, const long, long*));
extern void dpotrf_64_ __P((const char*, const long*, double*, const long*, long*, const long));
extern void dpotri_64 __P((const char, const long, double*, const long, long*));
extern void dpotri_64_ __P((const char*, const long*, double*, const long*, long*, const long));
extern void dpotrs_64 __P((const char, const long, const long, const double*, const long, double*, const long, long*));
extern void dpotrs_64_ __P((const char*, const long*, const long*, const double*, const long*, double*, const long*, long*, const long));
extern void dppcon_64 __P((const char, const long, const double*, const double, double*, long*));
extern void dppcon_64_ __P((const char*, const long*, const double*, const double*, double*, double*, long*, long*, const long));
extern void dppequ_64 __P((const char, const long, const double*, double*, double*, double*, long*));
extern void dppequ_64_ __P((const char*, const long*, const double*, double*, double*, double*, long*, const long));
extern void dpprfs_64 __P((const char, const long, const long, const double*, const double*, const double*, const long, double*, const long, double*, double*, long*));
extern void dpprfs_64_ __P((const char*, const long*, const long*, const double*, const double*, const double*, const long*, double*, const long*, double*, double*, double*, long*, long*, const long));
extern void dppsvx_64 __P((const char, const char, const long, const long, double*, double*, char*, double*, double*, const long, double*, const long, double*, double*, double*, long*));
extern void dppsvx_64_ __P((const char*, const char*, const long*, const long*, double*, double*, char*, double*, double*, const long*, double*, const long*, double*, double*, double*, double*, long*, long*, const long, const long, const long));
extern void dppsv_64 __P((const char, const long, const long, double*, double*, const long, long*));
extern void dppsv_64_ __P((const char*, const long*, const long*, double*, double*, const long*, long*, const long));
extern void dpptrf_64 __P((const char, const long, double*, long*));
extern void dpptrf_64_ __P((const char*, const long*, double*, long*, const long));
extern void dpptri_64 __P((const char, const long, double*, long*));
extern void dpptri_64_ __P((const char*, const long*, double*, long*, const long));
extern void dpptrs_64 __P((const char, const long, const long, const double*, double*, const long, long*));
extern void dpptrs_64_ __P((const char*, const long*, const long*, const double*, double*, const long*, long*, const long));
extern void dptcon_64 __P((const long, const double*, const double*, const double, double*, long*));
extern void dptcon_64_ __P((const long*, const double*, const double*, const double*, double*, double*, long*));
extern void dpteqr_64 __P((const char, const long, double*, double*, double*, const long, long*));
extern void dpteqr_64_ __P((const char*, const long*, double*, double*, double*, const long*, double*, long*, const long));
extern void dptrfs_64 __P((const long, const long, const double*, const double*, const double*, const double*, const double*, const long, double*, const long, double*, double*, long*));
extern void dptrfs_64_ __P((const long*, const long*, const double*, const double*, const double*, const double*, const double*, const long*, double*, const long*, double*, double*, double*, long*));
extern void dptsvx_64 __P((const char, const long, const long, const double*, const double*, double*, double*, const double*, const long, double*, const long, double*, double*, double*, long*));
extern void dptsvx_64_ __P((const char*, const long*, const long*, const double*, const double*, double*, double*, const double*, const long*, double*, const long*, double*, double*, double*, double*, long*, const long));
extern void dptsv_64 __P((const long, const long, double*, double*, double*, const long, long*));
extern void dptsv_64_ __P((const long*, const long*, double*, double*, double*, const long*, long*));
extern void dpttrf_64 __P((const long, double*, double*, long*));
extern void dpttrf_64_ __P((const long*, double*, double*, long*));
extern void dpttrs_64 __P((const long, const long, const double*, double*, double*, const long, long*));
extern void dpttrs_64_ __P((const long*, const long*, const double*, double*, double*, const long*, long*));
extern void dptts2_64 __P((const long, const long, const double*, const double*, double*, const long));
extern void dptts2_64_ __P((const long*, const long*, const double*, const double*, double*, const long*));
extern double dqdota_64 __P((const long, const double, long double*, const double*, const long, const double*, const long));
extern double dqdota_64_ __P((const long*, const double*, long double*, const double*, const long*, const double*, const long*));
extern double dqdoti_64 __P((const long, const double, long double*, const double*, const long, const double*, const long));
extern double dqdoti_64_ __P((const long*, const double*, long double*, const double*, const long*, const double*, const long*));
extern void drotg_64 __P((double*, double*, double*, double*));
extern void drotg_64_ __P((double*, double*, double*, double*));
extern void droti_64 __P((const long, const double*, const long*, double*, const double, const double));
extern void droti_64_ __P((const long*, const double*, const long*, double*, const double*, const double*));
extern void drotmg_64 __P((double*, double*, double*, const double, double*));
extern void drotmg_64_ __P((double*, double*, double*, const double*, double*));
extern void drotm_64 __P((const long, const double*, const long, double*, const long, const double*));
extern void drotm_64_ __P((const long*, const double*, const long*, double*, const long*, const double*));
extern void drot_64 __P((const long, double*, const long, double*, const long, const double, const double));
extern void drot_64_ __P((const long*, double*, const long*, double*, const long*, const double*, const double*));
extern void dsbevd_64 __P((const char, const char, const long, const long, double*, const long, double*, double*, const long, long*));
extern void dsbevd_64_ __P((const char*, const char*, const long*, const long*, double*, const long*, double*, double*, const long*, double*, const long*, long*, const long*, long*, const long, const long));
extern void dsbevx_64 __P((const char, const char, const char, const long, const long, double*, const long, double*, const long, const double, const double, const long, const long, const double, long*, double*, double*, const long, long*, long*));
extern void dsbevx_64_ __P((const char*, const char*, const char*, const long*, const long*, double*, const long*, double*, const long*, const double*, const double*, const long*, const long*, const double*, long*, double*, double*, const long*, double*, long*, long*, long*, const long, const long, const long));
extern void dsbev_64 __P((const char, const char, const long, const long, double*, const long, double*, double*, const long, long*));
extern void dsbev_64_ __P((const char*, const char*, const long*, const long*, double*, const long*, double*, double*, const long*, double*, long*, const long, const long));
extern void dsbgst_64 __P((const char, const char, const long, const long, const long, double*, const long, const double*, const long, double*, const long, long*));
extern void dsbgst_64_ __P((const char*, const char*, const long*, const long*, const long*, double*, const long*, const double*, const long*, double*, const long*, double*, long*, const long, const long));
extern void dsbgvd_64 __P((const char, const char, const long, const long, const long, double*, const long, double*, const long, double*, double*, const long, long*));
extern void dsbgvd_64_ __P((const char*, const char*, const long*, const long*, const long*, double*, const long*, double*, const long*, double*, double*, const long*, double*, const long*, long*, const long*, long*, const long, const long));
extern void dsbgvx_64 __P((const char, const char, const char, const long, const long, const long, double*, const long, double*, const long, double*, const long, const double, const double, const long, const long, const double, long*, double*, double*, const long, long*, long*));
extern void dsbgvx_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, double*, const long*, double*, const long*, double*, const long*, const double*, const double*, const long*, const long*, const double*, long*, double*, double*, const long*, double*, long*, long*, long*, const long, const long, const long));
extern void dsbgv_64 __P((const char, const char, const long, const long, const long, double*, const long, double*, const long, double*, double*, const long, long*));
extern void dsbgv_64_ __P((const char*, const char*, const long*, const long*, const long*, double*, const long*, double*, const long*, double*, double*, const long*, double*, long*, const long, const long));
extern void dsbmv_64 __P((const char, const long, const long, const double, const double*, const long, const double*, const long, const double, double*, const long));
extern void dsbmv_64_ __P((const char*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const double*, double*, const long*, const long));
extern void dsbtrd_64 __P((const char, const char, const long, const long, double*, const long, double*, double*, double*, const long, long*));
extern void dsbtrd_64_ __P((const char*, const char*, const long*, const long*, double*, const long*, double*, double*, double*, const long*, double*, long*, const long, const long));
extern void dscal_64 __P((const long, const double, double*, const long));
extern void dscal_64_ __P((const long*, const double*, double*, const long*));
extern void dsctr_64 __P((const long, const double*, const long*, double*));
extern void dsctr_64_ __P((const long*, const double*, const long*, double*));
extern double dsdot_64 __P((const long, const float*, const long, const float*, const long));
extern double dsdot_64_ __P((const long*, const float*, const long*, const float*, const long*));
extern double dsecnd_64 __P((void));
extern double dsecnd_64_ __P((void));
extern void dsinqb_64 __P((const long, double*, const double*));
extern void dsinqb_64_ __P((const long*, double*, const double*));
extern void dsinqf_64 __P((const long, double*, const double*));
extern void dsinqf_64_ __P((const long*, double*, const double*));
extern void dsinqi_64 __P((const long, double*));
extern void dsinqi_64_ __P((const long*, double*));
extern void dsinti_64 __P((const long, double*));
extern void dsinti_64_ __P((const long*, double*));
extern void dsint_64 __P((const long, double*, double*));
extern void dsint_64_ __P((const long*, double*, double*));
extern void dskymm_64 __P((const long, const long, const long, const long, const double, const long*, const double*, const long*, const double*, const long, const double, double*, const long));
extern void dskymm_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dskysm_64 __P((const long, const long, const long, const long, const double*, const double, const long*, const double*, const long*, const double*, const long, const double, double*, const long));
extern void dskysm_64_ __P((const long*, const long*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dspcon_64 __P((const char, const long, const double*, const long*, const double, double*, long*));
extern void dspcon_64_ __P((const char*, const long*, const double*, const long*, const double*, double*, double*, long*, long*, const long));
extern void dspevd_64 __P((const char, const char, const long, double*, double*, double*, const long, long*));
extern void dspevd_64_ __P((const char*, const char*, const long*, double*, double*, double*, const long*, double*, const long*, long*, const long*, long*, const long, const long));
extern void dspevx_64 __P((const char, const char, const char, const long, double*, const double, const double, const long, const long, const double, long*, double*, double*, const long, long*, long*));
extern void dspevx_64_ __P((const char*, const char*, const char*, const long*, double*, const double*, const double*, const long*, const long*, const double*, long*, double*, double*, const long*, double*, long*, long*, long*, const long, const long, const long));
extern void dspev_64 __P((const char, const char, const long, double*, double*, double*, const long, long*));
extern void dspev_64_ __P((const char*, const char*, const long*, double*, double*, double*, const long*, double*, long*, const long, const long));
extern void dspgst_64 __P((const long, const char, const long, double*, const double*, long*));
extern void dspgst_64_ __P((const long*, const char*, const long*, double*, const double*, long*, const long));
extern void dspgvd_64 __P((const long, const char, const char, const long, double*, double*, double*, double*, const long, long*));
extern void dspgvd_64_ __P((const long*, const char*, const char*, const long*, double*, double*, double*, double*, const long*, double*, const long*, long*, const long*, long*, const long, const long));
extern void dspgvx_64 __P((const long, const char, const char, const char, const long, double*, double*, const double, const double, const long, const long, const double, long*, double*, double*, const long, long*, long*));
extern void dspgvx_64_ __P((const long*, const char*, const char*, const char*, const long*, double*, double*, const double*, const double*, const long*, const long*, const double*, long*, double*, double*, const long*, double*, long*, long*, long*, const long, const long, const long));
extern void dspgv_64 __P((const long, const char, const char, const long, double*, double*, double*, double*, const long, long*));
extern void dspgv_64_ __P((const long*, const char*, const char*, const long*, double*, double*, double*, double*, const long*, double*, long*, const long, const long));
extern void dspmv_64 __P((const char, const long, const double, const double*, const double*, const long, const double, double*, const long));
extern void dspmv_64_ __P((const char*, const long*, const double*, const double*, const double*, const long*, const double*, double*, const long*, const long));
extern void dspr2_64 __P((const char, const long, const double, const double*, const long, const double*, const long, double*));
extern void dspr2_64_ __P((const char*, const long*, const double*, const double*, const long*, const double*, const long*, double*, const long));
extern void dsprfs_64 __P((const char, const long, const long, const double*, const double*, const long*, const double*, const long, double*, const long, double*, double*, long*));
extern void dsprfs_64_ __P((const char*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, double*, const long*, double*, double*, double*, long*, long*, const long));
extern void dspr_64 __P((const char, const long, const double, const double*, const long, double*));
extern void dspr_64_ __P((const char*, const long*, const double*, const double*, const long*, double*, const long));
extern void dspsvx_64 __P((const char, const char, const long, const long, const double*, double*, long*, const double*, const long, double*, const long, double*, double*, double*, long*));
extern void dspsvx_64_ __P((const char*, const char*, const long*, const long*, const double*, double*, long*, const double*, const long*, double*, const long*, double*, double*, double*, double*, long*, long*, const long, const long));
extern void dspsv_64 __P((const char, const long, const long, double*, long*, double*, const long, long*));
extern void dspsv_64_ __P((const char*, const long*, const long*, double*, long*, double*, const long*, long*, const long));
extern void dsptrd_64 __P((const char, const long, double*, double*, double*, double*, long*));
extern void dsptrd_64_ __P((const char*, const long*, double*, double*, double*, double*, long*, const long));
extern void dsptrf_64 __P((const char, const long, double*, long*, long*));
extern void dsptrf_64_ __P((const char*, const long*, double*, long*, long*, const long));
extern void dsptri_64 __P((const char, const long, double*, const long*, long*));
extern void dsptri_64_ __P((const char*, const long*, double*, const long*, double*, long*, const long));
extern void dsptrs_64 __P((const char, const long, const long, const double*, const long*, double*, const long, long*));
extern void dsptrs_64_ __P((const char*, const long*, const long*, const double*, const long*, double*, const long*, long*, const long));
extern void dss_memerr_64 __P((const char*, const long));
extern void dss_memerr_64_ __P((const char*, const long*, const long));
extern void dstebz_64 __P((const char, const char, const long, const double, const double, const long, const long, const double, const double*, const double*, long*, long*, double*, long*, long*, long*));
extern void dstebz_64_ __P((const char*, const char*, const long*, const double*, const double*, const long*, const long*, const double*, const double*, const double*, long*, long*, double*, long*, long*, double*, long*, long*, const long, const long));
extern void dstedc_64 __P((const char, const long, double*, double*, double*, const long, long*));
extern void dstedc_64_ __P((const char*, const long*, double*, double*, double*, const long*, double*, const long*, long*, const long*, long*, const long));
extern void dstegr_64 __P((const char, const char, const long, double*, double*, const double, const double, const long, const long, const double, long*, double*, double*, const long, long*, long*));
extern void dstegr_64_ __P((const char*, const char*, const long*, double*, double*, const double*, const double*, const long*, const long*, const double*, long*, double*, double*, const long*, long*, double*, const long*, long*, const long*, long*, const long, const long));
extern void dstein_64 __P((const long, const double*, const double*, const long, const double*, const long*, const long*, double*, const long, long*, long*));
extern void dstein_64_ __P((const long*, const double*, const double*, const long*, const double*, const long*, const long*, double*, const long*, double*, long*, long*, long*));
extern void dsteqr_64 __P((const char, const long, double*, double*, double*, const long, long*));
extern void dsteqr_64_ __P((const char*, const long*, double*, double*, double*, const long*, double*, long*, const long));
extern void dsterf_64 __P((const long, double*, double*, long*));
extern void dsterf_64_ __P((const long*, double*, double*, long*));
extern void dstevd_64 __P((const char, const long, double*, double*, double*, const long, long*));
extern void dstevd_64_ __P((const char*, const long*, double*, double*, double*, const long*, double*, const long*, long*, const long*, long*, const long));
extern void dstevr_64 __P((const char, const char, const long, double*, double*, const double, const double, const long, const long, const double, long*, double*, double*, const long, long*, long*));
extern void dstevr_64_ __P((const char*, const char*, const long*, double*, double*, const double*, const double*, const long*, const long*, const double*, long*, double*, double*, const long*, long*, double*, const long*, long*, const long*, long*, const long, const long));
extern void dstevx_64 __P((const char, const char, const long, double*, double*, const double, const double, const long, const long, const double, long*, double*, double*, const long, long*, long*));
extern void dstevx_64_ __P((const char*, const char*, const long*, double*, double*, const double*, const double*, const long*, const long*, const double*, long*, double*, double*, const long*, double*, long*, long*, long*, const long, const long));
extern void dstev_64 __P((const char, const long, double*, double*, double*, const long, long*));
extern void dstev_64_ __P((const char*, const long*, double*, double*, double*, const long*, double*, long*, const long));
extern void dstsv_64 __P((const long, const long, double*, double*, double*, double*, const long, long*, long*));
extern void dstsv_64_ __P((const long*, const long*, double*, double*, double*, double*, const long*, long*, long*));
extern void dsttrf_64 __P((const long, double*, double*, double*, long*, long*));
extern void dsttrf_64_ __P((const long*, double*, double*, double*, long*, long*));
extern void dsttrs_64 __P((const long, const long, const double*, const double*, const double*, const double*, const long, long*, long*));
extern void dsttrs_64_ __P((const long*, const long*, const double*, const double*, const double*, const double*, const long*, long*, long*));
extern void dswap_64 __P((const long, double*, const long, double*, const long));
extern void dswap_64_ __P((const long*, double*, const long*, double*, const long*));
extern void dsycon_64 __P((const char, const long, const double*, const long, const long*, const double, double*, long*));
extern void dsycon_64_ __P((const char*, const long*, const double*, const long*, const long*, const double*, double*, double*, long*, long*, const long));
extern void dsyevd_64 __P((const char, const char, const long, double*, const long, double*, long*));
extern void dsyevd_64_ __P((const char*, const char*, const long*, double*, const long*, double*, double*, const long*, long*, const long*, long*, const long, const long));
extern void dsyevr_64 __P((const char, const char, const char, const long, double*, const long, const double, const double, const long, const long, const double, long*, double*, double*, const long, long*, long*));
extern void dsyevr_64_ __P((const char*, const char*, const char*, const long*, double*, const long*, const double*, const double*, const long*, const long*, const double*, long*, double*, double*, const long*, long*, double*, const long*, long*, const long*, long*, const long, const long, const long));
extern void dsyevx_64 __P((const char, const char, const char, const long, double*, const long, const double, const double, const long, const long, const double, long*, double*, double*, const long, long*, long*));
extern void dsyevx_64_ __P((const char*, const char*, const char*, const long*, double*, const long*, const double*, const double*, const long*, const long*, const double*, long*, double*, double*, const long*, double*, const long*, long*, long*, long*, const long, const long, const long));
extern void dsyev_64 __P((const char, const char, const long, double*, const long, double*, long*));
extern void dsyev_64_ __P((const char*, const char*, const long*, double*, const long*, double*, double*, const long*, long*, const long, const long));
extern void dsygs2_64 __P((const long, const char, const long, double*, const long, const double*, const long, long*));
extern void dsygs2_64_ __P((const long*, const char*, const long*, double*, const long*, const double*, const long*, long*, const long));
extern void dsygst_64 __P((const long, const char, const long, double*, const long, const double*, const long, long*));
extern void dsygst_64_ __P((const long*, const char*, const long*, double*, const long*, const double*, const long*, long*, const long));
extern void dsygvd_64 __P((const long, const char, const char, const long, double*, const long, double*, const long, double*, long*));
extern void dsygvd_64_ __P((const long*, const char*, const char*, const long*, double*, const long*, double*, const long*, double*, double*, const long*, long*, const long*, long*, const long, const long));
extern void dsygvx_64 __P((const long, const char, const char, const char, const long, double*, const long, double*, const long, const double, const double, const long, const long, const double, long*, double*, double*, const long, long*, long*));
extern void dsygvx_64_ __P((const long*, const char*, const char*, const char*, const long*, double*, const long*, double*, const long*, const double*, const double*, const long*, const long*, const double*, long*, double*, double*, const long*, double*, const long*, long*, long*, long*, const long, const long, const long));
extern void dsygv_64 __P((const long, const char, const char, const long, double*, const long, double*, const long, double*, long*));
extern void dsygv_64_ __P((const long*, const char*, const char*, const long*, double*, const long*, double*, const long*, double*, double*, const long*, long*, const long, const long));
extern void dsymm_64 __P((const char, const char, const long, const long, const double, const double*, const long, const double*, const long, const double, double*, const long));
extern void dsymm_64_ __P((const char*, const char*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const double*, double*, const long*, const long, const long));
extern void dsymv_64 __P((const char, const long, const double, const double*, const long, const double*, const long, const double, double*, const long));
extern void dsymv_64_ __P((const char*, const long*, const double*, const double*, const long*, const double*, const long*, const double*, double*, const long*, const long));
extern void dsyr2k_64 __P((const char, const char, const long, const long, const double, const double*, const long, const double*, const long, const double, double*, const long));
extern void dsyr2k_64_ __P((const char*, const char*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const double*, double*, const long*, const long, const long));
extern void dsyr2_64 __P((const char, const long, const double, const double*, const long, const double*, const long, double*, const long));
extern void dsyr2_64_ __P((const char*, const long*, const double*, const double*, const long*, const double*, const long*, double*, const long*, const long));
extern void dsyrfs_64 __P((const char, const long, const long, const double*, const long, const double*, const long, const long*, const double*, const long, double*, const long, double*, double*, long*));
extern void dsyrfs_64_ __P((const char*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const double*, const long*, double*, const long*, double*, double*, double*, long*, long*, const long));
extern void dsyrk_64 __P((const char, const char, const long, const long, const double, const double*, const long, const double, double*, const long));
extern void dsyrk_64_ __P((const char*, const char*, const long*, const long*, const double*, const double*, const long*, const double*, double*, const long*, const long, const long));
extern void dsyr_64 __P((const char, const long, const double, const double*, const long, double*, const long));
extern void dsyr_64_ __P((const char*, const long*, const double*, const double*, const long*, double*, const long*, const long));
extern void dsysvx_64 __P((const char, const char, const long, const long, const double*, const long, double*, const long, long*, const double*, const long, double*, const long, double*, double*, double*, long*));
extern void dsysvx_64_ __P((const char*, const char*, const long*, const long*, const double*, const long*, double*, const long*, long*, const double*, const long*, double*, const long*, double*, double*, double*, double*, const long*, long*, long*, const long, const long));
extern void dsysv_64 __P((const char, const long, const long, double*, const long, long*, double*, const long, long*));
extern void dsysv_64_ __P((const char*, const long*, const long*, double*, const long*, long*, double*, const long*, double*, const long*, long*, const long));
extern void dsytd2_64 __P((const char, const long, double*, const long, double*, double*, double*, long*));
extern void dsytd2_64_ __P((const char*, const long*, double*, const long*, double*, double*, double*, long*, const long));
extern void dsytf2_64 __P((const char, const long, double*, const long, long*, long*));
extern void dsytf2_64_ __P((const char*, const long*, double*, const long*, long*, long*, const long));
extern void dsytrd_64 __P((const char, const long, double*, const long, double*, double*, double*, long*));
extern void dsytrd_64_ __P((const char*, const long*, double*, const long*, double*, double*, double*, double*, const long*, long*, const long));
extern void dsytrf_64 __P((const char, const long, double*, const long, long*, long*));
extern void dsytrf_64_ __P((const char*, const long*, double*, const long*, long*, double*, const long*, long*, const long));
extern void dsytri_64 __P((const char, const long, double*, const long, const long*, long*));
extern void dsytri_64_ __P((const char*, const long*, double*, const long*, const long*, double*, long*, const long));
extern void dsytrs_64 __P((const char, const long, const long, const double*, const long, const long*, double*, const long, long*));
extern void dsytrs_64_ __P((const char*, const long*, const long*, const double*, const long*, const long*, double*, const long*, long*, const long));
extern void dtbcon_64 __P((const char, const char, const char, const long, const long, const double*, const long, double*, long*));
extern void dtbcon_64_ __P((const char*, const char*, const char*, const long*, const long*, const double*, const long*, double*, double*, long*, long*, const long, const long, const long));
extern void dtbmv_64 __P((const char, const char, const char, const long, const long, const double*, const long, double*, const long));
extern void dtbmv_64_ __P((const char*, const char*, const char*, const long*, const long*, const double*, const long*, double*, const long*, const long, const long, const long));
extern void dtbrfs_64 __P((const char, const char, const char, const long, const long, const long, const double*, const long, const double*, const long, const double*, const long, double*, double*, long*));
extern void dtbrfs_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const double*, const long*, double*, double*, double*, long*, long*, const long, const long, const long));
extern void dtbsv_64 __P((const char, const char, const char, const long, const long, const double*, const long, double*, const long));
extern void dtbsv_64_ __P((const char*, const char*, const char*, const long*, const long*, const double*, const long*, double*, const long*, const long, const long, const long));
extern void dtbtrs_64 __P((const char, const char, const char, const long, const long, const long, const double*, const long, double*, const long, long*));
extern void dtbtrs_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const double*, const long*, double*, const long*, long*, const long, const long, const long));
extern void dtgevc_64 __P((const char, const char, const long*, const long, const double*, const long, const double*, const long, double*, const long, double*, const long, const long, long*, long*));
extern void dtgevc_64_ __P((const char*, const char*, const long*, const long*, const double*, const long*, const double*, const long*, double*, const long*, double*, const long*, const long*, long*, double*, long*, const long, const long));
extern void dtgexc_64 __P((const long, const long, const long, double*, const long, double*, const long, double*, const long, double*, const long, long*, long*, long*));
extern void dtgexc_64_ __P((const long*, const long*, const long*, double*, const long*, double*, const long*, double*, const long*, double*, const long*, long*, long*, double*, const long*, long*));
extern void dtgsen_64 __P((const long, const long, const long, const long*, const long, double*, const long, double*, const long, double*, double*, double*, double*, const long, double*, const long, long*, double*, double*, double*, long*));
extern void dtgsen_64_ __P((const long*, const long*, const long*, const long*, const long*, double*, const long*, double*, const long*, double*, double*, double*, double*, const long*, double*, const long*, long*, double*, double*, double*, double*, const long*, long*, const long*, long*));
extern void dtgsja_64 __P((const char, const char, const char, const long, const long, const long, const long, const long, double*, const long, double*, const long, const double, const double, double*, double*, double*, const long, double*, const long, double*, const long, long*, long*));
extern void dtgsja_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const long*, const long*, double*, const long*, double*, const long*, const double*, const double*, double*, double*, double*, const long*, double*, const long*, double*, const long*, double*, long*, long*, const long, const long, const long));
extern void dtgsna_64 __P((const char, const char, const long*, const long, const double*, const long, const double*, const long, const double*, const long, const double*, const long, double*, double*, const long, long*, long*));
extern void dtgsna_64_ __P((const char*, const char*, const long*, const long*, const double*, const long*, const double*, const long*, const double*, const long*, const double*, const long*, double*, double*, const long*, long*, double*, const long*, long*, long*, const long, const long));
extern void dtgsyl_64 __P((const char, const long, const long, const long, const double*, const long, const double*, const long, double*, const long, const double*, const long, const double*, const long, double*, const long, double*, double*, long*));
extern void dtgsyl_64_ __P((const char*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, double*, const long*, const double*, const long*, const double*, const long*, double*, const long*, double*, double*, double*, const long*, long*, long*, const long));
extern void dtpcon_64 __P((const char, const char, const char, const long, const double*, double*, long*));
extern void dtpcon_64_ __P((const char*, const char*, const char*, const long*, const double*, double*, double*, long*, long*, const long, const long, const long));
extern void dtpmv_64 __P((const char, const char, const char, const long, const double*, double*, const long));
extern void dtpmv_64_ __P((const char*, const char*, const char*, const long*, const double*, double*, const long*, const long, const long, const long));
extern void dtprfs_64 __P((const char, const char, const char, const long, const long, const double*, const double*, const long, const double*, const long, double*, double*, long*));
extern void dtprfs_64_ __P((const char*, const char*, const char*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, double*, double*, double*, long*, long*, const long, const long, const long));
extern void dtpsv_64 __P((const char, const char, const char, const long, const double*, double*, const long));
extern void dtpsv_64_ __P((const char*, const char*, const char*, const long*, const double*, double*, const long*, const long, const long, const long));
extern void dtptri_64 __P((const char, const char, const long, double*, long*));
extern void dtptri_64_ __P((const char*, const char*, const long*, double*, long*, const long, const long));
extern void dtptrs_64 __P((const char, const char, const char, const long, const long, const double*, double*, const long, long*));
extern void dtptrs_64_ __P((const char*, const char*, const char*, const long*, const long*, const double*, double*, const long*, long*, const long, const long, const long));
extern void dtrans_64 __P((const char, const double, double*, const long, const long, double*));
extern void dtrans_64_ __P((const char*, const double*, double*, const long*, const long*, double*, const long));
extern void dtrcon_64 __P((const char, const char, const char, const long, const double*, const long, double*, long*));
extern void dtrcon_64_ __P((const char*, const char*, const char*, const long*, const double*, const long*, double*, double*, long*, long*, const long, const long, const long));
extern void dtrevc_64 __P((const char, const char, long*, const long, double*, const long, double*, const long, double*, const long, const long, long*, long*));
extern void dtrevc_64_ __P((const char*, const char*, long*, const long*, double*, const long*, double*, const long*, double*, const long*, const long*, long*, double*, long*, const long, const long));
extern void dtrexc_64 __P((const char, const long, double*, const long, double*, const long, long*, long*, long*));
extern void dtrexc_64_ __P((const char*, const long*, double*, const long*, double*, const long*, long*, long*, double*, long*, const long));
extern void dtrmm_64 __P((const char, const char, const char, const char, const long, const long, const double, const double*, const long, double*, const long));
extern void dtrmm_64_ __P((const char*, const char*, const char*, const char*, const long*, const long*, const double*, const double*, const long*, double*, const long*, const long, const long, const long, const long));
extern void dtrmv_64 __P((const char, const char, const char, const long, const double*, const long, double*, const long));
extern void dtrmv_64_ __P((const char*, const char*, const char*, const long*, const double*, const long*, double*, const long*, const long, const long, const long));
extern void dtrrfs_64 __P((const char, const char, const char, const long, const long, const double*, const long, const double*, const long, const double*, const long, double*, double*, long*));
extern void dtrrfs_64_ __P((const char*, const char*, const char*, const long*, const long*, const double*, const long*, const double*, const long*, const double*, const long*, double*, double*, double*, long*, long*, const long, const long, const long));
extern void dtrsen_64 __P((const char, const char, const long*, const long, double*, const long, double*, const long, double*, double*, long*, double*, double*, long*));
extern void dtrsen_64_ __P((const char*, const char*, const long*, const long*, double*, const long*, double*, const long*, double*, double*, long*, double*, double*, double*, const long*, long*, const long*, long*, const long, const long));
extern void dtrsm_64 __P((const char, const char, const char, const char, const long, const long, const double, const double*, const long, double*, const long));
extern void dtrsm_64_ __P((const char*, const char*, const char*, const char*, const long*, const long*, const double*, const double*, const long*, double*, const long*, const long, const long, const long, const long));
extern void dtrsna_64 __P((const char, const char, const long*, const long, const double*, const long, const double*, const long, const double*, const long, double*, double*, const long, long*, const long, long*));
extern void dtrsna_64_ __P((const char*, const char*, const long*, const long*, const double*, const long*, const double*, const long*, const double*, const long*, double*, double*, const long*, long*, double*, const long*, long*, long*, const long, const long));
extern void dtrsv_64 __P((const char, const char, const char, const long, const double*, const long, double*, const long));
extern void dtrsv_64_ __P((const char*, const char*, const char*, const long*, const double*, const long*, double*, const long*, const long, const long, const long));
extern void dtrsyl_64 __P((const char, const char, const long, const long, const long, const double*, const long, const double*, const long, double*, const long, double*, long*));
extern void dtrsyl_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, double*, const long*, double*, long*, const long, const long));
extern void dtrti2_64 __P((const char, const char, const long, double*, const long, long*));
extern void dtrti2_64_ __P((const char*, const char*, const long*, double*, const long*, long*, const long, const long));
extern void dtrtri_64 __P((const char, const char, const long, double*, const long, long*));
extern void dtrtri_64_ __P((const char*, const char*, const long*, double*, const long*, long*, const long, const long));
extern void dtrtrs_64 __P((const char, const char, const char, const long, const long, const double*, const long, double*, const long, long*));
extern void dtrtrs_64_ __P((const char*, const char*, const char*, const long*, const long*, const double*, const long*, double*, const long*, long*, const long, const long, const long));
extern void dtzrqf_64 __P((const long, const long, double*, const long, double*, long*));
extern void dtzrqf_64_ __P((const long*, const long*, double*, const long*, double*, long*));
extern void dtzrzf_64 __P((const long, const long, double*, const long, double*, long*));
extern void dtzrzf_64_ __P((const long*, const long*, double*, const long*, double*, double*, const long*, long*));
extern void dvbrmm_64 __P((const long, const long, const long, const long, const double, const long*, const double*, const long*, const long*, const long*, const long*, const long*, const long*, const double*, const long, const double, double*, const long));
extern void dvbrmm_64_ __P((const long*, const long*, const long*, const long*, const double*, const long*, const double*, const long*, const long*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dvbrsm_64 __P((const long, const long, const long, const long, const double*, const double, const long*, const double*, const long*, const long*, const long*, const long*, const long*, const long*, const double*, const long, const double, double*, const long));
extern void dvbrsm_64_ __P((const long*, const long*, const long*, const long*, const double*, const double*, const long*, const double*, const long*, const long*, const long*, const long*, const long*, const long*, const double*, const long*, const double*, double*, const long*, double*, const long*));
extern void dwiener_64 __P((const long, const double*, const double*, double*, const double*, long*, long*));
extern void dwiener_64_ __P((const long*, const double*, const double*, double*, const double*, long*, long*));
extern double dzasum_64 __P((const long, const doublecomplex*, const long));
extern double dzasum_64_ __P((const long*, const doublecomplex*, const long*));
extern double dznrm2_64 __P((const long, const doublecomplex*, const long));
extern double dznrm2_64_ __P((const long*, const doublecomplex*, const long*));
extern void ezfftb_64 __P((const long, float*, const float, const float*, const float*, const float*));
extern void ezfftb_64_ __P((const long*, float*, const float*, const float*, const float*, const float*));
extern void ezfftf_64 __P((const long, const float*, float*, float*, float*, const float*));
extern void ezfftf_64_ __P((const long*, const float*, float*, float*, float*, const float*));
extern void ezffti_64 __P((const long, float*));
extern void ezffti_64_ __P((const long*, float*));
extern long icamax_64 __P((const long, const floatcomplex*, const long));
extern long icamax_64_ __P((const long*, const floatcomplex*, const long*));
extern long idamax_64 __P((const long, const double*, const long));
extern long idamax_64_ __P((const long*, const double*, const long*));
extern long ieeeck_64 __P((const long, const float, const float));
extern long ieeeck_64_ __P((const long*, const float*, const float*));
extern long ilaenv_64 __P((const long, const char*, const char*, const long, const long, const long, const long));
extern long ilaenv_64_ __P((const long*, const char*, const char*, const long*, const long*, const long*, const long*, const long, const long));
extern long isamax_64 __P((const long, const float*, const long));
extern long isamax_64_ __P((const long*, const float*, const long*));
extern long izamax_64 __P((const long, const doublecomplex*, const long));
extern long izamax_64_ __P((const long*, const doublecomplex*, const long*));
extern long lsame_64 __P((const char, const char));
extern long lsame_64_ __P((const char*, const char*, const long, const long));
extern void rfft2b_64 __P((const char, const long, const long, float*, const long, float*, const long, float*, const long));
extern void rfft2b_64_ __P((const char*, const long*, const long*, float*, const long*, float*, const long*, float*, const long*, const long));
extern void rfft2f_64 __P((const char, const char, const long, const long, float*, const long, float*, const long, float*, const long));
extern void rfft2f_64_ __P((const char*, const char*, const long*, const long*, float*, const long*, float*, const long*, float*, const long*, const long, const long));
extern void rfft2i_64 __P((const long, const long, float*));
extern void rfft2i_64_ __P((const long*, const long*, float*));
extern void rfft3b_64 __P((const char, const long, const long, const long, float*, const long, float*, const long, float*, const long));
extern void rfft3b_64_ __P((const char*, const long*, const long*, const long*, float*, const long*, float*, const long*, float*, const long*, const long));
extern void rfft3f_64 __P((const char, const char, const long, const long, const long, float*, const long, float*, const long, float*, const long));
extern void rfft3f_64_ __P((const char*, const char*, const long*, const long*, const long*, float*, const long*, float*, const long*, float*, const long*, const long, const long));
extern void rfft3i_64 __P((const long, const long, const long, float*));
extern void rfft3i_64_ __P((const long*, const long*, const long*, float*));
extern void rfftb_64 __P((const long, float*, const float*));
extern void rfftb_64_ __P((const long*, float*, const float*));
extern void rfftf_64 __P((const long, float*, const float*));
extern void rfftf_64_ __P((const long*, float*, const float*));
extern void rffti_64 __P((const long, float*));
extern void rffti_64_ __P((const long*, float*));
extern long rfftopt_64 __P((const long));
extern long rfftopt_64_ __P((const long*));
extern float sasum_64 __P((const long, const float*, const long));
extern float sasum_64_ __P((const long*, const float*, const long*));
extern void saxpyi_64 __P((const long, const float, const float*, const long*, float*));
extern void saxpyi_64_ __P((const long*, const float*, const float*, const long*, float*));
extern void saxpy_64 __P((const long, const float, const float*, const long, float*, const long));
extern void saxpy_64_ __P((const long*, const float*, const float*, const long*, float*, const long*));
extern void sbcomm_64 __P((const long, const long, const long, const long, const float, const long*, const float*, const long*, const long*, const long, const long, const float*, const long, const float, float*, const long));
extern void sbcomm_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sbdimm_64 __P((const long, const long, const long, const long, const float, const long*, const float*, const long, const long*, const long, const long, const float*, const long, const float, float*, const long));
extern void sbdimm_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sbdism_64 __P((const long, const long, const long, const long, const float*, const float, const long*, const float*, const long, const long*, const long, const long, const float*, const long, const float, float*, const long));
extern void sbdism_64_ __P((const long*, const long*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sbdsdc_64 __P((const char, const char, const long, float*, float*, float*, const long, float*, const long, float*, long*, long*));
extern void sbdsdc_64_ __P((const char*, const char*, const long*, float*, float*, float*, const long*, float*, const long*, float*, long*, float*, long*, long*, const long, const long));
extern void sbdsqr_64 __P((const char, const long, const long, const long, const long, float*, float*, float*, const long, float*, const long, float*, const long, long*));
extern void sbdsqr_64_ __P((const char*, const long*, const long*, const long*, const long*, float*, float*, float*, const long*, float*, const long*, float*, const long*, float*, long*, const long));
extern void sbelmm_64 __P((const long, const long, const long, const long, const float, const long*, const float*, const long*, const long, const long, const long, const float*, const long, const float, float*, const long));
extern void sbelmm_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sbelsm_64 __P((const long, const long, const long, const long, const float*, const float, const long*, const float*, const long*, const long, const long, const long, const float*, const long, const float, float*, const long));
extern void sbelsm_64_ __P((const long*, const long*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sbscmm_64 __P((const long, const long, const long, const long, const float, const long*, const float*, const long*, const long*, const long*, const long, const float*, const long, const float, float*, const long));
extern void sbscmm_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sbscsm_64 __P((const long, const long, const long, const long, const float*, const float, const long*, const float*, const long*, const long*, const long*, const long, const float*, const long, const float, float*, const long));
extern void sbscsm_64_ __P((const long*, const long*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sbsrmm_64 __P((const long, const long, const long, const long, const float, const long*, const float*, const long*, const long*, const long*, const long, const float*, const long, const float, float*, const long));
extern void sbsrmm_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sbsrsm_64 __P((const long, const long, const long, const long, const float*, const float, const long*, const float*, const long*, const long*, const long*, const long, const float*, const long, const float, float*, const long));
extern void sbsrsm_64_ __P((const long*, const long*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern float scasum_64 __P((const long, const floatcomplex*, const long));
extern float scasum_64_ __P((const long*, const floatcomplex*, const long*));
extern float scnrm2_64 __P((const long, const floatcomplex*, const long));
extern float scnrm2_64_ __P((const long*, const floatcomplex*, const long*));
extern void scnvcor2_64 __P((const char, const char, const char, const char, const char, const char, const long, const long, const float*, const long, const long, const long, const long, const long, const float*, const long, const long, const long, float*, const long, floatcomplex*, const long));
extern void scnvcor2_64_ __P((const char*, const char*, const char*, const char*, const char*, const char*, const long*, const long*, const float*, const long*, const long*, const long*, const long*, const long*, const float*, const long*, const long*, const long*, float*, const long*, floatcomplex*, const long*, const long, const long, const long, const long, const long, const long));
extern void scnvcor_64 __P((const char, const char, const long, const float*, const long, const long, const long, const long, const long, const float*, const long, const long, const long, const long, const long, float*, const long, const long, const long, float*, const long));
extern void scnvcor_64_ __P((const char*, const char*, const long*, const float*, const long*, const long*, const long*, const long*, const long*, const float*, const long*, const long*, const long*, const long*, const long*, float*, const long*, const long*, const long*, float*, const long*, const long, const long));
extern void scoomm_64 __P((const long, const long, const long, const long, const float, const long*, const float*, const long*, const long*, const long, const float*, const long, const float, float*, const long));
extern void scoomm_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void scopy_64 __P((const long, const float*, const long, float*, const long));
extern void scopy_64_ __P((const long*, const float*, const long*, float*, const long*));
extern void scscmm_64 __P((const long, const long, const long, const long, const float, const long*, const float*, const long*, const long*, const long*, const float*, const long, const float, float*, const long));
extern void scscmm_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void scscsm_64 __P((const long, const long, const long, const long, const float*, const float, const long*, const float*, const long*, const long*, const long*, const float*, const long, const float, float*, const long));
extern void scscsm_64_ __P((const long*, const long*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void scsrmm_64 __P((const long, const long, const long, const long, const float, const long*, const float*, const long*, const long*, const long*, const float*, const long, const float, float*, const long));
extern void scsrmm_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void scsrsm_64 __P((const long, const long, const long, const long, const float*, const float, const long*, const float*, const long*, const long*, const long*, const float*, const long, const float, float*, const long));
extern void scsrsm_64_ __P((const long*, const long*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sdiamm_64 __P((const long, const long, const long, const long, const float, const long*, const float*, const long, const long*, const long, const float*, const long, const float, float*, const long));
extern void sdiamm_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sdiasm_64 __P((const long, const long, const long, const long, const float*, const float, const long*, const float*, const long, const long*, const long, const float*, const long, const float, float*, const long));
extern void sdiasm_64_ __P((const long*, const long*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sdisna_64 __P((const char, const long, const long, const float*, float*, long*));
extern void sdisna_64_ __P((const char*, const long*, const long*, const float*, float*, long*, const long));
extern float sdoti_64 __P((const long, const float*, const long*, const float*));
extern float sdoti_64_ __P((const long*, const float*, const long*, const float*));
extern float sdot_64 __P((const long, const float*, const long, const float*, const long));
extern float sdot_64_ __P((const long*, const float*, const long*, const float*, const long*));
extern float sdsdot_64 __P((const long, const float, const float*, const long, const float*, const long));
extern float sdsdot_64_ __P((const long*, const float*, const float*, const long*, const float*, const long*));
extern float second_64 __P((void));
extern float second_64_ __P((void));
extern void sellmm_64 __P((const long, const long, const long, const long, const float, const long*, const float*, const long*, const long, const long, const float*, const long, const float, float*, const long));
extern void sellmm_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sellsm_64 __P((const long, const long, const long, const long, const float*, const float, const long*, const float*, const long*, const long, const long, const float*, const long, const float, float*, const long));
extern void sellsm_64_ __P((const long*, const long*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sfftc2_64_ __P((const long*, const long*, const long*, const float*, const float*, const long*, floatcomplex*, const long*, float*, long*, float*, const long*, long*));
extern void sfftc3_64_ __P((const long*, const long*, const long*, const long*, const float*, const float*, const long*, const long*, floatcomplex*, const long*, const long*, float*, long*, float*, const long*, long*));
extern void sfftcm_64_ __P((const long*, const long*, const long*, const float*, const float*, const long*, floatcomplex*, const long*, float*, long*, float*, const long*, long*));
extern void sfftc_64_ __P((const long*, const long*, const float*, const float*, floatcomplex*, float*, long*, float*, const long*, long*));
extern void sgbbrd_64 __P((const char, const long, const long, const long, const long, const long, float*, const long, float*, float*, float*, const long, float*, const long, float*, const long, long*));
extern void sgbbrd_64_ __P((const char*, const long*, const long*, const long*, const long*, const long*, float*, const long*, float*, float*, float*, const long*, float*, const long*, float*, const long*, float*, long*, const long));
extern void sgbcon_64 __P((const char, const long, const long, const long, const float*, const long, const long*, const float, float*, long*));
extern void sgbcon_64_ __P((const char*, const long*, const long*, const long*, const float*, const long*, const long*, const float*, float*, float*, long*, long*, const long));
extern void sgbequ_64 __P((const long, const long, const long, const long, const float*, const long, float*, float*, float*, float*, float*, long*));
extern void sgbequ_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, float*, float*, float*, float*, float*, long*));
extern void sgbmv_64 __P((const char, const long, const long, const long, const long, const float, const float*, const long, const float*, const long, const float, float*, const long));
extern void sgbmv_64_ __P((const char*, const long*, const long*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const float*, float*, const long*, const long));
extern void sgbrfs_64 __P((const char, const long, const long, const long, const long, const float*, const long, const float*, const long, const long*, const float*, const long, float*, const long, float*, float*, long*));
extern void sgbrfs_64_ __P((const char*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const float*, const long*, float*, const long*, float*, float*, float*, long*, long*, const long));
extern void sgbsvx_64 __P((const char, const char, const long, const long, const long, const long, float*, const long, float*, const long, long*, char*, float*, float*, float*, const long, float*, const long, float*, float*, float*, long*));
extern void sgbsvx_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, float*, const long*, float*, const long*, long*, char*, float*, float*, float*, const long*, float*, const long*, float*, float*, float*, float*, long*, long*, const long, const long, const long));
extern void sgbsv_64 __P((const long, const long, const long, const long, float*, const long, long*, float*, const long, long*));
extern void sgbsv_64_ __P((const long*, const long*, const long*, const long*, float*, const long*, long*, float*, const long*, long*));
extern void sgbtf2_64 __P((const long, const long, const long, const long, float*, const long, long*, long*));
extern void sgbtf2_64_ __P((const long*, const long*, const long*, const long*, float*, const long*, long*, long*));
extern void sgbtrf_64 __P((const long, const long, const long, const long, float*, const long, long*, long*));
extern void sgbtrf_64_ __P((const long*, const long*, const long*, const long*, float*, const long*, long*, long*));
extern void sgbtrs_64 __P((const char, const long, const long, const long, const long, const float*, const long, const long*, float*, const long, long*));
extern void sgbtrs_64_ __P((const char*, const long*, const long*, const long*, const long*, const float*, const long*, const long*, float*, const long*, long*, const long));
extern void sgebak_64 __P((const char, const char, const long, const long, const long, const float*, const long, float*, const long, long*));
extern void sgebak_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const long*, float*, const long*, long*, const long, const long));
extern void sgebal_64 __P((const char, const long, float*, const long, long*, long*, float*, long*));
extern void sgebal_64_ __P((const char*, const long*, float*, const long*, long*, long*, float*, long*, const long));
extern void sgebrd_64 __P((const long, const long, float*, const long, float*, float*, float*, float*, long*));
extern void sgebrd_64_ __P((const long*, const long*, float*, const long*, float*, float*, float*, float*, float*, const long*, long*));
extern void sgecon_64 __P((const char, const long, const float*, const long, const float, float*, long*));
extern void sgecon_64_ __P((const char*, const long*, const float*, const long*, const float*, float*, float*, long*, long*, const long));
extern void sgeequ_64 __P((const long, const long, const float*, const long, float*, float*, float*, float*, float*, long*));
extern void sgeequ_64_ __P((const long*, const long*, const float*, const long*, float*, float*, float*, float*, float*, long*));
extern void sgeesx_64 __P((const char, const char, const long(*select)(float,float), const char, const long, float*, const long, long*, float*, float*, float*, const long, float*, float*, long*));
extern void sgeesx_64_ __P((const char*, const char*, const long(*select)(float,float), const char*, const long*, float*, const long*, long*, float*, float*, float*, const long*, float*, float*, float*, const long*, long*, const long*, long*, long*, const long, const long, const long));
extern void sgees_64 __P((const char, const char, const long(*select)(float,float), const long, float*, const long, long*, float*, float*, float*, const long, long*));
extern void sgees_64_ __P((const char*, const char*, const long(*select)(float,float), const long*, float*, const long*, long*, float*, float*, float*, const long*, float*, const long*, long*, long*, const long, const long));
extern void sgeevx_64 __P((const char, const char, const char, const char, const long, float*, const long, float*, float*, float*, const long, float*, const long, long*, long*, float*, float*, float*, float*, long*));
extern void sgeevx_64_ __P((const char*, const char*, const char*, const char*, const long*, float*, const long*, float*, float*, float*, const long*, float*, const long*, long*, long*, float*, float*, float*, float*, double*, const long*, long*, long*, const long, const long, const long, const long));
extern void sgeev_64 __P((const char, const char, const long, float*, const long, float*, float*, float*, const long, float*, const long, long*));
extern void sgeev_64_ __P((const char*, const char*, const long*, float*, const long*, float*, float*, float*, const long*, float*, const long*, float*, const long*, long*, const long, const long));
extern void sgegs_64 __P((const char, const char, const long, float*, const long, float*, const long, float*, float*, float*, float*, const long, float*, const long, long*));
extern void sgegs_64_ __P((const char*, const char*, const long*, float*, const long*, float*, const long*, float*, float*, float*, float*, const long*, float*, const long*, float*, const long*, long*, const long, const long));
extern void sgegv_64 __P((const char, const char, const long, float*, const long, float*, const long, float*, float*, float*, float*, const long, float*, const long, long*));
extern void sgegv_64_ __P((const char*, const char*, const long*, float*, const long*, float*, const long*, float*, float*, float*, float*, const long*, float*, const long*, float*, const long*, long*, const long, const long));
extern void sgehrd_64 __P((const long, const long, const long, float*, const long, float*, long*));
extern void sgehrd_64_ __P((const long*, const long*, const long*, float*, const long*, float*, float*, const long*, long*));
extern void sgelqf_64 __P((const long, const long, float*, const long, float*, long*));
extern void sgelqf_64_ __P((const long*, const long*, float*, const long*, float*, float*, const long*, long*));
extern void sgelsd_64 __P((const long, const long, const long, float*, const long, float*, const long, float*, const float, long*, long*));
extern void sgelsd_64_ __P((const long*, const long*, const long*, float*, const long*, float*, const long*, float*, const float*, long*, float*, const long*, long*, long*));
extern void sgelss_64 __P((const long, const long, const long, float*, const long, float*, const long, float*, const float, long*, long*));
extern void sgelss_64_ __P((const long*, const long*, const long*, float*, const long*, float*, const long*, float*, const float*, long*, float*, const long*, long*));
extern void sgelsx_64 __P((const long, const long, const long, float*, const long, float*, const long, long*, const float, long*, long*));
extern void sgelsx_64_ __P((const long*, const long*, const long*, float*, const long*, float*, const long*, long*, const float*, long*, float*, long*));
extern void sgelsy_64 __P((const long, const long, const long, float*, const long, float*, const long, long*, const float, long*, long*));
extern void sgelsy_64_ __P((const long*, const long*, const long*, float*, const long*, float*, const long*, long*, const float*, long*, float*, const long*, long*));
extern void sgels_64 __P((const char, const long, const long, const long, float*, const long, float*, const long, long*));
extern void sgels_64_ __P((const char*, const long*, const long*, const long*, float*, const long*, float*, const long*, float*, const long*, long*, const long));
extern void sgemm_64 __P((const char, const char, const long, const long, const long, const float, const float*, const long, const float*, const long, const float, float*, const long));
extern void sgemm_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const float*, float*, const long*, const long, const long));
extern void sgemv_64 __P((const char, const long, const long, const float, const float*, const long, const float*, const long, const float, float*, const long));
extern void sgemv_64_ __P((const char*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const float*, float*, const long*, const long));
extern void sgeqlf_64 __P((const long, const long, float*, const long, float*, long*));
extern void sgeqlf_64_ __P((const long*, const long*, float*, const long*, float*, float*, const long*, long*));
extern void sgeqp3_64 __P((const long, const long, float*, const long, long*, float*, long*));
extern void sgeqp3_64_ __P((const long*, const long*, float*, const long*, long*, float*, float*, const long*, long*));
extern void sgeqpf_64 __P((const long, const long, float*, const long, long*, float*, long*));
extern void sgeqpf_64_ __P((const long*, const long*, float*, const long*, long*, float*, float*, long*));
extern void sgeqrf_64 __P((const long, const long, float*, const long, float*, long*));
extern void sgeqrf_64_ __P((const long*, const long*, float*, const long*, float*, float*, const long*, long*));
extern void sgerfs_64 __P((const char, const long, const long, const float*, const long, const float*, const long, const long*, const float*, const long, float*, const long, float*, float*, long*));
extern void sgerfs_64_ __P((const char*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const float*, const long*, float*, const long*, float*, float*, float*, long*, long*, const long));
extern void sgerqf_64 __P((const long, const long, float*, const long, float*, long*));
extern void sgerqf_64_ __P((const long*, const long*, float*, const long*, float*, float*, const long*, long*));
extern void sger_64 __P((const long, const long, const float, const float*, const long, const float*, const long, float*, const long));
extern void sger_64_ __P((const long*, const long*, const float*, const float*, const long*, const float*, const long*, float*, const long*));
extern void sgesdd_64 __P((const char, const long, const long, float*, const long, float*, float*, const long, float*, const long, long*));
extern void sgesdd_64_ __P((const char*, const long*, const long*, float*, const long*, float*, float*, const long*, float*, const long*, float*, const long*, long*, long*, const long));
extern void sgesvd_64 __P((const char, const char, const long, const long, float*, const long, float*, float*, const long, float*, const long, long*));
extern void sgesvd_64_ __P((const char*, const char*, const long*, const long*, float*, const long*, float*, float*, const long*, float*, const long*, float*, const long*, long*, const long, const long));
extern void sgesvx_64 __P((const char, const char, const long, const long, float*, const long, float*, const long, long*, char*, float*, float*, float*, const long, float*, const long, float*, float*, float*, long*));
extern void sgesvx_64_ __P((const char*, const char*, const long*, const long*, float*, const long*, float*, const long*, long*, char*, float*, float*, float*, const long*, float*, const long*, float*, float*, float*, float*, long*, long*, const long, const long, const long));
extern void sgesv_64 __P((const long, const long, float*, const long, long*, float*, const long, long*));
extern void sgesv_64_ __P((const long*, const long*, float*, const long*, long*, float*, const long*, long*));
extern void sgetf2_64 __P((const long, const long, float*, const long, long*, long*));
extern void sgetf2_64_ __P((const long*, const long*, float*, const long*, long*, long*));
extern void sgetrf_64 __P((const long, const long, float*, const long, long*, long*));
extern void sgetrf_64_ __P((const long*, const long*, float*, const long*, long*, long*));
extern void sgetri_64 __P((const long, float*, const long, const long*, long*));
extern void sgetri_64_ __P((const long*, float*, const long*, const long*, float*, const long*, long*));
extern void sgetrs_64 __P((const char, const long, const long, const float*, const long, const long*, float*, const long, long*));
extern void sgetrs_64_ __P((const char*, const long*, const long*, const float*, const long*, const long*, float*, const long*, long*, const long));
extern void sggbak_64 __P((const char, const char, const long, const long, const long, const float*, const float*, const long, float*, const long, long*));
extern void sggbak_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const float*, const long*, float*, const long*, long*, const long, const long));
extern void sggbal_64 __P((const char, const long, float*, const long, float*, const long, long*, long*, const float*, const float*, long*));
extern void sggbal_64_ __P((const char*, const long*, float*, const long*, float*, const long*, long*, long*, const float*, const float*, float*, long*, const long));
extern void sggesx_64 __P((const char, const char, const char, const long(*selctg)(float,float,float), const char, const long, float*, const long, float*, const long, long*, float*, float*, float*, float*, const long, float*, const long, float*, float*, long*));
extern void sggesx_64_ __P((const char*, const char*, const char*, const long(*selctg)(float,float,float), const char*, const long*, float*, const long*, float*, const long*, long*, float*, float*, float*, float*, const long*, float*, const long*, float*, float*, float*, const long*, long*, const long*, long*, long*, const long, const long, const long, const long));
extern void sgges_64 __P((const char, const char, const char, const long(*selctg)(float,float,float), const long, float*, const long, float*, const long, long*, float*, float*, float*, float*, const long, float*, const long, long*));
extern void sgges_64_ __P((const char*, const char*, const char*, const long(*selctg)(float,float,float), const long*, float*, const long*, float*, const long*, long*, float*, float*, float*, float*, const long*, float*, const long*, float*, const long*, long*, long*, const long, const long, const long));
extern void sggevx_64 __P((const char, const char, const char, const char, const long, float*, const long, float*, const long, float*, float*, float*, float*, const long, float*, const long, long*, long*, float*, float*, float*, float*, float*, float*, long*));
extern void sggevx_64_ __P((const char*, const char*, const char*, const char*, const long*, float*, const long*, float*, const long*, float*, float*, float*, float*, const long*, float*, const long*, long*, long*, float*, float*, float*, float*, float*, float*, float*, const long*, long*, long*, long*, const long, const long, const long, const long));
extern void sggev_64 __P((const char, const char, const long, float*, const long, float*, const long, float*, float*, float*, float*, const long, float*, const long, long*));
extern void sggev_64_ __P((const char*, const char*, const long*, float*, const long*, float*, const long*, float*, float*, float*, float*, const long*, float*, const long*, float*, const long*, long*, const long, const long));
extern void sggglm_64 __P((const long, const long, const long, float*, const long, float*, const long, float*, float*, float*, long*));
extern void sggglm_64_ __P((const long*, const long*, const long*, float*, const long*, float*, const long*, float*, float*, float*, float*, const long*, long*));
extern void sgghrd_64 __P((const char, const char, const long, const long, const long, float*, const long, float*, const long, float*, const long, float*, const long, long*));
extern void sgghrd_64_ __P((const char*, const char*, const long*, const long*, const long*, float*, const long*, float*, const long*, float*, const long*, float*, const long*, long*, const long, const long));
extern void sgglse_64 __P((const long, const long, const long, float*, const long, float*, const long, float*, float*, float*, long*));
extern void sgglse_64_ __P((const long*, const long*, const long*, float*, const long*, float*, const long*, float*, float*, float*, float*, const long*, long*));
extern void sggqrf_64 __P((const long, const long, const long, float*, const long, float*, float*, const long, float*, long*));
extern void sggqrf_64_ __P((const long*, const long*, const long*, float*, const long*, float*, float*, const long*, float*, float*, const long*, long*));
extern void sggrqf_64 __P((const long, const long, const long, float*, const long, float*, float*, const long, float*, long*));
extern void sggrqf_64_ __P((const long*, const long*, const long*, float*, const long*, float*, float*, const long*, float*, float*, const long*, long*));
extern void sggsvd_64 __P((const char, const char, const char, const long, const long, const long, long*, long*, float*, const long, float*, const long, float*, float*, float*, const long, float*, const long, float*, const long, long*, long*));
extern void sggsvd_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, long*, long*, float*, const long*, float*, const long*, float*, float*, float*, const long*, float*, const long*, float*, const long*, float*, long*, long*, const long, const long, const long));
extern void sggsvp_64 __P((const char, const char, const char, const long, const long, const long, float*, const long, float*, const long, const float, const float, long*, long*, float*, const long, float*, const long, float*, const long, long*));
extern void sggsvp_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, float*, const long*, float*, const long*, const float*, const float*, long*, long*, float*, const long*, float*, const long*, float*, const long*, long*, float*, float*, long*, const long, const long, const long));
extern void sgssco_64_ __P((float*, double*, long*));
extern void sgssda_64_ __P((double*, long*));
extern void sgssfa_64_ __P((const long*, const long*, const long*, const float*, double*, long*));
extern void sgssfs_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const long*, float*, const long*, const char*, const long*, const long*, double*, long*, const long, const long, const long));
extern void sgssin_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const long*, double*, long*, const long, const long));
extern void sgssor_64_ __P((const char*, double*, long*, const long));
extern void sgssps_64_ __P((double*, long*));
extern void sgssrp_64_ __P((long*, double*, long*));
extern void sgsssl_64_ __P((const long*, float*, const long*, double*, long*));
extern void sgssuo_64_ __P((const long*, double*, long*));
extern void sgtcon_64 __P((const char, const long, const float*, const float*, const float*, const float*, const long*, const float, float*, long*));
extern void sgtcon_64_ __P((const char*, const long*, const float*, const float*, const float*, const float*, const long*, const float*, float*, float*, long*, long*, const long));
extern void sgthrz_64 __P((const long, float*, float*, const long*));
extern void sgthrz_64_ __P((const long*, float*, float*, const long*));
extern void sgthr_64 __P((const long, const float*, float*, const long*));
extern void sgthr_64_ __P((const long*, const float*, float*, const long*));
extern void sgtrfs_64 __P((const char, const long, const long, const float*, const float*, const float*, const float*, const float*, const float*, const float*, const long*, const float*, const long, float*, const long, float*, float*, long*));
extern void sgtrfs_64_ __P((const char*, const long*, const long*, const float*, const float*, const float*, const float*, const float*, const float*, const float*, const long*, const float*, const long*, float*, const long*, float*, float*, float*, long*, long*, const long));
extern void sgtsvx_64 __P((const char, const char, const long, const long, const float*, const float*, float*, float*, float*, float*, float*, long*, const float*, const long, float*, const long, float*, float*, float*, long*));
extern void sgtsvx_64_ __P((const char*, const char*, const long*, const long*, const float*, const float*, float*, float*, float*, float*, float*, long*, const float*, const long*, float*, const long*, float*, float*, float*, float*, long*, long*, const long, const long));
extern void sgtsv_64 __P((const long, const long, float*, float*, float*, float*, const long, long*));
extern void sgtsv_64_ __P((const long*, const long*, float*, float*, float*, float*, const long*, long*));
extern void sgttrf_64 __P((const long, float*, float*, float*, float*, long*, long*));
extern void sgttrf_64_ __P((const long*, float*, float*, float*, float*, long*, long*));
extern void sgttrs_64 __P((const char, const long, const long, const float*, const float*, const float*, const float*, const long*, float*, const long, long*));
extern void sgttrs_64_ __P((const char*, const long*, const long*, const float*, const float*, const float*, const float*, const long*, float*, const long*, long*, const long));
extern void shgeqz_64 __P((const char, const char, const char, const long, const long, const long, float*, const long, float*, const long, float*, float*, float*, float*, const long, float*, const long, long*));
extern void shgeqz_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, float*, const long*, float*, const long*, float*, float*, float*, float*, const long*, float*, const long*, float*, const long*, long*, const long, const long, const long));
extern void shsein_64 __P((const char, const char, const char, long*, const long, const float*, const long, float*, const float*, float*, const long, float*, const long, const long, long*, long*, long*, long*));
extern void shsein_64_ __P((const char*, const char*, const char*, long*, const long*, const float*, const long*, float*, const float*, float*, const long*, float*, const long*, const long*, long*, float*, long*, long*, long*, const long, const long, const long));
extern void shseqr_64 __P((const char, const char, const long, const long, const long, float*, const long, float*, float*, float*, const long, long*));
extern void shseqr_64_ __P((const char*, const char*, const long*, const long*, const long*, float*, const long*, float*, float*, float*, const long*, float*, const long*, long*, const long, const long));
extern void sinqb_64 __P((const long, float*, const float*));
extern void sinqb_64_ __P((const long*, float*, const float*));
extern void sinqf_64 __P((const long, float*, const float*));
extern void sinqf_64_ __P((const long*, float*, const float*));
extern void sinqi_64 __P((const long, float*));
extern void sinqi_64_ __P((const long*, float*));
extern void sinti_64 __P((const long, float*));
extern void sinti_64_ __P((const long*, float*));
extern void sint_64 __P((const long, float*, float*));
extern void sint_64_ __P((const long*, float*, float*));
extern void sjadmm_64 __P((const long, const long, const long, const long, const float, const long*, const float*, const long*, const long*, const long, const long*, const float*, const long, const float, float*, const long));
extern void sjadmm_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sjadrp_64 __P((const long, const long, const long, const float*, const long*, long*, const long, const long*));
extern void sjadrp_64_ __P((const long*, const long*, const long*, const float*, const long*, long*, const long*, const long*, long*, const long*));
extern void sjadsm_64 __P((const long, const long, const long, const long, const float*, const float, const long*, const float*, const long*, const long*, const long, const long*, const float*, const long, const float, float*, const long));
extern void sjadsm_64_ __P((const long*, const long*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sladiv_64 __P((const float, const float, const float, const float, float*, float*));
extern void sladiv_64_ __P((const float*, const float*, const float*, const float*, float*, float*));
extern void slaeda_64 __P((const long, const long, const long, const long, const long*, const long*, const long*, const long*, const float*, const float*, const long*, float*, long*));
extern void slaeda_64_ __P((const long*, const long*, const long*, const long*, const long*, const long*, const long*, const long*, const float*, const float*, const long*, float*, float*, long*));
extern void slagtf_64 __P((const long, float*, const float, float*, float*, const float, float*, long*, long*));
extern void slagtf_64_ __P((const long*, float*, const float*, float*, float*, const float*, float*, long*, long*));
extern float slamch_64 __P((const char));
extern float slamch_64_ __P((const char*, const long));
extern void slamrg_64 __P((const long, const long, const float*, const long, const long, long*));
extern void slamrg_64_ __P((const long*, const long*, const float*, const long*, const long*, long*));
extern void slanv2_64 __P((float*, float*, float*, float*, float*, float*, float*, float*, float*, float*));
extern void slanv2_64_ __P((float*, float*, float*, float*, float*, float*, float*, float*, float*, float*));
extern void slarzb_64 __P((const char, const char, const char, const char, const long, const long, const long, const long, const float*, const long, const float*, const long, float*, const long, const long));
extern void slarzb_64_ __P((const char*, const char*, const char*, const char*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, float*, const long*, float*, const long*, const long, const long, const long, const long));
extern void slarzt_64 __P((const char, const char, const long, const long, const float*, const long, const float*, float*, const long));
extern void slarzt_64_ __P((const char*, const char*, const long*, const long*, const float*, const long*, const float*, float*, const long*, const long, const long));
extern void slarz_64 __P((const char, const long, const long, const long, const float*, const long, const float, float*, const long));
extern void slarz_64_ __P((const char*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long));
extern void slasq1_64 __P((const long, float*, float*, long*));
extern void slasq1_64_ __P((const long*, float*, float*, float*, long*));
extern void slasq2_64 __P((const long, float*, long*));
extern void slasq2_64_ __P((const long*, float*, long*));
extern void slasrt_64 __P((const char, const long, float*, long*));
extern void slasrt_64_ __P((const char*, const long*, float*, long*, const long));
extern void slatzm_64 __P((const char, const long, const long, const float*, const long, const float, float*, float*, const long));
extern void slatzm_64_ __P((const char*, const long*, const long*, const float*, const long*, const float*, float*, float*, const long*, float*, const long));
extern float snrm2_64 __P((const long, const float*, const long));
extern float snrm2_64_ __P((const long*, const float*, const long*));
extern void sopgtr_64 __P((const char, const long, const float*, const float*, float*, const long, long*));
extern void sopgtr_64_ __P((const char*, const long*, const float*, const float*, float*, const long*, float*, long*, const long));
extern void sopmtr_64 __P((const char, const char, const char, const long, const long, const float*, const float*, float*, const long, long*));
extern void sopmtr_64_ __P((const char*, const char*, const char*, const long*, const long*, const float*, const float*, float*, const long*, float*, long*, const long, const long, const long));
extern void sorg2l_64 __P((const long, const long, const long, float*, const long, const float*, long*));
extern void sorg2l_64_ __P((const long*, const long*, const long*, float*, const long*, const float*, float*, long*));
extern void sorg2r_64 __P((const long, const long, const long, float*, const long, const float*, long*));
extern void sorg2r_64_ __P((const long*, const long*, const long*, float*, const long*, const float*, float*, long*));
extern void sorgbr_64 __P((const char, const long, const long, const long, float*, const long, const float*, long*));
extern void sorgbr_64_ __P((const char*, const long*, const long*, const long*, float*, const long*, const float*, float*, const long*, long*, const long));
extern void sorghr_64 __P((const long, const long, const long, float*, const long, const float*, long*));
extern void sorghr_64_ __P((const long*, const long*, const long*, float*, const long*, const float*, float*, const long*, long*));
extern void sorgl2_64 __P((const long, const long, const long, float*, const long, const float*, long*));
extern void sorgl2_64_ __P((const long*, const long*, const long*, float*, const long*, const float*, float*, long*));
extern void sorglq_64 __P((const long, const long, const long, float*, const long, const float*, long*));
extern void sorglq_64_ __P((const long*, const long*, const long*, float*, const long*, const float*, float*, const long*, long*));
extern void sorgql_64 __P((const long, const long, const long, float*, const long, const float*, long*));
extern void sorgql_64_ __P((const long*, const long*, const long*, float*, const long*, const float*, float*, const long*, long*));
extern void sorgqr_64 __P((const long, const long, const long, float*, const long, const float*, long*));
extern void sorgqr_64_ __P((const long*, const long*, const long*, float*, const long*, const float*, float*, const long*, long*));
extern void sorgr2_64 __P((const long, const long, const long, float*, const long, const float*, long*));
extern void sorgr2_64_ __P((const long*, const long*, const long*, float*, const long*, const float*, float*, long*));
extern void sorgrq_64 __P((const long, const long, const long, float*, const long, const float*, long*));
extern void sorgrq_64_ __P((const long*, const long*, const long*, float*, const long*, const float*, float*, const long*, long*));
extern void sorgtr_64 __P((const char, const long, float*, const long, const float*, long*));
extern void sorgtr_64_ __P((const char*, const long*, float*, const long*, const float*, float*, const long*, long*, const long));
extern void sorm2l_64 __P((const char, const char, const long, const long, const long, const float*, const long, const float*, float*, const long, long*));
extern void sorm2l_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, long*, const long, const long));
extern void sorm2r_64 __P((const char, const char, const long, const long, const long, float*, const long, const float*, float*, const long, long*));
extern void sorm2r_64_ __P((const char*, const char*, const long*, const long*, const long*, float*, const long*, const float*, float*, const long*, float*, long*, const long, const long));
extern void sormbr_64 __P((const char, const char, const char, const long, const long, const long, const float*, const long, const float*, float*, const long, long*));
extern void sormbr_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*, long*, const long, const long, const long));
extern void sormhr_64 __P((const char, const char, const long, const long, const long, const long, const float*, const long, const float*, float*, const long, long*));
extern void sormhr_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*, long*, const long, const long));
extern void sorml2_64 __P((const char, const char, const long, const long, const long, const float*, const long, const float*, float*, const long, long*));
extern void sorml2_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, long*, const long, const long));
extern void sormlq_64 __P((const char, const char, const long, const long, const long, const float*, const long, const float*, float*, const long, long*));
extern void sormlq_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*, long*, const long, const long));
extern void sormql_64 __P((const char, const char, const long, const long, const long, const float*, const long, const float*, float*, const long, long*));
extern void sormql_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*, long*, const long, const long));
extern void sormqr_64 __P((const char, const char, const long, const long, const long, const float*, const long, const float*, float*, const long, long*));
extern void sormqr_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*, long*, const long, const long));
extern void sormr2_64 __P((const char, const char, const long, const long, const long, const float*, const long, const float*, float*, const long, long*));
extern void sormr2_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, long*, const long, const long));
extern void sormr3_64 __P((const char, const char, const long, const long, const long, const long, const float*, const long, const float*, float*, const long, long*));
extern void sormr3_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, long*, const long, const long));
extern void sormrq_64 __P((const char, const char, const long, const long, const long, const float*, const long, const float*, float*, const long, long*));
extern void sormrq_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*, long*, const long, const long));
extern void sormrz_64 __P((const char, const char, const long, const long, const long, const long, const float*, const long, const float*, float*, const long, long*));
extern void sormrz_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*, long*, const long, const long));
extern void sormtr_64 __P((const char, const char, const char, const long, const long, const float*, const long, const float*, float*, const long, long*));
extern void sormtr_64_ __P((const char*, const char*, const char*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*, long*, const long, const long, const long));
extern void spbcon_64 __P((const char, const long, const long, const float*, const long, const float, float*, long*));
extern void spbcon_64_ __P((const char*, const long*, const long*, const float*, const long*, const float*, float*, float*, long*, long*, const long));
extern void spbequ_64 __P((const char, const long, const long, const float*, const long, float*, float*, float*, long*));
extern void spbequ_64_ __P((const char*, const long*, const long*, const float*, const long*, float*, float*, float*, long*, const long));
extern void spbrfs_64 __P((const char, const long, const long, const long, const float*, const long, const float*, const long, const float*, const long, float*, const long, float*, float*, long*));
extern void spbrfs_64_ __P((const char*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const float*, const long*, float*, const long*, float*, float*, float*, long*, long*, const long));
extern void spbstf_64 __P((const char, const long, const long, float*, const long, long*));
extern void spbstf_64_ __P((const char*, const long*, const long*, float*, const long*, long*, const long));
extern void spbsvx_64 __P((const char, const char, const long, const long, const long, float*, const long, float*, const long, char*, float*, float*, const long, float*, const long, float*, float*, float*, long*));
extern void spbsvx_64_ __P((const char*, const char*, const long*, const long*, const long*, float*, const long*, float*, const long*, char*, float*, float*, const long*, float*, const long*, float*, float*, float*, float*, long*, long*, const long, const long, const long));
extern void spbsv_64 __P((const char, const long, const long, const long, float*, const long, float*, const long, long*));
extern void spbsv_64_ __P((const char*, const long*, const long*, const long*, float*, const long*, float*, const long*, long*, const long));
extern void spbtf2_64 __P((const char, const long, const long, float*, const long, long*));
extern void spbtf2_64_ __P((const char*, const long*, const long*, float*, const long*, long*, const long));
extern void spbtrf_64 __P((const char, const long, const long, float*, const long, long*));
extern void spbtrf_64_ __P((const char*, const long*, const long*, float*, const long*, long*, const long));
extern void spbtrs_64 __P((const char, const long, const long, const long, const float*, const long, float*, const long, long*));
extern void spbtrs_64_ __P((const char*, const long*, const long*, const long*, const float*, const long*, float*, const long*, long*, const long));
extern void spocon_64 __P((const char, const long, const float*, const long, const float, float*, long*));
extern void spocon_64_ __P((const char*, const long*, const float*, const long*, const float*, float*, float*, long*, long*, const long));
extern void spoequ_64 __P((const long, const float*, const long, float*, float*, float*, long*));
extern void spoequ_64_ __P((const long*, const float*, const long*, float*, float*, float*, long*));
extern void sporfs_64 __P((const char, const long, const long, const float*, const long, const float*, const long, const float*, const long, float*, const long, float*, float*, long*));
extern void sporfs_64_ __P((const char*, const long*, const long*, const float*, const long*, const float*, const long*, const float*, const long*, float*, const long*, float*, float*, float*, long*, long*, const long));
extern void sposvx_64 __P((const char, const char, const long, const long, float*, const long, float*, const long, char*, float*, float*, const long, float*, const long, float*, float*, float*, long*));
extern void sposvx_64_ __P((const char*, const char*, const long*, const long*, float*, const long*, float*, const long*, char*, float*, float*, const long*, float*, const long*, float*, float*, float*, float*, long*, long*, const long, const long, const long));
extern void sposv_64 __P((const char, const long, const long, float*, const long, float*, const long, long*));
extern void sposv_64_ __P((const char*, const long*, const long*, float*, const long*, float*, const long*, long*, const long));
extern void spotf2_64 __P((const char, const long, float*, const long, long*));
extern void spotf2_64_ __P((const char*, const long*, float*, const long*, long*, const long));
extern void spotrf_64 __P((const char, const long, float*, const long, long*));
extern void spotrf_64_ __P((const char*, const long*, float*, const long*, long*, const long));
extern void spotri_64 __P((const char, const long, float*, const long, long*));
extern void spotri_64_ __P((const char*, const long*, float*, const long*, long*, const long));
extern void spotrs_64 __P((const char, const long, const long, const float*, const long, float*, const long, long*));
extern void spotrs_64_ __P((const char*, const long*, const long*, const float*, const long*, float*, const long*, long*, const long));
extern void sppcon_64 __P((const char, const long, const float*, const float, float*, long*));
extern void sppcon_64_ __P((const char*, const long*, const float*, const float*, float*, float*, long*, long*, const long));
extern void sppequ_64 __P((const char, const long, const float*, float*, float*, float*, long*));
extern void sppequ_64_ __P((const char*, const long*, const float*, float*, float*, float*, long*, const long));
extern void spprfs_64 __P((const char, const long, const long, const float*, const float*, const float*, const long, float*, const long, float*, float*, long*));
extern void spprfs_64_ __P((const char*, const long*, const long*, const float*, const float*, const float*, const long*, float*, const long*, float*, float*, float*, long*, long*, const long));
extern void sppsvx_64 __P((const char, const char, const long, const long, float*, float*, char*, float*, float*, const long, float*, const long, float*, float*, float*, long*));
extern void sppsvx_64_ __P((const char*, const char*, const long*, const long*, float*, float*, char*, float*, float*, const long*, float*, const long*, float*, float*, float*, float*, long*, long*, const long, const long, const long));
extern void sppsv_64 __P((const char, const long, const long, float*, float*, const long, long*));
extern void sppsv_64_ __P((const char*, const long*, const long*, float*, float*, const long*, long*, const long));
extern void spptrf_64 __P((const char, const long, float*, long*));
extern void spptrf_64_ __P((const char*, const long*, float*, long*, const long));
extern void spptri_64 __P((const char, const long, float*, long*));
extern void spptri_64_ __P((const char*, const long*, float*, long*, const long));
extern void spptrs_64 __P((const char, const long, const long, const float*, float*, const long, long*));
extern void spptrs_64_ __P((const char*, const long*, const long*, const float*, float*, const long*, long*, const long));
extern void sptcon_64 __P((const long, const float*, const float*, const float, float*, long*));
extern void sptcon_64_ __P((const long*, const float*, const float*, const float*, float*, float*, long*));
extern void spteqr_64 __P((const char, const long, float*, float*, float*, const long, long*));
extern void spteqr_64_ __P((const char*, const long*, float*, float*, float*, const long*, float*, long*, const long));
extern void sptrfs_64 __P((const long, const long, const float*, const float*, const float*, const float*, const float*, const long, float*, const long, float*, float*, long*));
extern void sptrfs_64_ __P((const long*, const long*, const float*, const float*, const float*, const float*, const float*, const long*, float*, const long*, float*, float*, float*, long*));
extern void sptsvx_64 __P((const char, const long, const long, const float*, const float*, float*, float*, const float*, const long, float*, const long, float*, float*, float*, long*));
extern void sptsvx_64_ __P((const char*, const long*, const long*, const float*, const float*, float*, float*, const float*, const long*, float*, const long*, float*, float*, float*, float*, long*, const long));
extern void sptsv_64 __P((const long, const long, float*, float*, float*, const long, long*));
extern void sptsv_64_ __P((const long*, const long*, float*, float*, float*, const long*, long*));
extern void spttrf_64 __P((const long, float*, float*, long*));
extern void spttrf_64_ __P((const long*, float*, float*, long*));
extern void spttrs_64 __P((const long, const long, const float*, float*, float*, const long, long*));
extern void spttrs_64_ __P((const long*, const long*, const float*, float*, float*, const long*, long*));
extern void sptts2_64 __P((const long, const long, const float*, const float*, float*, const long));
extern void sptts2_64_ __P((const long*, const long*, const float*, const float*, float*, const long*));
extern void srotg_64 __P((float*, float*, float*, float*));
extern void srotg_64_ __P((float*, float*, float*, float*));
extern void sroti_64 __P((const long, const float*, const long*, float*, const float, const float));
extern void sroti_64_ __P((const long*, const float*, const long*, float*, const float*, const float*));
extern void srotmg_64 __P((float*, float*, float*, const float, float*));
extern void srotmg_64_ __P((float*, float*, float*, const float*, float*));
extern void srotm_64 __P((const long, const float*, const long, float*, const long, const float*));
extern void srotm_64_ __P((const long*, const float*, const long*, float*, const long*, const float*));
extern void srot_64 __P((const long, float*, const long, float*, const long, const float, const float));
extern void srot_64_ __P((const long*, float*, const long*, float*, const long*, const float*, const float*));
extern void ssbevd_64 __P((const char, const char, const long, const long, float*, const long, float*, float*, const long, long*));
extern void ssbevd_64_ __P((const char*, const char*, const long*, const long*, float*, const long*, float*, float*, const long*, float*, const long*, long*, const long*, long*, const long, const long));
extern void ssbevx_64 __P((const char, const char, const char, const long, const long, float*, const long, float*, const long, const float, const float, const long, const long, const float, long*, float*, float*, const long, long*, long*));
extern void ssbevx_64_ __P((const char*, const char*, const char*, const long*, const long*, float*, const long*, float*, const long*, const float*, const float*, const long*, const long*, const float*, long*, float*, float*, const long*, float*, long*, long*, long*, const long, const long, const long));
extern void ssbev_64 __P((const char, const char, const long, const long, float*, const long, float*, float*, const long, long*));
extern void ssbev_64_ __P((const char*, const char*, const long*, const long*, float*, const long*, float*, float*, const long*, float*, long*, const long, const long));
extern void ssbgst_64 __P((const char, const char, const long, const long, const long, float*, const long, const float*, const long, float*, const long, long*));
extern void ssbgst_64_ __P((const char*, const char*, const long*, const long*, const long*, float*, const long*, const float*, const long*, float*, const long*, float*, long*, const long, const long));
extern void ssbgvd_64 __P((const char, const char, const long, const long, const long, float*, const long, float*, const long, float*, float*, const long, long*));
extern void ssbgvd_64_ __P((const char*, const char*, const long*, const long*, const long*, float*, const long*, float*, const long*, float*, float*, const long*, float*, const long*, long*, const long*, long*, const long, const long));
extern void ssbgvx_64 __P((const char, const char, const char, const long, const long, const long, float*, const long, float*, const long, float*, const long, const float, const float, const long, const long, const float, long*, float*, float*, const long, long*, long*));
extern void ssbgvx_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, float*, const long*, float*, const long*, float*, const long*, const float*, const float*, const long*, const long*, const float*, long*, float*, float*, const long*, float*, long*, long*, long*, const long, const long, const long));
extern void ssbgv_64 __P((const char, const char, const long, const long, const long, float*, const long, float*, const long, float*, float*, const long, long*));
extern void ssbgv_64_ __P((const char*, const char*, const long*, const long*, const long*, float*, const long*, float*, const long*, float*, float*, const long*, float*, long*, const long, const long));
extern void ssbmv_64 __P((const char, const long, const long, const float, const float*, const long, const float*, const long, const float, float*, const long));
extern void ssbmv_64_ __P((const char*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const float*, float*, const long*, const long));
extern void ssbtrd_64 __P((const char, const char, const long, const long, float*, const long, float*, float*, float*, const long, long*));
extern void ssbtrd_64_ __P((const char*, const char*, const long*, const long*, float*, const long*, float*, float*, float*, const long*, float*, long*, const long, const long));
extern void sscal_64 __P((const long, const float, float*, const long));
extern void sscal_64_ __P((const long*, const float*, float*, const long*));
extern void ssctr_64 __P((const long, const float*, const long*, float*));
extern void ssctr_64_ __P((const long*, const float*, const long*, float*));
extern void sskymm_64 __P((const long, const long, const long, const long, const float, const long*, const float*, const long*, const float*, const long, const float, float*, const long));
extern void sskymm_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sskysm_64 __P((const long, const long, const long, const long, const float*, const float, const long*, const float*, const long*, const float*, const long, const float, float*, const long));
extern void sskysm_64_ __P((const long*, const long*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void sspcon_64 __P((const char, const long, const float*, const long*, const float, float*, long*));
extern void sspcon_64_ __P((const char*, const long*, const float*, const long*, const float*, float*, float*, long*, long*, const long));
extern void sspevd_64 __P((const char, const char, const long, float*, float*, float*, const long, long*));
extern void sspevd_64_ __P((const char*, const char*, const long*, float*, float*, float*, const long*, float*, const long*, long*, const long*, long*, const long, const long));
extern void sspevx_64 __P((const char, const char, const char, const long, float*, const float, const float, const long, const long, const float, long*, float*, float*, const long, long*, long*));
extern void sspevx_64_ __P((const char*, const char*, const char*, const long*, float*, const float*, const float*, const long*, const long*, const float*, long*, float*, float*, const long*, float*, long*, long*, long*, const long, const long, const long));
extern void sspev_64 __P((const char, const char, const long, float*, float*, float*, const long, long*));
extern void sspev_64_ __P((const char*, const char*, const long*, float*, float*, float*, const long*, float*, long*, const long, const long));
extern void sspgst_64 __P((const long, const char, const long, float*, const float*, long*));
extern void sspgst_64_ __P((const long*, const char*, const long*, float*, const float*, long*, const long));
extern void sspgvd_64 __P((const long, const char, const char, const long, float*, float*, float*, float*, const long, long*));
extern void sspgvd_64_ __P((const long*, const char*, const char*, const long*, float*, float*, float*, float*, const long*, float*, const long*, long*, const long*, long*, const long, const long));
extern void sspgvx_64 __P((const long, const char, const char, const char, const long, float*, float*, const float, const float, const long, const long, const float, long*, float*, float*, const long, long*, long*));
extern void sspgvx_64_ __P((const long*, const char*, const char*, const char*, const long*, float*, float*, const float*, const float*, const long*, const long*, const float*, long*, float*, float*, const long*, float*, long*, long*, long*, const long, const long, const long));
extern void sspgv_64 __P((const long, const char, const char, const long, float*, float*, float*, float*, const long, long*));
extern void sspgv_64_ __P((const long*, const char*, const char*, const long*, float*, float*, float*, float*, const long*, float*, long*, const long, const long));
extern void sspmv_64 __P((const char, const long, const float, const float*, const float*, const long, const float, float*, const long));
extern void sspmv_64_ __P((const char*, const long*, const float*, const float*, const float*, const long*, const float*, float*, const long*, const long));
extern void sspr2_64 __P((const char, const long, const float, const float*, const long, const float*, const long, float*));
extern void sspr2_64_ __P((const char*, const long*, const float*, const float*, const long*, const float*, const long*, float*, const long));
extern void ssprfs_64 __P((const char, const long, const long, const float*, const float*, const long*, const float*, const long, float*, const long, float*, float*, long*));
extern void ssprfs_64_ __P((const char*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, float*, const long*, float*, float*, float*, long*, long*, const long));
extern void sspr_64 __P((const char, const long, const float, const float*, const long, float*));
extern void sspr_64_ __P((const char*, const long*, const float*, const float*, const long*, float*, const long));
extern void sspsvx_64 __P((const char, const char, const long, const long, const float*, float*, long*, const float*, const long, float*, const long, float*, float*, float*, long*));
extern void sspsvx_64_ __P((const char*, const char*, const long*, const long*, const float*, float*, long*, const float*, const long*, float*, const long*, float*, float*, float*, float*, long*, long*, const long, const long));
extern void sspsv_64 __P((const char, const long, const long, float*, long*, float*, const long, long*));
extern void sspsv_64_ __P((const char*, const long*, const long*, float*, long*, float*, const long*, long*, const long));
extern void ssptrd_64 __P((const char, const long, float*, float*, float*, float*, long*));
extern void ssptrd_64_ __P((const char*, const long*, float*, float*, float*, float*, long*, const long));
extern void ssptrf_64 __P((const char, const long, float*, long*, long*));
extern void ssptrf_64_ __P((const char*, const long*, float*, long*, long*, const long));
extern void ssptri_64 __P((const char, const long, float*, const long*, long*));
extern void ssptri_64_ __P((const char*, const long*, float*, const long*, float*, long*, const long));
extern void ssptrs_64 __P((const char, const long, const long, const float*, const long*, float*, const long, long*));
extern void ssptrs_64_ __P((const char*, const long*, const long*, const float*, const long*, float*, const long*, long*, const long));
extern void sstebz_64 __P((const char, const char, const long, const float, const float, const long, const long, const float, const float*, const float*, long*, long*, float*, long*, long*, long*));
extern void sstebz_64_ __P((const char*, const char*, const long*, const float*, const float*, const long*, const long*, const float*, const float*, const float*, long*, long*, float*, long*, long*, float*, long*, long*, const long, const long));
extern void sstedc_64 __P((const char, const long, float*, float*, float*, const long, long*));
extern void sstedc_64_ __P((const char*, const long*, float*, float*, float*, const long*, float*, const long*, long*, const long*, long*, const long));
extern void sstegr_64 __P((const char, const char, const long, float*, float*, const float, const float, const long, const long, const float, long*, float*, float*, const long, long*, long*));
extern void sstegr_64_ __P((const char*, const char*, const long*, float*, float*, const float*, const float*, const long*, const long*, const float*, long*, float*, float*, const long*, long*, float*, const long*, long*, const long*, long*, const long, const long));
extern void sstein_64 __P((const long, const float*, const float*, const long, const float*, const long*, const long*, float*, const long, long*, long*));
extern void sstein_64_ __P((const long*, const float*, const float*, const long*, const float*, const long*, const long*, float*, const long*, float*, long*, long*, long*));
extern void ssteqr_64 __P((const char, const long, float*, float*, float*, const long, long*));
extern void ssteqr_64_ __P((const char*, const long*, float*, float*, float*, const long*, float*, long*, const long));
extern void ssterf_64 __P((const long, float*, float*, long*));
extern void ssterf_64_ __P((const long*, float*, float*, long*));
extern void sstevd_64 __P((const char, const long, float*, float*, float*, const long, long*));
extern void sstevd_64_ __P((const char*, const long*, float*, float*, float*, const long*, float*, const long*, long*, const long*, long*, const long));
extern void sstevr_64 __P((const char, const char, const long, float*, float*, const float, const float, const long, const long, const float, long*, float*, float*, const long, long*, long*));
extern void sstevr_64_ __P((const char*, const char*, const long*, float*, float*, const float*, const float*, const long*, const long*, const float*, long*, float*, float*, const long*, long*, float*, const long*, long*, const long*, long*, const long, const long));
extern void sstevx_64 __P((const char, const char, const long, float*, float*, const float, const float, const long, const long, const float, long*, float*, float*, const long, long*, long*));
extern void sstevx_64_ __P((const char*, const char*, const long*, float*, float*, const float*, const float*, const long*, const long*, const float*, long*, float*, float*, const long*, float*, long*, long*, long*, const long, const long));
extern void sstev_64 __P((const char, const long, float*, float*, float*, const long, long*));
extern void sstev_64_ __P((const char*, const long*, float*, float*, float*, const long*, float*, long*, const long));
extern void sstsv_64 __P((const long, const long, float*, float*, float*, float*, const long, long*, long*));
extern void sstsv_64_ __P((const long*, const long*, float*, float*, float*, float*, const long*, long*, long*));
extern void ssttrf_64 __P((const long, float*, float*, float*, long*, long*));
extern void ssttrf_64_ __P((const long*, float*, float*, float*, long*, long*));
extern void ssttrs_64 __P((const long, const long, const float*, const float*, const float*, const float*, const long, long*, long*));
extern void ssttrs_64_ __P((const long*, const long*, const float*, const float*, const float*, const float*, const long*, long*, long*));
extern void sswap_64 __P((const long, float*, const long, float*, const long));
extern void sswap_64_ __P((const long*, float*, const long*, float*, const long*));
extern void ssycon_64 __P((const char, const long, const float*, const long, const long*, const float, float*, long*));
extern void ssycon_64_ __P((const char*, const long*, const float*, const long*, const long*, const float*, float*, float*, long*, long*, const long));
extern void ssyevd_64 __P((const char, const char, const long, float*, const long, float*, long*));
extern void ssyevd_64_ __P((const char*, const char*, const long*, float*, const long*, float*, float*, const long*, long*, const long*, long*, const long, const long));
extern void ssyevr_64 __P((const char, const char, const char, const long, float*, const long, const float, const float, const long, const long, const float, long*, float*, float*, const long, long*, long*));
extern void ssyevr_64_ __P((const char*, const char*, const char*, const long*, float*, const long*, const float*, const float*, const long*, const long*, const float*, long*, float*, float*, const long*, long*, float*, const long*, long*, const long*, long*, const long, const long, const long));
extern void ssyevx_64 __P((const char, const char, const char, const long, float*, const long, const float, const float, const long, const long, const float, long*, float*, float*, const long, long*, long*));
extern void ssyevx_64_ __P((const char*, const char*, const char*, const long*, float*, const long*, const float*, const float*, const long*, const long*, const float*, long*, float*, float*, const long*, float*, const long*, long*, long*, long*, const long, const long, const long));
extern void ssyev_64 __P((const char, const char, const long, float*, const long, float*, long*));
extern void ssyev_64_ __P((const char*, const char*, const long*, float*, const long*, float*, float*, const long*, long*, const long, const long));
extern void ssygs2_64 __P((const long, const char, const long, float*, const long, const float*, const long, long*));
extern void ssygs2_64_ __P((const long*, const char*, const long*, float*, const long*, const float*, const long*, long*, const long));
extern void ssygst_64 __P((const long, const char, const long, float*, const long, const float*, const long, long*));
extern void ssygst_64_ __P((const long*, const char*, const long*, float*, const long*, const float*, const long*, long*, const long));
extern void ssygvd_64 __P((const long, const char, const char, const long, float*, const long, float*, const long, float*, long*));
extern void ssygvd_64_ __P((const long*, const char*, const char*, const long*, float*, const long*, float*, const long*, float*, float*, const long*, long*, const long*, long*, const long, const long));
extern void ssygvx_64 __P((const long, const char, const char, const char, const long, float*, const long, float*, const long, const float, const float, const long, const long, const float, long*, float*, float*, const long, long*, long*));
extern void ssygvx_64_ __P((const long*, const char*, const char*, const char*, const long*, float*, const long*, float*, const long*, const float*, const float*, const long*, const long*, const float*, long*, float*, float*, const long*, float*, const long*, long*, long*, long*, const long, const long, const long));
extern void ssygv_64 __P((const long, const char, const char, const long, float*, const long, float*, const long, float*, long*));
extern void ssygv_64_ __P((const long*, const char*, const char*, const long*, float*, const long*, float*, const long*, float*, float*, const long*, long*, const long, const long));
extern void ssymm_64 __P((const char, const char, const long, const long, const float, const float*, const long, const float*, const long, const float, float*, const long));
extern void ssymm_64_ __P((const char*, const char*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const float*, float*, const long*, const long, const long));
extern void ssymv_64 __P((const char, const long, const float, const float*, const long, const float*, const long, const float, float*, const long));
extern void ssymv_64_ __P((const char*, const long*, const float*, const float*, const long*, const float*, const long*, const float*, float*, const long*, const long));
extern void ssyr2k_64 __P((const char, const char, const long, const long, const float, const float*, const long, const float*, const long, const float, float*, const long));
extern void ssyr2k_64_ __P((const char*, const char*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const float*, float*, const long*, const long, const long));
extern void ssyr2_64 __P((const char, const long, const float, const float*, const long, const float*, const long, float*, const long));
extern void ssyr2_64_ __P((const char*, const long*, const float*, const float*, const long*, const float*, const long*, float*, const long*, const long));
extern void ssyrfs_64 __P((const char, const long, const long, const float*, const long, const float*, const long, const long*, const float*, const long, float*, const long, float*, float*, long*));
extern void ssyrfs_64_ __P((const char*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const float*, const long*, float*, const long*, float*, float*, float*, long*, long*, const long));
extern void ssyrk_64 __P((const char, const char, const long, const long, const float, const float*, const long, const float, float*, const long));
extern void ssyrk_64_ __P((const char*, const char*, const long*, const long*, const float*, const float*, const long*, const float*, float*, const long*, const long, const long));
extern void ssyr_64 __P((const char, const long, const float, const float*, const long, float*, const long));
extern void ssyr_64_ __P((const char*, const long*, const float*, const float*, const long*, float*, const long*, const long));
extern void ssysvx_64 __P((const char, const char, const long, const long, const float*, const long, float*, const long, long*, const float*, const long, float*, const long, float*, float*, float*, long*));
extern void ssysvx_64_ __P((const char*, const char*, const long*, const long*, const float*, const long*, float*, const long*, long*, const float*, const long*, float*, const long*, float*, float*, float*, float*, const long*, long*, long*, const long, const long));
extern void ssysv_64 __P((const char, const long, const long, float*, const long, long*, float*, const long, long*));
extern void ssysv_64_ __P((const char*, const long*, const long*, float*, const long*, long*, float*, const long*, float*, const long*, long*, const long));
extern void ssytd2_64 __P((const char, const long, float*, const long, float*, float*, float*, long*));
extern void ssytd2_64_ __P((const char*, const long*, float*, const long*, float*, float*, float*, long*, const long));
extern void ssytf2_64 __P((const char, const long, float*, const long, long*, long*));
extern void ssytf2_64_ __P((const char*, const long*, float*, const long*, long*, long*, const long));
extern void ssytrd_64 __P((const char, const long, float*, const long, float*, float*, float*, long*));
extern void ssytrd_64_ __P((const char*, const long*, float*, const long*, float*, float*, float*, float*, const long*, long*, const long));
extern void ssytrf_64 __P((const char, const long, float*, const long, long*, long*));
extern void ssytrf_64_ __P((const char*, const long*, float*, const long*, long*, float*, const long*, long*, const long));
extern void ssytri_64 __P((const char, const long, float*, const long, const long*, long*));
extern void ssytri_64_ __P((const char*, const long*, float*, const long*, const long*, float*, long*, const long));
extern void ssytrs_64 __P((const char, const long, const long, const float*, const long, const long*, float*, const long, long*));
extern void ssytrs_64_ __P((const char*, const long*, const long*, const float*, const long*, const long*, float*, const long*, long*, const long));
extern void stbcon_64 __P((const char, const char, const char, const long, const long, const float*, const long, float*, long*));
extern void stbcon_64_ __P((const char*, const char*, const char*, const long*, const long*, const float*, const long*, float*, float*, long*, long*, const long, const long, const long));
extern void stbmv_64 __P((const char, const char, const char, const long, const long, const float*, const long, float*, const long));
extern void stbmv_64_ __P((const char*, const char*, const char*, const long*, const long*, const float*, const long*, float*, const long*, const long, const long, const long));
extern void stbrfs_64 __P((const char, const char, const char, const long, const long, const long, const float*, const long, const float*, const long, const float*, const long, float*, float*, long*));
extern void stbrfs_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const float*, const long*, float*, float*, float*, long*, long*, const long, const long, const long));
extern void stbsv_64 __P((const char, const char, const char, const long, const long, const float*, const long, float*, const long));
extern void stbsv_64_ __P((const char*, const char*, const char*, const long*, const long*, const float*, const long*, float*, const long*, const long, const long, const long));
extern void stbtrs_64 __P((const char, const char, const char, const long, const long, const long, const float*, const long, float*, const long, long*));
extern void stbtrs_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const float*, const long*, float*, const long*, long*, const long, const long, const long));
extern void stgevc_64 __P((const char, const char, const long*, const long, const float*, const long, const float*, const long, float*, const long, float*, const long, const long, long*, long*));
extern void stgevc_64_ __P((const char*, const char*, const long*, const long*, const float*, const long*, const float*, const long*, float*, const long*, float*, const long*, const long*, long*, float*, long*, const long, const long));
extern void stgexc_64 __P((const long, const long, const long, float*, const long, float*, const long, float*, const long, float*, const long, long*, long*, long*));
extern void stgexc_64_ __P((const long*, const long*, const long*, float*, const long*, float*, const long*, float*, const long*, float*, const long*, long*, long*, float*, const long*, long*));
extern void stgsen_64 __P((const long, const long, const long, const long*, const long, float*, const long, float*, const long, float*, float*, float*, float*, const long, float*, const long, long*, float*, float*, float*, long*));
extern void stgsen_64_ __P((const long*, const long*, const long*, const long*, const long*, float*, const long*, float*, const long*, float*, float*, float*, float*, const long*, float*, const long*, long*, float*, float*, float*, float*, const long*, long*, const long*, long*));
extern void stgsja_64 __P((const char, const char, const char, const long, const long, const long, const long, const long, float*, const long, float*, const long, const float, const float, float*, float*, float*, const long, float*, const long, float*, const long, long*, long*));
extern void stgsja_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const long*, const long*, float*, const long*, float*, const long*, const float*, const float*, float*, float*, float*, const long*, float*, const long*, float*, const long*, float*, long*, long*, const long, const long, const long));
extern void stgsna_64 __P((const char, const char, const long*, const long, const float*, const long, const float*, const long, const float*, const long, const float*, const long, float*, float*, const long, long*, long*));
extern void stgsna_64_ __P((const char*, const char*, const long*, const long*, const float*, const long*, const float*, const long*, const float*, const long*, const float*, const long*, float*, float*, const long*, long*, float*, const long*, long*, long*, const long, const long));
extern void stgsyl_64 __P((const char, const long, const long, const long, const float*, const long, const float*, const long, float*, const long, const float*, const long, const float*, const long, float*, const long, float*, float*, long*));
extern void stgsyl_64_ __P((const char*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, float*, const long*, const float*, const long*, const float*, const long*, float*, const long*, float*, float*, float*, const long*, long*, long*, const long));
extern void stpcon_64 __P((const char, const char, const char, const long, const float*, float*, long*));
extern void stpcon_64_ __P((const char*, const char*, const char*, const long*, const float*, float*, float*, long*, long*, const long, const long, const long));
extern void stpmv_64 __P((const char, const char, const char, const long, const float*, float*, const long));
extern void stpmv_64_ __P((const char*, const char*, const char*, const long*, const float*, float*, const long*, const long, const long, const long));
extern void stprfs_64 __P((const char, const char, const char, const long, const long, const float*, const float*, const long, const float*, const long, float*, float*, long*));
extern void stprfs_64_ __P((const char*, const char*, const char*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, float*, float*, float*, long*, long*, const long, const long, const long));
extern void stpsv_64 __P((const char, const char, const char, const long, const float*, float*, const long));
extern void stpsv_64_ __P((const char*, const char*, const char*, const long*, const float*, float*, const long*, const long, const long, const long));
extern void stptri_64 __P((const char, const char, const long, float*, long*));
extern void stptri_64_ __P((const char*, const char*, const long*, float*, long*, const long, const long));
extern void stptrs_64 __P((const char, const char, const char, const long, const long, const float*, float*, const long, long*));
extern void stptrs_64_ __P((const char*, const char*, const char*, const long*, const long*, const float*, float*, const long*, long*, const long, const long, const long));
extern void strans_64 __P((const char, const float, float*, const long, const long, float*));
extern void strans_64_ __P((const char*, const float*, float*, const long*, const long*, float*, const long));
extern void strcon_64 __P((const char, const char, const char, const long, const float*, const long, float*, long*));
extern void strcon_64_ __P((const char*, const char*, const char*, const long*, const float*, const long*, float*, float*, long*, long*, const long, const long, const long));
extern void strevc_64 __P((const char, const char, long*, const long, float*, const long, float*, const long, float*, const long, const long, long*, long*));
extern void strevc_64_ __P((const char*, const char*, long*, const long*, float*, const long*, float*, const long*, float*, const long*, const long*, long*, float*, long*, const long, const long));
extern void strexc_64 __P((const char, const long, float*, const long, float*, const long, long*, long*, long*));
extern void strexc_64_ __P((const char*, const long*, float*, const long*, float*, const long*, long*, long*, float*, long*, const long));
extern void strmm_64 __P((const char, const char, const char, const char, const long, const long, const float, const float*, const long, float*, const long));
extern void strmm_64_ __P((const char*, const char*, const char*, const char*, const long*, const long*, const float*, const float*, const long*, float*, const long*, const long, const long, const long, const long));
extern void strmv_64 __P((const char, const char, const char, const long, const float*, const long, float*, const long));
extern void strmv_64_ __P((const char*, const char*, const char*, const long*, const float*, const long*, float*, const long*, const long, const long, const long));
extern void strrfs_64 __P((const char, const char, const char, const long, const long, const float*, const long, const float*, const long, const float*, const long, float*, float*, long*));
extern void strrfs_64_ __P((const char*, const char*, const char*, const long*, const long*, const float*, const long*, const float*, const long*, const float*, const long*, float*, float*, float*, long*, long*, const long, const long, const long));
extern void strsen_64 __P((const char, const char, const long*, const long, float*, const long, float*, const long, float*, float*, long*, float*, float*, long*));
extern void strsen_64_ __P((const char*, const char*, const long*, const long*, float*, const long*, float*, const long*, float*, float*, long*, float*, float*, float*, const long*, long*, const long*, long*, const long, const long));
extern void strsm_64 __P((const char, const char, const char, const char, const long, const long, const float, const float*, const long, float*, const long));
extern void strsm_64_ __P((const char*, const char*, const char*, const char*, const long*, const long*, const float*, const float*, const long*, float*, const long*, const long, const long, const long, const long));
extern void strsna_64 __P((const char, const char, const long*, const long, const float*, const long, const float*, const long, const float*, const long, float*, float*, const long, long*, const long, long*));
extern void strsna_64_ __P((const char*, const char*, const long*, const long*, const float*, const long*, const float*, const long*, const float*, const long*, float*, float*, const long*, long*, float*, const long*, long*, long*, const long, const long));
extern void strsv_64 __P((const char, const char, const char, const long, const float*, const long, float*, const long));
extern void strsv_64_ __P((const char*, const char*, const char*, const long*, const float*, const long*, float*, const long*, const long, const long, const long));
extern void strsyl_64 __P((const char, const char, const long, const long, const long, const float*, const long, const float*, const long, float*, const long, float*, long*));
extern void strsyl_64_ __P((const char*, const char*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, float*, const long*, float*, long*, const long, const long));
extern void strti2_64 __P((const char, const char, const long, float*, const long, long*));
extern void strti2_64_ __P((const char*, const char*, const long*, float*, const long*, long*, const long, const long));
extern void strtri_64 __P((const char, const char, const long, float*, const long, long*));
extern void strtri_64_ __P((const char*, const char*, const long*, float*, const long*, long*, const long, const long));
extern void strtrs_64 __P((const char, const char, const char, const long, const long, const float*, const long, float*, const long, long*));
extern void strtrs_64_ __P((const char*, const char*, const char*, const long*, const long*, const float*, const long*, float*, const long*, long*, const long, const long, const long));
extern void stzrqf_64 __P((const long, const long, float*, const long, float*, long*));
extern void stzrqf_64_ __P((const long*, const long*, float*, const long*, float*, long*));
extern void stzrzf_64 __P((const long, const long, float*, const long, float*, long*));
extern void stzrzf_64_ __P((const long*, const long*, float*, const long*, float*, float*, const long*, long*));
extern char * sunperf_version_64 __P((long*, long*, long*));
extern void sunperf_version_64_ __P((long*, long*, long*));
extern void svbrmm_64 __P((const long, const long, const long, const long, const float, const long*, const float*, const long*, const long*, const long*, const long*, const long*, const long*, const float*, const long, const float, float*, const long));
extern void svbrmm_64_ __P((const long*, const long*, const long*, const long*, const float*, const long*, const float*, const long*, const long*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void svbrsm_64 __P((const long, const long, const long, const long, const float*, const float, const long*, const float*, const long*, const long*, const long*, const long*, const long*, const long*, const float*, const long, const float, float*, const long));
extern void svbrsm_64_ __P((const long*, const long*, const long*, const long*, const float*, const float*, const long*, const float*, const long*, const long*, const long*, const long*, const long*, const long*, const float*, const long*, const float*, float*, const long*, float*, const long*));
extern void swiener_64 __P((const long, const float*, const float*, float*, const float*, long*, long*));
extern void swiener_64_ __P((const long*, const float*, const float*, float*, const float*, long*, long*));
extern void use_threads_64 __P((const long));
extern void use_threads_64_ __P((const long*));
extern long using_threads_64 __P((void));
extern long using_threads_64_ __P((void));
extern void vcfftb_64 __P((const long, const long, floatcomplex*, const floatcomplex*, const long, const char, const floatcomplex*));
extern void vcfftb_64_ __P((const long*, const long*, floatcomplex*, const floatcomplex*, const long*, const char*, const floatcomplex*, const long));
extern void vcfftf_64 __P((const long, const long, floatcomplex*, const floatcomplex*, const long, const char, const floatcomplex*));
extern void vcfftf_64_ __P((const long*, const long*, floatcomplex*, const floatcomplex*, const long*, const char*, const floatcomplex*, const long));
extern void vcffti_64 __P((const long, floatcomplex*));
extern void vcffti_64_ __P((const long*, floatcomplex*));
extern void vcosqb_64 __P((const long, const long, float*, const float*, const long, const float*));
extern void vcosqb_64_ __P((const long*, const long*, float*, const float*, const long*, const float*));
extern void vcosqf_64 __P((const long, const long, float*, const float*, const long, const float*));
extern void vcosqf_64_ __P((const long*, const long*, float*, const float*, const long*, const float*));
extern void vcosqi_64 __P((const long, float*));
extern void vcosqi_64_ __P((const long*, float*));
extern void vcosti_64 __P((const long, float*));
extern void vcosti_64_ __P((const long*, float*));
extern void vcost_64 __P((const long, const long, float*, const float*, const long, const float*));
extern void vcost_64_ __P((const long*, const long*, float*, const float*, const long*, const float*));
extern void vdcosqb_64 __P((const long, const long, double*, const double*, const long, const double*));
extern void vdcosqb_64_ __P((const long*, const long*, double*, const double*, const long*, const double*));
extern void vdcosqf_64 __P((const long, const long, double*, const double*, const long, const double*));
extern void vdcosqf_64_ __P((const long*, const long*, double*, const double*, const long*, const double*));
extern void vdcosqi_64 __P((const long, double*));
extern void vdcosqi_64_ __P((const long*, double*));
extern void vdcosti_64 __P((const long, double*));
extern void vdcosti_64_ __P((const long*, double*));
extern void vdcost_64 __P((const long, const long, double*, const double*, const long, const double*));
extern void vdcost_64_ __P((const long*, const long*, double*, const double*, const long*, const double*));
extern void vdfftb_64 __P((const long, const long, double*, const double*, const long, const double*));
extern void vdfftb_64_ __P((const long*, const long*, double*, const double*, const long*, const double*));
extern void vdfftf_64 __P((const long, const long, double*, const double*, const long, const double*));
extern void vdfftf_64_ __P((const long*, const long*, double*, const double*, const long*, const double*));
extern void vdffti_64 __P((const long, double*));
extern void vdffti_64_ __P((const long*, double*));
extern void vdsinqb_64 __P((const long, const long, double*, const double*, const long, const double*));
extern void vdsinqb_64_ __P((const long*, const long*, double*, const double*, const long*, const double*));
extern void vdsinqf_64 __P((const long, const long, double*, const double*, const long, const double*));
extern void vdsinqf_64_ __P((const long*, const long*, double*, const double*, const long*, const double*));
extern void vdsinqi_64 __P((const long, double*));
extern void vdsinqi_64_ __P((const long*, double*));
extern void vdsinti_64 __P((const long, double*));
extern void vdsinti_64_ __P((const long*, double*));
extern void vdsint_64 __P((const long, const long, double*, double*, const long, const double*));
extern void vdsint_64_ __P((const long*, const long*, double*, double*, const long*, const double*));
extern void vrfftb_64 __P((const long, const long, float*, const float*, const long, float*));
extern void vrfftb_64_ __P((const long*, const long*, float*, const float*, const long*, float*));
extern void vrfftf_64 __P((const long, const long, float*, const float*, const long, const float*));
extern void vrfftf_64_ __P((const long*, const long*, float*, const float*, const long*, const float*));
extern void vrffti_64 __P((const long, float*));
extern void vrffti_64_ __P((const long*, float*));
extern void vsinqb_64 __P((const long, const long, float*, const float*, const long, const float*));
extern void vsinqb_64_ __P((const long*, const long*, float*, const float*, const long*, const float*));
extern void vsinqf_64 __P((const long, const long, float*, const float*, const long, const float*));
extern void vsinqf_64_ __P((const long*, const long*, float*, const float*, const long*, const float*));
extern void vsinqi_64 __P((const long, float*));
extern void vsinqi_64_ __P((const long*, float*));
extern void vsinti_64 __P((const long, float*));
extern void vsinti_64_ __P((const long*, float*));
extern void vsint_64 __P((const long, const long, float*, float*, const long, const float*));
extern void vsint_64_ __P((const long*, const long*, float*, float*, const long*, const float*));
extern void vzfftb_64 __P((const long, const long, doublecomplex*, const doublecomplex*, const long, const char, doublecomplex*));
extern void vzfftb_64_ __P((const long*, const long*, doublecomplex*, const doublecomplex*, const long*, const char*, doublecomplex*, const long));
extern void vzfftf_64 __P((const long, const long, doublecomplex*, const doublecomplex*, const long, const char, const doublecomplex*));
extern void vzfftf_64_ __P((const long*, const long*, doublecomplex*, const doublecomplex*, const long*, const char*, const doublecomplex*, const long));
extern void vzffti_64 __P((const long, doublecomplex*));
extern void vzffti_64_ __P((const long*, doublecomplex*));
extern void xerbla_64 __P((const char*, const long));
extern void xerbla_64_ __P((const char*, const long*, const long));
extern void zaxpyi_64 __P((const long, const doublecomplex*, const doublecomplex*, const long*, doublecomplex*));
extern void zaxpyi_64_ __P((const long*, const doublecomplex*, const doublecomplex*, const long*, doublecomplex*));
extern void zaxpy_64 __P((const long, const doublecomplex*, const doublecomplex*, const long, doublecomplex*, const long));
extern void zaxpy_64_ __P((const long*, const doublecomplex*, const doublecomplex*, const long*, doublecomplex*, const long*));
extern void zbcomm_64 __P((const long, const long, const long, const long, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zbcomm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zbdimm_64 __P((const long, const long, const long, const long, const doublecomplex*, const long*, const doublecomplex*, const long, const long*, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zbdimm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zbdism_64 __P((const long, const long, const long, const long, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long, const long*, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zbdism_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zbdsqr_64 __P((const char, const long, const long, const long, const long, double*, double*, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zbdsqr_64_ __P((const char*, const long*, const long*, const long*, const long*, double*, double*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, const long));
extern void zbelmm_64 __P((const long, const long, const long, const long, const doublecomplex*, const long*, const doublecomplex*, const long*, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zbelmm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zbelsm_64 __P((const long, const long, const long, const long, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zbelsm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zbscmm_64 __P((const long, const long, const long, const long, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zbscmm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zbscsm_64 __P((const long, const long, const long, const long, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zbscsm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zbsrmm_64 __P((const long, const long, const long, const long, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zbsrmm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zbsrsm_64 __P((const long, const long, const long, const long, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zbsrsm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zcnvcor2_64 __P((const char, const char, const char, const char, const char, const char, const long, const long, const doublecomplex*, const long, const long, const long, const long, const long, const doublecomplex*, const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long));
extern void zcnvcor2_64_ __P((const char*, const char*, const char*, const char*, const char*, const char*, const long*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, const long, const long, const long, const long, const long, const long));
extern void zcnvcor_64 __P((const char, const char, const long, const doublecomplex*, const long, const long, const long, const long, const long, const doublecomplex*, const long, const long, const long, const long, const long, doublecomplex*, const long, const long, const long, doublecomplex*, const long));
extern void zcnvcor_64_ __P((const char*, const char*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const long*, doublecomplex*, const long*, const long*, const long*, doublecomplex*, const long*, const long, const long));
extern void zcoomm_64 __P((const long, const long, const long, const long, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zcoomm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zcopy_64 __P((const long, const doublecomplex*, const long, doublecomplex*, const long));
extern void zcopy_64_ __P((const long*, const doublecomplex*, const long*, doublecomplex*, const long*));
extern void zcscmm_64 __P((const long, const long, const long, const long, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zcscmm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zcscsm_64 __P((const long, const long, const long, const long, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zcscsm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zcsrmm_64 __P((const long, const long, const long, const long, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zcsrmm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zcsrsm_64 __P((const long, const long, const long, const long, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zcsrsm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zdiamm_64 __P((const long, const long, const long, const long, const doublecomplex*, const long*, const doublecomplex*, const long, const long*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zdiamm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zdiasm_64 __P((const long, const long, const long, const long, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long, const long*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zdiasm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern doublecomplex zdotci_64 __P((const long, const doublecomplex*, const long*, const doublecomplex*));
extern doublecomplex zdotc_64 __P((const long, const doublecomplex*, const long, const doublecomplex*, const long));
extern doublecomplex zdotui_64 __P((const long, const doublecomplex*, const long*, const doublecomplex*));
extern doublecomplex zdotu_64 __P((const long, const doublecomplex*, const long, const doublecomplex*, const long));
extern void zdrot_64 __P((const long, doublecomplex*, const long, doublecomplex*, const long, const double, const double));
extern void zdrot_64_ __P((const long*, doublecomplex*, const long*, doublecomplex*, const long*, const double*, const double*));
extern void zdscal_64 __P((const long, const double, doublecomplex*, const long));
extern void zdscal_64_ __P((const long*, const double*, doublecomplex*, const long*));
extern void zellmm_64 __P((const long, const long, const long, const long, const doublecomplex*, const long*, const doublecomplex*, const long*, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zellmm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zellsm_64 __P((const long, const long, const long, const long, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zellsm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zfft2b_64 __P((const long, const long, doublecomplex*, const long, const double*, const long));
extern void zfft2b_64_ __P((const long*, const long*, doublecomplex*, const long*, const double*, const long*));
extern void zfft2f_64 __P((const long, const long, doublecomplex*, const long, const double*, const long));
extern void zfft2f_64_ __P((const long*, const long*, doublecomplex*, const long*, const double*, const long*));
extern void zfft2i_64 __P((const long, const long, double*));
extern void zfft2i_64_ __P((const long*, const long*, double*));
extern void zfft3b_64 __P((const long, const long, const long, doublecomplex*, const long, const long, const double*, const long));
extern void zfft3b_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, const long*, const double*, const long*));
extern void zfft3f_64 __P((const long, const long, const long, doublecomplex*, const long, const long, const double*, const long));
extern void zfft3f_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, const long*, const double*, const long*));
extern void zfft3i_64 __P((const long, const long, const long, double*));
extern void zfft3i_64_ __P((const long*, const long*, const long*, double*));
extern void zfftb_64 __P((const long, doublecomplex*, double*));
extern void zfftb_64_ __P((const long*, doublecomplex*, double*));
extern void zfftd2_64_ __P((const long*, const long*, const long*, const double*, const doublecomplex*, const long*, double*, const long*, double*, long*, double*, const long*, long*));
extern void zfftd3_64_ __P((const long*, const long*, const long*, const long*, const double*, const doublecomplex*, const long*, const long*, double*, const long*, const long*, double*, long*, double*, const long*, long*));
extern void zfftdm_64_ __P((const long*, const long*, const long*, const double*, const doublecomplex*, const long*, double*, const long*, double*, long*, double*, const long*, long*));
extern void zfftd_64_ __P((const long*, const long*, const double*, const doublecomplex*, double*, double*, long*, double*, const long*, long*));
extern void zfftf_64 __P((const long, doublecomplex*, const double*));
extern void zfftf_64_ __P((const long*, doublecomplex*, const double*));
extern void zffti_64 __P((const long, double*));
extern void zffti_64_ __P((const long*, double*));
extern long zfftopt_64 __P((const long));
extern long zfftopt_64_ __P((const long*));
extern void zfftz2_64_ __P((const long*, const long*, const long*, const double*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, double*, const long*, long*));
extern void zfftz3_64_ __P((const long*, const long*, const long*, const long*, const double*, const doublecomplex*, const long*, const long*, doublecomplex*, const long*, const long*, double*, long*, double*, const long*, long*));
extern void zfftzm_64_ __P((const long*, const long*, const long*, const double*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, double*, const long*, long*));
extern void zfftz_64_ __P((const long*, const long*, const double*, const doublecomplex*, doublecomplex*, double*, long*, double*, const long*, long*));
extern void zgbbrd_64 __P((const char, const long, const long, const long, const long, const long, doublecomplex*, const long, double*, double*, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zgbbrd_64_ __P((const char*, const long*, const long*, const long*, const long*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, double*, long*, const long));
extern void zgbcon_64 __P((const char, const long, const long, const long, const doublecomplex*, const long, const long*, const double, double*, long*));
extern void zgbcon_64_ __P((const char*, const long*, const long*, const long*, const doublecomplex*, const long*, const long*, const double*, double*, doublecomplex*, double*, long*, const long));
extern void zgbequ_64 __P((const long, const long, const long, const long, const doublecomplex*, const long, double*, double*, double*, double*, double*, long*));
extern void zgbequ_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, double*, double*, double*, double*, double*, long*));
extern void zgbmv_64 __P((const char, const long, const long, const long, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zgbmv_64_ __P((const char*, const long*, const long*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, const long));
extern void zgbrfs_64 __P((const char, const long, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, const long, const long*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, long*));
extern void zgbrfs_64_ __P((const char*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long));
extern void zgbsvx_64 __P((const char, const char, const long, const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, long*, char*, double*, double*, doublecomplex*, const long, doublecomplex*, const long, double*, double*, double*, long*));
extern void zgbsvx_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, char*, double*, double*, doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, double*, doublecomplex*, double*, long*, const long, const long, const long));
extern void zgbsv_64 __P((const long, const long, const long, const long, doublecomplex*, const long, long*, doublecomplex*, const long, long*));
extern void zgbsv_64_ __P((const long*, const long*, const long*, const long*, doublecomplex*, const long*, long*, doublecomplex*, const long*, long*));
extern void zgbtf2_64 __P((const long, const long, const long, const long, doublecomplex*, const long, long*, long*));
extern void zgbtf2_64_ __P((const long*, const long*, const long*, const long*, doublecomplex*, const long*, long*, long*));
extern void zgbtrf_64 __P((const long, const long, const long, const long, doublecomplex*, const long, long*, long*));
extern void zgbtrf_64_ __P((const long*, const long*, const long*, const long*, doublecomplex*, const long*, long*, long*));
extern void zgbtrs_64 __P((const char, const long, const long, const long, const long, const doublecomplex*, const long, const long*, doublecomplex*, const long, long*));
extern void zgbtrs_64_ __P((const char*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const long*, doublecomplex*, const long*, long*, const long));
extern void zgebak_64 __P((const char, const char, const long, const long, const long, const double*, const long, doublecomplex*, const long, long*));
extern void zgebak_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const long*, doublecomplex*, const long*, long*, const long, const long));
extern void zgebal_64 __P((const char, const long, doublecomplex*, const long, long*, long*, double*, long*));
extern void zgebal_64_ __P((const char*, const long*, doublecomplex*, const long*, long*, long*, double*, long*, const long));
extern void zgebrd_64 __P((const long, const long, doublecomplex*, const long, double*, double*, doublecomplex*, doublecomplex*, long*));
extern void zgebrd_64_ __P((const long*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, doublecomplex*, doublecomplex*, const long*, long*));
extern void zgecon_64 __P((const char, const long, const doublecomplex*, const long, const double, double*, long*));
extern void zgecon_64_ __P((const char*, const long*, const doublecomplex*, const long*, const double*, double*, doublecomplex*, double*, long*, const long));
extern void zgeequ_64 __P((const long, const long, const doublecomplex*, const long, double*, double*, double*, double*, double*, long*));
extern void zgeequ_64_ __P((const long*, const long*, const doublecomplex*, const long*, double*, double*, double*, double*, double*, long*));
extern void zgeesx_64 __P((const char, const char, const long(*select)(doublecomplex*), const char, const long, doublecomplex*, const long, long*, doublecomplex*, doublecomplex*, const long, double*, double*, long*));
extern void zgeesx_64_ __P((const char*, const char*, const long(*select)(doublecomplex*), const char*, const long*, doublecomplex*, const long*, long*, doublecomplex*, doublecomplex*, const long*, double*, double*, doublecomplex*, const long*, double*, long*, long*, const long, const long, const long));
extern void zgees_64 __P((const char, const char, const long(*select)(doublecomplex*), const long, doublecomplex*, const long, long*, doublecomplex*, doublecomplex*, const long, long*));
extern void zgees_64_ __P((const char*, const char*, const long(*select)(doublecomplex*), const long*, doublecomplex*, const long*, long*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, long*, const long, const long));
extern void zgeevx_64 __P((const char, const char, const char, const char, const long, doublecomplex*, const long, doublecomplex*, doublecomplex*, const long, doublecomplex*, const long, long*, long*, double*, double*, double*, double*, long*));
extern void zgeevx_64_ __P((const char*, const char*, const char*, const char*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, long*, long*, double*, double*, double*, double*, doublecomplex*, const long*, double*, long*, const long, const long, const long, const long));
extern void zgeev_64 __P((const char, const char, const long, doublecomplex*, const long, doublecomplex*, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zgeev_64_ __P((const char*, const char*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, const long, const long));
extern void zgegs_64 __P((const char, const char, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, doublecomplex*, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zgegs_64_ __P((const char*, const char*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, const long, const long));
extern void zgegv_64 __P((const char, const char, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, doublecomplex*, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zgegv_64_ __P((const char*, const char*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, const long, const long));
extern void zgehrd_64 __P((const long, const long, const long, doublecomplex*, const long, doublecomplex*, long*));
extern void zgehrd_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, long*));
extern void zgelqf_64 __P((const long, const long, doublecomplex*, const long, doublecomplex*, long*));
extern void zgelqf_64_ __P((const long*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, long*));
extern void zgelsd_64 __P((const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, double*, const double, long*, long*));
extern void zgelsd_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, const double*, long*, doublecomplex*, const long*, double*, long*, long*));
extern void zgelss_64 __P((const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, double*, const double, long*, long*));
extern void zgelss_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, const double*, long*, doublecomplex*, const long*, double*, long*));
extern void zgelsx_64 __P((const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, long*, const double, long*, long*));
extern void zgelsx_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const double*, long*, doublecomplex*, double*, long*));
extern void zgelsy_64 __P((const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, long*, const double, long*, long*));
extern void zgelsy_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const double*, long*, doublecomplex*, const long*, double*, long*));
extern void zgels_64 __P((const char, const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zgels_64_ __P((const char*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long));
extern void zgemm_64 __P((const char, const char, const long, const long, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zgemm_64_ __P((const char*, const char*, const long*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, const long, const long));
extern void zgemv_64 __P((const char, const long, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zgemv_64_ __P((const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, const long));
extern void zgeqlf_64 __P((const long, const long, doublecomplex*, const long, doublecomplex*, long*));
extern void zgeqlf_64_ __P((const long*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, long*));
extern void zgeqp3_64 __P((const long, const long, doublecomplex*, const long, long*, doublecomplex*, long*));
extern void zgeqp3_64_ __P((const long*, const long*, doublecomplex*, const long*, long*, doublecomplex*, doublecomplex*, const long*, double*, long*));
extern void zgeqpf_64 __P((const long, const long, doublecomplex*, const long, long*, doublecomplex*, long*));
extern void zgeqpf_64_ __P((const long*, const long*, doublecomplex*, const long*, long*, doublecomplex*, doublecomplex*, double*, long*));
extern void zgeqrf_64 __P((const long, const long, doublecomplex*, const long, doublecomplex*, long*));
extern void zgeqrf_64_ __P((const long*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, long*));
extern void zgerc_64 __P((const long, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, doublecomplex*, const long));
extern void zgerc_64_ __P((const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*));
extern void zgerfs_64 __P((const char, const long, const long, const doublecomplex*, const long, const doublecomplex*, const long, const long*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, long*));
extern void zgerfs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long));
extern void zgerqf_64 __P((const long, const long, doublecomplex*, const long, doublecomplex*, long*));
extern void zgerqf_64_ __P((const long*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, long*));
extern void zgeru_64 __P((const long, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, doublecomplex*, const long));
extern void zgeru_64_ __P((const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*));
extern void zgesdd_64 __P((const char, const long, const long, doublecomplex*, const long, double*, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zgesdd_64_ __P((const char*, const long*, const long*, doublecomplex*, const long*, double*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, long*, const long));
extern void zgesvd_64 __P((const char, const char, const long, const long, doublecomplex*, const long, double*, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zgesvd_64_ __P((const char*, const char*, const long*, const long*, doublecomplex*, const long*, double*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, const long, const long));
extern void zgesvx_64 __P((const char, const char, const long, const long, doublecomplex*, const long, doublecomplex*, const long, long*, char*, double*, double*, doublecomplex*, const long, doublecomplex*, const long, double*, double*, double*, long*));
extern void zgesvx_64_ __P((const char*, const char*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, char*, double*, double*, doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, double*, doublecomplex*, double*, long*, const long, const long, const long));
extern void zgesv_64 __P((const long, const long, doublecomplex*, const long, long*, doublecomplex*, const long, long*));
extern void zgesv_64_ __P((const long*, const long*, doublecomplex*, const long*, long*, doublecomplex*, const long*, long*));
extern void zgetf2_64 __P((const long, const long, doublecomplex*, const long, long*, long*));
extern void zgetf2_64_ __P((const long*, const long*, doublecomplex*, const long*, long*, long*));
extern void zgetrf_64 __P((const long, const long, doublecomplex*, const long, long*, long*));
extern void zgetrf_64_ __P((const long*, const long*, doublecomplex*, const long*, long*, long*));
extern void zgetri_64 __P((const long, doublecomplex*, const long, const long*, long*));
extern void zgetri_64_ __P((const long*, doublecomplex*, const long*, const long*, doublecomplex*, const long*, long*));
extern void zgetrs_64 __P((const char, const long, const long, const doublecomplex*, const long, const long*, doublecomplex*, const long, long*));
extern void zgetrs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const long*, const long*, doublecomplex*, const long*, long*, const long));
extern void zggbak_64 __P((const char, const char, const long, const long, const long, const double*, const double*, const long, doublecomplex*, const long, long*));
extern void zggbak_64_ __P((const char*, const char*, const long*, const long*, const long*, const double*, const double*, const long*, doublecomplex*, const long*, long*, const long, const long));
extern void zggbal_64 __P((const char, const long, doublecomplex*, const long, doublecomplex*, const long, long*, long*, const double*, const double*, long*));
extern void zggbal_64_ __P((const char*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, long*, const double*, const double*, double*, long*, const long));
extern void zggesx_64 __P((const char, const char, const char, const long(*delctg)(doublecomplex*,doublecomplex*), const char, const long, doublecomplex*, const long, doublecomplex*, const long, long*, doublecomplex*, doublecomplex*, doublecomplex*, const long, doublecomplex*, const long, double*, double*, long*));
extern void zggesx_64_ __P((const char*, const char*, const char*, const long(*delctg)(doublecomplex*,doublecomplex*), const char*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, doublecomplex*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, const long*, double*, long*, const long*, long*, long*, const long, const long, const long, const long));
extern void zgges_64 __P((const char, const char, const char, const long(*delztg)(doublecomplex*,doublecomplex*), const long, doublecomplex*, const long, doublecomplex*, const long, long*, doublecomplex*, doublecomplex*, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zgges_64_ __P((const char*, const char*, const char*, const long(*delztg)(doublecomplex*,doublecomplex*), const long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, doublecomplex*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, long*, const long, const long, const long));
extern void zggevx_64 __P((const char, const char, const char, const char, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, doublecomplex*, doublecomplex*, const long, doublecomplex*, const long, long*, long*, double*, double*, double*, double*, double*, double*, long*));
extern void zggevx_64_ __P((const char*, const char*, const char*, const char*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, long*, long*, double*, double*, double*, double*, double*, double*, doublecomplex*, const long*, double*, long*, long*, long*, const long, const long, const long, const long));
extern void zggev_64 __P((const char, const char, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, doublecomplex*, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zggev_64_ __P((const char*, const char*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, const long, const long));
extern void zggglm_64 __P((const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, doublecomplex*, doublecomplex*, long*));
extern void zggglm_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, const long*, long*));
extern void zgghrd_64 __P((const char, const char, const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zgghrd_64_ __P((const char*, const char*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long, const long));
extern void zgglse_64 __P((const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, doublecomplex*, doublecomplex*, long*));
extern void zgglse_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, const long*, long*));
extern void zggqrf_64 __P((const long, const long, const long, doublecomplex*, const long, doublecomplex*, doublecomplex*, const long, doublecomplex*, long*));
extern void zggqrf_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, long*));
extern void zggrqf_64 __P((const long, const long, const long, doublecomplex*, const long, doublecomplex*, doublecomplex*, const long, doublecomplex*, long*));
extern void zggrqf_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, long*));
extern void zggsvd_64 __P((const char, const char, const char, const long, const long, const long, long*, long*, doublecomplex*, const long, doublecomplex*, const long, double*, double*, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, const long, long*, long*));
extern void zggsvd_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, long*, long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, double*, long*, long*, const long, const long, const long));
extern void zggsvp_64 __P((const char, const char, const char, const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, const double, const double, long*, long*, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zggsvp_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, const double*, const double*, long*, long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, double*, doublecomplex*, doublecomplex*, long*, const long, const long, const long));
extern void zgssco_64_ __P((double*, double*, long*));
extern void zgssda_64_ __P((double*, long*));
extern void zgssfa_64_ __P((const long*, const long*, const long*, const doublecomplex*, double*, long*));
extern void zgssfs_64_ __P((const char*, const char*, const long*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, const char*, const long*, const long*, double*, long*, const long, const long, const long));
extern void zgssin_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const long*, double*, long*, const long, const long));
extern void zgssor_64_ __P((const char*, double*, long*, const long));
extern void zgssps_64_ __P((double*, long*));
extern void zgssrp_64_ __P((long*, double*, long*));
extern void zgsssl_64_ __P((const long*, doublecomplex*, const long*, double*, long*));
extern void zgssuo_64_ __P((const long*, double*, long*));
extern void zgtcon_64 __P((const char, const long, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long*, const double, double*, long*));
extern void zgtcon_64_ __P((const char*, const long*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long*, const double*, double*, doublecomplex*, long*, const long));
extern void zgthrz_64 __P((const long, doublecomplex*, doublecomplex*, const long*));
extern void zgthrz_64_ __P((const long*, doublecomplex*, doublecomplex*, const long*));
extern void zgthr_64 __P((const long, const doublecomplex*, doublecomplex*, const long*));
extern void zgthr_64_ __P((const long*, const doublecomplex*, doublecomplex*, const long*));
extern void zgtrfs_64 __P((const char, const long, const long, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, long*));
extern void zgtrfs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long));
extern void zgtsvx_64 __P((const char, const char, const long, const long, const doublecomplex*, const doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, long*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, double*, long*));
extern void zgtsvx_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, double*, doublecomplex*, double*, long*, const long, const long));
extern void zgtsv_64 __P((const long, const long, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, const long, long*));
extern void zgtsv_64_ __P((const long*, const long*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, const long*, long*));
extern void zgttrf_64 __P((const long, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, long*, long*));
extern void zgttrf_64_ __P((const long*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, long*, long*));
extern void zgttrs_64 __P((const char, const long, const long, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long*, doublecomplex*, const long, long*));
extern void zgttrs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long*, doublecomplex*, const long*, long*, const long));
extern void zhbevd_64 __P((const char, const char, const long, const long, doublecomplex*, const long, double*, doublecomplex*, const long, long*));
extern void zhbevd_64_ __P((const char*, const char*, const long*, const long*, doublecomplex*, const long*, double*, doublecomplex*, const long*, doublecomplex*, const long*, double*, const long*, long*, const long*, long*, const long, const long));
extern void zhbevx_64 __P((const char, const char, const char, const long, const long, doublecomplex*, const long, doublecomplex*, const long, const double, const double, const long, const long, const double, long*, double*, doublecomplex*, const long, long*, long*));
extern void zhbevx_64_ __P((const char*, const char*, const char*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, const double*, const double*, const long*, const long*, const double*, long*, double*, doublecomplex*, const long*, doublecomplex*, double*, long*, long*, long*, const long, const long, const long));
extern void zhbev_64 __P((const char, const char, const long, const long, doublecomplex*, const long, double*, doublecomplex*, const long, long*));
extern void zhbev_64_ __P((const char*, const char*, const long*, const long*, doublecomplex*, const long*, double*, doublecomplex*, const long*, doublecomplex*, double*, long*, const long, const long));
extern void zhbgst_64 __P((const char, const char, const long, const long, const long, doublecomplex*, const long, const doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zhbgst_64_ __P((const char*, const char*, const long*, const long*, const long*, doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, double*, long*, const long, const long));
extern void zhbgvd_64 __P((const char, const char, const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, double*, doublecomplex*, const long, long*));
extern void zhbgvd_64_ __P((const char*, const char*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, doublecomplex*, const long*, doublecomplex*, const long*, double*, const long*, long*, const long*, long*, const long, const long));
extern void zhbgvx_64 __P((const char, const char, const char, const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, const long, const double, const double, const long, const long, const double, long*, double*, doublecomplex*, const long, long*, long*));
extern void zhbgvx_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, const double*, const double*, const long*, const long*, const double*, long*, double*, doublecomplex*, const long*, doublecomplex*, double*, long*, long*, long*, const long, const long, const long));
extern void zhbgv_64 __P((const char, const char, const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, double*, doublecomplex*, const long, long*));
extern void zhbgv_64_ __P((const char*, const char*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, doublecomplex*, const long*, doublecomplex*, double*, long*, const long, const long));
extern void zhbmv_64 __P((const char, const long, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zhbmv_64_ __P((const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, const long));
extern void zhbtrd_64 __P((const char, const char, const long, const long, doublecomplex*, const long, double*, double*, doublecomplex*, const long, long*));
extern void zhbtrd_64_ __P((const char*, const char*, const long*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, const long*, doublecomplex*, long*, const long, const long));
extern void zhecon_64 __P((const char, const long, const doublecomplex*, const long, const long*, const double, double*, long*));
extern void zhecon_64_ __P((const char*, const long*, const doublecomplex*, const long*, const long*, const double*, double*, doublecomplex*, long*, const long));
extern void zheevd_64 __P((const char, const char, const long, doublecomplex*, const long, double*, long*));
extern void zheevd_64_ __P((const char*, const char*, const long*, doublecomplex*, const long*, double*, doublecomplex*, const long*, double*, const long*, long*, const long*, long*, const long, const long));
extern void zheevr_64 __P((const char, const char, const char, const long, doublecomplex*, const long, const double, const double, const long, const long, const double, long*, double*, doublecomplex*, const long, long*, long*));
extern void zheevr_64_ __P((const char*, const char*, const char*, const long*, doublecomplex*, const long*, const double*, const double*, const long*, const long*, const double*, long*, double*, doublecomplex*, const long*, long*, doublecomplex*, const long*, double*, const long*, long*, const long*, long*, const long, const long, const long));
extern void zheevx_64 __P((const char, const char, const char, const long, doublecomplex*, const long, const double, const double, const long, const long, const double, long*, double*, doublecomplex*, const long, long*, long*));
extern void zheevx_64_ __P((const char*, const char*, const char*, const long*, doublecomplex*, const long*, const double*, const double*, const long*, const long*, const double*, long*, double*, doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, long*, long*, const long, const long, const long));
extern void zheev_64 __P((const char, const char, const long, doublecomplex*, const long, double*, long*));
extern void zheev_64_ __P((const char*, const char*, const long*, doublecomplex*, const long*, double*, doublecomplex*, const long*, double*, long*, const long, const long));
extern void zhegs2_64 __P((const long, const char, const long, doublecomplex*, const long, const doublecomplex*, const long, long*));
extern void zhegs2_64_ __P((const long*, const char*, const long*, doublecomplex*, const long*, const doublecomplex*, const long*, long*, const long));
extern void zhegst_64 __P((const long, const char, const long, doublecomplex*, const long, const doublecomplex*, const long, long*));
extern void zhegst_64_ __P((const long*, const char*, const long*, doublecomplex*, const long*, const doublecomplex*, const long*, long*, const long));
extern void zhegvd_64 __P((const long, const char, const char, const long, doublecomplex*, const long, doublecomplex*, const long, double*, long*));
extern void zhegvd_64_ __P((const long*, const char*, const char*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, doublecomplex*, const long*, double*, const long*, long*, const long*, long*, const long, const long));
extern void zhegvx_64 __P((const long, const char, const char, const char, const long, doublecomplex*, const long, doublecomplex*, const long, const double, const double, const long, const long, const double, long*, double*, doublecomplex*, const long, long*, long*));
extern void zhegvx_64_ __P((const long*, const char*, const char*, const char*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, const double*, const double*, const long*, const long*, const double*, long*, double*, doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, long*, long*, const long, const long, const long));
extern void zhegv_64 __P((const long, const char, const char, const long, doublecomplex*, const long, doublecomplex*, const long, double*, long*));
extern void zhegv_64_ __P((const long*, const char*, const char*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, doublecomplex*, const long*, double*, long*, const long, const long));
extern void zhemm_64 __P((const char, const char, const long, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zhemm_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, const long, const long));
extern void zhemv_64 __P((const char, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zhemv_64_ __P((const char*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, const long));
extern void zher2k_64 __P((const char, const char, const long, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, const double, doublecomplex*, const long));
extern void zher2k_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const double*, doublecomplex*, const long*, const long, const long));
extern void zher2_64 __P((const char, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, doublecomplex*, const long));
extern void zher2_64_ __P((const char*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, const long));
extern void zherfs_64 __P((const char, const long, const long, const doublecomplex*, const long, const doublecomplex*, const long, const long*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, long*));
extern void zherfs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long));
extern void zherk_64 __P((const char, const char, const long, const long, const double, const doublecomplex*, const long, const double, doublecomplex*, const long));
extern void zherk_64_ __P((const char*, const char*, const long*, const long*, const double*, const doublecomplex*, const long*, const double*, doublecomplex*, const long*, const long, const long));
extern void zher_64 __P((const char, const long, const double, const doublecomplex*, const long, doublecomplex*, const long));
extern void zher_64_ __P((const char*, const long*, const double*, const doublecomplex*, const long*, doublecomplex*, const long*, const long));
extern void zhesvx_64 __P((const char, const char, const long, const long, const doublecomplex*, const long, doublecomplex*, const long, long*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, double*, long*));
extern void zhesvx_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, double*, doublecomplex*, const long*, double*, long*, const long, const long));
extern void zhesv_64 __P((const char, const long, const long, doublecomplex*, const long, long*, doublecomplex*, const long, long*));
extern void zhesv_64_ __P((const char*, const long*, const long*, doublecomplex*, const long*, long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long));
extern void zhetf2_64 __P((const char, const long, doublecomplex*, const long, long*, long*));
extern void zhetf2_64_ __P((const char*, const long*, doublecomplex*, const long*, long*, long*, const long));
extern void zhetrd_64 __P((const char, const long, doublecomplex*, const long, double*, double*, doublecomplex*, long*));
extern void zhetrd_64_ __P((const char*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, doublecomplex*, const long*, long*, const long));
extern void zhetrf_64 __P((const char, const long, doublecomplex*, const long, long*, long*));
extern void zhetrf_64_ __P((const char*, const long*, doublecomplex*, const long*, long*, doublecomplex*, const long*, long*, const long));
extern void zhetri_64 __P((const char, const long, doublecomplex*, const long, const long*, long*));
extern void zhetri_64_ __P((const char*, const long*, doublecomplex*, const long*, const long*, doublecomplex*, long*, const long));
extern void zhetrs_64 __P((const char, const long, const long, const doublecomplex*, const long, const long*, doublecomplex*, const long, long*));
extern void zhetrs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const long*, const long*, doublecomplex*, const long*, long*, const long));
extern void zhgeqz_64 __P((const char, const char, const char, const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, doublecomplex*, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zhgeqz_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, const long, const long, const long));
extern void zhpcon_64 __P((const char, const long, const doublecomplex*, const long*, const double, double*, long*));
extern void zhpcon_64_ __P((const char*, const long*, const doublecomplex*, const long*, const double*, double*, doublecomplex*, long*, const long));
extern void zhpevd_64 __P((const char, const char, const long, doublecomplex*, double*, doublecomplex*, const long, long*));
extern void zhpevd_64_ __P((const char*, const char*, const long*, doublecomplex*, double*, doublecomplex*, const long*, doublecomplex*, const long*, double*, const long*, long*, const long*, long*, const long, const long));
extern void zhpevx_64 __P((const char, const char, const char, const long, doublecomplex*, const double, const double, const long, const long, const double, long*, double*, doublecomplex*, const long, long*, long*));
extern void zhpevx_64_ __P((const char*, const char*, const char*, const long*, doublecomplex*, const double*, const double*, const long*, const long*, const double*, long*, double*, doublecomplex*, const long*, doublecomplex*, double*, long*, long*, long*, const long, const long, const long));
extern void zhpev_64 __P((const char, const char, const long, doublecomplex*, double*, doublecomplex*, const long, long*));
extern void zhpev_64_ __P((const char*, const char*, const long*, doublecomplex*, double*, doublecomplex*, const long*, doublecomplex*, double*, long*, const long, const long));
extern void zhpgst_64 __P((const long, const char, const long, doublecomplex*, const doublecomplex*, long*));
extern void zhpgst_64_ __P((const long*, const char*, const long*, doublecomplex*, const doublecomplex*, long*, const long));
extern void zhpgvd_64 __P((const long, const char, const char, const long, doublecomplex*, doublecomplex*, double*, doublecomplex*, const long, long*));
extern void zhpgvd_64_ __P((const long*, const char*, const char*, const long*, doublecomplex*, doublecomplex*, double*, doublecomplex*, const long*, doublecomplex*, const long*, double*, const long*, long*, const long*, long*, const long, const long));
extern void zhpgvx_64 __P((const long, const char, const char, const char, const long, doublecomplex*, doublecomplex*, const double, const double, const long, const long, const double, long*, double*, doublecomplex*, const long, long*, long*));
extern void zhpgvx_64_ __P((const long*, const char*, const char*, const char*, const long*, doublecomplex*, doublecomplex*, const double*, const double*, const long*, const long*, const double*, long*, double*, doublecomplex*, const long*, doublecomplex*, double*, long*, long*, long*, const long, const long, const long));
extern void zhpgv_64 __P((const long, const char, const char, const long, doublecomplex*, doublecomplex*, double*, doublecomplex*, const long, long*));
extern void zhpgv_64_ __P((const long*, const char*, const char*, const long*, doublecomplex*, doublecomplex*, double*, doublecomplex*, const long*, doublecomplex*, double*, long*, const long, const long));
extern void zhpmv_64 __P((const char, const long, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zhpmv_64_ __P((const char*, const long*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, const long));
extern void zhpr2_64 __P((const char, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, doublecomplex*));
extern void zhpr2_64_ __P((const char*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long));
extern void zhprfs_64 __P((const char, const long, const long, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, long*));
extern void zhprfs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long));
extern void zhpr_64 __P((const char, const long, const double, const doublecomplex*, const long, doublecomplex*));
extern void zhpr_64_ __P((const char*, const long*, const double*, const doublecomplex*, const long*, doublecomplex*, const long));
extern void zhpsvx_64 __P((const char, const char, const long, const long, const doublecomplex*, doublecomplex*, long*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, double*, long*));
extern void zhpsvx_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, doublecomplex*, long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, double*, doublecomplex*, double*, long*, const long, const long));
extern void zhpsv_64 __P((const char, const long, const long, doublecomplex*, long*, doublecomplex*, const long, long*));
extern void zhpsv_64_ __P((const char*, const long*, const long*, doublecomplex*, long*, doublecomplex*, const long*, long*, const long));
extern void zhptrd_64 __P((const char, const long, doublecomplex*, double*, double*, doublecomplex*, long*));
extern void zhptrd_64_ __P((const char*, const long*, doublecomplex*, double*, double*, doublecomplex*, long*, const long));
extern void zhptrf_64 __P((const char, const long, doublecomplex*, long*, long*));
extern void zhptrf_64_ __P((const char*, const long*, doublecomplex*, long*, long*, const long));
extern void zhptri_64 __P((const char, const long, doublecomplex*, const long*, long*));
extern void zhptri_64_ __P((const char*, const long*, doublecomplex*, const long*, doublecomplex*, long*, const long));
extern void zhptrs_64 __P((const char, const long, const long, const doublecomplex*, const long*, doublecomplex*, const long, long*));
extern void zhptrs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, long*, const long));
extern void zhsein_64 __P((const char, const char, const char, const long*, const long, const doublecomplex*, const long, doublecomplex*, doublecomplex*, const long, doublecomplex*, const long, const long, long*, long*, long*, long*));
extern void zhsein_64_ __P((const char*, const char*, const char*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, const long*, long*, doublecomplex*, double*, long*, long*, long*, const long, const long, const long));
extern void zhseqr_64 __P((const char, const char, const long, const long, const long, doublecomplex*, const long, doublecomplex*, doublecomplex*, const long, long*));
extern void zhseqr_64_ __P((const char*, const char*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long, const long));
extern void zjadmm_64 __P((const long, const long, const long, const long, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long, const long*, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zjadmm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zjadrp_64 __P((const long, const long, const long, const doublecomplex*, const long*, long*, const long, const long*));
extern void zjadrp_64_ __P((const long*, const long*, const long*, const doublecomplex*, const long*, long*, const long*, const long*, long*, const long*));
extern void zjadsm_64 __P((const long, const long, const long, const long, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long, const long*, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zjadsm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zlarzb_64 __P((const char, const char, const char, const char, const long, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, const long, doublecomplex*, const long, const long));
extern void zlarzb_64_ __P((const char*, const char*, const char*, const char*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, const long, const long, const long, const long));
extern void zlarzt_64 __P((const char, const char, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zlarzt_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, const long, const long));
extern void zlarz_64 __P((const char, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zlarz_64_ __P((const char*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long));
extern void zlatzm_64 __P((const char, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, doublecomplex*, const long));
extern void zlatzm_64_ __P((const char*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long));
extern void zpbcon_64 __P((const char, const long, const long, const doublecomplex*, const long, const double, double*, long*));
extern void zpbcon_64_ __P((const char*, const long*, const long*, const doublecomplex*, const long*, const double*, double*, doublecomplex*, double*, long*, const long));
extern void zpbequ_64 __P((const char, const long, const long, const doublecomplex*, const long, double*, double*, double*, long*));
extern void zpbequ_64_ __P((const char*, const long*, const long*, const doublecomplex*, const long*, double*, double*, double*, long*, const long));
extern void zpbrfs_64 __P((const char, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, long*));
extern void zpbrfs_64_ __P((const char*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long));
extern void zpbstf_64 __P((const char, const long, const long, doublecomplex*, const long, long*));
extern void zpbstf_64_ __P((const char*, const long*, const long*, doublecomplex*, const long*, long*, const long));
extern void zpbsvx_64 __P((const char, const char, const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, char*, double*, doublecomplex*, const long, doublecomplex*, const long, double*, double*, double*, long*));
extern void zpbsvx_64_ __P((const char*, const char*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, char*, double*, doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, double*, doublecomplex*, double*, long*, const long, const long, const long));
extern void zpbsv_64 __P((const char, const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zpbsv_64_ __P((const char*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long));
extern void zpbtf2_64 __P((const char, const long, const long, doublecomplex*, const long, long*));
extern void zpbtf2_64_ __P((const char*, const long*, const long*, doublecomplex*, const long*, long*, const long));
extern void zpbtrf_64 __P((const char, const long, const long, doublecomplex*, const long, long*));
extern void zpbtrf_64_ __P((const char*, const long*, const long*, doublecomplex*, const long*, long*, const long));
extern void zpbtrs_64 __P((const char, const long, const long, const long, const doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zpbtrs_64_ __P((const char*, const long*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, long*, const long));
extern void zpocon_64 __P((const char, const long, const doublecomplex*, const long, const double, double*, long*));
extern void zpocon_64_ __P((const char*, const long*, const doublecomplex*, const long*, const double*, double*, doublecomplex*, double*, long*, const long));
extern void zpoequ_64 __P((const long, const doublecomplex*, const long, double*, double*, double*, long*));
extern void zpoequ_64_ __P((const long*, const doublecomplex*, const long*, double*, double*, double*, long*));
extern void zporfs_64 __P((const char, const long, const long, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, long*));
extern void zporfs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long));
extern void zposvx_64 __P((const char, const char, const long, const long, doublecomplex*, const long, doublecomplex*, const long, char*, double*, doublecomplex*, const long, doublecomplex*, const long, double*, double*, double*, long*));
extern void zposvx_64_ __P((const char*, const char*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, char*, double*, doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, double*, doublecomplex*, double*, long*, const long, const long, const long));
extern void zposv_64 __P((const char, const long, const long, doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zposv_64_ __P((const char*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long));
extern void zpotf2_64 __P((const char, const long, doublecomplex*, const long, long*));
extern void zpotf2_64_ __P((const char*, const long*, doublecomplex*, const long*, long*, const long));
extern void zpotrf_64 __P((const char, const long, doublecomplex*, const long, long*));
extern void zpotrf_64_ __P((const char*, const long*, doublecomplex*, const long*, long*, const long));
extern void zpotri_64 __P((const char, const long, doublecomplex*, const long, long*));
extern void zpotri_64_ __P((const char*, const long*, doublecomplex*, const long*, long*, const long));
extern void zpotrs_64 __P((const char, const long, const long, const doublecomplex*, const long, doublecomplex*, const long, long*));
extern void zpotrs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, long*, const long));
extern void zppcon_64 __P((const char, const long, const doublecomplex*, const double, double*, long*));
extern void zppcon_64_ __P((const char*, const long*, const doublecomplex*, const double*, double*, doublecomplex*, double*, long*, const long));
extern void zppequ_64 __P((const char, const long, const doublecomplex*, double*, double*, double*, long*));
extern void zppequ_64_ __P((const char*, const long*, const doublecomplex*, double*, double*, double*, long*, const long));
extern void zpprfs_64 __P((const char, const long, const long, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, long*));
extern void zpprfs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long));
extern void zppsvx_64 __P((const char, const char, const long, const long, doublecomplex*, doublecomplex*, char*, double*, doublecomplex*, const long, doublecomplex*, const long, double*, double*, double*, long*));
extern void zppsvx_64_ __P((const char*, const char*, const long*, const long*, doublecomplex*, doublecomplex*, char*, double*, doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, double*, doublecomplex*, double*, long*, const long, const long, const long));
extern void zppsv_64 __P((const char, const long, const long, doublecomplex*, doublecomplex*, const long, long*));
extern void zppsv_64_ __P((const char*, const long*, const long*, doublecomplex*, doublecomplex*, const long*, long*, const long));
extern void zpptrf_64 __P((const char, const long, doublecomplex*, long*));
extern void zpptrf_64_ __P((const char*, const long*, doublecomplex*, long*, const long));
extern void zpptri_64 __P((const char, const long, doublecomplex*, long*));
extern void zpptri_64_ __P((const char*, const long*, doublecomplex*, long*, const long));
extern void zpptrs_64 __P((const char, const long, const long, const doublecomplex*, doublecomplex*, const long, long*));
extern void zpptrs_64_ __P((const char*, const long*, const long*, const doublecomplex*, doublecomplex*, const long*, long*, const long));
extern void zptcon_64 __P((const long, const double*, const doublecomplex*, const double, double*, long*));
extern void zptcon_64_ __P((const long*, const double*, const doublecomplex*, const double*, double*, double*, long*));
extern void zpteqr_64 __P((const char, const long, double*, double*, doublecomplex*, const long, long*));
extern void zpteqr_64_ __P((const char*, const long*, double*, double*, doublecomplex*, const long*, double*, long*, const long));
extern void zptrfs_64 __P((const char, const long, const long, const double*, const doublecomplex*, const double*, const doublecomplex*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, long*));
extern void zptrfs_64_ __P((const char*, const long*, const long*, const double*, const doublecomplex*, const double*, const doublecomplex*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long));
extern void zptsvx_64 __P((const char, const long, const long, const double*, const doublecomplex*, double*, doublecomplex*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, double*, long*));
extern void zptsvx_64_ __P((const char*, const long*, const long*, const double*, const doublecomplex*, double*, doublecomplex*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, double*, doublecomplex*, double*, long*, const long));
extern void zptsv_64 __P((const long, const long, double*, doublecomplex*, doublecomplex*, const long, long*));
extern void zptsv_64_ __P((const long*, const long*, double*, doublecomplex*, doublecomplex*, const long*, long*));
extern void zpttrf_64 __P((const long, double*, doublecomplex*, long*));
extern void zpttrf_64_ __P((const long*, double*, doublecomplex*, long*));
extern void zpttrs_64 __P((const char, const long, const long, const double*, doublecomplex*, doublecomplex*, const long, long*));
extern void zpttrs_64_ __P((const char*, const long*, const long*, const double*, doublecomplex*, doublecomplex*, const long*, long*, const long));
extern void zptts2_64 __P((const long, const long, const long, const double*, const doublecomplex*, doublecomplex*, const long));
extern void zptts2_64_ __P((const long*, const long*, const long*, const double*, const doublecomplex*, doublecomplex*, const long*));
extern void zrotg_64 __P((doublecomplex*, const doublecomplex*, double*, doublecomplex*));
extern void zrotg_64_ __P((doublecomplex*, const doublecomplex*, double*, doublecomplex*));
extern void zrot_64 __P((const long, doublecomplex*, const long, doublecomplex*, const long, const double, const doublecomplex*));
extern void zrot_64_ __P((const long*, doublecomplex*, const long*, doublecomplex*, const long*, const double*, const doublecomplex*));
extern void zscal_64 __P((const long, const doublecomplex*, doublecomplex*, const long));
extern void zscal_64_ __P((const long*, const doublecomplex*, doublecomplex*, const long*));
extern void zsctr_64 __P((const long, const doublecomplex*, const long*, doublecomplex*));
extern void zsctr_64_ __P((const long*, const doublecomplex*, const long*, doublecomplex*));
extern void zskymm_64 __P((const long, const long, const long, const long, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zskymm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zskysm_64 __P((const long, const long, const long, const long, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zskysm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zspcon_64 __P((const char, const long, const doublecomplex*, const long*, const double, double*, long*));
extern void zspcon_64_ __P((const char*, const long*, const doublecomplex*, const long*, const double*, double*, doublecomplex*, long*, const long));
extern void zspmv_64 __P((const char, const long, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zspmv_64_ __P((const char*, const long*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, const long));
extern void zsprfs_64 __P((const char, const long, const long, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, long*));
extern void zsprfs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long));
extern void zspsvx_64 __P((const char, const char, const long, const long, const doublecomplex*, doublecomplex*, long*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, double*, long*));
extern void zspsvx_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, doublecomplex*, long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, double*, doublecomplex*, double*, long*, const long, const long));
extern void zspsv_64 __P((const char, const long, const long, doublecomplex*, long*, doublecomplex*, const long, long*));
extern void zspsv_64_ __P((const char*, const long*, const long*, doublecomplex*, long*, doublecomplex*, const long*, long*, const long));
extern void zsptrf_64 __P((const char, const long, doublecomplex*, long*, long*));
extern void zsptrf_64_ __P((const char*, const long*, doublecomplex*, long*, long*, const long));
extern void zsptri_64 __P((const char, const long, doublecomplex*, const long*, long*));
extern void zsptri_64_ __P((const char*, const long*, doublecomplex*, const long*, doublecomplex*, long*, const long));
extern void zsptrs_64 __P((const char, const long, const long, const doublecomplex*, const long*, doublecomplex*, const long, long*));
extern void zsptrs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, long*, const long));
extern void zstedc_64 __P((const char, const long, double*, double*, doublecomplex*, const long, long*));
extern void zstedc_64_ __P((const char*, const long*, double*, double*, doublecomplex*, const long*, doublecomplex*, const long*, double*, const long*, long*, const long*, long*, const long));
extern void zstegr_64 __P((const char, const char, const long, double*, double*, const double, const double, const long, const long, const double, long*, double*, doublecomplex*, const long, long*, long*));
extern void zstegr_64_ __P((const char*, const char*, const long*, double*, double*, const double*, const double*, const long*, const long*, const double*, long*, double*, doublecomplex*, const long*, long*, double*, const long*, long*, const long*, long*, const long, const long));
extern void zstein_64 __P((const long, const double*, const double*, const long, const double*, const long*, const long*, doublecomplex*, const long, long*, long*));
extern void zstein_64_ __P((const long*, const double*, const double*, const long*, const double*, const long*, const long*, doublecomplex*, const long*, double*, long*, long*, long*));
extern void zsteqr_64 __P((const char, const long, double*, double*, doublecomplex*, const long, long*));
extern void zsteqr_64_ __P((const char*, const long*, double*, double*, doublecomplex*, const long*, double*, long*, const long));
extern void zstsv_64 __P((const long, const long, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, const long, long*, long*));
extern void zstsv_64_ __P((const long*, const long*, doublecomplex*, doublecomplex*, doublecomplex*, doublecomplex*, const long*, long*, long*));
extern void zsttrf_64 __P((const long, doublecomplex*, doublecomplex*, doublecomplex*, long*, long*));
extern void zsttrf_64_ __P((const long*, doublecomplex*, doublecomplex*, doublecomplex*, long*, long*));
extern void zsttrs_64 __P((const long, const long, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long, long*, long*));
extern void zsttrs_64_ __P((const long*, const long*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const doublecomplex*, const long*, long*, long*));
extern void zswap_64 __P((const long, doublecomplex*, const long, doublecomplex*, const long));
extern void zswap_64_ __P((const long*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zsycon_64 __P((const char, const long, const doublecomplex*, const long, const long*, const double, double*, long*));
extern void zsycon_64_ __P((const char*, const long*, const doublecomplex*, const long*, const long*, const double*, double*, doublecomplex*, long*, const long));
extern void zsymm_64 __P((const char, const char, const long, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zsymm_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, const long, const long));
extern void zsyr2k_64 __P((const char, const char, const long, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zsyr2k_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, const long, const long));
extern void zsyrfs_64 __P((const char, const long, const long, const doublecomplex*, const long, const doublecomplex*, const long, const long*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, long*));
extern void zsyrfs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long));
extern void zsyrk_64 __P((const char, const char, const long, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zsyrk_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, const long, const long));
extern void zsysvx_64 __P((const char, const char, const long, const long, const doublecomplex*, const long, doublecomplex*, const long, long*, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, double*, long*));
extern void zsysvx_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, double*, doublecomplex*, const long*, double*, long*, const long, const long));
extern void zsysv_64 __P((const char, const long, const long, doublecomplex*, const long, long*, doublecomplex*, const long, long*));
extern void zsysv_64_ __P((const char*, const long*, const long*, doublecomplex*, const long*, long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long));
extern void zsytf2_64 __P((const char, const long, doublecomplex*, const long, long*, long*));
extern void zsytf2_64_ __P((const char*, const long*, doublecomplex*, const long*, long*, long*, const long));
extern void zsytrf_64 __P((const char, const long, doublecomplex*, const long, long*, long*));
extern void zsytrf_64_ __P((const char*, const long*, doublecomplex*, const long*, long*, doublecomplex*, const long*, long*, const long));
extern void zsytri_64 __P((const char, const long, doublecomplex*, const long, const long*, long*));
extern void zsytri_64_ __P((const char*, const long*, doublecomplex*, const long*, const long*, doublecomplex*, long*, const long));
extern void zsytrs_64 __P((const char, const long, const long, const doublecomplex*, const long, const long*, doublecomplex*, const long, long*));
extern void zsytrs_64_ __P((const char*, const long*, const long*, const doublecomplex*, const long*, const long*, doublecomplex*, const long*, long*, const long));
extern void ztbcon_64 __P((const char, const char, const char, const long, const long, const doublecomplex*, const long, double*, long*));
extern void ztbcon_64_ __P((const char*, const char*, const char*, const long*, const long*, const doublecomplex*, const long*, double*, doublecomplex*, double*, long*, const long, const long, const long));
extern void ztbmv_64 __P((const char, const char, const char, const long, const long, const doublecomplex*, const long, doublecomplex*, const long));
extern void ztbmv_64_ __P((const char*, const char*, const char*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, const long, const long, const long));
extern void ztbrfs_64 __P((const char, const char, const char, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, const long, double*, double*, long*));
extern void ztbrfs_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long, const long, const long));
extern void ztbsv_64 __P((const char, const char, const char, const long, const long, const doublecomplex*, const long, doublecomplex*, const long));
extern void ztbsv_64_ __P((const char*, const char*, const char*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, const long, const long, const long));
extern void ztbtrs_64 __P((const char, const char, const char, const long, const long, const long, const doublecomplex*, const long, doublecomplex*, const long, long*));
extern void ztbtrs_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, long*, const long, const long, const long));
extern void ztgevc_64 __P((const char, const char, const long*, const long, const doublecomplex*, const long, const doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, const long, const long, long*, long*));
extern void ztgevc_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, const long*, long*, doublecomplex*, double*, long*, const long, const long));
extern void ztgexc_64 __P((const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, const long, long*, long*, long*));
extern void ztgexc_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, long*, long*, long*));
extern void ztgsen_64 __P((const long, const long, const long, const long*, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, doublecomplex*, doublecomplex*, const long, doublecomplex*, const long, long*, double*, double*, double*, long*));
extern void ztgsen_64_ __P((const long*, const long*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, long*, double*, double*, double*, doublecomplex*, const long*, long*, const long*, long*));
extern void ztgsja_64 __P((const char, const char, const char, const long, const long, const long, const long, const long, doublecomplex*, const long, doublecomplex*, const long, const double, const double, double*, double*, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, const long, long*, long*));
extern void ztgsja_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, const double*, const double*, double*, double*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, long*, long*, const long, const long, const long));
extern void ztgsna_64 __P((const char, const char, const long*, const long, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, const long, double*, double*, const long, long*, long*));
extern void ztgsna_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, double*, double*, const long*, long*, doublecomplex*, const long*, long*, long*, const long, const long));
extern void ztgsyl_64 __P((const char, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, const long, doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, const long, doublecomplex*, const long, double*, double*, long*));
extern void ztgsyl_64_ __P((const char*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, double*, doublecomplex*, const long*, long*, long*, const long));
extern void ztpcon_64 __P((const char, const char, const char, const long, const doublecomplex*, double*, long*));
extern void ztpcon_64_ __P((const char*, const char*, const char*, const long*, const doublecomplex*, double*, doublecomplex*, double*, long*, const long, const long, const long));
extern void ztpmv_64 __P((const char, const char, const char, const long, const doublecomplex*, doublecomplex*, const long));
extern void ztpmv_64_ __P((const char*, const char*, const char*, const long*, const doublecomplex*, doublecomplex*, const long*, const long, const long, const long));
extern void ztprfs_64 __P((const char, const char, const char, const long, const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, double*, double*, long*));
extern void ztprfs_64_ __P((const char*, const char*, const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long, const long, const long));
extern void ztpsv_64 __P((const char, const char, const char, const long, const doublecomplex*, doublecomplex*, const long));
extern void ztpsv_64_ __P((const char*, const char*, const char*, const long*, const doublecomplex*, doublecomplex*, const long*, const long, const long, const long));
extern void ztptri_64 __P((const char, const char, const long, doublecomplex*, long*));
extern void ztptri_64_ __P((const char*, const char*, const long*, doublecomplex*, long*, const long, const long));
extern void ztptrs_64 __P((const char, const char, const char, const long, const long, const doublecomplex*, doublecomplex*, const long, long*));
extern void ztptrs_64_ __P((const char*, const char*, const char*, const long*, const long*, const doublecomplex*, doublecomplex*, const long*, long*, const long, const long, const long));
extern void ztrans_64 __P((const char, const doublecomplex*, doublecomplex*, const long, const long, doublecomplex*));
extern void ztrans_64_ __P((const char*, const doublecomplex*, doublecomplex*, const long*, const long*, doublecomplex*, const long));
extern void ztrcon_64 __P((const char, const char, const char, const long, const doublecomplex*, const long, double*, long*));
extern void ztrcon_64_ __P((const char*, const char*, const char*, const long*, const doublecomplex*, const long*, double*, doublecomplex*, double*, long*, const long, const long, const long));
extern void ztrevc_64 __P((const char, const char, long*, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, const long, const long, long*, long*));
extern void ztrevc_64_ __P((const char*, const char*, long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, const long*, long*, doublecomplex*, double*, long*, const long, const long));
extern void ztrexc_64 __P((const char, const long, doublecomplex*, const long, doublecomplex*, const long, const long, const long, long*));
extern void ztrexc_64_ __P((const char*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, const long*, const long*, long*, const long));
extern void ztrmm_64 __P((const char, const char, const char, const char, const long, const long, const doublecomplex*, const doublecomplex*, const long, doublecomplex*, const long));
extern void ztrmm_64_ __P((const char*, const char*, const char*, const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, doublecomplex*, const long*, const long, const long, const long, const long));
extern void ztrmv_64 __P((const char, const char, const char, const long, const doublecomplex*, const long, doublecomplex*, const long));
extern void ztrmv_64_ __P((const char*, const char*, const char*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, const long, const long, const long));
extern void ztrrfs_64 __P((const char, const char, const char, const long, const long, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, const long, double*, double*, long*));
extern void ztrrfs_64_ __P((const char*, const char*, const char*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, double*, double*, doublecomplex*, double*, long*, const long, const long, const long));
extern void ztrsen_64 __P((const char, const char, const long*, const long, doublecomplex*, const long, doublecomplex*, const long, doublecomplex*, long*, double*, double*, long*));
extern void ztrsen_64_ __P((const char*, const char*, const long*, const long*, doublecomplex*, const long*, doublecomplex*, const long*, doublecomplex*, long*, double*, double*, doublecomplex*, const long*, long*, const long, const long));
extern void ztrsm_64 __P((const char, const char, const char, const char, const long, const long, const doublecomplex*, const doublecomplex*, const long, doublecomplex*, const long));
extern void ztrsm_64_ __P((const char*, const char*, const char*, const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, doublecomplex*, const long*, const long, const long, const long, const long));
extern void ztrsna_64 __P((const char, const char, const long*, const long, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, const long, double*, double*, const long, long*, const long, long*));
extern void ztrsna_64_ __P((const char*, const char*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, double*, double*, const long*, long*, doublecomplex*, const long*, double*, long*, const long, const long));
extern void ztrsv_64 __P((const char, const char, const char, const long, const doublecomplex*, const long, doublecomplex*, const long));
extern void ztrsv_64_ __P((const char*, const char*, const char*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, const long, const long, const long));
extern void ztrsyl_64 __P((const char, const char, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, const long, doublecomplex*, const long, double*, long*));
extern void ztrsyl_64_ __P((const char*, const char*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, double*, long*, const long, const long));
extern void ztrti2_64 __P((const char, const char, const long, doublecomplex*, const long, long*));
extern void ztrti2_64_ __P((const char*, const char*, const long*, doublecomplex*, const long*, long*, const long, const long));
extern void ztrtri_64 __P((const char, const char, const long, doublecomplex*, const long, long*));
extern void ztrtri_64_ __P((const char*, const char*, const long*, doublecomplex*, const long*, long*, const long, const long));
extern void ztrtrs_64 __P((const char, const char, const char, const long, const long, const doublecomplex*, const long, doublecomplex*, const long, long*));
extern void ztrtrs_64_ __P((const char*, const char*, const char*, const long*, const long*, const doublecomplex*, const long*, doublecomplex*, const long*, long*, const long, const long, const long));
extern void ztzrqf_64 __P((const long, const long, doublecomplex*, const long, doublecomplex*, long*));
extern void ztzrqf_64_ __P((const long*, const long*, doublecomplex*, const long*, doublecomplex*, long*));
extern void ztzrzf_64 __P((const long, const long, doublecomplex*, const long, doublecomplex*, long*));
extern void ztzrzf_64_ __P((const long*, const long*, doublecomplex*, const long*, doublecomplex*, doublecomplex*, const long*, long*));
extern void zung2l_64 __P((const long, const long, const long, doublecomplex*, const long, const doublecomplex*, long*));
extern void zung2l_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, const doublecomplex*, doublecomplex*, long*));
extern void zung2r_64 __P((const long, const long, const long, doublecomplex*, const long, const doublecomplex*, long*));
extern void zung2r_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, const doublecomplex*, doublecomplex*, long*));
extern void zungbr_64 __P((const char, const long, const long, const long, doublecomplex*, const long, const doublecomplex*, long*));
extern void zungbr_64_ __P((const char*, const long*, const long*, const long*, doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, long*, const long));
extern void zunghr_64 __P((const long, const long, const long, doublecomplex*, const long, const doublecomplex*, long*));
extern void zunghr_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, long*));
extern void zungl2_64 __P((const long, const long, const long, doublecomplex*, const long, const doublecomplex*, long*));
extern void zungl2_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, const doublecomplex*, doublecomplex*, long*));
extern void zunglq_64 __P((const long, const long, const long, doublecomplex*, const long, const doublecomplex*, long*));
extern void zunglq_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, long*));
extern void zungql_64 __P((const long, const long, const long, doublecomplex*, const long, const doublecomplex*, long*));
extern void zungql_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, long*));
extern void zungqr_64 __P((const long, const long, const long, doublecomplex*, const long, const doublecomplex*, long*));
extern void zungqr_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, long*));
extern void zungr2_64 __P((const long, const long, const long, doublecomplex*, const long, const doublecomplex*, long*));
extern void zungr2_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, const doublecomplex*, doublecomplex*, long*));
extern void zungrq_64 __P((const long, const long, const long, doublecomplex*, const long, const doublecomplex*, long*));
extern void zungrq_64_ __P((const long*, const long*, const long*, doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, long*));
extern void zungtr_64 __P((const char, const long, doublecomplex*, const long, const doublecomplex*, long*));
extern void zungtr_64_ __P((const char*, const long*, doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, long*, const long));
extern void zunmbr_64 __P((const char, const char, const char, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long, long*));
extern void zunmbr_64_ __P((const char*, const char*, const char*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long, const long, const long));
extern void zunmhr_64 __P((const char, const char, const long, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long, long*));
extern void zunmhr_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long, const long));
extern void zunml2_64 __P((const char, const char, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long, long*));
extern void zunml2_64_ __P((const char*, const char*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, long*, const long, const long));
extern void zunmlq_64 __P((const char, const char, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long, long*));
extern void zunmlq_64_ __P((const char*, const char*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long, const long));
extern void zunmql_64 __P((const char, const char, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long, long*));
extern void zunmql_64_ __P((const char*, const char*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long, const long));
extern void zunmqr_64 __P((const char, const char, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long, long*));
extern void zunmqr_64_ __P((const char*, const char*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long, const long));
extern void zunmr2_64 __P((const char, const char, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long, long*));
extern void zunmr2_64_ __P((const char*, const char*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, long*, const long, const long));
extern void zunmrq_64 __P((const char, const char, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long, long*));
extern void zunmrq_64_ __P((const char*, const char*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long, const long));
extern void zunmrz_64 __P((const char, const char, const long, const long, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long, long*));
extern void zunmrz_64_ __P((const char*, const char*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long, const long));
extern void zunmtr_64 __P((const char, const char, const char, const long, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long, long*));
extern void zunmtr_64_ __P((const char*, const char*, const char*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*, long*, const long, const long, const long));
extern void zupgtr_64 __P((const char, const long, const doublecomplex*, const doublecomplex*, doublecomplex*, const long, long*));
extern void zupgtr_64_ __P((const char*, const long*, const doublecomplex*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, long*, const long));
extern void zupmtr_64 __P((const char, const char, const char, const long, const long, const doublecomplex*, const doublecomplex*, doublecomplex*, const long, long*));
extern void zupmtr_64_ __P((const char*, const char*, const char*, const long*, const long*, const doublecomplex*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, long*, const long, const long, const long));
extern void zvbrmm_64 __P((const long, const long, const long, const long, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const long*, const long*, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zvbrmm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zvbrsm_64 __P((const long, const long, const long, const long, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const long*, const long*, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zvbrsm_64_ __P((const long*, const long*, const long*, const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const long*, const long*, const long*, const long*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*, doublecomplex*, const long*));
extern void zvmul_64 __P((const long, const doublecomplex*, const doublecomplex*, const long, const doublecomplex*, const long, const doublecomplex*, doublecomplex*, const long));
extern void zvmul_64_ __P((const long*, const doublecomplex*, const doublecomplex*, const long*, const doublecomplex*, const long*, const doublecomplex*, doublecomplex*, const long*));

#endif /* defined (__sparcv9) || (defined (__x86_64) && defined(__amd64)) */

/* 32-bit SUPERLU data structures and prototypes */
/********************************************/
typedef enum {NO, YES}                                          yes_no_t;
typedef enum {NOTRANS, TRANS, CONJ}                             trans_t;
typedef enum {DOFACT, SamePattern, SamePattern_SameRowPerm,
              FACTORED, EQUILIBRATE}                            fact_t;
typedef enum {NOROWPERM, LargeDiag, MY_PERMR}                   rowperm_t;
typedef enum {NATURAL, MMD_ATA, MMD_AT_PLUS_A, COLAMD, MY_PERMC}colperm_t;
typedef enum {NOEQUIL, ROW, COL, BOTH}                          DiagScale_t;
typedef enum {NOREFINE, SINGLE=1, DOUBLE, EXTRA}                IterRefine_t;
typedef enum {LUSUP, UCOL, LSUB, USUB}                          MemType;
typedef enum {SYSTEM, USER}                                     LU_space_t;

typedef enum {
    COLPERM, /* find a column ordering that minimizes fills */
    RELAX,   /* find artificial supernodes */
    ETREE,   /* compute column etree */
    EQUIL,   /* equilibrate the original matrix */
    FACT,    /* perform LU factorization */
    RCOND,   /* estimate reciprocal condition number */
    SOLVE,   /* forward and back solves */
    REFINE,  /* perform iterative refinement */
    TRSV,    /* fraction of FACT spent in xTRSV */
    GEMV,    /* fraction of FACT spent in xGEMV */
    FERR,    /* estimate error bounds after iterative refinement */
    NPHASES  /* total number of phases */
} PhaseType;

typedef enum {
    SLU_NC,        /* column-wise, no supernode */
    SLU_NCP,       /* column-wise, column-permuted, no supernode
                      (The consecutive columns of nonzeros, after permutation,
                       may not be stored  contiguously.) */
    SLU_NR,        /* row-wize, no supernode */
    SLU_SC,        /* column-wise, supernode */
    SLU_SCP,       /* supernode, column-wise, permuted */
    SLU_SR,        /* row-wise, supernode */
    SLU_DN         /* Fortran style column-wise storage for dense matrix */
} Stype_t;

typedef enum {
    SLU_S,         /* single */
    SLU_D,         /* double */
    SLU_C,         /* single complex */
    SLU_Z          /* double complex */
} Dtype_t;

typedef enum {
    SLU_GE,        /* general */
    SLU_TRLU,      /* lower triangular, unit diagonal */
    SLU_TRUU,      /* upper triangular, unit diagonal */
    SLU_TRL,       /* lower triangular */
    SLU_TRU,       /* upper triangular */
    SLU_SYL,       /* symmetric, store lower half */
    SLU_SYU,       /* symmetric, store upper half */
    SLU_HEL,       /* Hermitian, store lower half */
    SLU_HEU        /* Hermitian, store upper half */
} Mtype_t;

typedef struct {
        Stype_t Stype; /* Storage type: interprets the storage structure
                          pointed to by *Store. */
        Dtype_t Dtype; /* Data type. */
        Mtype_t Mtype; /* Matrix type: describes the mathematical property of
                          the matrix. */
        int  nrow;     /* number of rows */
        int  ncol;     /* number of columns */
        void *Store;   /* pointer to the actual storage of the matrix */
} SuperMatrix;

/***********************************************
 * The storage schemes are defined as follows. *
 ***********************************************/

/* Stype == NC (Also known as Harwell-Boeing sparse matrix format) */
typedef struct {
    int  nnz;    /* number of nonzeros in the matrix */
    void *nzval;  /* pointer to array of nonzero values, packed by column */
    int  *rowind; /* pointer to array of row indices of the nonzeros */
    int  *colptr; /* pointer to array of beginning of columns in nzval[]
                     and rowind[]  */
                  /* Note:
                     Zero-based indexing is used;
                     colptr[] has ncol+1 entries, the last one pointing
                         beyond the last column, so that colptr[ncol] = nnz. */
} NCformat;

/* Stype == NR (Also known as row compressed storage (RCS). */
typedef struct {
    int  nnz;    /* number of nonzeros in the matrix */
    void *nzval;  /* pointer to array of nonzero values, packed by column */
    int  *colind; /* pointer to array of column indices of the nonzeros */
    int  *rowptr; /* pointer to array of beginning of rows in nzval[]
                     and colind[]  */
                  /* Note:
                     Zero-based indexing is used;
                     rowptr[] has nrow+1 entries, the last one pointing
                         beyond the last column, so that rowptr[nrow] = nnz. */
} NRformat;

/* Stype == SC */
typedef struct {
  int  nnz;         /* number of nonzeros in the matrix */
  int  nsuper;       /* number of supernodes, minus 1 */
  void *nzval;       /* pointer to array of nonzero values, packed by column */
  int  *nzval_colptr;/* pointer to array of beginning of columns in nzval[] */
  int  *rowind;      /* pointer to array of compressed row indices of
                        rectangular supernodes */
  int *rowind_colptr;/* pointer to array of beginning of columns in rowind[] */
  int *col_to_sup;   /* col_to_sup[j] is the supernode number to which column
                        j beints; mapping from column to supernode number. */
  int *sup_to_col;   /* sup_to_col[s] points to the start of the s-th
                        supernode; mapping from supernode number to column.
                        e.g.: col_to_sup: 0 1 2 2 3 3 3 4 4 4 4 4 4 (ncol=12)
                              sup_to_col: 0 1 2 4 7 12           (nsuper=4) */
                     /* Note:
                        Zero-based indexing is used;
                        nzval_colptr[], rowind_colptr[], col_to_sup and
                        sup_to_col[] have ncol+1 entries, the last one
                        pointing beyond the last column.         */
} SCformat;

/* Stype == SCP */
typedef struct {
  int  nnz;         /* number of nonzeros in the matrix */
  int  nsuper;       /* number of supernodes */
  void *nzval;       /* pointer to array of nonzero values, packed by column */
  int  *nzval_colbeg;/* nzval_colbeg[j] points to beginning of column j
                        in nzval[] */
  int  *nzval_colend;/* nzval_colend[j] points to one past the last element
                        of column j in nzval[] */
  int  *rowind;      /* pointer to array of compressed row indices of
                        rectangular supernodes */
  int *rowind_colbeg;/* rowind_colbeg[j] points to beginning of column j
                        in rowind[] */
  int *rowind_colend;/* rowind_colend[j] points to one past the last element
                        of column j in rowind[] */
  int *col_to_sup;   /* col_to_sup[j] is the supernode number to which column
                        j beints; mapping from column to supernode number. */
  int *sup_to_colbeg; /* sup_to_colbeg[s] points to the start of the s-th
                        supernode; mapping from supernode number to column.*/
  int *sup_to_colend; /* sup_to_colend[s] points to one past the end of the
                          s-th supernode; mapping from supernode number to
                          column.
                        e.g.: col_to_sup: 0 1 2 2 3 3 3 4 4 4 4 4 4 (ncol=12)
                              sup_to_colbeg: 0 1 2 4 7              (nsuper=4)
                              sup_to_colend: 1 2 4 7 12                    */
                     /* Note:
                        Zero-based indexing is used;
                        nzval_colptr[], rowind_colptr[], col_to_sup and
                        sup_to_col[] have ncol+1 entries, the last one
                        pointing beyond the last column.         */
} SCPformat;

/* Stype == NCP */
typedef struct {
    int nnz;     /* number of nonzeros in the matrix */
    void *nzval;  /* pointer to array of nonzero values, packed by column */
    int *rowind;  /* pointer to array of row indices of the nonzeros */
                  /* Note: nzval[]/rowind[] always have the same length */
    int *colbeg;  /* colbeg[j] points to the beginning of column j in nzval[]
                     and rowind[]  */
    int *colend;  /* colend[j] points to one past the last element of column
                     j in nzval[] and rowind[]  */
                  /* Note:
                     Zero-based indexing is used;
                     The consecutive columns of the nonzeros may not be
                     contiguous in storage, because the matrix has been
                     postmultiplied by a column permutation matrix. */
} NCPformat;

/* Stype == DN */
typedef struct {
    int lda;      /* leading dimension */
    void *nzval;  /* array of size lda*ncol to represent a dense matrix */
} DNformat;
/*
typedef struct {
    int     *xsup;            supernode and column mapping
    int     *supno;
    int     *lsub;            compressed L subscripts
    int       *xlsub;
    float  *lusup;            L supernodes
    int     *xlusup;
    float  *ucol;             U columns
    int     *usub;
    int       *xusub;
    int     nzlmax;           current max size of lsub
    int     nzumax;              "    "    "      ucol
    int     nzlumax;             "    "    "     lusup
    int     n;                number of columns in the matrix
    LU_space_t MemModel;      0 - system malloc'd; 1 - user provided
} GlobalLU_t;
*/
typedef struct {
    float for_lu;
    float total_needed;
    int   expansions;
} mem_usage_t;

typedef struct {
    fact_t        Fact;
    yes_no_t      Equil;
    colperm_t     ColPerm;
    trans_t       Trans;
    IterRefine_t  IterRefine;
    yes_no_t      PrintStat;
    yes_no_t      SymmetricMode;
    double        DiagPivotThresh;
    yes_no_t      PivotGrowth;
    yes_no_t      ConditionNumber;
    rowperm_t     RowPerm;
    yes_no_t      ReplaceTinyPivot;
    yes_no_t      SolveInitialized;
    yes_no_t      RefineInitialized;
} superlu_options_t;

typedef struct {
    int     *panel_histo; /* histogram of panel size distribution */
    double  *utime;       /* running time at various phases */
    float *ops;         /* operation count at various phases */
    int     TinyPivots;   /* number of tiny pivots */
    int     RefineSteps;  /* number of iterative refinement steps */
} SuperLUStat_t;


/**** superlu 32-bit routines ****/
extern void slu_xerbla0(const char *, int, int);
extern void slu_xerbla1(const char *, int, const char *, int, int, int);
extern void set_default_options(superlu_options_t *);
extern void Destroy_SuperMatrix_Store(SuperMatrix *);
extern void Destroy_CompCol_Matrix(SuperMatrix *);
extern void Destroy_CompRow_Matrix(SuperMatrix *);
extern void Destroy_SuperNode_Matrix(SuperMatrix *);
extern void Destroy_CompCol_Permuted(SuperMatrix *);
extern void Destroy_Dense_Matrix(SuperMatrix *);
extern void get_perm_c(int, SuperMatrix *, int *);
extern void sp_preorder(superlu_options_t *, SuperMatrix*, int* , int*, SuperMatrix*);
extern void StatInit(SuperLUStat_t *);
extern void StatFree(SuperLUStat_t *);
extern double LUFactTime(SuperLUStat_t *);
extern double LUSolveTime(SuperLUStat_t *);
extern float LUFactFlops(SuperLUStat_t *);
extern float LUSolveFlops(SuperLUStat_t *);
extern int sp_ienv(int);

/**** superlu single-precision 32-bit routines ****/
extern void sgssv(superlu_options_t *, SuperMatrix *, int *, int *,
                  SuperMatrix *, SuperMatrix *, SuperMatrix *,
                  SuperLUStat_t *, int *);
extern void sgssvx(superlu_options_t *, SuperMatrix *, int *, int *, int *,
                   char *, float *, float *, SuperMatrix *, SuperMatrix *,
                   void *, int, SuperMatrix *, SuperMatrix *,
       		   float *, float *, float *, float *,
                   mem_usage_t *, SuperLUStat_t *, int *);
extern void sgscon (char *, SuperMatrix *, SuperMatrix *,
                    float, float *, SuperLUStat_t*, int *);
extern void sgsequ (SuperMatrix *, float *, float *, float *,
                    float *, float *, int *);
extern void sgsrfs (trans_t, SuperMatrix *, SuperMatrix *,
                    SuperMatrix *, int *, int *, char *, float *,
                    float *, SuperMatrix *, SuperMatrix *,
                    float *, float *, SuperLUStat_t*, int *);
extern void sgstrs (trans_t, SuperMatrix *, SuperMatrix *, int *, int *,
                    SuperMatrix *, SuperLUStat_t*, int *);
extern void sgstrf (superlu_options_t*, SuperMatrix*, float,
                    int, int, int*, void *, int, int *, int *,
                    SuperMatrix *, SuperMatrix *, SuperLUStat_t*, int *);
extern float slangs (char *, SuperMatrix *);
extern void slaqgs (SuperMatrix *, float *, float *, float,
                    float, float, char *);
extern int sp_sgemm (char *, char *, int, int, int, float, SuperMatrix *,
                     float *, int, float, float *, int);
extern void sCreate_CompCol_Matrix(SuperMatrix *, int, int, int, float *,
                                   int *, int *, Stype_t, Dtype_t, Mtype_t);
extern void sCreate_CompRow_Matrix(SuperMatrix *, int, int, int, float *,
                                   int *, int *, Stype_t, Dtype_t, Mtype_t);
extern void sCopy_CompCol_Matrix(SuperMatrix *, SuperMatrix *);
extern void sCreate_Dense_Matrix(SuperMatrix *, int, int, float *, int,
                     Stype_t, Dtype_t, Mtype_t);
extern void sCreate_SuperNode_Matrix(SuperMatrix *, int, int, int, float *,
                         int *, int *, int *, int *, int *,
                         Stype_t, Dtype_t, Mtype_t);
extern void sinfinite_norm_error(int, SuperMatrix *, float *, float *);
extern int sQuerySpace(SuperMatrix *, SuperMatrix *, mem_usage_t *);
extern void sPrintPerf(SuperMatrix *, SuperMatrix *, mem_usage_t *,
           float, float, float *, float *, char *, SuperLUStat_t *);

/**** superlu double-precision 32-bit routines ****/
extern void dgssv(superlu_options_t *, SuperMatrix *, int *, int *,
                  SuperMatrix *, SuperMatrix *, SuperMatrix *,
                  SuperLUStat_t *, int *);
extern void dgssvx(superlu_options_t *, SuperMatrix *, int *, int *, int *,
                   char *, double *, double *, SuperMatrix *, SuperMatrix *,
                   void *, int, SuperMatrix *, SuperMatrix *,
       		   double *, double *, double *, double *,
                   mem_usage_t *, SuperLUStat_t *, int *);
extern void dgscon (char *, SuperMatrix *, SuperMatrix *,
                    double, double *, SuperLUStat_t*, int *);
extern void dgsequ (SuperMatrix *, double *, double *, double *,
                    double *, double *, int *);
extern void dgsrfs (trans_t, SuperMatrix *, SuperMatrix *,
                    SuperMatrix *, int *, int *, char *, double *,
                    double *, SuperMatrix *, SuperMatrix *,
                    double *, double *, SuperLUStat_t*, int *);
extern void dgstrs (trans_t, SuperMatrix *, SuperMatrix *, int *, int *,
                    SuperMatrix *, SuperLUStat_t*, int *);
extern void dgstrf (superlu_options_t*, SuperMatrix*, double,
                    int, int, int*, void *, int, int *, int *,
                    SuperMatrix *, SuperMatrix *, SuperLUStat_t*, int *);
extern double dlangs (char *, SuperMatrix *);
extern void dlaqgs (SuperMatrix *, double *, double *, double,
                    double, double, char *);
extern int sp_dgemm (char *, char *, int, int, int, double, SuperMatrix *,
                     double *, int, double, double *, int);
extern void dCreate_CompCol_Matrix(SuperMatrix *, int, int, int, double *,
                                   int *, int *, Stype_t, Dtype_t, Mtype_t);
extern void dCreate_CompRow_Matrix(SuperMatrix *, int, int, int, double *,
                                   int *, int *, Stype_t, Dtype_t, Mtype_t);
extern void dCopy_CompCol_Matrix(SuperMatrix *, SuperMatrix *);
extern void dCreate_Dense_Matrix(SuperMatrix *, int, int, double *, int,
                     Stype_t, Dtype_t, Mtype_t);
extern void dCreate_SuperNode_Matrix(SuperMatrix *, int, int, int, double *,
                         int *, int *, int *, int *, int *,
                         Stype_t, Dtype_t, Mtype_t);
extern void dinfinite_norm_error(int, SuperMatrix *, double *, double *);
extern int dQuerySpace(SuperMatrix *, SuperMatrix *, mem_usage_t *);
extern void dPrintPerf(SuperMatrix *, SuperMatrix *, mem_usage_t *,
           double, double, double *, double *, char *, SuperLUStat_t *);

/**** superlu complex 32-bit routines ****/
extern void cgssv(superlu_options_t *, SuperMatrix *, int *, int *,
                  SuperMatrix *, SuperMatrix *, SuperMatrix *,
                  SuperLUStat_t *, int *);
extern void cgssvx(superlu_options_t *, SuperMatrix *, int *, int *, int *,
                   char *, float *, float *, SuperMatrix *, SuperMatrix *,
                   void *, int, SuperMatrix *, SuperMatrix *,
       		   float *, float *, float *, float *,
                   mem_usage_t *, SuperLUStat_t *, int *);
extern void cgscon (char *, SuperMatrix *, SuperMatrix *,
                    float, float *, SuperLUStat_t*, int *);
extern void cgsequ (SuperMatrix *, float *, float *, float *,
                    float *, float *, int *);
extern void cgsrfs (trans_t, SuperMatrix *, SuperMatrix *,
                    SuperMatrix *, int *, int *, char *, float *,
                    float *, SuperMatrix *, SuperMatrix *,
                    float *, float *, SuperLUStat_t*, int *);
extern void cgstrs (trans_t, SuperMatrix *, SuperMatrix *, int *, int *,
                    SuperMatrix *, SuperLUStat_t*, int *);
extern void cgstrf (superlu_options_t*, SuperMatrix*, float,
                    int, int, int*, void *, int, int *, int *,
                    SuperMatrix *, SuperMatrix *, SuperLUStat_t*, int *);
extern float clangs (char *, SuperMatrix *);
extern void claqgs (SuperMatrix *, float *, float *, float,
                    float, float, char *);
extern int sp_cgemm (char *, char *, int, int, int, complex, SuperMatrix *,
                     complex *, int, complex, complex *, int);
extern void cCreate_CompCol_Matrix(SuperMatrix *, int, int, int, complex *,
                                   int *, int *, Stype_t, Dtype_t, Mtype_t);
extern void cCreate_CompRow_Matrix(SuperMatrix *, int, int, int, complex *,
                                   int *, int *, Stype_t, Dtype_t, Mtype_t);
extern void cCopy_CompCol_Matrix(SuperMatrix *, SuperMatrix *);
extern void cCreate_Dense_Matrix(SuperMatrix *, int, int, complex *, int,
                     Stype_t, Dtype_t, Mtype_t);
extern void cCreate_SuperNode_Matrix(SuperMatrix *, int, int, int, complex *,
                         int *, int *, int *, int *, int *,
                         Stype_t, Dtype_t, Mtype_t);
extern void cinfinite_norm_error(int, SuperMatrix *, complex *, float *);
extern int cQuerySpace(SuperMatrix *, SuperMatrix *, mem_usage_t *);
extern void cPrintPerf(SuperMatrix *, SuperMatrix *, mem_usage_t *,
           float, float, float *, float *, char *, SuperLUStat_t *);

/**** superlu double complex 32-bit routines ****/
extern void zgssv(superlu_options_t *, SuperMatrix *, int *, int *,
                  SuperMatrix *, SuperMatrix *, SuperMatrix *,
                  SuperLUStat_t *, int *);
extern void zgssvx(superlu_options_t *, SuperMatrix *, int *, int *, int *,
                   char *, double *, double *, SuperMatrix *, SuperMatrix *,
                   void *, int, SuperMatrix *, SuperMatrix *,
       		   double *, double *, double *, double *,
                   mem_usage_t *, SuperLUStat_t *, int *);
extern void zgscon (char *, SuperMatrix *, SuperMatrix *,
                    double, double *, SuperLUStat_t*, int *);
extern void zgsequ (SuperMatrix *, double *, double *, double *,
                    double *, double *, int *);
extern void zgsrfs (trans_t, SuperMatrix *, SuperMatrix *,
                    SuperMatrix *, int *, int *, char *, double *,
                    double *, SuperMatrix *, SuperMatrix *,
                    double *, double *, SuperLUStat_t*, int *);
extern void zgstrs (trans_t, SuperMatrix *, SuperMatrix *, int *, int *,
                    SuperMatrix *, SuperLUStat_t*, int *);
extern void zgstrf (superlu_options_t*, SuperMatrix*, double,
                    int, int, int*, void *, int, int *, int *,
                    SuperMatrix *, SuperMatrix *, SuperLUStat_t*, int *);
extern double zlangs (char *, SuperMatrix *);
extern void zlaqgs (SuperMatrix *, double *, double *, double,
                    double, double, char *);
extern int sp_zgemm (char *, char *, int, int, int, doublecomplex, SuperMatrix *,
                     doublecomplex *, int, doublecomplex, doublecomplex *, int);
extern void zCreate_CompCol_Matrix(SuperMatrix *, int, int, int, doublecomplex *,
                                   int *, int *, Stype_t, Dtype_t, Mtype_t);
extern void zCreate_CompRow_Matrix(SuperMatrix *, int, int, int, doublecomplex *,
                                   int *, int *, Stype_t, Dtype_t, Mtype_t);
extern void zCopy_CompCol_Matrix(SuperMatrix *, SuperMatrix *);
extern void zCreate_Dense_Matrix(SuperMatrix *, int, int, doublecomplex *, int,
                     Stype_t, Dtype_t, Mtype_t);
extern void zCreate_SuperNode_Matrix(SuperMatrix *, int, int, int, doublecomplex *,
                         int *, int *, int *, int *, int *,
                         Stype_t, Dtype_t, Mtype_t);
extern void zinfinite_norm_error(int, SuperMatrix *, doublecomplex *, double *);
extern int zQuerySpace(SuperMatrix *, SuperMatrix *, mem_usage_t *);
extern void zPrintPerf(SuperMatrix *, SuperMatrix *, mem_usage_t *,
           double, double, double *, double *, char *, SuperLUStat_t *);
/* 64-bit SUPERLU data structures and prototypes */
/********************************************/
#if defined (__sparcv9) || (defined (__x86_64) && defined(__amd64))
typedef struct {
        Stype_t Stype; /* Storage type: interprets the storage structure
                          pointed to by *Store. */
        Dtype_t Dtype; /* Data type. */
        Mtype_t Mtype; /* Matrix type: describes the mathematical property of
                          the matrix. */
        long  nrow;     /* number of rows */
        long  ncol;     /* number of columns */
        void *Store;   /* pointer to the actual storage of the matrix */
} SuperMatrix_64;

/***********************************************
 * The storage schemes are defined as follows. *
 ***********************************************/

/* Stype == NC (Also known as Harwell-Boeing sparse matrix format) */
typedef struct {
    long  nnz;    /* number of nonzeros in the matrix */
    void *nzval;  /* pointer to array of nonzero values, packed by column */
    long  *rowind; /* pointer to array of row indices of the nonzeros */
    long  *colptr; /* pointer to array of beginning of columns in nzval[]
                     and rowind[]  */
                  /* Note:
                     Zero-based indexing is used;
                     colptr[] has ncol+1 entries, the last one pointing
                         beyond the last column, so that colptr[ncol] = nnz. */
} NCformat_64;

/* Stype == NR (Also known as row compressed storage (RCS). */
typedef struct {
    long  nnz;    /* number of nonzeros in the matrix */
    void *nzval;  /* pointer to array of nonzero values, packed by column */
    long  *colind; /* pointer to array of column indices of the nonzeros */
    long  *rowptr; /* pointer to array of beginning of rows in nzval[]
                     and colind[]  */
                  /* Note:
                     Zero-based indexing is used;
                     rowptr[] has nrow+1 entries, the last one pointing
                         beyond the last column, so that rowptr[nrow] = nnz. */
} NRformat_64;

/* Stype == SC */
typedef struct {
  long  nnz;         /* number of nonzeros in the matrix */
  long  nsuper;       /* number of supernodes, minus 1 */
  void *nzval;       /* pointer to array of nonzero values, packed by column */
  long  *nzval_colptr;/* pointer to array of beginning of columns in nzval[] */
  long  *rowind;      /* pointer to array of compressed row indices of
                        rectangular supernodes */
  long *rowind_colptr;/* pointer to array of beginning of columns in rowind[] */
  long *col_to_sup;   /* col_to_sup[j] is the supernode number to which column
                        j beints; mapping from column to supernode number. */
  long *sup_to_col;   /* sup_to_col[s] points to the start of the s-th
                        supernode; mapping from supernode number to column.
                        e.g.: col_to_sup: 0 1 2 2 3 3 3 4 4 4 4 4 4 (ncol=12)
                              sup_to_col: 0 1 2 4 7 12           (nsuper=4) */
                     /* Note:
                        Zero-based indexing is used;
                        nzval_colptr[], rowind_colptr[], col_to_sup and
                        sup_to_col[] have ncol+1 entries, the last one
                        pointing beyond the last column.         */
} SCformat_64;

/* Stype == SCP */
typedef struct {
  long  nnz;         /* number of nonzeros in the matrix */
  long  nsuper;       /* number of supernodes */
  void *nzval;       /* pointer to array of nonzero values, packed by column */
  long  *nzval_colbeg;/* nzval_colbeg[j] points to beginning of column j
                        in nzval[] */
  long  *nzval_colend;/* nzval_colend[j] points to one past the last element
                        of column j in nzval[] */
  long  *rowind;      /* pointer to array of compressed row indices of
                        rectangular supernodes */
  long *rowind_colbeg;/* rowind_colbeg[j] points to beginning of column j
                        in rowind[] */
  long *rowind_colend;/* rowind_colend[j] points to one past the last element
                        of column j in rowind[] */
  long *col_to_sup;   /* col_to_sup[j] is the supernode number to which column
                        j beints; mapping from column to supernode number. */
  long *sup_to_colbeg; /* sup_to_colbeg[s] points to the start of the s-th
                        supernode; mapping from supernode number to column.*/
  long *sup_to_colend; /* sup_to_colend[s] points to one past the end of the
                          s-th supernode; mapping from supernode number to
                          column.
                        e.g.: col_to_sup: 0 1 2 2 3 3 3 4 4 4 4 4 4 (ncol=12)
                              sup_to_colbeg: 0 1 2 4 7              (nsuper=4)
                              sup_to_colend: 1 2 4 7 12                    */
                     /* Note:
                        Zero-based indexing is used;
                        nzval_colptr[], rowind_colptr[], col_to_sup and
                        sup_to_col[] have ncol+1 entries, the last one
                        pointing beyond the last column.         */
} SCPformat_64;

/* Stype == NCP */
typedef struct {
    long nnz;     /* number of nonzeros in the matrix */
    void *nzval;  /* pointer to array of nonzero values, packed by column */
    long *rowind;  /* pointer to array of row indices of the nonzeros */
                  /* Note: nzval[]/rowind[] always have the same length */
    long *colbeg;  /* colbeg[j] points to the beginning of column j in nzval[]
                     and rowind[]  */
    long *colend;  /* colend[j] points to one past the last element of column
                     j in nzval[] and rowind[]  */
                  /* Note:
                     Zero-based indexing is used;
                     The consecutive columns of the nonzeros may not be
                     contiguous in storage, because the matrix has been
                     postmultiplied by a column permutation matrix. */
} NCPformat_64;

/* Stype == DN */
typedef struct {
    long lda;      /* leading dimension */
    void *nzval;  /* array of size lda*ncol to represent a dense matrix */
} DNformat_64;
/*
typedef struct {
    long     *xsup;            supernode and column mapping
    long     *supno;
    long     *lsub;            compressed L subscripts
    long       *xlsub;
    double  *lusup;            L supernodes
    long     *xlusup;
    double  *ucol;             U columns
    long     *usub;
    long       *xusub;
    long     nzlmax;           current max size of lsub
    long     nzumax;              "    "    "      ucol
    long     nzlumax;             "    "    "     lusup
    long     n;                number of columns in the matrix
    LU_space_t MemModel;       0 - system malloc'd; 1 - user provided
} GlobalLU_t_64;
*/
typedef struct {
    float for_lu;
    float total_needed;
    long   expansions;
} mem_usage_t_64;

typedef struct {
    fact_t        Fact;
    yes_no_t      Equil;
    colperm_t     ColPerm;
    trans_t       Trans;
    IterRefine_t  IterRefine;
    yes_no_t      PrintStat;
    yes_no_t      SymmetricMode;
    double        DiagPivotThresh;
    yes_no_t      PivotGrowth;
    yes_no_t      ConditionNumber;
    rowperm_t     RowPerm;
    yes_no_t      ReplaceTinyPivot;
    yes_no_t      SolveInitialized;
    yes_no_t      RefineInitialized;
} superlu_options_t_64;

typedef struct {
    long     *panel_histo; /* histogram of panel size distribution */
    double  *utime;       /* running time at various phases */
    float *ops;         /* operation count at various phases */
    long     TinyPivots;   /* number of tiny pivots */
    long     RefineSteps;  /* number of iterative refinement steps */
} SuperLUStat_t_64;

/**** superlu 64-bit routines ****/
extern void slu_xerbla0_64(const char *, long, long);
extern void slu_xerbla1_64(const char *, long, const char *, long, long, long);
extern void set_default_options_64(superlu_options_t_64 *);
extern void Destroy_SuperMatrix_Store_64(SuperMatrix_64 *);
extern void Destroy_CompCol_Matrix_64(SuperMatrix_64 *);
extern void Destroy_CompRow_Matrix_64(SuperMatrix_64 *);
extern void Destroy_SuperNode_Matrix_64(SuperMatrix_64 *);
extern void Destroy_CompCol_Permuted_64(SuperMatrix_64 *);
extern void Destroy_Dense_Matrix_64(SuperMatrix_64 *);
extern void get_perm_c_64(long, SuperMatrix_64 *, long *);
extern void sp_preorder_64(superlu_options_t_64 *, SuperMatrix_64 *,
                           long *, long*, SuperMatrix_64 *);
extern void StatInit_64(SuperLUStat_t_64 *);
extern void StatFree_64(SuperLUStat_t_64 *);
extern double LUFactTime_64(SuperLUStat_t_64 *);
extern double LUSolveTime_64(SuperLUStat_t_64 *);
extern float LUFactFlops_64(SuperLUStat_t_64 *);
extern float LUSolveFlops_64(SuperLUStat_t_64 *);
extern long sp_ienv_64(long);

/**** superlu single-precision 64-bit routines ****/
extern void sgssv_64(superlu_options_t_64 *, SuperMatrix_64 *, long *, long *,
                  SuperMatrix_64 *, SuperMatrix_64 *, SuperMatrix_64 *,
                  SuperLUStat_t_64 *, long *);
extern void sgssvx_64(superlu_options_t_64 *, SuperMatrix_64 *, long *, long *,
                   long *, char *, float *, float *, SuperMatrix_64 *,
                   SuperMatrix_64 *,void *, long, SuperMatrix_64 *,
       		   SuperMatrix_64 *,float *, float *, float *, float *,
                   mem_usage_t_64 *, SuperLUStat_t_64 *, long *);
extern void sgscon_64(char *, SuperMatrix_64 *, SuperMatrix_64 *,
                    float, float *, SuperLUStat_t_64 *, long *);
extern void sgsequ_64(SuperMatrix_64 *, float *, float *, float *,
                    float *, float *, long *);
extern void sgsrfs_64(trans_t, SuperMatrix_64 *, SuperMatrix_64 *,
                    SuperMatrix_64 *, long *, long *, char *, float *,
                    float *, SuperMatrix_64 *, SuperMatrix_64 *,
                    float *, float *, SuperLUStat_t_64 *, long *);
extern void sgstrs_64(trans_t, SuperMatrix_64 *, SuperMatrix_64 *, long *, long *,
                    SuperMatrix_64 *, SuperLUStat_t_64 *, long *);
extern void sgstrf_64(superlu_options_t_64 *, SuperMatrix_64*, float,
                    long, long, long*, void *, long, long *, long *,
                    SuperMatrix_64 *, SuperMatrix_64 *, SuperLUStat_t_64 *, long *);
extern float slangs_64(char *, SuperMatrix_64 *);
extern void slaqgs_64(SuperMatrix_64 *, float *, float *, float,
                    float, float, char *);
extern long sp_sgemm_64(char *, char *, long, long, long, float, SuperMatrix_64 *,
                     float *, long, float, float *, long);
extern void sCreate_CompCol_Matrix_64(SuperMatrix_64 *, long, long, long, float *,
                                   long *, long *, Stype_t, Dtype_t, Mtype_t);
extern void sCreate_CompRow_Matrix_64(SuperMatrix_64 *, long, long, long, float *,
                                   long *, long *, Stype_t, Dtype_t, Mtype_t);
extern void sCopy_CompCol_Matrix_64(SuperMatrix_64 *, SuperMatrix_64 *);
extern void sCreate_Dense_Matrix_64(SuperMatrix_64 *, long, long, float *, long,
                     Stype_t, Dtype_t, Mtype_t);
extern void sCreate_SuperNode_Matrix_64(SuperMatrix_64 *, long, long,
                         long, float *, long *, long *, long *, long *, long *,
                         Stype_t, Dtype_t, Mtype_t);
extern void sinfinite_norm_error_64(long, SuperMatrix_64 *, float *, float *);
extern long sQuerySpace_64(SuperMatrix_64 *, SuperMatrix_64 *, mem_usage_t_64 *);
extern void sPrintPerf_64(SuperMatrix_64 *, SuperMatrix_64 *, mem_usage_t_64 *,
           float, float, float *, float *, char *, SuperLUStat_t_64 *);
/**** superlu complex 64-bit routines ****/
extern void cgssv_64(superlu_options_t_64 *, SuperMatrix_64 *, long *, long *,
                  SuperMatrix_64 *, SuperMatrix_64 *, SuperMatrix_64 *,
                  SuperLUStat_t_64 *, long *);
extern void cgssvx_64(superlu_options_t_64 *, SuperMatrix_64 *, long *, long *, long *,
                   char *, float *, float *, SuperMatrix_64 *, SuperMatrix_64 *,
                   void *, long, SuperMatrix_64 *, SuperMatrix_64 *,
       		   float *, float *, float *, float *,
                   mem_usage_t_64 *, SuperLUStat_t_64 *, long *);
extern void cgscon_64 (char *, SuperMatrix_64 *, SuperMatrix_64 *,
                    float, float *, SuperLUStat_t_64*, long *);
extern void cgsequ_64 (SuperMatrix_64 *, float *, float *, float *,
                    float *, float *, long *);
extern void cgsrfs_64 (trans_t, SuperMatrix_64 *, SuperMatrix_64 *,
                    SuperMatrix_64 *, long *, long *, char *, float *,
                    float *, SuperMatrix_64 *, SuperMatrix_64 *,
                    float *, float *, SuperLUStat_t_64*, long *);
extern void cgstrs_64 (trans_t, SuperMatrix_64 *, SuperMatrix_64 *, long *, long *,
                    SuperMatrix_64 *, SuperLUStat_t_64*, long *);
extern void cgstrf_64 (superlu_options_t_64*, SuperMatrix_64*, float,
                    long, long, long*, void *, long, long *, long *,
                    SuperMatrix_64 *, SuperMatrix_64 *, SuperLUStat_t_64*, long *);
extern float clangs_64 (char *, SuperMatrix_64 *);
extern void claqgs_64 (SuperMatrix_64 *, float *, float *, float,
                    float, float, char *);
extern long sp_cgemm_64 (char *, char *, long, long, long, complex, SuperMatrix_64 *,
                     complex *, long, complex, complex *, long);
extern void cCreate_CompCol_Matrix_64(SuperMatrix_64 *, long, long, long, complex *,
                                   long *, long *, Stype_t, Dtype_t, Mtype_t);
extern void cCreate_CompRow_Matrix_64(SuperMatrix_64 *, long, long, long, complex *,
                                   long *, long *, Stype_t, Dtype_t, Mtype_t);
extern void cCopy_CompCol_Matrix_64(SuperMatrix_64 *, SuperMatrix_64 *);
extern void cCreate_Dense_Matrix_64(SuperMatrix_64 *, long, long, complex *, long,
                     Stype_t, Dtype_t, Mtype_t);
extern void cCreate_SuperNode_Matrix_64(SuperMatrix_64 *, long, long, long, complex *,
                         long *, long *, long *, long *, long *,
                         Stype_t, Dtype_t, Mtype_t);
extern void cinfinite_norm_error_64(long, SuperMatrix_64 *, complex *, float *);
extern long cQuerySpace_64(SuperMatrix_64 *, SuperMatrix_64 *, mem_usage_t_64 *);
extern void cPrintPerf_64(SuperMatrix_64 *, SuperMatrix_64 *, mem_usage_t_64 *,
           float, float, float *, float *, char *, SuperLUStat_t_64 *);

/**** superlu double-precision 64-bit routines ****/
extern void dgssv_64(superlu_options_t_64 *, SuperMatrix_64 *, long *, long *,
                  SuperMatrix_64 *, SuperMatrix_64 *, SuperMatrix_64 *,
                  SuperLUStat_t_64 *, long *);
extern void dgssvx_64(superlu_options_t_64 *, SuperMatrix_64 *, long *, long *,
                   long *, char *, double *, double *, SuperMatrix_64 *,
                   SuperMatrix_64 *,void *, long, SuperMatrix_64 *,
       		   SuperMatrix_64 *,double *, double *, double *, double *,
                   mem_usage_t_64 *, SuperLUStat_t_64 *, long *);
extern void dgscon_64(char *, SuperMatrix_64 *, SuperMatrix_64 *,
                    double, double *, SuperLUStat_t_64 *, long *);
extern void dgsequ_64(SuperMatrix_64 *, double *, double *, double *,
                    double *, double *, long *);
extern void dgsrfs_64(trans_t, SuperMatrix_64 *, SuperMatrix_64 *,
                    SuperMatrix_64 *, long *, long *, char *, double *,
                    double *, SuperMatrix_64 *, SuperMatrix_64 *,
                    double *, double *, SuperLUStat_t_64 *, long *);
extern void dgstrs_64(trans_t, SuperMatrix_64 *, SuperMatrix_64 *, long *, long *,
                    SuperMatrix_64 *, SuperLUStat_t_64 *, long *);
extern void dgstrf_64(superlu_options_t_64 *, SuperMatrix_64*, double,
                    long, long, long*, void *, long, long *, long *,
                    SuperMatrix_64 *, SuperMatrix_64 *, SuperLUStat_t_64 *, long *);
extern double dlangs_64(char *, SuperMatrix_64 *);
extern void dlaqgs_64(SuperMatrix_64 *, double *, double *, double,
                    double, double, char *);
extern long sp_dgemm_64(char *, char *, long, long, long, double, SuperMatrix_64 *,
                     double *, long, double, double *, long);
extern void dCreate_CompCol_Matrix_64(SuperMatrix_64 *, long, long, long,
                           double *, long *, long *, Stype_t, Dtype_t, Mtype_t);
extern void dCreate_CompRow_Matrix_64(SuperMatrix_64 *, long, long, long,
                           double *, long *, long *, Stype_t, Dtype_t, Mtype_t);
extern void dCopy_CompCol_Matrix_64(SuperMatrix_64 *, SuperMatrix_64 *);
extern void dCreate_Dense_Matrix_64(SuperMatrix_64 *, long, long, double *,
                     long, Stype_t, Dtype_t, Mtype_t);
extern void dCreate_SuperNode_Matrix_64(SuperMatrix_64 *, long, long,
                         long, double *, long *, long *, long *, long *,
                         long *, Stype_t, Dtype_t, Mtype_t);
extern void dinfinite_norm_error_64(long, SuperMatrix_64 *, double *, double *);
extern long dQuerySpace_64(SuperMatrix_64 *, SuperMatrix_64 *, mem_usage_t_64 *);
extern void dPrintPerf_64(SuperMatrix_64 *, SuperMatrix_64 *, mem_usage_t_64 *,
           double, double, double *, double *, char *, SuperLUStat_t_64 *);
/**** superlu double complex 64-bit routines ****/
extern void zgssv_64(superlu_options_t_64 *, SuperMatrix_64 *, long *, long *,
                  SuperMatrix_64 *, SuperMatrix_64 *, SuperMatrix_64 *,
                  SuperLUStat_t_64 *, long *);
extern void zgssvx_64(superlu_options_t_64 *, SuperMatrix_64 *, long *, long *, long *,
                   char *, double *, double *, SuperMatrix_64 *, SuperMatrix_64 *,
                   void *, long, SuperMatrix_64 *, SuperMatrix_64 *,
       		   double *, double *, double *, double *,
                   mem_usage_t_64 *, SuperLUStat_t_64 *, long *);
extern void zgscon_64 (char *, SuperMatrix_64 *, SuperMatrix_64 *,
                    double, double *, SuperLUStat_t_64*, long *);
extern void zgsequ_64 (SuperMatrix_64 *, double *, double *, double *,
                    double *, double *, long *);
extern void zgsrfs_64 (trans_t, SuperMatrix_64 *, SuperMatrix_64 *,
                    SuperMatrix_64 *, long *, long *, char *, double *,
                    double *, SuperMatrix_64 *, SuperMatrix_64 *,
                    double *, double *, SuperLUStat_t_64*, long *);
extern void zgstrs_64 (trans_t, SuperMatrix_64 *, SuperMatrix_64 *, long *, long *,
                    SuperMatrix_64 *, SuperLUStat_t_64*, long *);
extern void zgstrf_64 (superlu_options_t_64*, SuperMatrix_64*, double,
                    long, long, long*, void *, long, long *, long *,
                    SuperMatrix_64 *, SuperMatrix_64 *, SuperLUStat_t_64*, long *);
extern double zlangs_64 (char *, SuperMatrix_64 *);
extern void zlaqgs_64 (SuperMatrix_64 *, double *, double *, double,
                    double, double, char *);
extern long sp_zgemm_64 (char *, char *, long, long, long, doublecomplex, SuperMatrix_64 *,
                     doublecomplex *, long, doublecomplex, doublecomplex *, long);
extern void zCreate_CompCol_Matrix_64(SuperMatrix_64 *, long, long, long, doublecomplex *,
                                   long *, long *, Stype_t, Dtype_t, Mtype_t);
extern void zCreate_CompRow_Matrix_64(SuperMatrix_64 *, long, long, long, doublecomplex *,
                                   long *, long *, Stype_t, Dtype_t, Mtype_t);
extern void zCopy_CompCol_Matrix_64(SuperMatrix_64 *, SuperMatrix_64 *);
extern void zCreate_Dense_Matrix_64(SuperMatrix_64 *, long, long, doublecomplex *, long,
                     Stype_t, Dtype_t, Mtype_t);
extern void zCreate_SuperNode_Matrix_64(SuperMatrix_64 *, long, long, long, doublecomplex *,
                         long *, long *, long *, long *, long *,
                         Stype_t, Dtype_t, Mtype_t);
extern void zinfinite_norm_error_64(long, SuperMatrix_64 *, doublecomplex *, double *);
extern long zQuerySpace_64(SuperMatrix_64 *, SuperMatrix_64 *, mem_usage_t_64 *);
extern void zPrintPerf_64(SuperMatrix_64 *, SuperMatrix_64 *, mem_usage_t_64 *,
           double, double, double *, double *, char *, SuperLUStat_t_64 *);
#endif /* if defined (__sparcv9) || (defined (__x86_64) && defined(__amd64)) */

#ifdef __cplusplus
}
#endif

#endif /* !defined(_SUNPERF_H) */
